#!/bin/sh
#
# default parameters
#

version=2005.0603.0

msg=0

# determine platform
if [ "x$1" = "x" ]; then
    machine=`uname`
else
    machine=$1
fi
LANG=C
export LANG
LC_ALL=C
export LC_ALL
date=`date`
echo "generate Makefile for $machine"
echo "$date"

# default paths
gracedir=`pwd`
bindir='$(GRACEDIR)/bin'
libdir='$(GRACEDIR)/lib'
modelpath='".:$(LIBDIR)/model"'
kinempath='".:$(LIBDIR)/dbkinem"'
ldflags=''

# default commands
ar='ar'
ranlib='ranlib'
reduce='reduce'

# cc
if [ -f /opt/FSUNf90/bin/fcc ]; then
    cc='fcc';
    copt='';
elif [ -f /opt/SUNWspro/bin/cc ]; then
    cc='/opt/SUNWspro/bin/cc';
    copt='';
elif [ -f /usr/FFC/bin/fcc ]; then
    cc='/usr/FFC/bin/fcc';
    copt='';
elif [ -f /usr/bin/cc ]; then
    cc='cc';
    copt='';
elif [ -f /usr/bin/gcc ]; then
    cc='gcc';
    copt='';
elif [ -f /usr/local/bin/gcc ]; then
    cc='/usr/local/bin/gcc';
    copt='';
else
    cc='cc';
    copt='';
fi

#fc
if [ -f /usr/bin/xlf ]; then
    fc='xlf'
    fopt=''
elif [ -f /opt/FSUNf90/bin/frt ]; then
    fc='frt'
    fopt='-fw'
elif [ -f /usr/FFC/bin/frt ]; then
    fc='/usr/FFC/bin/frt';
    fopt='-X9 -O0 -fw -rpath /usr/FFC/lib -static-flib';
    ldflags='-O0 -rpath /usr/FFC/lib -static-flib';
elif [ -f /opt/FFC/bin/frt ]; then
    fc='/opt/FFC/bin/frt';
    fopt='-X9 -O0 -fw -rpath /opt/FFC/lib -static-flib';
    ldflags='-O0 -rpath /opt/FFC/lib -static-flib';
elif [ -f /opt/fortran/bin/fort77 ]; then
    fc='/opt/fortran/bin/fort77'
    fopt=''
elif [ -f /usr/bin/fort ]; then
    fc='fort'
    fopt=''
elif [ -f /usr/bin/fort77 ]; then
    fc='fort77'
    fopt=''
elif [ -f /usr/local/bin/fort ]; then
    fc='fort'
    fopt=''
elif [ -f /usr/bin/f77 ]; then
    fc='f77'
    fopt=''
elif [ -f /usr/bin/g77 ]; then
    fc='g77'
    fopt=''
elif [ -f /usr/local/bin/g77 ]; then
    fc='g77'
    fopt=''
else
    echo "*******************************************"
    echo "*** I could not fortran compiler        ***"
    echo "*** Please edit Makefile by hand.       ***"
    echo "*******************************************"
    fc='fort'
    fopt=''
fi

# machine dependent functions
mdfuncs=''

# X-Window
if [ -f /usr/X11R6/include/X11/Xlib.h ]; then
    xwin=1
    xincd='/usr/X11R6/include'
    xopti="-I$xincd"
    xoptl='-L/usr/X11R6/lib'
    if [ -f /usr/X11R6/lib64 ]; then
        xoptl='-L/usr/X11R6/lib64'
    fi      
elif [ -f /usr/X11/include/X11/Xlib.h ]; then
    xwin=1
    xincd="/usr/X11/include"
    xopti="-I$xincd"
    xoptl="-L/usr/X11/lib"
elif [ -f /usr/X/include/X11/Xlib.h ]; then
    xwin=1
    xincd="/usr/X/include"
    xopti="-I$xincd"
    xoptl="-L/usr/X/lib"
elif [ -f /usr/lpp/X11/include/X11/Xlib.h ]; then
    xwin=1
    xincd="/usr/lpp/X11/include"
    xopti="-I$xincd"
    xoptl="-L/usr/lpp/X11/lib"
elif [ -f /usr/include/X11R6/X11/Xlib.h ]; then
    xwin=1
    xincd='/usr/include/X11R6'
    xopti="-I$xincd"
    xoptl='-L/usr/lib/X11R6'
elif [ -f /usr/include/X11/Xlib.h ]; then
    xwin=1
    xincd='/usr/include'
    xopti="-I$xincd"
    xoptl='-I/usr/lib'
elif [ -f /usr/include/X11R5/X11/Xlib.h ]; then
    xwin=1
    xincd='/usr/include/X11R5'
    xopti="-I$xincd"
    xoptl='-L/usr/lib/X11R5'
elif [ -f /usr/local/X11R6/include/X11/Xlib.h ]; then
    xwin=1
    xincd="/usr/local/X11R6/include"
    xopti="-I$xincd"
    xoptl="-L/usr/local/X11R6/lib"
elif [ -f /usr/local/X11R5/include/X11/Xlib.h ]; then
    xwin=1
    xincd="/usr/local/X11R5/include"
    xopti="-I$xincd"
    xoptl="-L/usr/local/X11R5/lib"
else
    xwin=0
    xopti=""
    xoptl=""
fi

# Athena widget and Motif
if [  $xwin = 1 ]; then
    if [ -f $xincd/X11/Xaw/Xm.h ]; then
        xcopt='-DTOOLKIT -DX11'
        xllib='-lXaw -lXmu -lXt -lXext -lX11'
    else
        xcopt='-DX11'
        xllib='-lX11'
    fi
    if [ -f $xincd/Xm/Xm.h ]; then
        motif=1
        mopti=''
        moptl=''
    elif [ -f /usr/include/Xm/Xm.h ]; then
        motif=1
        mopti=''
        moptl=''
    elif [ -f /usr/LessTif/Motif1.2/include/Xm/Xm.h ]; then
        motif=1
        mopti='-I/usr/LessTif/Motif1.2/include'
        moptl='-L/usr/LessTif/Motif1.2/lib'
    elif [ -f /usr/include/Motif1.2/Xm/Xm.h ]; then
        motif=1
        mopti='-I/usr/include/Motif1.2'
        moptl='-L/usr/lib/Motif1.2'
    elif [ -f /usr/dt/share/include/Xm/Xm.h ]; then
        motif=1
        mopti='-I/usr/dt/share/include'
        moptl='-L/usr/dt/share/lib'
    else
        motif=0
        mopti=''
        moptl=''
    fi
else
    xcopt=''
    xllib=''
    motif=0
    mopti=''
    moptl=''
fi
if [ $motif = 1 ]; then
    molib='-lXm -lXt -lX11 -lm'
else
    molib=''
fi

if [ x$xwin != x1 ]; then
    echo "*******************************************"
    echo "*** I could not find X-Window.          ***"
    echo "*** Please edit Makefile by hand.       ***"
    echo "*******************************************"
fi
if [ $msg = 1 ]; then
    echo "xwin = $xwin"
    echo "xopti = $xopti"
    echo "xoptl = $xoptl"
    echo "xcopt = $xcopt"
    echo "xllib = $xllib"
    echo "motif = $motif"
    echo "mopti = $mopti"
    echo "moptl = $moptl"
fi

# machine dependent part
exesuff=''
case $machine in
FreeBSD)
    cc='cc'
    copt='-g -Wall'
#   copt='-O -Wuninitialized -Wall'
    fc='f77'
    ;;

Linux-alpha)
    ;;

Linux)
    ;;

AIX)
    fc='xlf'
#   fopt='-O3 -qstrict -qarch=pwr3 -qtune=pwr3 -qextname'
#   fopt='-qsuppress=1501-245 -qsuppress=1501-510 -qstrict -qextname'
#   fopt='-qextname -qautodbl=dbl8'
    fopt='-qextname'
#   copt='-qlanglvl=ansi -qsuppress=1501-245 -qinfo=gen'
    copt='-qlanglvl=ansi'
    ;;

SunOS)
    mdfuncs='bstime_sun.f'
    ;;

HP-UX)
    fc='fort77'
    fopt='+ppu'
    copt='-Ae'
    ;;

OFS1)
    ;;


hiux)
    mdfuncs='bsdate_hiux.f bstime_hiux.f'
    ;;

CYGWIN*)
    exesuff='.exe'

esac

fname="MakeConf"

echo "VERSION   = $version"    > $fname
echo "MACHINE   = $machine"   >> $fname
echo "GRACEDIR  = $gracedir"  >> $fname
echo "LIBDIR    = $libdir"    >> $fname
echo "BINDIR    = $bindir"    >> $fname
echo "MODELPATH = $modelpath" >> $fname
echo "KINEMPATH = $kinempath" >> $fname
echo "FC        = $fc"        >> $fname
echo "FFLAGS    = $fopt"      >> $fname
echo "CC        = $cc"        >> $fname
echo "COPT      = $copt"      >> $fname
echo "LDFLAGS   = $ldflags"   >> $fname
echo "XOPTI     = $xopti"     >> $fname
echo "XOPTL     = $xoptl"     >> $fname
echo "XCOPT     = $xcopt"     >> $fname
echo "XLLIB     = $xllib"     >> $fname
echo "MOPTI     = $mopti"     >> $fname
echo "MOPTL     = $moptl"     >> $fname
echo "MOLIB     = $molib"     >> $fname
echo "AR        = $ar"        >> $fname
echo "RANLIB    = $ranlib"    >> $fname
echo "CMPDATE   = $date"      >> $fname
echo "MDFUNCS   = $mdfuncs"   >> $fname
echo "REDUCE    = $reduce"    >> $fname
echo "EXESUFF   = $exesuff"   >> $fname

cat $fname        > Makefile
cat Makefile.tpl >> Makefile

if [ $motif = 1 ]; then
    cp gracefig/Makefile.tpl gracefig/Makefile.tpl1
else
    cp MakeSkip gracefig/Makefile.tpl1
    cat gracefig/Makefile.tpl >> gracefig/Makefile.tpl1
fi
if [ $fc = g77 ]; then
    echo "*** g77 may not compile correctly. **"
fi

echo ""
echo "+++ \$(GRACEDIR) = $gracedir"
echo "+++ Commands  will be installed to $bindir"
echo "+++ Libraries will be installed to $libdir"
