C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 1301
C   Date      : 2002.07.26
C   Author    : T.Kon, Y.Kurihara
C---------------------------------------------------------------------
      subroutine kinit
      implicit real*8(a-h,o-z)
*
      parameter ( mxdim = 50 )
      common / loop0 / loop
      common / bparm1 / xl(mxdim),xu(mxdim),ndim,nwild,
     &                 ig(mxdim),ncall
      common / bparm2 / acc1,acc2,itmx1,itmx2
      COMMON / kinem1 / s,w,fact
      common / knmflg / knmgvs, knmhst, knmsph, knmisr
      COMMON/CUT001/AMASCT(2),ARESNS(2)
      COMMON/KCNTL1/IRESNS
      include 'inclk.h'
      character xstr*14, dstr*24
*--- 1. inforamtion of Mass and width
*     1: initial  mass=amass1(1)
*     2: final    mass=amass1(2)
*     3: final    mass=amass1(3)
*     4: final    mass=amass1(4)

******************************************
* Q2=(p2+p3)**2 singularity treatment    *
******************************************
* no-singularity           : IRESNS= 0
* narrow resonance         : IRESNS= 1
      IRESNS   = 0
      IF( abs(IRESNS).eq.1 ) then
        ARESNS(1)=AMz
        ARESNS(2)=AGz
      END IF

      WRITE(6,*)'*'
      WRITE(6,*)'* Kinematics initialization '
      WRITE(6,*)'*  Code # 1301 '
      WRITE(6,*)'* particle mass ',amass1
      WRITE(6,*)'* Singularity treatment '
      WRITE(6,*)'*   Q2 on particle2 and 3'
      IF(IRESNS.EQ. 0) THEN
         WRITE(6,*)'* NO   singularity '
      ELSE
         WRITE(6,*)'* Narrow resonance '
         WRITE(6,*)'*  resonance mass and width'
         WRITE(6,*) ARESNS
      END IF

*--- 3. Set MXREG : the maximum number of values which are returned 
*       by FUNC for one phase space point

      mxreg = 1

*=======================================================================
*          Parameters for BASES
*=======================================================================

*--- 4. Dimension of integration.

           ndim  = 2
           nwild = 2

*--- 5. Region of integration.

           xl(1)     = 0.0d0 
           xu(1)     = 1.0d0
           xl(2)     = 0.0d0
           xu(2)     = 1.0d0
                      
           ig(1)     = 1
           ig(2)     = 1

*--- 6. Numbers of iterations and sampling points / iteration
*       and expected accuracies

           itmx1  =  5
           itmx2  =  7

           acc1   = 0.2d0
           acc2   = 0.01d0

           ncall  = 5000

*--- 7. Set histograms
      if( knmhst .eq. 1 ) then
           nx = 50
           nd = 50

           do 100 i = 1, ndim
              write(xstr, 110) I
  110         format('x(',i2,') Spectrum')
              call xhinit(i, xl(i), xu(i), nx, xstr)
  100      continue

           k = ndim
           do 200 i = 1, ndim - 1
           do 200 j = i + 1, ndim
              write(dstr, 210) i, j
  210         format('x(',i2,')-x(',i2,') Distribution')
              k = k + 1
              call dhinit(k, xl(i),xu(i),nd, xl(j),xu(j),nd,dstr)
  200      continue
      endif

      return
      end
