C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 2301
C   Date      : 2002.07.26
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      SUBROUTINE KINEM(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
      IMPLICIT REAL* 8(A-H,O-Z)
*
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 50 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.h'
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS3,icos4
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,3),ENGYCT(2,3),AMASCT(2),ARESNS(2,2)
      COMMON/KINEM2/d23
      DIMENSION PBSTCL(4),rl2c(3,3),rc2l(3,3),ppa(4),pk1(4),pk2(4)
* BETA FUNCTION
       BETA(Z1,Z2)=SQRT(1-2*(Z1+Z2)+(Z1-Z2)**2)
*-----------------------------------------------------------------------
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* Set integration variables
************
* PHI3     *
************
      IF(NDIM.EQ.5) THEN
       PHI3=X(5)*2*PI
      ELSE
       PHI3=0
      END IF
                 AJACOB = AJACOB*2*PI
*************
* Q2        *
*************
      ipoint = 1
      Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
      Q2MAX=MIN(S+AMASS2(3)-2.d0*W*ENGYCT(1,1), AMASCT(2)**2)
      IF(Q2MIN.GE.Q2MAX) GOTO 999
      IF     (IRESNS.EQ. 0) THEN
       Q2  = Q2MIN+(Q2MAX-Q2MIN)*X(4)
                 AJACOB = AJACOB*(Q2MAX-Q2MIN)
      ELSE IF(IRESNS.EQ. 3) THEN
        e3min=(s+amass2(3)-q2max)/2.d0/w
        e3max=(s+amass2(3)-q2min)/2.d0/w
        e3=e3min*(e3max/e3min)**x(4)
                 ajacob = ajacob*e3*log(e3max/e3min)*2.d0*w
        q2=s+amass2(3)-2.d0*w*e3
      ELSE IF(IRESNS.EQ. 4) THEN
       if(x(4).lt.0.5d0) then
        x4=x(4)*2.d0
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,1)+aresns(2,1)*3)**2)
        if(q2max.lt.q2min) goto 999
        AM    = ARESNS(1,1)
        AM2   =AM*AM
        AMG   =ARESNS(1,1)*ARESNS(2,1)
        THEMIN=ATAN((Q2MIN-AM2)/AMG)
        THEMAX=ATAN((Q2MAX-AM2)/AMG)
        THE   =THEMIN+(THEMAX-THEMIN)*X4
        Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG*2
       else
        x4=2.d0-x(4)*2.d0
        q2min=max((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,1)+aresns(2,1)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        if(q2max.lt.q2min) goto 999
        e3min=(s+amass2(3)-q2max)/2.d0/w
        e3max=(s+amass2(3)-q2min)/2.d0/w
        e3=e3min*(e3max/e3min)**x4
                 ajacob = ajacob*e3*log(e3max/e3min)*4.d0*w
        q2=s+amass2(3)-2.d0*w*e3
       end if
      ELSE IF(IRESNS.EQ.-3) THEN
       if(q2min.le.0) goto 999
       Q2  = Q2MIN*(Q2MAX/Q2MIN)**X(4)
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)
      ELSE IF(IRESNS.EQ. 1) THEN
       AM    = ARESNS(1,1)
       AM2   =AM*AM
       AMG   =ARESNS(1,1)*ARESNS(2,1)
       THEMIN=ATAN((Q2MIN-AM2)/AMG)
       THEMAX=ATAN((Q2MAX-AM2)/AMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X(4)
       Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG
      ELSE IF(IRESNS.EQ.-1) THEN
       if(x(4).lt.0.5d0) then
        x4=X(4)*2.d0
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        if(q2max.lt.q2min) goto 999
        if(q2min.le.0) goto 999
        Q2  = Q2MIN*(Q2MAX/Q2MIN)**X4
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)*2
       else
        x4=2.d0-X(4)*2.d0
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        if(q2max.lt.q2min) goto 999
        AM    = ARESNS(1,1)
        AM2   =AM*AM
        AMG   =ARESNS(1,1)*ARESNS(2,1)
        THEMIN=ATAN((Q2MIN-AM2)/AMG)
        THEMAX=ATAN((Q2MAX-AM2)/AMG)
        THE   =THEMIN+(THEMAX-THEMIN)*X4
        Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG*2
       end if
      ELSE IF(IRESNS.EQ. 2) THEN
       if(x(4).lt.0.5d0) then
        x4=x(4)*2
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        ir=1
       else
        x4=2-X(4)*2
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        ir=2
       end if
       if(q2min.gt.q2max) goto 999
       AM    = ARESNS(1,ir)
       AM2   =AM*AM
       AMG   =ARESNS(1,ir)*ARESNS(2,ir)
       THEMIN=ATAN((Q2MIN-AM2)/AMG)
       THEMAX=ATAN((Q2MAX-AM2)/AMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X4
       Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG
     .*2
      ELSE IF(IRESNS.EQ.-2) THEN
       if(x(4).lt.1.d0/3.d0) then
        x4=x(4)*3 
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        if(q2max.lt.q2min) goto 999
        if(q2min.le.0) goto 999
        Q2  = Q2MIN*(Q2MAX/Q2MIN)**X4
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)*3
       else
       if(x(4).lt.2.d0/3.d0) then
        x4=x(4)*3-1 
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        ir=1
       else
        x4=3-X(4)*3
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        ir=2
       end if
       if(q2min.gt.q2max) goto 999
       AM    = ARESNS(1,ir)
       AM2   =AM*AM
       AMG   =ARESNS(1,ir)*ARESNS(2,ir)
       THEMIN=ATAN((Q2MIN-AM2)/AMG)
       THEMAX=ATAN((Q2MAX-AM2)/AMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X4
       Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG
     .*3
       end if
      ELSE
       GOTO 999
      END IF
*************
* ENERGY3   *
*************
       ipoint = 2
       E3   = (S+AMASS2(3)-Q2)/2.D0/W
       IF(E3.GT.ENGYCT(2,1)) GOTO 999
       IF(E3.LT.ENGYCT(1,1)) GOTO 999
       P3   = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )
       if(p3.le.1.d-10) goto 999
*************
* ENERGY1   *
*************
       ipoint = 3
       E1   = (S+AMASS2(1)-AMASS2(2))/2.D0/W
       P1   = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
       E2   = (S+AMASS2(2)-AMASS2(1))/2.D0/W
       P2   = P1
       if(p1.eq.0) goto 999
*************
* C0S(the3) *
*************
       ipoint = 4
      IF     (ICOS3.EQ.0) THEN
* no-singularity *************************************************
       COS3=COSCUT(1,1) + (COSCUT(2,1)-COSCUT(1,1))*X(3)
       SIN3=SQRT( (1-COS3)*(1+COS3) )
                 AJACOB = AJACOB*(COSCUT(2,1)-COSCUT(1,1))
       eta=1.d0-cos3
       d13=e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3
       eta=1.d0+cos3
       d23=amass2(2)*p3/(e2+p2)+amass2(3)*p2/(e3+p3)
     .+amass2(2)/(e2+p2)*amass2(3)/(e3+p3)+eta*p2*p3
      ELSE IF(ICOS3.EQ.1) THEN
* 1/t ************************************************************  
       eps=0
       eta=1.d0-coscut(2,1)
       d13min=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
       if(d13min.le.0     ) then
        eps=-d13min+amass2(1)
        d13min=d13min+eps
        if(d13min.le.0 ) goto 999
       end if
       eta=1.d0-coscut(1,1)
       d13max=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)+eps
       if(d13min.gt.d13max) goto 999
       d13=d13min*(d13max/d13min)**x(3)
		 ajacob=ajacob*d13*log(d13max/d13min)/p1/p3/2.d0
       d13=(d13-eps+amass2(3)+amass2(1))/2.d0
       cos3=e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)-d13
       cos3=1.d0+cos3/p1/p3
       eta=1.d0+cos3
       d23=amass2(2)*p3/(e2+p2)+amass2(3)*p2/(e3+p3)
     .+amass2(2)/(e2+p2)*amass2(3)/(e3+p3)+eta*p2*p3
      ELSE IF(ICOS3.EQ.2) THEN
* 1/t+1/u ********************************************************  
* 1/t *****
       eps=0
       if(x(3).lt.0.5d0) then
        x3=x(3)*2.d0
        eta=1.d0-coscut(2,1)
        d13min=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
        if(d13min.le.0     ) then
         eps=amass2(1)-d13min
         d13min=d13min+eps
         if(d13min.le.0 ) goto 999
        end if
        eta=1.d0-max(0.d0,coscut(1,1))
        d13max=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)+eps
       if(d13min.gt.d13max) goto 999
       d13=d13min*(d13max/d13min)**x3
		 ajacob=ajacob*d13*log(d13max/d13min)/p1/p3
       d13=(d13-eps+amass2(3)+amass2(1))/2.d0
       cos3=e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)-d13
       cos3=1.d0+cos3/p1/p3
       eta=1.d0+cos3
       d23=amass2(2)*p3/(e2+p2)+amass2(3)*p2/(e3+p3)
     .+amass2(2)/(e2+p2)*amass2(3)/(e3+p3)+eta*p2*p3
       else
* 1/u *****
        x3=2.d0-x(3)*2.d0
        eta=1.d0+coscut(1,1)
        d23min=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)
        if(d23min.le.0     ) then
         eps=amass2(2)-d23min
         d23min=d23min+eps
         if(d23min.le.0 ) goto 999
        end if
        eta=1.d0+min(0.d0,coscut(2,1))
        d23max=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)+eps
       if(d23min.gt.d23max) goto 999
       d23=d23min*(d23max/d23min)**x3
 	 ajacob=ajacob*d23*log(d23max/d23min)/p2/p3
       d23=(d23-eps+amass2(3)+amass2(2))/2.d0
       cos3=e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)-d23
       cos3=-1.d0-cos3/p2/p3
       eta=1.d0-cos3
       d13=amass2(1)*p3/(e1+p1)+amass2(3)*p1/(e3+p3)
     .+amass2(1)/(e1+p1)*amass2(3)/(e3+p3)+eta*p1*p3
       end if
      ELSE
       GOTO 999
      END IF
      if(abs(cos3).gt.1) goto 999
      sin3=sqrt( (1.d0-cos3)*(1.d0+cos3) )
************************
* PHI4 in 4-5 CM frame *
************************
      PHI4=X(2)*2*PI+PHI3
                 AJACOB = AJACOB*2*PI
* set 4-vector 
*Particle 1
      PE(1,1) = 0
      PE(2,1) = 0
      PE(3,1) = P1
      PE(4,1) = E1
 
*Particle 2
      PE(1,2) = 0
      PE(2,2) = 0
      PE(3,2) =-P2
      PE(4,2) = E2
 
*Particle 3
      PE(1,3) = P3*SIN3*COS(PHI3)
      PE(2,3) = P3*SIN3*SIN(PHI3)
      PE(3,3) = P3*COS3
      PE(4,3) = E3
 
* boost from 4-5 CM frame to 1-2 CM frame (Lab-frame)
      PBSTCL(1)=-PE(1,3)
      PBSTCL(2)=-PE(2,3)
      PBSTCL(3)=-PE(3,3)
      PBSTCL(4)= SQRT(P3*P3+Q2)

************************
* COS4 in 4-5 CM frame *
************************
      ipoint = 5
      ppa(1)=pe(1,1)
      ppa(2)=pe(2,1)
      ppa(3)=pe(3,1)
      ppa(4)=pe(4,1)
      call labtok(ppa,pbstcl,pe(1,1),pe(1,2), pk1,pk2)
      ee4=(q2+amass2(4)-amass2(5))/2.d0/sqrt(q2)
      pp4=sqrt( (ee4-amass1(4))*(ee4+amass1(4)) )
      ee5=(q2+amass2(5)-amass2(4))/2.d0/sqrt(q2)
      pp5=pp4
      if(icos4.eq.0) then
       COS4=-1+2*X(1)
                 AJACOB = AJACOB*2
      else if(icos4.ge. 1) then
       eps=2*amass2(4)/q2
       ymin=-log( 1.d0+2.d0/eps )/2
       ymax= log( 1.d0+2.d0/eps )/2
       y=ymin+(ymax-ymin)*x(1)
       cos4=(1+eps)*tanh(y)
                 ajacob=ajacob*(ymax-ymin)/cosh(y)**2*(1+eps)
      else if(icos4.eq.-1) then
        if(pp4.eq.0) goto 999
        eps = 0
        ee1=pk1(4) 
        pp1=sqrt( (ee1-amass1(1))*(ee1+amass1(1)) )
	if(pp1.eq.0) goto 999
        eta=0
        d14min=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1)
       if(d14min.le.0) then
        eps=amass1(1)
        d14min=d14min+eps
       end if
        eta=2.d0
        d14max=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1) + eps
        d14=d14min*(d14max/d14min)**x(1)
                  ajacob=ajacob*d14*log(d14max/d14min)/pp1/pp4/2.d0
        d14=(d14-eps+amass2(4)+amass2(1))/2.d0
        cos4=ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)-d14
        cos4= 1.d0+cos4/pp1/pp4
        eta=1.d0+cos4
        d15=ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5
      else if(icos4.eq.-2) then
       if(pp4.eq.0) goto 999
       eps = 0
       if(x(1).lt.0.5d0) then
       x1=x(1)*2.d0
        ee1=pk1(4) 
        pp1=sqrt( (ee1-amass1(1))*(ee1+amass1(1)) )
	if(pp1.eq.0) goto 999
        eta=0
        d14min=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1)
       if(d14min.le.0) then
        eps=amass1(1)
        d14min=d14min+eps
       end if
        eta=1.d0
        d14max=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1)+eps
        d14=d14min*(d14max/d14min)**x1
                  ajacob=ajacob*d14*log(d14max/d14min)/pp1/pp4
        d14=(d14-eps+amass2(4)+amass2(1))/2.d0
        cos4=ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)-d14
        cos4= 1.d0+cos4/pp1/pp4
        eta=1.d0+cos4
        d15=ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5
       else
       x1=2.d0-x(1)*2.d0
        ee1=pk1(4) 
        pp1=sqrt( (ee1-amass1(1))*(ee1+amass1(1)) )
	if(pp1.eq.0) goto 999
        eta=0
        d15min=2*(ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5)-amass2(5)-amass2(1)
       if(d15min.le.0) then
        eps=amass1(1) 
        d15min=d15min+eps
       end if
        eta=1.d0
        d15max=2*(ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5)-amass2(5)-amass2(1)+eps
        d15=d15min*(d15max/d15min)**x1
                  ajacob=ajacob*d15*log(d15max/d15min)/pp1/pp5
        d15=(d15-eps+amass2(5)+amass2(1))/2.d0
        cos5=ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)-d15
        cos5= 1.d0+cos5/pp1/pp5
        eta=1.d0+cos5
        d14=ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4
        cos4=-cos5
       end if
      ELSE
       GOTO 999
      END IF
      if(abs(cos4).gt.1) goto 999
      SIN4=SQRT( (1-COS4)*(1+COS4) )
 
* Set four-vectors
*Particle 4 
      E4      = (Q2+AMASS2(4)-AMASS2(5))/2.D0/SQRT(Q2)
      P4      = SQRT( (E4-AMASS1(4))*(E4+AMASS1(4)) )
      if(icos4.ge.0) then
c     if(icos4.gt.0) then
* Z-axis -> -P3 *********************
      ee  = (s+q2-amass2(3))/2.d0/w
      bet = 1.d0/(1.d0+q2/p3/(ee+p3))
      gam = ee/sqrt(q2)
      ee  = gam*(    amass2(4)/(e4+p4)+p4*(1.d0+bet*cos4))
      pz  = gam*(bet*amass2(4)/(e4+p4)+p4*(bet +    cos4))
      PE(1,4) = p4*sin4*cos(phi4)
      PE(2,4) = p4*sin4*sin(phi4)
      PE(3,4) = pz
      PE(4,4) = ee
   
      call rotmtx(pbstcl, rl2c)
      call minvr2(rl2c, rc2l)
      call mvmult(rc2l,pe(1,4), pe(1,4))
 
      PE(1,5) =  -pe(1,3)-pe(1,4)
      PE(2,5) =  -pe(2,3)-pe(2,4)
      PE(3,5) =  -pe(3,3)-pe(3,4)
      PE(4,5) = w-pe(4,3)-pe(4,4)
      else
* Z-axis -> P1 or P2 ****************
      E5      = (Q2+AMASS2(5)-AMASS2(4))/2.D0/SQRT(Q2)
      PE(1,4) = p4*sin4*cos(phi4)
      PE(2,4) = p4*sin4*sin(phi4)
      PE(3,4) = p4*cos4
      PE(4,4) = e4
      PE(1,5) =-p4*sin4*cos(phi4)
      PE(2,5) =-p4*sin4*sin(phi4)
      PE(3,5) =-p4*cos4
      PE(4,5) = e5
      call ktolab(ppa,pbstcl,pe(1,4),pe(1,5), pe(1,4),pe(1,5)) 
      end if
* cuts in Lab-frame
       ipoint = 6
      cos34 =pe(3,3)*pe(3,4)
     ./SQRT(PE(1,4)**2+PE(2,4)**2+PE(3,4)**2)
     ./SQRT(PE(1,3)**2+PE(2,3)**2+PE(3,3)**2)
      cos35 =pe(3,3)*pe(3,5)
     ./SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
     ./SQRT(PE(1,3)**2+PE(2,3)**2+PE(3,3)**2)
      COS4LB=PE(3,4)/SQRT(PE(1,4)**2+PE(2,4)**2+PE(3,4)**2)
      IF(COS4LB.LT.COSCUT(1,2) .OR. COS4LB.GT.COSCUT(2,2)) GOTO 999
      COS5LB=PE(3,5)/SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
      IF(COS5LB.LT.COSCUT(1,3) .OR. COS5LB.GT.COSCUT(2,3)) GOTO 999
      IF(PE(4,4).LT.ENGYCT(1,2).OR.PE(4,4).GT.ENGYCT(2,2)) GOTO 999
      IF(PE(4,5).LT.ENGYCT(1,3).OR.PE(4,5).GT.ENGYCT(2,3)) GOTO 999
 
*Set invariants
      PP(1,1) = AMASS2(1)
      PP(1,2) = (S-AMASS2(1)-AMASS2(2))/2.D0
      PP(1,3) = d13
      PP(1,4) = PE(4,1)*PE(4,4)-PE(3,1)*PE(3,4)
      PP(1,5) = PE(4,1)*PE(4,5)-PE(3,1)*PE(3,5)
      if(icos4.le.-1 .and. cos3.le.0) then
      PP(1,4) = d14
      PP(1,5) = d15
      end if
 
      PP(2,1) = PP(1,2)
      PP(2,2) = AMASS2(2)
      PP(2,3) = d23
      PP(2,4) = PE(4,2)*PE(4,4)-PE(3,2)*PE(3,4)
      PP(2,5) = PE(4,2)*PE(4,5)-PE(3,2)*PE(3,5)
 
      PP(3,1) = PP(1,3)
      PP(3,2) = PP(2,3)
      PP(3,3) = AMASS2(3)
      pp(3,4) = (amass2(5)-amass2(4)-amass2(3)+s)/2.d0
     .-pp(1,5)-pp(2,5)
      pp(3,5) = (amass2(4)-amass2(5)-amass2(3)+s)/2.d0
     .-pp(1,4)-pp(2,4)
 
      PP(4,1) = PP(1,4)
      PP(4,2) = PP(2,4)
      PP(4,3) = PP(3,4)
      PP(4,4) = AMASS2(4)
      PP(4,5) = (Q2-AMASS2(4)-AMASS2(5))/2.D0
 
      PP(5,1) = PP(1,5)
      PP(5,2) = PP(2,5)
      PP(5,3) = PP(3,5)
      PP(5,4) = PP(4,5)
      PP(5,5) = AMASS2(5)
 
*Set jacobian
      YACOB=FACT*AJACOB
     ./(2*PI)/(32*PI2)/(32*PI2)
     .*BETA(Q2       /S ,AMASS2(3)/S )
     .*BETA(AMASS2(4)/Q2,AMASS2(5)/Q2)

c     write(6,*)' P1 ',(pe(k,1),k=1,4)
c     write(6,*)' P2 ',(pe(k,2),k=1,4)
c     write(6,*)' P3 ',(pe(k,3),k=1,4)
c     write(6,*)' P4 ',(pe(k,4),k=1,4)
c     write(6,*)' P5 ',(pe(k,5),k=1,4)
c     write(6,*)' Pk1 ',(pk1(k),k=1,4)
c     write(6,*)' Pk2 ',(pk2(k),k=1,4)
c     write(6,*)'E init  ',pe(4,1)+pe(4,2)
c     write(6,*)'E final ',pe(4,3)+pe(4,4)+pe(4,5)
c     write(6,*)'Px ',pe(1,3)+pe(1,4)+pe(1,5)
c     write(6,*)'Py ',pe(2,3)+pe(2,4)+pe(2,5)
c     write(6,*)'Pz ',pe(3,3)+pe(3,4)+pe(3,5)
c     write(6,*)' mass3 in  ',amass2(3)
c     write(6,*)' mass4 in  ',amass2(4)
c     write(6,*)' mass5 in  ',amass2(5)
c     write(6,*)' mass45 in  ',q2
c     write(6,*)' mass3 out '
c    .,(pe(4,3)-pe(3,3))*(pe(4,3)+pe(3,3))-pe(1,3)**2-pe(2,3)**2
c     write(6,*)' mass4 out '
c    .,(pe(4,4)-pe(3,4))*(pe(4,4)+pe(3,4))-pe(1,4)**2-pe(2,4)**2
c     write(6,*)' mass5 out '
c    .,(pe(4,5)-pe(3,5))*(pe(4,5)+pe(3,5))-pe(1,5)**2-pe(2,5)**2
c     write(6,*)' mass45 out '
c    .,(pe(4,4)+pe(4,5))**2-(pe(3,4)+pe(3,5))**2
c    .                     -(pe(2,4)+pe(2,5))**2
c    .                     -(pe(1,4)+pe(1,5))**2
c     write(6,*)' test1 ',amass2(3)+amass2(2)-2*pp(2,3)
c     write(6,*)' test2 ',amass2(1)+q2-2*pp(1,4)-2*PP(1,5)
      RETURN
999   CONTINUE
      JUMP=1
      YACOB=0
c     write(6,*)' point ',ipoint
      RETURN
      END
      SUBROUTINE KINEMP(IREG)
      IMPLICIT REAL* 8(A-H,O-Z)
      RETURN
      END
