C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 2403
C   Date      : 2002.07.26
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      SUBROUTINE KINEM(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
      IMPLICIT REAL* 8(A-H,O-Z)
*
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 100 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.h'
      data icntl/5/
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS3,icos4,ifrad
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,4),ENGYCT(2,4),AMASCT(2),ARESNS(2,2)
*--------------------------------------------------------------------
      if     (ifrad.eq.1) then
       call  KINEMi(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
      else if(ifrad.eq.2) then
       call  KINEMf(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
      else if(ifrad.eq.3) then
       x3=x(icntl)
       if(x3.lt.0.5d0) then
        x(icntl)=x3*2
        call  KINEMi(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
        yacob=yacob*2
        x(icntl)=x3
       else
        x(icntl)=2-x3*2
        call  KINEMf(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
        yacob=yacob*2
        x(icntl)=x3
       end if
      end if
      q2_45=amass2(4)+amass2(5)+2*pp(4,5)
      if(abs(sqrt(q2_45)-amw).lt.0.01d0) then
       jump=1
       yacob=0
      end if
c     q2_456=amass2(4)+amass2(5)+amass2(6)+2*pp(4,5)+2*pp(5,6)
c    .      +2*pp(6,4)
c     if(abs(sqrt(q2_456)-amw).lt.0.01d0) then
c      jump=1
c      yacob=0
c     end if
*
      return
      end
      SUBROUTINE KINEMi(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 4203-i
C   Date      : 1995.01.07
C   Last update : 1995.02.20   Y.Kurihara
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 100 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.h'
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS3,icos4,ifrad
      COMMON/KINEM1/S0,W0,FACT
      COMMON/CUT001/COSCUT(2,4),ENGYCT(2,4),AMASCT(2),ARESNS(2,2)
      DIMENSION PBSTCL(4),rl2c(3,3),rc2l(3,3),ppa(4),pk1(4),pk2(4)
      real*8 pbeam(4)
c     real*16 aaaa,bbbb,abdb,xi,ea,pa,y,teta
      real*8 aaaa,bbbb,abdb,xi,ea,pa,y,teta
*-----------------------------------------------------------------------
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* Set integration variables
*************
* ENERGY1   *
*************
       E1   = (S0+AMASS2(1)-AMASS2(2))/2.D0/W0
       P1   = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
       E2   = (S0+AMASS2(2)-AMASS2(1))/2.D0/W0
       P2   = P1
************
* PHIa     *
************
      IF(NDIM.EQ.8) THEN
       PHIa=X(8)*2*PI
      ELSE
       PHIa=0
      END IF
                 AJACOB = AJACOB*2*PI
************
* PHI3     *
************
       PHI3=X(6)*2*PI+phia
                 AJACOB = AJACOB*2*PI
************
* Ea       *
************
        e3min=max(amass1(6),ENGYCT(1,4))
        E3MAX=MIN(ENGYCT(2,4)
     . ,(S0+AMASS2(6)-(AMASS1(3)+AMASS1(4)+AMASS1(5))**2)/2.D0/W0)
       Ea=E3MIN*(E3MAX/E3MIN)**X(7)
                 AJACOB = AJACOB*Ea*log(E3max/E3min)*2.D0*W0
       Pa   = SQRT( (Ea-AMASS1(6))*(Ea+AMASS1(6)) )
       q2r=s0+amass2(6)-2*w0*ea
*************
* C0S(the3) *
*************
       if(amass1(6).gt.1.d-8) then
        aaaa = 2*(ea*amass2(1)/(e1+p1)+p1*amass2(6)/(ea+pa))
        bbbb = 2*p1*pa
        XI   = (aaaa+2*bbbb)/aaaa
        ABDB = (aaaa+bbbb)/bbbb
       else
        XI   = (E1+P1)/AMASS1(1)
        ABDB = 1+AMASS2(1)/P1/(E1+P1)
       end if
       TEMAX= (ABDB+COSCUT(2,4))/(ABDB-COSCUT(2,4))
       TEMIN= (ABDB+COSCUT(1,4))/(ABDB-COSCUT(1,4))
       YMAX = (LOG(TEMAX)/LOG(XI)+2)/4.D0
       YMIN = (LOG(TEMIN)/LOG(XI)+2)/4.D0
       if(coscut(1,4).lt.-1.d0+1.d-10)ymin=0
       if(coscut(2,4).gt. 1.d0-1.d-10)ymax=1
       Y    = YMIN+(YMAX-YMIN)*X(5)
                 AJACOB = AJACOB*(YMAX-YMIN)
       TETA = XI**(4*Y-2)
       COSa = ABDB*(TETA-1)/(TETA+1)
       IF(ABS(COSa).GT.1) COSa=SIGN(1.D0,COSa)
       SINa = SQRT( (1-COSa)*(1+COSa) )
       D1   = 4*Ea*E1/(TETA+1)
       D2   = TETA*D1
       D13  = 4   *E1/(TETA+1)
       D23  = TETA*D13
                 AJACOB = AJACOB*LOG(XI)/2.D0/E1/P1
     .*                   D13*D23
     .*                   (ea/pa)**2
      ajacob=ajacob/(2.d0*pi)
     ./(32*pi2)
     .*beta(q2r/s0,amass2(6)/s0)

      s = q2r
      w = sqrt(s)

      pe(1,6)= pa*sina*cos(phia)
      pe(2,6)= pa*sina*sin(phia)
      pe(3,6)= pa*cosa
      pe(4,6)= ea

      pbeam(1)=-pe(1,6)
      pbeam(2)=-pe(2,6)
      pbeam(3)=-pe(3,6)
      pbeam(4)=w0-ea
*************
* Q2        *
*************
      Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
      Q2MAX=MIN(S+AMASS2(3)-2.d0*W*ENGYCT(1,1), AMASCT(2)**2)
      IF(Q2MIN.GE.Q2MAX) GOTO 999
      IF     (IRESNS.EQ. 0) THEN
       Q2  = Q2MIN+(Q2MAX-Q2MIN)*X(4)
                 AJACOB = AJACOB*(Q2MAX-Q2MIN)
      ELSE IF(IRESNS.EQ. 3) THEN
        e3min=(s+amass2(3)-q2max)/2.d0/w
        e3max=(s+amass2(3)-q2min)/2.d0/w
        e3=e3min*(e3max/e3min)**x(4)
                 ajacob = ajacob*e3*log(e3max/e3min)*2.d0*w
        q2=s+amass2(3)-2.d0*w*e3
      ELSE IF(IRESNS.EQ. 4) THEN
       if(x(4).lt.0.5d0) then
        x4=x(4)*2.d0
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,1)+aresns(2,1)*3)**2)
        if(q2max.lt.q2min) goto 999
        AM    = ARESNS(1,1)
        AM2   =AM*AM
        AMG   =ARESNS(1,1)*ARESNS(2,1)
        THEMIN=ATAN((Q2MIN-AM2)/AMG)
        THEMAX=ATAN((Q2MAX-AM2)/AMG)
        THE   =THEMIN+(THEMAX-THEMIN)*X4
        Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG*2
       else
        x4=2.d0-x(4)*2.d0
        q2min=max((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,1)+aresns(2,1)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        if(q2max.lt.q2min) goto 999
        e3min=(s+amass2(3)-q2max)/2.d0/w
        e3max=(s+amass2(3)-q2min)/2.d0/w
        e3=e3min*(e3max/e3min)**x4
                 ajacob = ajacob*e3*log(e3max/e3min)*4.d0*w
        q2=s+amass2(3)-2.d0*w*e3
       end if
      ELSE IF(IRESNS.EQ.-3) THEN
       if(q2min.le.0) goto 999
       Q2  = Q2MIN*(Q2MAX/Q2MIN)**X(4)
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)
      ELSE IF(IRESNS.EQ. 1) THEN
       AM    = ARESNS(1,1)
       AM2   =AM*AM
       AMG   =ARESNS(1,1)*ARESNS(2,1)
       THEMIN=ATAN((Q2MIN-AM2)/AMG)
       THEMAX=ATAN((Q2MAX-AM2)/AMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X(4)
       Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG
      ELSE IF(IRESNS.EQ.-1) THEN
       if(x(4).lt.0.5d0) then
        x4=X(4)*2.d0
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        if(q2max.lt.q2min) goto 999
        if(q2min.le.0) goto 999
        Q2  = Q2MIN*(Q2MAX/Q2MIN)**X4
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)*2
       else
        x4=2.d0-X(4)*2.d0
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        if(q2max.lt.q2min) goto 999
        AM    = ARESNS(1,1)
        AM2   =AM*AM
        AMG   =ARESNS(1,1)*ARESNS(2,1)
        THEMIN=ATAN((Q2MIN-AM2)/AMG)
        THEMAX=ATAN((Q2MAX-AM2)/AMG)
        THE   =THEMIN+(THEMAX-THEMIN)*X4
        Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG*2
       end if
      ELSE IF(IRESNS.EQ. 2) THEN
       if(x(4).lt.0.5d0) then
        x4=x(4)*2
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        ir=1
       else
        x4=2-X(4)*2
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        ir=2
       end if
       if(q2min.gt.q2max) goto 999
       AM    = ARESNS(1,ir)
       AM2   =AM*AM
       AMG   =ARESNS(1,ir)*ARESNS(2,ir)
       THEMIN=ATAN((Q2MIN-AM2)/AMG)
       THEMAX=ATAN((Q2MAX-AM2)/AMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X4
       Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG
     .*2
      ELSE IF(IRESNS.EQ.-2) THEN
       if(x(4).lt.1.d0/3.d0) then
        x4=x(4)*3 
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        if(q2max.lt.q2min) goto 999
        if(q2min.le.0) goto 999
        Q2  = Q2MIN*(Q2MAX/Q2MIN)**X4
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)*3
       else
       if(x(4).lt.2.d0/3.d0) then
        x4=x(4)*3-1 
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        ir=1
       else
        x4=3-X(4)*3
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        ir=2
       end if
       if(q2min.gt.q2max) goto 999
       AM    = ARESNS(1,ir)
       AM2   =AM*AM
       AMG   =ARESNS(1,ir)*ARESNS(2,ir)
       THEMIN=ATAN((Q2MIN-AM2)/AMG)
       THEMAX=ATAN((Q2MAX-AM2)/AMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X4
       Q2    =AMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+AMG**2)/AMG
     .*3
       end if
      ELSE
       GOTO 999
      END IF
*************
* ENERGY3   *
*************
       ipoint = 2
       E3   = (S+AMASS2(3)-Q2)/2.D0/W
       IF(E3.GT.ENGYCT(2,1)) GOTO 999
       IF(E3.LT.ENGYCT(1,1)) GOTO 999
       P3   = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )
       if(p3.le.1.d-10) goto 999
*************
* C0S(the3) *
*************
       ipoint = 4
      IF     (ICOS3.EQ.0) THEN
* no-singularity *************************************************
       COS3=COSCUT(1,1) + (COSCUT(2,1)-COSCUT(1,1))*X(3)
       SIN3=SQRT( (1-COS3)*(1+COS3) )
                 AJACOB = AJACOB*(COSCUT(2,1)-COSCUT(1,1))
       eta=1.d0-cos3
       d13=e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3
       eta=1.d0+cos3
       d23=amass2(2)*p3/(e2+p2)+amass2(3)*p2/(e3+p3)
     .+amass2(2)/(e2+p2)*amass2(3)/(e3+p3)+eta*p2*p3
      ELSE IF(ICOS3.EQ.1) THEN
* 1/t ************************************************************  
       eta=1.d0-coscut(2,1)
       d13min=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
       eta=1.d0-coscut(1,1)
       d13max=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
       if(d13min.gt.d13max) goto 999
       if(d13min.le.0     ) goto 999
       d13=d13min*(d13max/d13min)**x(3)
		 ajacob=ajacob*d13*log(d13max/d13min)/p1/p3/2.d0
       d13=(d13+amass2(3)+amass2(1))/2.d0
       pppp=e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)-d13
       cos3=1.d0+pppp/p1/p3
       sin3=sqrt(-(1.d0+cos3)*pppp/p1/p3)
       eta=1.d0+cos3
       d23=amass2(2)*p3/(e2+p2)+amass2(3)*p2/(e3+p3)
     .+amass2(2)/(e2+p2)*amass2(3)/(e3+p3)+eta*p2*p3
      ELSE IF(ICOS3.EQ.2) THEN
* 1/t+1/u ********************************************************  
* 1/t *****
       if(x(3).lt.0.5d0) then
        x3=x(3)*2.d0
        eta=1.d0-coscut(2,1)
        d13min=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
        eta=1.d0-max(0.d0,coscut(1,1))
        d13max=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
       if(d13min.gt.d13max) goto 999
       if(d13min.le.0     ) goto 999
       d13=d13min*(d13max/d13min)**x3
		 ajacob=ajacob*d13*log(d13max/d13min)/p1/p3
       d13=(d13+amass2(3)+amass2(1))/2.d0
       pppp=e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)-d13
       cos3=1.d0+pppp/p1/p3
       sin3=sqrt(-(1.d0+cos3)*pppp/p1/p3)
       eta=1.d0+cos3
       d23=amass2(2)*p3/(e2+p2)+amass2(3)*p2/(e3+p3)
     .+amass2(2)/(e2+p2)*amass2(3)/(e3+p3)+eta*p2*p3
       else
* 1/u *****
        x3=2.d0-x(3)*2.d0
        eta=1.d0+coscut(1,1)
        d23min=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)
        eta=1.d0+min(0.d0,coscut(2,1))
        d23max=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)
       if(d23min.gt.d23max) goto 999
       if(d23min.le.0     ) goto 999
       d23=d23min*(d23max/d23min)**x3
 	 ajacob=ajacob*d23*log(d23max/d23min)/p2/p3
       d23=(d23+amass2(3)+amass2(2))/2.d0
       pppp=e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)-d23
       cos3=-1.d0-pppp/p2/p3
       sin3=sqrt(-(1.d0-cos3)*pppp/p2/p3)
       eta=1.d0-cos3
       d13=amass2(1)*p3/(e1+p1)+amass2(3)*p1/(e3+p3)
     .+amass2(1)/(e1+p1)*amass2(3)/(e3+p3)+eta*p1*p3
       end if
      ELSE IF(ICOS3.EQ.-1) THEN
* 1/u *****
        eta=1.d0+coscut(1,1)
        d23min=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)
        eta=1.d0+coscut(2,1)
        d23max=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)
       if(d23min.gt.d23max) goto 999
       if(d23min.le.0     ) goto 999
       d23=d23min*(d23max/d23min)**x(3)
 	 ajacob=ajacob*d23*log(d23max/d23min)/p2/p3/2.d0
       d23=(d23+amass2(3)+amass2(2))/2.d0
       pppp=e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)-d23
       cos3=-1.d0-pppp/p2/p3
       sin3=sqrt(-(1.d0-cos3)*pppp/p2/p3)
       eta=1.d0-cos3
       d13=amass2(1)*p3/(e1+p1)+amass2(3)*p1/(e3+p3)
     .+amass2(1)/(e1+p1)*amass2(3)/(e3+p3)+eta*p1*p3
      ELSE
       GOTO 999
      END IF
      if(abs(cos3).gt.1) goto 999
************************
* PHI4 in 4-5 CM frame *
************************
      PHI4=X(2)*2*PI+PHI3
                 AJACOB = AJACOB*2*PI
* set 4-vector 
*Particle 1
      PE(1,1) = 0
      PE(2,1) = 0
      PE(3,1) = P1
      PE(4,1) = E1
 
*Particle 2
      PE(1,2) = 0
      PE(2,2) = 0
      PE(3,2) =-P2
      PE(4,2) = E2
 
*Particle 3
      PE(1,3) = P3*SIN3*COS(PHI3)
      PE(2,3) = P3*SIN3*SIN(PHI3)
      PE(3,3) = P3*COS3
      PE(4,3) = E3
 
* boost from 4-5 CM frame to 1-2 CM frame (Lab-frame)
      PBSTCL(1)=-PE(1,3)
      PBSTCL(2)=-PE(2,3)
      PBSTCL(3)=-PE(3,3)
      PBSTCL(4)= SQRT(P3*P3+Q2)

************************
* COS4 in 4-5 CM frame *
************************
      ipoint = 5
      ppa(1)=pe(1,1)
      ppa(2)=pe(2,1)
      ppa(3)=pe(3,1)
      ppa(4)=pe(4,1)
      call labtok(ppa,pbstcl,pe(1,1),pe(1,2), pk1,pk2)
      ee4=(q2+amass2(4)-amass2(5))/2.d0/sqrt(q2)
      pp4=sqrt( (ee4-amass1(4))*(ee4+amass1(4)) )
      ee5=(q2+amass2(5)-amass2(4))/2.d0/sqrt(q2)
      pp5=pp4
      if(pp4.eq.0) goto 999
      if(icos4.eq.0) then
       COS4=-1+2*X(1)
                 AJACOB = AJACOB*2
      else if(icos4.ge. 1) then
       eps=2*amass2(4)/q2
       ymin=-log( 1.d0+2.d0/eps )/2
       ymax= log( 1.d0+2.d0/eps )/2
       y=ymin+(ymax-ymin)*x(1)
       cos4=(1+eps)*tanh(y)
                 ajacob=ajacob*(ymax-ymin)/cosh(y)**2*(1+eps)
      else if(icos4.eq.-1) then
       eps = 0
        ee1=pk1(4) 
        pp1=sqrt( (ee1-amass1(1))*(ee1+amass1(1)) )
	if(pp1.eq.0) goto 999
        eta=0
        d14min=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1)
       if(d14min.le.0) then
        eps=1.d-6
        d14min=0.d0+eps
       end if
        eta=2.d0
        d14max=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1) + eps
        d14=d14min*(d14max/d14min)**x(1)
                  ajacob=ajacob*d14*log(d14max/d14min)/pp1/pp4/2.d0
        d14=(d14-eps+amass2(4)+amass2(1))/2.d0
        cos4=ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)-d14
        cos4= 1.d0+cos4/pp1/pp4
        eta=1.d0+cos4
        d15=ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5
      else if(icos4.eq.-2) then
       eps = 0
       if(x(1).lt.0.5d0) then
       x1=x(1)*2.d0
        ee1=pk1(4) 
        pp1=sqrt( (ee1-amass1(1))*(ee1+amass1(1)) )
	if(pp1.eq.0) goto 999
        eta=0
        d14min=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1)
       if(d14min.le.0) then
        eps=1.d-6
        d14min=0.d0+eps
       end if
        eta=1.d0
        d14max=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1)+eps
        d14=d14min*(d14max/d14min)**x1
                  ajacob=ajacob*d14*log(d14max/d14min)/pp1/pp4
        d14=(d14-eps+amass2(4)+amass2(1))/2.d0
        cos4=ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)-d14
        cos4= 1.d0+cos4/pp1/pp4
        eta=1.d0+cos4
        d15=ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5
       else
       x1=2.d0-x(1)*2.d0
        ee1=pk1(4) 
        pp1=sqrt( (ee1-amass1(1))*(ee1+amass1(1)) )
	if(pp1.eq.0) goto 999
        eta=0
        d15min=2*(ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5)-amass2(5)-amass2(1)
       if(d15min.le.0) then
        eps=1.d-6
        d15min=0.d0+eps
       end if
        eta=1.d0
        d15max=2*(ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5)-amass2(5)-amass2(1)+eps
        d15=d15min*(d15max/d15min)**x1
                  ajacob=ajacob*d15*log(d15max/d15min)/pp1/pp5
        d15=(d15-eps+amass2(5)+amass2(1))/2.d0
        cos5=ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)-d15
        cos5= 1.d0+cos5/pp1/pp5
        eta=1.d0+cos5
        d14=ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4
        cos4=-cos5
       end if
      ELSE
       GOTO 999
      END IF
      if(abs(cos4).gt.1) goto 999
      SIN4=SQRT( (1-COS4)*(1+COS4) )
 
* Set four-vectors
*Particle 4 
      E4      = (Q2+AMASS2(4)-AMASS2(5))/2.D0/SQRT(Q2)
      P4      = SQRT( (E4-AMASS1(4))*(E4+AMASS1(4)) )
      if(icos4.ge.0) then
c     if(icos4.gt.0) then
* Z-axis -> -P3 *********************
      ee  = (s+q2-amass2(3))/2.d0/w
      bet = 1.d0/(1.d0+q2/p3/(ee+p3))
      gam = ee/sqrt(q2)
      ee  = gam*(    amass2(4)/(e4+p4)+p4*(1.d0+bet*cos4))
      pz  = gam*(bet*amass2(4)/(e4+p4)+p4*(bet +    cos4))
      PE(1,4) = p4*sin4*cos(phi4)
      PE(2,4) = p4*sin4*sin(phi4)
      PE(3,4) = pz
      PE(4,4) = ee
   
      call rotmtx(pbstcl, rl2c)
      call minvr2(rl2c, rc2l)
      call mvmult(rc2l,pe(1,4), pe(1,4))
 
      PE(1,5) =  -pe(1,3)-pe(1,4)
      PE(2,5) =  -pe(2,3)-pe(2,4)
      PE(3,5) =  -pe(3,3)-pe(3,4)
      PE(4,5) = w-pe(4,3)-pe(4,4)
      else
* Z-axis -> P1 or P2 ****************
      E5      = (Q2+AMASS2(5)-AMASS2(4))/2.D0/SQRT(Q2)
      PE(1,4) = p4*sin4*cos(phi4)
      PE(2,4) = p4*sin4*sin(phi4)
      PE(3,4) = p4*cos4
      PE(4,4) = e4
      PE(1,5) =-p4*sin4*cos(phi4)
      PE(2,5) =-p4*sin4*sin(phi4)
      PE(3,5) =-p4*cos4
      PE(4,5) = e5
      call ktolab(ppa,pbstcl,pe(1,4),pe(1,5), pe(1,4),pe(1,5)) 
      end if
      if(pbeam(3).ne.0) then
        CALL PBOOST(PE(1,3),PBEAM, PE(1,3))
        CALL PBOOST(PE(1,4),PBEAM, PE(1,4))
        CALL PBOOST(PE(1,5),PBEAM, PE(1,5))
      end if

* cuts in Lab-frame
       ipoint = 6
      COS4LB=PE(3,4)/SQRT(PE(1,4)**2+PE(2,4)**2+PE(3,4)**2)
      IF(COS4LB.LT.COSCUT(1,2) .OR. COS4LB.GT.COSCUT(2,2)) GOTO 999
      COS5LB=PE(3,5)/SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
      IF(COS5LB.LT.COSCUT(1,3) .OR. COS5LB.GT.COSCUT(2,3)) GOTO 999
      IF(PE(4,4).LT.ENGYCT(1,2).OR.PE(4,4).GT.ENGYCT(2,2)) GOTO 999
      IF(PE(4,5).LT.ENGYCT(1,3).OR.PE(4,5).GT.ENGYCT(2,3)) GOTO 999
 
*Set invariants
      DO 2 I1=1,6
      DO 2 I2=1,6
       PP(I1,I2)=PE(4,I1)*PE(4,I2)
     .-          PE(3,I1)*PE(3,I2)
     .-          PE(1,I1)*PE(1,I2)
     .-          PE(2,I1)*PE(2,I2)
2     continue
      PP(1,2) = (S0-AMASS2(1)-AMASS2(2))/2.D0
      PP(1,6) = d1/2.d0
      PP(6,1) = d1/2.d0
      PP(2,6) = d2/2.d0
      PP(6,2) = d2/2.d0
      PP(4,5) = (Q2-AMASS2(4)-AMASS2(5))/2.D0
 
      if(ifrad.eq.3) then
      do 5 i5=3,4
       if(pp(i5,6).lt.min(pp(1,6),pp(2,6))) goto 999
5     continue
      end if

*Set jacobian
      YACOB=FACT*AJACOB
     ./(2*PI)/(32*PI2)/(32*PI2)
     .*BETA(Q2       /S ,AMASS2(3)/S )
     .*BETA(AMASS2(4)/Q2,AMASS2(5)/Q2)

c********** DEBUG **********************************
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(4E13.4/))')PE
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(6E13.4/))')PP
c     do 1 i1=1,6
c     do 1 j1=1,6
c1      pp(i1,j1)=pe(4,i1)*pe(4,j1)
c    .-          pe(3,i1)*pe(3,j1)
c    .-          pe(1,i1)*pe(1,j1)
c    .-          pe(2,i1)*pe(2,j1)
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(6E13.4/))')PP
c     WRITE(6,*)' YACOB ',YACOB
c     WRITE(6,*)' TOTAL ENERGY INI   ',PE(4,1)+PE(4,2)
c     WRITE(6,*)' TOTAL ENERGY FINAL ',PE(4,3)+PE(4,4)
c    .+                                PE(4,5)+PE(4,6)
c     WRITE(6,'(6E13.4)')(SQRT(abs(PP(KKK,KKK))),KKK=1,6)
c     WRITE(6,*)' INITIAL '
c     WRITE(6,*)' PX ',PE(1,1)+PE(1,2)
c     WRITE(6,*)' PY ',PE(2,1)+PE(2,2)
c     WRITE(6,*)' PZ ',PE(3,1)+PE(3,2)
c     WRITE(6,*)' FINAL   '
c     WRITE(6,*)' PX ',PE(1,3)+PE(1,4)+PE(1,5)+PE(1,6)
c     WRITE(6,*)' PY ',PE(2,3)+PE(2,4)+PE(2,5)+PE(2,6)
c     WRITE(6,*)' PZ ',PE(3,6)+PE(3,5)+PE(3,3)+PE(3,4)
c********** DEBUG **********************************
      RETURN
999   CONTINUE
      JUMP=1
      YACOB=0
c     write(6,*)' point ',ipoint
      RETURN
      END
*---------------------------------------------------------------------
      SUBROUTINE KINEMf(NEXTRN,X,PE,PP,YACOB,NREG,IREG,JUMP)
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 4203-f
C   Date      : 1996.08.29
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
      IMPLICIT REAL* 8(A-H,O-Z)
************************************************************************
      INTEGER NEXTRN
      PARAMETER ( MXDIM = 100 )
 
      COMMON / BASE1 / XL(MXDIM),XU(MXDIM),NDIM
      REAL*8  X(MXDIM)
      REAL*8  PE(4,NEXTRN), PP(NEXTRN,NEXTRN)
      REAL*8  YACOB
c     real*16 eps,ymin,ymax,y,q2pa,q2pamx,q2pamn
c     real*16 egmin,egmax,eg,gam,ea,bet,eq,pq,umbet
      real*8 eps,ymin,ymax,y,q2pa,q2pamx,q2pamn
      real*8 egmin,egmax,eg,gam,ea,bet,eq,pq,umbet
     .,upcosa,ezg,cosa,sina
      INTEGER NREG, IREG
      INTEGER JUMP
 
      INCLUDE 'inclk.h'
*--------------------------------------------------------------------
      COMMON/KMCNTL/IRESNS,ICOS3,icos4,ifrad
      COMMON/KINEM1/S,W,FACT
      COMMON/CUT001/COSCUT(2,4),ENGYCT(2,4),AMASCT(2),ARESNS(2,2)
      DIMENSION PBSTCL(4),rl2c(3,3),rc2l(3,3),ppa(4),pk1(4),pk2(4)
     .,pk3(4)
* BETA FUNCTION
c      BETA(Z1,Z2)=SQRT(1-2*(Z1+Z2)+(Z1-Z2)**2)
*-----------------------------------------------------------------------
      NREG   =   1
      JUMP   =   0
      YACOB  =   0.D0
      AJACOB=    1
* Set integration variables
*************
* ENERGY1,2 *
*************
       E1   = (S+AMASS2(1)-AMASS2(2))/2.D0/W
       P1   = SQRT( (E1-AMASS1(1))*(E1+AMASS1(1)) )
       E2   = (S+AMASS2(2)-AMASS2(1))/2.D0/W
       P2   = P1
************
* PHI3     *
************
      IF(NDIM.EQ.8) THEN
       PHI3=X(8)*2*PI
      ELSE
       PHI3=0
      END IF
                 AJACOB = AJACOB*2*PI
* who emmits a photon

      if     (x(5).lt.0.5d0) then
       x5=x(5)*2.d0
       ia=3
      else
       x5=x(5)*2.d0-1.d0
       ia=4
      end if
                     ajacob = ajacob*2.d0
c     x5=x(5)
c     ia=4

      amtmp1=amass1(ia)
      amtmp2=amass2(ia)

**********
* q2(pa) *
**********
      q2pamx=(w-amass1(3)-amass1(4)-amass1(5)+amass1(ia))**2
      q2pamn=(amass1(ia)+amass1(6))**2
      if(q2pamx.lt.q2pamn) goto 999
      if(q2pamn.le.0) goto 999
c     q2pa=q2pamn*(q2pamx/q2pamn)**x5
c     ajacob=ajacob*q2pa*log(q2pamx/q2pamn)
**************************************
ccc       EPS=q2pamn/s*1.d-8
          if(ia.eq.3) then
c          EPS=1.q-8
           q2pa=q2pamn+(q2pamx-q2pamn)*x5
                  AJACOB=AJACOB*(q2pamx-q2pamn)
          else if(ia.eq.4) then
           EPS=1.d-12
c          EPS=1.q-10
          YMIN= 0
          YMAX= LOG( 1.d0+2.d0/EPS )/2
          Y=YMIN+(YMAX-YMIN)*x5
          q2pa=q2pamx-(1+EPS)*TANH(Y)*(q2pamx-q2pamn)
                  AJACOB=AJACOB*(YMAX-YMIN)/COSH(Y)**2*(1+EPS)
     .                         *(q2pamx-q2pamn)
          end if
**************************************

      dq2pa=q2pa 
      ajacob=ajacob/(2.d0*pi)
     ./(32*pi2)
     .*beta(amass2(ia)/dq2pa,amass2(6)/dq2pa)

      amass1(ia)=sqrt(q2pa)
      amass2(ia)=     q2pa

********
* phia *
********
      phia=2*pi*x(6)+phi3
      ajacob=ajacob*2*pi

*************
* Q2        *
*************
      ipoint = 1
      Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
      Q2MAX=MIN(S+AMASS2(3)-2.d0*W*ENGYCT(1,1), AMASCT(2)**2)
      IF(Q2MIN.GE.Q2MAX) GOTO 999
      IF     (IRESNS.EQ. 0) THEN
       Q2  = Q2MIN+(Q2MAX-Q2MIN)*X(4)
                 AJACOB = AJACOB*(Q2MAX-Q2MIN)
      ELSE IF(IRESNS.EQ. 3) THEN
        e3min=(s+amass2(3)-q2max)/2.d0/w
        e3max=(s+amass2(3)-q2min)/2.d0/w
        e3=e3min*(e3max/e3min)**x(4)
                 ajacob = ajacob*e3*log(e3max/e3min)*2.d0*w
        q2=s+amass2(3)-2.d0*w*e3
      ELSE IF(IRESNS.EQ. 4) THEN
       if(x(4).lt.0.5d0) then
        x4=x(4)*2.d0
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,1)+aresns(2,1)*3)**2)
        if(q2max.lt.q2min) goto 999
        AM    = ARESNS(1,1)
        AM2   =AM*AM
        zMG   =ARESNS(1,1)*ARESNS(2,1)
        THEMIN=ATAN((Q2MIN-AM2)/zMG)
        THEMAX=ATAN((Q2MAX-AM2)/zMG)
        THE   =THEMIN+(THEMAX-THEMIN)*X4
        Q2    =zMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+zMG**2)/zMG*2
       else
        x4=2.d0-x(4)*2.d0
        q2min=max((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,1)+aresns(2,1)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        if(q2max.lt.q2min) goto 999
        e3min=(s+amass2(3)-q2max)/2.d0/w
        e3max=(s+amass2(3)-q2min)/2.d0/w
        e3=e3min*(e3max/e3min)**x4
                 ajacob = ajacob*e3*log(e3max/e3min)*4.d0*w
        q2=s+amass2(3)-2.d0*w*e3
       end if
      ELSE IF(IRESNS.EQ.-3) THEN
       if(q2min.le.0) goto 999
       Q2  = Q2MIN*(Q2MAX/Q2MIN)**X(4)
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)
      ELSE IF(IRESNS.EQ. 1) THEN
       AM    = ARESNS(1,1)
       AM2   =AM*AM
       zMG   =ARESNS(1,1)*ARESNS(2,1)
       THEMIN=ATAN((Q2MIN-AM2)/zMG)
       THEMAX=ATAN((Q2MAX-AM2)/zMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X(4)
       Q2    =zMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+zMG**2)/zMG
      ELSE IF(IRESNS.EQ.-1) THEN
       if(x(4).lt.0.5d0) then
        x4=X(4)*2.d0
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        if(q2max.lt.q2min) goto 999
        if(q2min.le.0) goto 999
        Q2  = Q2MIN*(Q2MAX/Q2MIN)**X4
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)*2
       else
        x4=2.d0-X(4)*2.d0
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        if(q2max.lt.q2min) goto 999
        AM    = ARESNS(1,1)
        AM2   =AM*AM
        zMG   =ARESNS(1,1)*ARESNS(2,1)
        THEMIN=ATAN((Q2MIN-AM2)/zMG)
        THEMAX=ATAN((Q2MAX-AM2)/zMG)
        THE   =THEMIN+(THEMAX-THEMIN)*X4
        Q2    =zMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+zMG**2)/zMG*2
       end if
      ELSE IF(IRESNS.EQ. 2) THEN
       if(x(4).lt.0.5d0) then
        x4=x(4)*2
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        ir=1
       else
        x4=2-X(4)*2
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        ir=2
       end if
       if(q2min.gt.q2max) goto 999
       AM    = ARESNS(1,ir)
       AM2   =AM*AM
       zMG   =ARESNS(1,ir)*ARESNS(2,ir)
       THEMIN=ATAN((Q2MIN-AM2)/zMG)
       THEMAX=ATAN((Q2MAX-AM2)/zMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X4
       Q2    =zMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+zMG**2)/zMG
     .*2
      ELSE IF(IRESNS.EQ.-2) THEN
       if(x(4).lt.1.d0/3.d0) then
        x4=x(4)*3 
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        if(q2max.lt.q2min) goto 999
        if(q2min.le.0) goto 999
        Q2  = Q2MIN*(Q2MAX/Q2MIN)**X4
                 AJACOB = AJACOB*Q2*LOG(Q2MAX/Q2MIN)*3
       else
       if(x(4).lt.2.d0/3.d0) then
        x4=x(4)*3-1 
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,1)-aresns(2,1)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        ir=1
       else
        x4=3-X(4)*3
        Q2MIN=MAX((AMASS1(4)+AMASS1(5))**2   , AMASCT(1)**2
     .,          (aresns(1,2)-aresns(2,2)*3)**2)
        Q2MAX=MIN(S+AMASS2(3)-2*W*ENGYCT(1,1), AMASCT(2)**2)
        ir=2
       end if
       if(q2min.gt.q2max) goto 999
       AM    = ARESNS(1,ir)
       AM2   =AM*AM
       zMG   =ARESNS(1,ir)*ARESNS(2,ir)
       THEMIN=ATAN((Q2MIN-AM2)/zMG)
       THEMAX=ATAN((Q2MAX-AM2)/zMG)
       THE   =THEMIN+(THEMAX-THEMIN)*X4
       Q2    =zMG*TAN(THE)+AM2
                 AJACOB=AJACOB*(THEMAX-THEMIN)
     .*                 ((Q2-AM2)**2+zMG**2)/zMG
     .*3
       end if
      ELSE
       GOTO 999
      END IF
*************
* ENERGY3   *
*************
       ipoint = 2
       E3   = (S+AMASS2(3)-Q2)/2.D0/W
       IF(E3.GT.ENGYCT(2,1)) GOTO 999
       IF(E3.LT.ENGYCT(1,1)) GOTO 999
       IF(E3.LT.AMASS1(3)  ) GOTO 999
       P3   = SQRT( (E3-AMASS1(3))*(E3+AMASS1(3)) )
       if(p3.le.1.d-10) goto 999
*************
* C0S(the3) *
*************
       ipoint = 4
      IF     (ICOS3.EQ.0) THEN
* no-singularity *************************************************
       COS3=COSCUT(1,1) + (COSCUT(2,1)-COSCUT(1,1))*X(3)
       SIN3=SQRT( (1-COS3)*(1+COS3) )
                 AJACOB = AJACOB*(COSCUT(2,1)-COSCUT(1,1))
       eta=1.d0-cos3
       d13=e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3
       eta=1.d0+cos3
       d23=amass2(2)*p3/(e2+p2)+amass2(3)*p2/(e3+p3)
     .+amass2(2)/(e2+p2)*amass2(3)/(e3+p3)+eta*p2*p3
      ELSE IF(ICOS3.EQ.1) THEN
* 1/t ************************************************************  
       eta=1.d0-coscut(2,1)
       d13min=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
       eta=1.d0-coscut(1,1)
       d13max=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
       if(d13min.gt.d13max) goto 999
       if(d13min.le.0     ) goto 999
       d13=d13min*(d13max/d13min)**x(3)
		 ajacob=ajacob*d13*log(d13max/d13min)/p1/p3/2.d0
       d13=(d13+amass2(3)+amass2(1))/2.d0
       pppp=e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)-d13
       cos3=1.d0+pppp/p1/p3
       sin3=sqrt(-(1.d0+cos3)*pppp/p1/p3)
       eta=1.d0+cos3
       d23=amass2(2)*p3/(e2+p2)+amass2(3)*p2/(e3+p3)
     .+amass2(2)/(e2+p2)*amass2(3)/(e3+p3)+eta*p2*p3
      ELSE IF(ICOS3.EQ.2) THEN
* 1/t+1/u ********************************************************  
* 1/t *****
       if(x(3).lt.0.5d0) then
        x3=x(3)*2.d0
        eta=1.d0-coscut(2,1)
        d13min=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
        eta=1.d0-max(0.d0,coscut(1,1))
        d13max=2*(e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)
     .+eta*p1*p3)-amass2(3)-amass2(1)
       if(d13min.gt.d13max) goto 999
       if(d13min.le.0     ) goto 999
       d13=d13min*(d13max/d13min)**x3
		 ajacob=ajacob*d13*log(d13max/d13min)/p1/p3
       d13=(d13+amass2(3)+amass2(1))/2.d0
       pppp=e1*amass2(3)/(e3+p3)+p3*amass2(1)/(e1+p1)-d13
       cos3=1.d0+pppp/p1/p3
       sin3=sqrt(-(1.d0+cos3)*pppp/p1/p3)
       eta=1.d0+cos3
       d23=amass2(2)*p3/(e2+p2)+amass2(3)*p2/(e3+p3)
     .+amass2(2)/(e2+p2)*amass2(3)/(e3+p3)+eta*p2*p3
       else
* 1/u *****
        x3=2.d0-x(3)*2.d0
        eta=1.d0+coscut(1,1)
        d23min=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)
        eta=1.d0+min(0.d0,coscut(2,1))
        d23max=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)
       if(d23min.gt.d23max) goto 999
       if(d23min.le.0     ) goto 999
       d23=d23min*(d23max/d23min)**x3
 	 ajacob=ajacob*d23*log(d23max/d23min)/p2/p3
       d23=(d23+amass2(3)+amass2(2))/2.d0
       pppp=e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)-d23
       cos3=-1.d0-pppp/p2/p3
       sin3=sqrt(-(1.d0-cos3)*pppp/p2/p3)
       eta=1.d0-cos3
       d13=amass2(1)*p3/(e1+p1)+amass2(3)*p1/(e3+p3)
     .+amass2(1)/(e1+p1)*amass2(3)/(e3+p3)+eta*p1*p3
       end if
      ELSE IF(ICOS3.EQ.-1) THEN
* 1/u *****
        eta=1.d0+coscut(1,1)
        d23min=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)
        eta=1.d0+coscut(2,1)
        d23max=2*(e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)
     .+eta*p2*p3)-amass2(3)-amass2(2)
       if(d23min.gt.d23max) goto 999
       if(d23min.le.0     ) goto 999
       d23=d23min*(d23max/d23min)**x(3)
 	 ajacob=ajacob*d23*log(d23max/d23min)/p2/p3/2.d0
       d23=(d23+amass2(3)+amass2(2))/2.d0
       pppp=e2*amass2(3)/(e3+p3)+p3*amass2(2)/(e2+p2)-d23
       cos3=-1.d0-pppp/p2/p3
       sin3=sqrt(-(1.d0-cos3)*pppp/p2/p3)
       eta=1.d0-cos3
       d13=amass2(1)*p3/(e1+p1)+amass2(3)*p1/(e3+p3)
     .+amass2(1)/(e1+p1)*amass2(3)/(e3+p3)+eta*p1*p3
      ELSE
       GOTO 999
      END IF
      if(abs(cos3).gt.1) goto 999
************************
* PHI4 in 4-5 CM frame *
************************
      PHI4=X(2)*2*PI+PHI3
                 AJACOB = AJACOB*2*PI
* set 4-vector 
*Particle 1
      PE(1,1) = 0
      PE(2,1) = 0
      PE(3,1) = P1
      PE(4,1) = E1
 
*Particle 2
      PE(1,2) = 0
      PE(2,2) = 0
      PE(3,2) =-P2
      PE(4,2) = E2
 
*Particle 3
      PE(1,3) = P3*SIN3*COS(PHI3)
      PE(2,3) = P3*SIN3*SIN(PHI3)
      PE(3,3) = P3*COS3
      PE(4,3) = E3
 
* boost from 4-5 CM frame to 1-2 CM frame (Lab-frame)
      PBSTCL(1)=-PE(1,3)
      PBSTCL(2)=-PE(2,3)
      PBSTCL(3)=-PE(3,3)
      PBSTCL(4)= SQRT(P3*P3+Q2)

************************
* COS4 in 4-5 CM frame *
************************
      ipoint = 5
      ppa(1)=pe(1,1)
      ppa(2)=pe(2,1)
      ppa(3)=pe(3,1)
      ppa(4)=pe(4,1)
      call labtok(ppa,pbstcl,pe(1,1),pe(1,2), pk1,pk2)
      ee4=(q2+amass2(4)-amass2(5))/2.d0/sqrt(q2)
      pp4=sqrt( (ee4-amass1(4))*(ee4+amass1(4)) )
      ee5=(q2+amass2(5)-amass2(4))/2.d0/sqrt(q2)
      pp5=pp4
      if(pp4.eq.0) goto 999
      ipoint = 6
      if(icos4.eq.0) then
       COS4=-1+2*X(1)
                 AJACOB = AJACOB*2
      else if(icos4.ge. 1) then
       eps=2*amass2(4)/q2
       ymin=-log( 1.d0+2.d0/eps )/2
       ymax= log( 1.d0+2.d0/eps )/2
       y=ymin+(ymax-ymin)*x(1)
       cos4=(1+eps)*tanh(y)
                 ajacob=ajacob*(ymax-ymin)/cosh(y)**2*(1+eps)
      else if(icos4.eq.-1) then
       eps = 0
        ee1=pk1(4) 
        pp1=sqrt( (ee1-amass1(1))*(ee1+amass1(1)) )
	if(pp1.eq.0) goto 999
        eta=0
        d14min=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1)
       if(d14min.le.0) then
        eps=1.d-6
        d14min=0.d0+eps
       end if
        eta=2.d0
        d14max=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1) + eps
        d14=d14min*(d14max/d14min)**x(1)
                  ajacob=ajacob*d14*log(d14max/d14min)/pp1/pp4/2.d0
        d14=(d14-eps+amass2(4)+amass2(1))/2.d0
        cos4=ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)-d14
        cos4= 1.d0+cos4/pp1/pp4
        eta=1.d0+cos4
        d15=ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5
      else if(icos4.eq.-2) then
       eps = 0
       if(x(1).lt.0.5d0) then
       x1=x(1)*2.d0
        ee1=pk1(4) 
        pp1=sqrt( (ee1-amass1(1))*(ee1+amass1(1)) )
	if(pp1.eq.0) goto 999
        eta=0
        d14min=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1)
       if(d14min.le.0) then
        eps=1.d-6
        d14min=0.d0+eps
       end if
        eta=1.d0
        d14max=2*(ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4)-amass2(4)-amass2(1)+eps
        d14=d14min*(d14max/d14min)**x1
                  ajacob=ajacob*d14*log(d14max/d14min)/pp1/pp4
        d14=(d14-eps+amass2(4)+amass2(1))/2.d0
        cos4=ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)-d14
        cos4= 1.d0+cos4/pp1/pp4
        eta=1.d0+cos4
        d15=ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5
       else
       x1=2.d0-x(1)*2.d0
        ee1=pk1(4) 
        pp1=sqrt( (ee1-amass1(1))*(ee1+amass1(1)) )
	if(pp1.eq.0) goto 999
        eta=0
        d15min=2*(ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5)-amass2(5)-amass2(1)
       if(d15min.le.0) then
        eps=1.d-6
        d15min=0.d0+eps
       end if
        eta=1.d0
        d15max=2*(ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp5)-amass2(5)-amass2(1)+eps
        d15=d15min*(d15max/d15min)**x1
                  ajacob=ajacob*d15*log(d15max/d15min)/pp1/pp5
        d15=(d15-eps+amass2(5)+amass2(1))/2.d0
        cos5=ee1*amass2(5)/(ee5+pp5)+pp5*amass2(1)/(ee1+pp1)-d15
        cos5= 1.d0+cos5/pp1/pp5
        eta=1.d0+cos5
        d14=ee1*amass2(4)/(ee4+pp4)+pp4*amass2(1)/(ee1+pp1)
     .+eta*pp1*pp4
        cos4=-cos5
       end if
      ELSE
       GOTO 999
      END IF
      ipoint = 7
      if(abs(cos4).gt.1) goto 999
      SIN4=SQRT( (1-COS4)*(1+COS4) )
 
* Set four-vectors
*Particle 4 
      E4      = (Q2+AMASS2(4)-AMASS2(5))/2.D0/SQRT(Q2)
      P4      = SQRT( (E4-AMASS1(4))*(E4+AMASS1(4)) )
      if(icos4.ge.0) then
c     if(icos4.gt.0) then
* Z-axis -> -P3 *********************
      ee  = (s+q2-amass2(3))/2.d0/w
      bet = 1.d0/(1.d0+q2/p3/(ee+p3))
      gam = ee/sqrt(q2)
      ee  = gam*(    amass2(4)/(e4+p4)+p4*(1.d0+bet*cos4))
      pz  = gam*(bet*amass2(4)/(e4+p4)+p4*(bet +    cos4))
      PE(1,4) = p4*sin4*cos(phi4)
      PE(2,4) = p4*sin4*sin(phi4)
      PE(3,4) = pz
      PE(4,4) = ee
   
      call rotmtx(pbstcl, rl2c)
      call minvr2(rl2c, rc2l)
      call mvmult(rc2l,pe(1,4), pe(1,4))
 
      PE(1,5) =  -pe(1,3)-pe(1,4)
      PE(2,5) =  -pe(2,3)-pe(2,4)
      PE(3,5) =  -pe(3,3)-pe(3,4)
      PE(4,5) = w-pe(4,3)-pe(4,4)
      else
* Z-axis -> P1 or P2 ****************
      E5      = (Q2+AMASS2(5)-AMASS2(4))/2.D0/SQRT(Q2)
      PE(1,4) = p4*sin4*cos(phi4)
      PE(2,4) = p4*sin4*sin(phi4)
      PE(3,4) = p4*cos4
      PE(4,4) = e4
      PE(1,5) =-p4*sin4*cos(phi4)
      PE(2,5) =-p4*sin4*sin(phi4)
      PE(3,5) =-p4*cos4
      PE(4,5) = e5
      call ktolab(ppa,pbstcl,pe(1,4),pe(1,5), pe(1,4),pe(1,5)) 
      end if
 
*Set invariants
      PP(1,1) = AMASS2(1)
      PP(1,2) = (S-AMASS2(1)-AMASS2(2))/2.D0
      PP(1,3) = d13
      PP(1,4) = PE(4,1)*PE(4,4)-PE(3,1)*PE(3,4)
      PP(1,5) = PE(4,1)*PE(4,5)-PE(3,1)*PE(3,5)
      if(icos4.le.-1 .and. cos3.le.0) then
      PP(1,4) = d14
      PP(1,5) = d15
      end if
 
      PP(2,1) = PP(1,2)
      PP(2,2) = AMASS2(2)
      PP(2,3) = d23
      PP(2,4) = PE(4,2)*PE(4,4)-PE(3,2)*PE(3,4)
      PP(2,5) = PE(4,2)*PE(4,5)-PE(3,2)*PE(3,5)
 
      PP(3,1) = PP(1,3)
      PP(3,2) = PP(2,3)
      PP(3,3) = AMASS2(3)
      pp(3,4) = (amass2(5)-amass2(4)-amass2(3)+s)/2.d0
     .-pp(1,5)-pp(2,5)
      pp(3,5) = (amass2(4)-amass2(5)-amass2(3)+s)/2.d0
     .-pp(1,4)-pp(2,4)
 
      PP(4,1) = PP(1,4)
      PP(4,2) = PP(2,4)
      PP(4,3) = PP(3,4)
      PP(4,4) = AMASS2(4)
      PP(4,5) = (Q2-AMASS2(4)-AMASS2(5))/2.D0
 
      PP(5,1) = PP(1,5)
      PP(5,2) = PP(2,5)
      PP(5,3) = PP(3,5)
      PP(5,4) = PP(4,5)
      PP(5,5) = AMASS2(5)
 
* set 4-momentum of a photon and his mother

      ea  = (q2pa+amass2(6)-amtmp2)/2.d0/sqrt(q2pa)
      eq  = pe(4,ia)
      pq  = sqrt( (eq-sqrt(q2pa))*(eq+sqrt(q2pa)) )
      bet = 1.d0/(1.d0+q2pa/pq/(eq+pq))
      umbet=q2pa/eq/(eq+pq)
      gam = eq/sqrt(q2pa)


********
* cosa *
********
      ipoint = 8
      egmin=max((engyct(1,4)),gam*ea*umbet)
      egmax=min((engyct(2,4)),gam*ea*(1.d0+bet))
      if(egmin.gt.egmax) goto 999
      if(egmin.le.0.d0) goto 999
      eg   = egmin*(egmax/egmin)**x(7)
      ajacob=ajacob*eg*log(egmax/egmin)/gam/ea/bet
c*************************************
c         EPS=1.d-15
c         YMIN= 0
c         YMAX= LOG( 1.D0+2.D0/EPS )/2
c         Y=YMIN+(YMAX-YMIN)*x(7)
c         eg=egmax-(1+EPS)*TANH(Y)*(egmax-egmin)
c                 AJACOB=AJACOB*(YMAX-YMIN)/COSH(Y)**2*(1+EPS)
c    .                         *(egmax-egmin)/gam/ea/bet
**************************************

      upcosa=eg/gam/ea/bet-umbet/bet
      egz  = gam*ea*(upcosa-umbet)
      cosa=(upcosa-umbet)/(umbet+bet*upcosa)
      if(abs(cosa).gt.1) goto 999
      sina=sqrt( (1.d0-cosa)*(1.d0+cosa) )

      pk3(1)=pe(1,ia)
      pk3(2)=pe(2,ia)
      pk3(3)=pe(3,ia)
      pk3(4)=pe(4,ia)

      PE(1,6) = eg*sina*cos(phia)
      PE(2,6) = eg*sina*sin(phia)
      PE(3,6) = egz
      PE(4,6) = eg

      call rotmtx(pk3, rl2c)
      call minvr2(rl2c, rc2l)
      call mvmult(rc2l,pe(1,6), pe(1,6))

      pe(1,ia)=0.d0
      pe(2,ia)=0.d0
      pe(3,ia)=0.d0
      pe(4,ia)=0.d0
      PE(1,ia) = -pe(1,3)-pe(1,4)
     .           -pe(1,5)-pe(1,6)
      PE(2,ia) = -pe(2,3)-pe(2,4)
     .           -pe(2,5)-pe(2,6)
      PE(3,ia) = -pe(3,3)-pe(3,4)
     .           -pe(3,5)-pe(3,6)
      PE(4,ia) =w-pe(4,3)-pe(4,4)
     .           -pe(4,5)-pe(4,6)

      DO 2 I1=1,5
       PP(I1, 6)=PE(4,I1)*PE(4, 6)
     .-          PE(3,I1)*PE(3, 6)
     .-          PE(1,I1)*PE(1, 6)
     .-          PE(2,I1)*PE(2, 6)
       PP( 6,I1)=pp(i1,6)
2     continue

      do 3 i1=1,5
       pp(i1,ia)=pp(i1,ia)-pp(i1,6)
       pp(ia,i1)=pp(i1,ia)
3     continue
      pp(6,ia)=(q2pa-amtmp2-amass2(6))/2.d0
      pp(ia,6)=(q2pa-amtmp2-amass2(6))/2.d0

      do 4 i1=1,6
       pp(i1,i1)=amass2(i1)
 4    continue
      pp(ia,ia)=amtmp2

      ist = 3
      if(ifrad.eq.3)ist=1
      do 5 i5=ist,4
       if(i5.eq.ia) goto 5
       if(pp(i5,6).lt.pp(ia,6)) goto 999
5     continue

* cuts in Lab-frame
       ipoint = 9
c     cos34 =pe(3,3)*pe(3,4)
c    ./SQRT(PE(1,4)**2+PE(2,4)**2+PE(3,4)**2)
c    ./SQRT(PE(1,3)**2+PE(2,3)**2+PE(3,3)**2)
c     cos35 =pe(3,3)*pe(3,5)
c    ./SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
c    ./SQRT(PE(1,3)**2+PE(2,3)**2+PE(3,3)**2)
      COS4LB=PE(3,4)/SQRT(PE(1,4)**2+PE(2,4)**2+PE(3,4)**2)
      IF(COS4LB.LT.COSCUT(1,2) .OR. COS4LB.GT.COSCUT(2,2)) GOTO 999
      COS5LB=PE(3,5)/SQRT(PE(1,5)**2+PE(2,5)**2+PE(3,5)**2)
      IF(COS5LB.LT.COSCUT(1,3) .OR. COS5LB.GT.COSCUT(2,3)) GOTO 999
      COS6LB=PE(3,6)/SQRT(PE(1,6)**2+PE(2,6)**2+PE(3,6)**2)
      IF(COS6LB.LT.COSCUT(1,4) .OR. COS6LB.GT.COSCUT(2,4)) GOTO 999

      IF(PE(4,4).LT.ENGYCT(1,2).OR.PE(4,4).GT.ENGYCT(2,2)) GOTO 999
      IF(PE(4,5).LT.ENGYCT(1,3).OR.PE(4,5).GT.ENGYCT(2,3)) GOTO 999

*Set jacobian

      YACOB=FACT*AJACOB
     ./(2*PI)/(32*PI2)/(32*PI2)
     .*BETA(Q2       /S ,AMASS2(3)/S )
     .*BETA(AMASS2(4)/Q2,AMASS2(5)/Q2)


      amass1(ia)=amtmp1
      amass2(ia)=amtmp2

c********** DEBUG **********************************
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(4E13.4/))')PE
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(6E13.4/))')PP
c     do 1 i1=1,6
c     do 1 j1=1,6
c1      pp(i1,j1)=pe(4,i1)*pe(4,j1)
c    .-          pe(3,i1)*pe(3,j1)
c    .-          pe(1,i1)*pe(1,j1)
c    .-          pe(2,i1)*pe(2,j1)
c     WRITE(6,*)'*****************************'
c     WRITE(6,'(6(6E13.4/))')PP
c     WRITE(6,*)' YACOB ',YACOB
c     WRITE(6,*)' TOTAL ENERGY INI   ',PE(4,1)+PE(4,2)
c     WRITE(6,*)' TOTAL ENERGY FINAL ',PE(4,3)+PE(4,4)
c    .+                                PE(4,5)+PE(4,6)
c     WRITE(6,'(6E13.4)')(SQRT(abs(PP(KKK,KKK))),KKK=1,6)
c     WRITE(6,*)' INITIAL '
c     WRITE(6,*)' PX ',PE(1,1)+PE(1,2)
c     WRITE(6,*)' PY ',PE(2,1)+PE(2,2)
c     WRITE(6,*)' PZ ',PE(3,1)+PE(3,2)
c     WRITE(6,*)' FINAL   '
c     WRITE(6,*)' PX ',PE(1,3)+PE(1,4)+PE(1,5)+PE(1,6)
c     WRITE(6,*)' PY ',PE(2,3)+PE(2,4)+PE(2,5)+PE(2,6)
c     WRITE(6,*)' PZ ',PE(3,6)+PE(3,5)+PE(3,3)+PE(3,4)
c********** DEBUG **********************************

      RETURN
999   CONTINUE
      JUMP=1
      YACOB=0
c     write(6,*)' point ',ipoint
      amass1(ia)=amtmp1
      amass2(ia)=amtmp2
      RETURN
      END
*-----------------------------------------------------------------------
      function beta(z1,z2)
      implicit real* 8(a-h,o-z)
      if(1-2*(z1+z2)+(z1-z2)**2.lt.0)then
       beta = 0
      else
       beta=sqrt(1-2*(z1+z2)+(z1-z2)**2)
      end if
      return
      end
      SUBROUTINE KINEMP(IREG)
      RETURN
      END

