#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

/***********************************************************************
*                                                                      *
*                Libarary for character string                         *
*                                                                      *
************************************************************************
								      */
                                                                      /*
************************************************************************
*                ============================                         */
                  void strcntr( s, t, mxpt )
/*               ============================
************************************************************************
* (Function )                                                          *
* To copy the string t[] to s[] at the center between 0 and mxpt       *
*                                                                      *
************************************************************************
                                                                      */
char s[], t[];
int mxpt;
{
int  strlength( ) ;
void stcopy   ( ) ;

int n, m, leng ;

  leng = strlength( t ) ;
  n    = ( mxpt - leng ) / 2 ;
  if( n > 0 )
      { for( m = 0 ; m < mxpt ; m++ )
	     s[m] = ' ' ;
        stcopy( s, t, n, n+leng ) ;
	s[mxpt] = '\n' ;
      }
  else
      { stcopy( s, t, 0, leng ) ;
	s[leng+1] = '\n' ;
      }
}
                                                                      /*
************************************************************************
*                ==============================                       *
                 int strset( char *s, char *t )
 *               ==============================
************************************************************************
* ( Function )                                                         *
*   To copy the string t[] to s[]                                      *
*                                                                      *
************************************************************************
                                                                      *
{
 int i, leng ;
 int strlength( ) ;

 leng = strlength( t ) ;
 for( i = 0 ; i <= leng ; i++ )
      s[i] = t[i] ;
 s[leng+1] = '\0' ;
 return leng ;
}
*/
                                                                      /*
************************************************************************
*                ==============================                       */
                  void clearbuff(  s,  leng )
/*               ==============================
************************************************************************
* ( Function )                                                         *
*    To fill all characters by space and set '\0' at the end           *
*                                                                      *
************************************************************************
                                                                      */
char s[];
int leng;
{
  s[leng] = '\0' ;
  while( --leng >= 0 )
	 s[leng] = ' ' ;
}

                                                                      /*
************************************************************************
*             =====================================                   */
               void strcopy(  s, t,  begin,  end )
/*            =====================================
************************************************************************
* ( Function )                                                         *
*   To copy string between begin and end of t[] to s[]                 *
*                                                                      *
************************************************************************
                                                                      */
char s[], t[];
int begin, end;
{
    int i, j ;

    for( i = begin, j = 0 ; i <= end ; i++, j++ )
         s[j] = t[i] ;
  s[j] = '\0' ;
}

                                                                      /*
************************************************************************
*             =====================================                   */
                 void stcopy( s, t, begin, end )
/*            =====================================
************************************************************************
* ( Function )                                                         *
*   To copy string between begin and end of t[] to s[]                 *
*              between from begin to end of s[]                        *
*                                                                      *
************************************************************************
                                                                      */
char *s, *t;
int begin, end;
{
    int i, j ;

    for( i = begin, j = 0 ; i <= end ; i++, j++ )
       s[i] = t[j] ;
}

                                                                      /*
************************************************************************
*             =====================================                   */
                       int strlength( s )
/*            =====================================
************************************************************************
* ( Function )                                                         *
*   To get the real length of the sring                                *
*                                                                      *
************************************************************************
                                                                      */
char *s;
{
  int i ;

  for( i = 0 ; *s != '\n' && *s != '\0' ; i++, s++ )
       ;
  return i-1 ;
}

                                                                      /*
************************************************************************
*             =====================================                   */
               int strnext( s,  begin, direction )
/*            =====================================
************************************************************************
* ( Function )                                                         *
*   To find non-blank char in the string                               *
*                                                                      *
************************************************************************
                                                                      */
char s[];
int begin, direction;
{
  int i, j, k ;
 
  if( direction >= 1 )
    {
      for( i = begin ; isspace( s[i] ) ; i++ )
         { 
	   if( s[i] == '\0' )
	       return -1 ;
         }
    }
  else
    {
      for( i = begin ; isspace( s[i] ) ; i-- )
         { 
	   if( i == 0 )
	       return -1 ;
         }
    }
  return i ;
}

                                                                      /*
************************************************************************
*             =====================================                   */
                 int strindex( s, t, begin )
/*            =====================================
************************************************************************
* ( Function )                                                         *
*   To find the string t[] in the string s[]                           *
*                                                                      *
************************************************************************
                                                                      */
char s[], t[];
int begin;
{
  int i, j, k ;
 
  for( i = begin ; s[i] != '\0' ; i++ )
     { for( j = i, k = 0 ; t[k] != '\0' && s[j] == t[k] ; j++, k++ )
	    ;
       if( k > 0 && t[k] == '\0' )
           return i ;
     }
  return -1 ;
}

                                                                      /*
************************************************************************
*             =====================================                   */
                   int strtoi(  s,  begin )
/*            =====================================
************************************************************************
* ( Function )                                                         *
*   To convert the character to integer                                *
*                                                                      *
************************************************************************
                                                                      */
char s[];
int begin;
{
  int i, n, sign ;

  for( i = begin ; isspace( s[i] ) ; i++ )
     ;
  sign = ( s[i] == '-' ) ? -1 : 1 ;
  if( s[i] == '+' || s[i] == '-' )
      i++ ;
  for( n = 0 ; isdigit( s[i] ) ; i++ )
       n = 10 * n + ( s[i] - '0' ) ;

  return sign*n ;
}

/****************************************************************************
	                   ==================                              */
                             int iabs( i )
/*                         ==================
*****************************************************************************
*( Function )                                                               *
*    return the absolute value of the integer i                             *
*****************************************************************************
                                                                           */
int i;
{
int returnf;

returnf = i;
if( i < 0 ) returnf = -i;

 return returnf;
}

/****************************************************************************
	                   ===================                             */
                             int mode( i, j )
/*                         ===================
*****************************************************************************
*( Function )                                                               *
*    return the mode i of j                                                 *
*****************************************************************************
                                                                           */
int i, j;
{
int n, returnf;

returnf = 0;
if( i > 0 && j > 0 )
  {
    n    = i/j;
    returnf = i - n*j;
   }

 return returnf;
}
