
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <Xm/Form.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/BulletinB.h>
#include <Xm/DrawingA.h>
#include <Xm/MessageB.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>

#include "debug_flag"

/*****************************************************************************
*                                                                            *
*                          Global Variables                                  *
*                                                                            *
******************************************************************************
==============================================================================
         global variables for Feynman diagram layout
==============================================================================
                                                                            */
int no_graph;    /* The number of diagrams analyzed                         */
int graph_no;    /* The graph number of diagrams analyzed                   */
int no_loop;     /* The number of loops in the graph                        */
int First_graph; /* The graph number appeared at the top of page            */
int Nx_graph;    /* Nx_graph*Ny_graph graphs appeared in a page             */
int Ny_graph;    /* Nx_graph*Ny_graph graphs appeared in a page             */
int no_unitary;  /* The number of diagrams in unitary guage                 */
int no_select;   /* The number of selected diagrams                         */
int no_draw;     /* The number of diagrams to be drawn                      */
int no_sunrise, no_self, no_vcor, no_multi;
                                                                            /*
==============================================================================
        global variables for Drawing the diagrams
==============================================================================
                                                                            */
int read_flag;
Widget toplevel, shellf, fm, fmf, da, da1; 
Widget pb0, pb1, pb2, pb3, pb4, pb5, pb6;
Widget pb7, pb8, pb9, pb10, qd, pbb0;
Widget cb1, puld1, cb2, puld2, cb3, puld3, gpb[5], gpbx[3], gpby[2];
Display *d; 
Window  wfm, w0, w1; 
int screen;
int mcolor;
int print_vtx, print_pname, print_graphn, print_final, print_line;
int print_unitary, print_select, select_mode; 
int npage_ps;

char inputfile[100];
                                                                            /*
=============================================================================
         Functions used in main
=============================================================================
                                                                            */
void exitCB(  );
void mesgCB(  );

                                                                            /*
==============================================================================
==============================================================================

/*****************************************************************************
                =========================================                   */
                          main ( argc, argv )
/*              =========================================
******************************************************************************
* (Function )                                                                *
*    A call back routine to display the messages on board.                   *
*****************************************************************************/

int    argc ;
char **argv ;
{
                                                                            /*
---------------------------
    Local Variables
---------------------------
                                                                            */
Display *d1;
Arg     args[12];
extern char *getenv();
int   i, j, width, height, gwidth, gheight, xm, ym;
unsigned long  black, ivory, grey;
XFontStruct *fs;
XmFontList   fl;
char *font_name =
        "-adobe-times-medium-i-normal--12-120-75-75-p-63-iso8859-1";
static char str0[]  = "Quit"; 
static char str1[]  = "Next page",       str2[]  = "Previos page";
static char str3[]  = "+ 5 page",        str4[]  = "- 5 page";
static char str5[]  = "Scale up",        str6[]  = "Scale down";
static char str7[]  = "  Option menu  ", str8[]  = "  Graph menu   ";
static char str9[]  = "Mode selection",  str10[] = "EPS output";
static char str11[] = "Really Quit ?";
static char str12[] = "Yes",             str13[] = "No";
XmString xms0, xms1, xms2, xms3, xms4; 
XmString xms5, xms6, xms7, xms8, xms9;
XmString xms10, xms11, xms12, xms13;
static char stx0[] = "Graph number", stx1[] = "Particle number";
static char stx2[] = "Vertex number";
static char stx3[] = "Particle name", stx4[]= "Covariant Guage";
static char stx5[] = "Unitary Guage", stx6[]= "Selected Graph";
static char stx7[] = "Drawing mode", stx8[]= "Select mode";
static char stx9[] = "Line number";
XmString xgpb0, xgpb1, xgpb2, xgpb3, xgpb4, xgpbx0, xgpbx1, xgpbx2;
XmString xgpby0, xgpby1;
Arg arglist[2];
int n, wid;
char string[40], temp_string[100];
int  wd_border;

XtAppContext   app1;


static char *title[] = {
"**************************************************************************\n",
"*                                                                        *\n",
"*                                                   fff    iii           *\n",
"*        gg                                        ff f              gg  *\n",
"*    gggg    r  rrr      aaa     cccc     eeee     f      iiii   gggg    *\n",
"*   g    gg   rr  r    aa  a    cc cc    ee ee   fffff     i    g    gg  *\n",
"*  g     g    rr      aa   a   cc       ee  ee    ff      ii   g     g   *\n",
"*   ggggg    rr      aa   a    c        eeeee     f       i     ggggg    *\n",
"*       g    r      aa   aa   cc       ee        ff      ii         g    *\n",
"*      gg   rr      aa   aa   cc  cc   ee  ee    ff      ii        gg    *\n",
"* gg  gg   rrrrr     aaaa a    cccc     eeee    ffff   iiiii  gg  gg     *\n",
"*  gggg                                                        gggg      *\n",
"*                   Version 2.21  Date: Jan. '98                         *\n",
"*                                                                        *\n",
"*          Coded by S.Kawabata, KEK Computing Research Center            *\n",
"**************************************************************************\n"
};


int ps_file, type;
                                                                            /*
---------------------------
    Functions
---------------------------
                                                                            */
void  gfinit();
int   gfread();
void  gftree();
void  tree_adjust();
void  gflist();
void  print_vtxtable();
void  print_straight();
void  gfsave    ();
void  gfclose();

void  gfDraw_ps();

void  tgdxOption();
void  tgdxGraphs();
void  tgdxMode();
void  tgdxButton();
void  tgdxinit();
unsigned long MyColor();
                                                                            /*
============================= Entry of gracefig ==============================
                                                                            */
                                                                            /*
******************************************************************************
*                                                                            *
*            Determine the layout of Feyman graphs                           *
*                                                                            *
******************************************************************************
------------------------------------------------------------------------------
     Print Title and Logo of gracefig
------------------------------------------------------------------------------
								            */
 for( i = 0; i < 16; i++ ) printf("%s", title[i] );

 strcpy(inputfile,"out.grf");
 ps_file = 0;
 type    = 1;

#ifndef                                                              DFinput
 for( i = 1; i < argc; i++ )
    {
      strcpy( temp_string, *++argv );

      printf(" %d  [%s]\n", i, temp_string );

      if( temp_string[0] == '-' )
        {
          if( temp_string[1] == 'u' ) type = 1;
          else                        type = 0;
          ps_file = 1;
         }
      else
        {
          strcpy(inputfile, temp_string);
         }
     }
#endif

   printf(" ps_file = %d\n", ps_file );
 no_graph = 0;
 
                                                                            /*
==============================================================================
         Initialization : Read The grneral information of graphs
==============================================================================

 <<<<<<<>>>>>>>                                                             */
   gfinit( );                                                               /*
 <<<<<<<>>>>>>>                                                             */

                                                                            /*
==============================================================================
         Read the information of one graph
==============================================================================

       <<<<<>>>>>                                                           */
 while( gfread( ) == 0 )                                                    /*
       <<<<<>>>>>                                                           */
 {
   if( read_flag == 2 )
     {
#ifdef                                                              DFgraphno
		   printf("\n");
                   printf(" *******************************************\n");
		   printf("   Start GraceFig no =%4d  graph_no =%4d\n", 
			    no_graph, graph_no);
		   printf(" *******************************************\n");
		   printf("\n");
#endif
                 /*
                   gflist( );
                 */
                                                                            /*
==============================================================================
         Remove the loop correction parts from the graph
==============================================================================

           <<<<<>>>>>                                                       */
       if( rm_loop( ) == 0 )                                                /*
           <<<<<>>>>>                                                       */
         {
#ifdef                                                               DFloop
	   printf("\n");
           printf(" **********************************************\n");
           printf("         After rm_Loop\n");
           if( no_loop > 0 )
             {
               printf("  no_loop no_sunrise  no_self  no_vcor no_multi\n");
               printf(" %8d %10d %8d %8d %8d\n",
                        no_loop, no_sunrise, no_self, no_vcor, no_multi );
              }
           printf(" **********************************************\n");
		   printf("\n");
                  /*
                   gflist( );
                  */
#endif
                                                                            /*
==============================================================================
         Draw the skeleton of graph ( no loop )
==============================================================================

         <<<<<<<>>>>>>>                                                     */
           gftree( );                                                       /*
         <<<<<<<>>>>>>>                                                     */

                 /*
		   printf("\n");
                   printf(" ************************************\n");
		   printf("         After gftree\n");
		   printf(" ************************************\n");
		   printf("\n");
                 */
                 /*
                   gflist( );
                 
                   print_vtxtable( -1, 0 );
                 */
                 
                                                                            /*
         <<<<<<<<<>>>>>>>>>                                                 */
           tree_adjust( );                                                  /*
         <<<<<<<<<>>>>>>>>>                                                 */

                  /*
		   printf("\n");
                   printf(" ************************************\n");
		   printf("         After tree_adjust\n");
		   printf(" ************************************\n");
		   printf("\n");
                 /*
                   gflist( );
                   print_straight( -1 );
                 */
                                                                            /*
==============================================================================
          Put the loop correction into the skeleton graph
==============================================================================
                                                                            */
#ifndef                                                              DFskelton
         if( no_loop > 0 )
           {
                                                                            /*
           <<<<<<<>>>>>>>>                                                  */
             put_loop( );                                                   /*
           <<<<<<<>>>>>>>>                                                  */

                  /**
		   printf("\n");
                   printf(" ************************************\n");
		   printf("         After PutLoop\n");
		   printf(" ************************************\n");
		   printf("\n");
                  
                  /*
                   gflist( );
                  */

                                                                            /*
           <<<<<<<>>>>>>>>>>>                                               */
             loop_adjust( );                                                /*
           <<<<<<<>>>>>>>>>>>                                               */

                 /*
		   printf("\n");
                   printf(" ************************************\n");
		   printf("         After loop_adjust\n");
		   printf(" ************************************\n");
		   printf("\n");
                  
                  /*
                   gflist( );
                  
                   exit( 0 );
                  */
           }
#endif
         }
                                                                            /*
==============================================================================
          Save the graph information in a temporary file
==============================================================================

         <<<<<<<<<<<<<>>>>>>>>>>>>                                          */
           gfsave( no_graph-1 );                                            /*
         <<<<<<<<<<<<<>>>>>>>>>>>>                                          */

      }
  }

                                                                            /*
 <<<<<<<>>>>>>>>>                                                           */
   gfclose( );                                                              /*
 <<<<<<<>>>>>>>>>                                                           */

 no_draw = no_unitary;

   /*
    printf(" no_graph = %d no_unitary = %d\n", no_graph, no_unitary );
   */

/**************
   exit( 0 );
**************/
                                                                            /*
******************************************************************************
*                                                                            *
*              Drawing the Feynman Graphs on Display                         *
*                                                                            *
******************************************************************************

==============================================================================
                  Initialization  
==============================================================================
								            */
   First_graph = 0;
   Nx_graph    = 4;
   Ny_graph    = 6;
   for( i = 1; i < 5; i++ )
      {
        j = i*1.5;
        if( no_draw <= i*j )
          {
            Nx_graph = i;
            Ny_graph = j;
            i = 5;
           }
       }
   if( Nx_graph == 1 ) Ny_graph = 2;

   print_final   = 0;
   print_vtx     = 0;
   print_pname   = 1;
   print_line    = 0;
   print_graphn  = 1;
   print_unitary = 1;
   print_select  = 0;
   select_mode   = 0;
   no_select     = 0;
   npage_ps      = 0;
                                                                            /*
==============================================================================
   Draw graphs in eps format in an output file
==============================================================================
                                                                            */
 if( ps_file > 0 )
   {
     if( type == 0 )
       {
         print_unitary = 0;
         no_draw       = no_graph;
        }

     gfDraw_ps( );

     exit(0);
    }
                                                                            /*
==============================================================================
   Create Root window and make XmStrings for labels
==============================================================================

<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> 

 XtToolkitInitialize( );
 app1     = XtCreateApplicationContext( );
 d        = XtOpenDisplay( app1, getenv("DISPLAY"),
                 "gracefig", "GRACEFIG", NULL, 0, &argc, argv );
  
   screen   = DefaultScreen( d );
   mcolor   = DisplayCells( d, screen );
   gwidth   = DisplayWidth( d, 0 ); 
   gheight  = DisplayHeight( d, 0 );
   height = gheight * 5 / 6;
   width  = gheight * 210 / 295;

   i = 0;
   sprintf(string, "%dx%d+%d+0", width, height, gwidth-width-130 );
   printf("%s\n", string);
   XtSetArg( args[i],  XmNgeometry, string ); i++;

 toplevel = XtAppCreateShell( "gracefig", "GRACEFIG", 
                               applicationShellWidgetClass, d, args, i );

   i = 0;
   sprintf(string, "130x%d+%d+0", height, gwidth-130 );
   printf("%s\n", string);
   XtSetArg( args[i],  XmNgeometry, string ); i++;

 shellf   = XtAppCreateShell( "gracefig", "GRACEFIG",
			   topLevelShellWidgetClass, d, args, i );      
                                                                            /*
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */

 toplevel = XtInitialize( "gracefig", "GRACEFIG", 
				   NULL, 0, &argc, argv ); 
   
   d        = XtDisplay( toplevel );
   screen   = DefaultScreen( d );
   mcolor   = DisplayCells( d, screen );
   gwidth   = DisplayWidth( d, 0 ); 
   gheight  = DisplayHeight( d, 0 );
   height = gheight * 5 / 6;
   width  = gheight * 200 / 295;
   wd_border = 11;
 /*
   i = 0;
   sprintf(string, "130x%d+%d+0", height, gwidth-130 );
   XtSetArg( args[i],  XmNgeometry, string ); i++;
  */
 shellf   = XtCreateApplicationShell( NULL, 
			   topLevelShellWidgetClass, NULL, 0 );             
                                                                            /*
<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */


   if( mcolor < 3 )
     {
       ivory  = MyColor("white");
       grey   = MyColor("white");
       black  = MyColor("black");
      }
   else
     {
       ivory  = MyColor("ivory");
       black  = MyColor("black");
       /*
       grey   = MyColor("peru");
       grey   = MyColor("tan");
       grey   = MyColor("RoyalBlue");
       grey   = MyColor("DarkSalmon");
       grey   = MyColor("MediumSeaGreen");
       grey   = MyColor("MistyRose3");
       grey   = MyColor("honeydew4");
       grey   = MyColor("SkyBlue3");
       grey   = MyColor("seashell3");
       grey   = MyColor("SlateGrey");
       grey   = MyColor("DodgerBlue3");
      */
       grey   = MyColor("PeachPuff3");
      }

   fs = XLoadQueryFont( XtDisplay( toplevel ), font_name );
   fl = XmFontListCreate( fs, "charset");
   xms0  = XmStringCreate(  str0, "charset");
   xms1  = XmStringCreate(  str1, "charset");
   xms2  = XmStringCreate(  str2, "charset");
   xms3  = XmStringCreate(  str3, "charset");
   xms4  = XmStringCreate(  str4, "charset");
   xms5  = XmStringCreate(  str5, "charset");
   xms6  = XmStringCreate(  str6, "charset");
   xms7  = XmStringCreate(  str7, "charset");
   xms8  = XmStringCreate(  str8, "charset");
   xms9  = XmStringCreate(  str9, "charset");
   xms10 = XmStringCreate( str10, "charset");
   xms11 = XmStringCreate( str11, "charset");
   xms12 = XmStringCreate( str12, "charset");
   xms13 = XmStringCreate( str13, "charset");
   xgpb0  = XmStringCreate(  stx0, "charset");
   xgpb1  = XmStringCreate(  stx1, "charset");
   xgpb2  = XmStringCreate(  stx2, "charset");
   xgpb3  = XmStringCreate(  stx3, "charset");
   xgpb4  = XmStringCreate(  stx9, "charset");
   xgpbx0  = XmStringCreate(  stx4, "charset");
   xgpbx1  = XmStringCreate(  stx5, "charset");
   xgpbx2  = XmStringCreate(  stx6, "charset");
   xgpby0  = XmStringCreate(  stx7, "charset");
   xgpby1  = XmStringCreate(  stx8, "charset");
                                                                            /*
==============================================================================
   Create form widget fm under the toplevel
==============================================================================
				    				            */
   i = 0;
   xm  = 0;
   ym  = 0;

   XtSetArg( args[i],          XmNx,     xm ); i++;
   XtSetArg( args[i],          XmNy,     ym ); i++;
   XtSetArg( args[i], XmNwidth, width); i++;
   XtSetArg( args[i], XmNheight, height ); i++;
 /*
   sprintf( string, "%dx%d+%d+%d", width, height, xm, ym );
   XtSetArg( args[i],       XmNgeometry,  string ); i++;
 */
   XtSetArg( args[i], XmNforeground, ivory ); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   fm = XmCreateForm( toplevel, "fm", args, i ) ;
   XtManageChild( fm ) ; 
                                                                            /*
==============================================================================
   Create Drawing Area
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNbottomAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNleftAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 5); i++;
   XtSetArg( args[i], XmNbottomOffset, 5); i++;
   XtSetArg( args[i], XmNleftOffset, 5); i++;
   XtSetArg( args[i], XmNrightOffset, 5); i++;
   XtSetArg( args[i], XmNforeground, ivory ); i++;
   XtSetArg( args[i], XmNbackground, grey ); i++;

   da = XmCreateDrawingArea( fm, "da", args, i );
   XtManageChild( da );
                                                                            /*
==============================================================================
   Create form widget fmf under the Shellf
==============================================================================
				    				            */
   i = 0;
   wid   = 120;
   xm    = 0;
   ym    = 0;
   XtSetArg( args[i],          XmNx,     xm ); i++;
   XtSetArg( args[i],          XmNy,     ym ); i++;
   XtSetArg( args[i],      XmNwidth,  wid ); i++;
   XtSetArg( args[i],     XmNheight, height ); i++;
   XtSetArg( args[i], XmNforeground,  ivory ); i++;
   XtSetArg( args[i], XmNbackground,  ivory ); i++;

   fmf= XmCreateForm( shellf, "fmf", args, i ) ;
   XtManageChild( fmf ) ; 
                                                                            /*
==============================================================================
   Create Drawing Area ( for Message board )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNbottomAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 450); i++;
   XtSetArg( args[i], XmNbottomOffset, 5); i++;
   XtSetArg( args[i], XmNrightOffset, 5); i++;
   XtSetArg( args[i], XmNwidth, 110); i++;
   XtSetArg( args[i], XmNforeground, ivory ); i++;
   XtSetArg( args[i], XmNbackground, ivory); i++;

   da1 = XmCreateDrawingArea( fmf, "da1", args, i );
   XtManageChild( da1 );
                                                                            /*
==============================================================================
   Create Push Button for Quit ( pb0 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 10); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms0); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb0 = XmCreatePushButton( fmf, "pb0", args, i ) ;
   XtManageChild( pb0 ) ;
                                                                            /*
------------------------------------------------------------------------------
   Create Question Dialog
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNlabelFontList, fl); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNmessageString, xms11); i++;
   XtSetArg( args[i], XmNokLabelString, xms12); i++;
   XtSetArg( args[i], XmNcancelLabelString, xms13); i++;
   XtSetArg( args[i], XmNmessageAlignment, XmALIGNMENT_CENTER); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   qd  = XmCreateQuestionDialog( toplevel, "qd", args, i );
   XtAddCallback( qd, XmNcancelCallback, mesgCB, NULL );
   XtAddCallback( qd, XmNokCallback, mesgCB, NULL );

   pbb0  = XmMessageBoxGetChild( qd, XmDIALOG_HELP_BUTTON);
   XtUnmanageChild( pbb0 );
                                                                            /*
==============================================================================
   Create Push Button for Next page ( pb1 )
==============================================================================
							   	            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 50); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms1); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb1 = XmCreatePushButton( fmf, "pb1", args, i ) ;
   XtManageChild( pb1 ) ;
                                                                            /*
==============================================================================
   Create Push Button for Previous page ( pb2 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 90); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms2); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb2 = XmCreatePushButton( fmf, "pb2", args, i ) ;
   XtManageChild( pb2 ) ;
                                                                            /*
==============================================================================
   Create Push Button for +5 page ( pb3 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 130); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms3); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb3 = XmCreatePushButton( fmf, "pb3", args, i ) ;
   XtManageChild( pb3 ) ;
                                                                            /*
==============================================================================
   Create Push Button for -5 page ( pb4 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 170); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms4); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb4 = XmCreatePushButton( fmf, "pb4", args, i ) ;
   XtManageChild( pb4 ) ;
                                                                            /*
==============================================================================
   Create Push Button for Scale up ( pb5 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 210); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms5); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb5 = XmCreatePushButton( fmf, "pb5", args, i ) ;
   XtManageChild( pb5 ) ;
                                                                            /*
==============================================================================
   Create Push Button for Scale down ( pb6 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 250); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms6); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb6 = XmCreatePushButton( fmf, "pb6", args, i ) ;
   XtManageChild( pb6 ) ;
                                                                            /*
==============================================================================
   Create  Menue Bar for Option Menu( pb7 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 290); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNforeground, ivory ); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb7 = XmCreateMenuBar( fmf, "pb7", args, i ) ;
   XtManageChild( pb7 ) ;
                                                                            /*
------------------------------------------------------------------------------
   Create  Cascade Button for Option Menu ( cb1 )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms7); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   cb1 = XmCreateCascadeButton( pb7, "cb1", args, i );
   XtManageChild( cb1 ) ;
                                                                            /*
------------------------------------------------------------------------------
   Create Pulldown Menu for Option Menu ( puld1 )
------------------------------------------------------------------------------
								            */
   puld1  = XmCreatePulldownMenu( pb7, "puld1", NULL, 0 );
   XtSetArg( args[0], XmNsubMenuId, puld1 );
   XtSetValues( cb1, args, 1 );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "graph number" flag ( gpb[0] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpb0); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpb[0] = XmCreatePushButtonGadget( puld1, "gpb0", args, i ) ;
   XtAddCallback( gpb[0], XmNactivateCallback, tgdxOption, "Graphno" );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "particle number" flag ( gpb[1] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpb1); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpb[1] = XmCreatePushButtonGadget( puld1, "gpb1", args, i ) ;
   XtAddCallback( gpb[1], XmNactivateCallback, tgdxOption, "Final" );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "vertex number" flag ( gpb[2] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpb2); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpb[2] = XmCreatePushButtonGadget( puld1, "gpb2", args, i ) ;
   XtAddCallback( gpb[2], XmNactivateCallback, tgdxOption, "Vertex" );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "particle name" flag ( gpb[3] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpb3); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpb[3] = XmCreatePushButtonGadget( puld1, "gpb3", args, i ) ;
   XtAddCallback( gpb[3], XmNactivateCallback, tgdxOption, "Particle" );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "Line number" flag ( gpb[4] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpb4); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpb[4] = XmCreatePushButtonGadget( puld1, "gpb4", args, i ) ;
   XtAddCallback( gpb[4], XmNactivateCallback, tgdxOption, "Line" );

   XtManageChildren( gpb, 5 ) ;
                                                                            /*
==============================================================================
   Create  Menue Bar for Graph Menu( pb8 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 330); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb8 = XmCreateMenuBar( fmf, "pb8", args, i ) ;
   XtManageChild( pb8 ) ;
                                                                            /*
------------------------------------------------------------------------------
   Create  Cascade Button for Graph Menu ( cb2 )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms8); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   cb2 = XmCreateCascadeButton( pb8, "cb2", args, i );
   XtManageChild( cb2 ) ;
                                                                            /*
------------------------------------------------------------------------------
   Create Pulldown Menu for Graph Menu ( puld2 )
------------------------------------------------------------------------------
								            */
   puld2  = XmCreatePulldownMenu( pb8, "puld2", NULL, 0 );
   XtSetArg( args[0], XmNsubMenuId, puld2 );
   XtSetValues( cb2, args, 1 );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "Covariant" flag ( gpbx[0] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpbx0); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpbx[0] = XmCreatePushButtonGadget( puld2, "gpbx0", args, i ) ;
   XtAddCallback( gpbx[0], XmNactivateCallback, tgdxGraphs, "Covariant" );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "Unitary" flag ( gpbx[1] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpbx1); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpbx[1] = XmCreatePushButtonGadget( puld2, "gpbx1", args, i ) ;
   XtAddCallback( gpbx[1], XmNactivateCallback, tgdxGraphs, "Unitary" );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "Selected" flag ( gpbx[2] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpbx2); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpbx[2] = XmCreatePushButtonGadget( puld2, "gpbx2", args, i ) ;
   XtAddCallback( gpbx[2], XmNactivateCallback, tgdxGraphs, "Selected" );

   XtManageChildren( gpbx, 3 ) ;
                                                                            /*
==============================================================================
   Create  Menue Bar for Mode Selection ( pb9 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 370); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb9 = XmCreateMenuBar( fmf, "pb9", args, i ) ;
   XtManageChild( pb9 ) ;
                                                                            /*
------------------------------------------------------------------------------
   Create  Cascade Button for Mode Selection ( cb3 )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms9); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   cb3 = XmCreateCascadeButton( pb9, "cb3", args, i );
   XtManageChild( cb3 ) ;
                                                                            /*
------------------------------------------------------------------------------
   Create Pulldown Menu for Mode Selection ( puld3 )
------------------------------------------------------------------------------
								            */
   puld3  = XmCreatePulldownMenu( pb9, "puld3", NULL, 0 );
   XtSetArg( args[0], XmNsubMenuId, puld3 );
   XtSetValues( cb3, args, 1 );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "Drawing Mode" flag ( gpby[0] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpby0); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpby[0] = XmCreatePushButtonGadget( puld3, "gpby0", args, i ) ;
   XtAddCallback( gpby[0], XmNactivateCallback, tgdxMode, "Drawing" );
                                                                            /*
------------------------------------------------------------------------------
   Create Push Button Gadget for "Selecting Mode" flag ( gpby[1] )
------------------------------------------------------------------------------
								            */
   i = 0;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xgpby1); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   gpby[1] = XmCreatePushButtonGadget( puld3, "gpby1", args, i ) ;
   XtAddCallback( gpby[1], XmNactivateCallback, tgdxMode, "Select" );

   XtManageChildren( gpby, 2 ) ;
                                                                            /*
==============================================================================
   Create Push Button for making EPS output ( pb10 )
==============================================================================
								            */
   i = 0;
   XtSetArg( args[i], XmNwidth, 100); i++;
   XtSetArg( args[i], XmNheight, 30 ); i++;
   XtSetArg( args[i], XmNtopAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNrightAttachment, XmATTACH_FORM); i++;
   XtSetArg( args[i], XmNtopOffset, 410); i++;
   XtSetArg( args[i], XmNrightOffset, 10); i++;
   XtSetArg( args[i], XmNshadowThickness, 4); i++;
   XtSetArg( args[i], XmNlabelType, XmSTRING); i++;
   XtSetArg( args[i], XmNfontList, fl); i++;
   XtSetArg( args[i], XmNlabelString, xms10); i++;
   XtSetArg( args[i], XmNforeground, black); i++;
   XtSetArg( args[i], XmNbackground, ivory ); i++;

   pb10 = XmCreatePushButton( fmf, "pb10", args, i ) ;
   XtManageChild( pb10 ) ;
                                                                            /*
==============================================================================
   Make temporary space for character strings free
==============================================================================
								            */
   XmFontListFree( fl );
   XmStringFree( xms0 );
   XmStringFree( xms1 );
   XmStringFree( xms2 );
   XmStringFree( xms3 );
   XmStringFree( xms4 );
   XmStringFree( xms5 );
   XmStringFree( xms6 );
   XmStringFree( xms7 );
   XmStringFree( xms8 );
   XmStringFree( xms9 );
   XmStringFree( xms10 );
   XmStringFree( xms11 );
   XmStringFree( xms12 );
   XmStringFree( xms13 );
   XmStringFree( xgpb0 );
   XmStringFree( xgpb1 );
   XmStringFree( xgpb2 );
   XmStringFree( xgpbx0 );
   XmStringFree( xgpbx1 );
   XmStringFree( xgpbx2 );
   XmStringFree( xgpby0 );
   XmStringFree( xgpby1 );
                                                                            /*
==============================================================================
   Realize widgets
==============================================================================
			  					            */
   i = 0;
 
   sprintf(string, "%dx%d+%d+0", 
	       width, height, gwidth-width-120-4*wd_border );
   XtSetArg( args[i],  XmNgeometry, string ); i++;
 /*
   printf("%s\n", string);
 */
   XtSetValues( toplevel, args, i );

   XtRealizeWidget( toplevel ) ;
 
   i = 0;
   sprintf(string, "120x%d+%d+0", height, gwidth-120 );
   XtSetArg( args[i],  XmNgeometry, string ); i++;
 /*
   printf("%s\n", string);
 */
   XtSetValues( shellf, args, i );

   XtRealizeWidget( shellf ) ;

   wfm = XtWindow( fm );
   w0  = XtWindow( da );
   w1  = XtWindow( da1 );

   tgdxinit( );
                                                                            /*
==============================================================================
   Callback routines
==============================================================================
								            */
   XtAddCallback(  pb0,  XmNactivateCallback, exitCB, qd );

   XtAddCallback(  pb1,  XmNactivateCallback, tgdxButton, NULL );
   XtAddCallback(  pb2,  XmNactivateCallback, tgdxButton, NULL );
   XtAddCallback(  pb3,  XmNactivateCallback, tgdxButton, NULL );
   XtAddCallback(  pb4,  XmNactivateCallback, tgdxButton, NULL );
   XtAddCallback(  pb5,  XmNactivateCallback, tgdxButton, NULL );
   XtAddCallback(  pb6,  XmNactivateCallback, tgdxButton, NULL );
   XtAddCallback( pb10,  XmNactivateCallback, tgdxButton, NULL );

   XtAddCallback(   da,     XmNinputCallback, tgdxButton, NULL );

   XtAddCallback(   da,    XmNexposeCallback, tgdxButton, NULL );

   XtMainLoop () ;

} 
