  
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>

#include "debug_flag"

#define MXLEN  80
#define MXVTX  100
#define MXLINE 100
#define MXGRF  10000
#define MXEXTV 100
  
                                                                      /*
 ===================================================================
     Structure vertex, vtx_line, int_line, inl_vtx
 ===================================================================
                                                                      */
struct vertex {
        int     flag;
        int     cntr_flag;
	char    kind[4];       
	float   x;         
	float   y;   
	int     no_line;   
        }      vtx[MXVTX];

struct vtx_line {
	int   vtxno[10];
        int   lineno[10];
        }     vtxline[MXVTX];

struct int_line {
	int   flag;
	char  kind[4];      
        float x;
        float y;
	int   direct;   
	char  species[4];  
	char  form[4];  
	int   print;  
        }     intline[MXLINE];

struct inl_vtx {
	int   vtxno[2];
	}     inlvtx[MXLINE];
                                                                      /*
 ====================================================================
     Structure sun_rise
 ====================================================================
                                                                      */
int no_sunrise;
struct sun_rise {
        int   line;
	int   edge[2];
        int   vtx;
        int   edge_line[2];
       }      sunrise[3];
                                                                      /*
 ====================================================================
     Structure self_energu
 ====================================================================
                                                                      */
int no_self;
struct self_energy {
	int   edge[2];
        int   selfv[2];
        int   edge_line[2];
        int   self_line[2];
       }      self[3];
                                                                      /*
 ====================================================================
     Structure vertex_correction,
 ====================================================================
                                                                      */
int no_vcor;
struct vertex_correction {
	int   edge[3];
	float edgex[3];
	float edgey[3];
        int   vcorv[3];
        int   edge_line[3];
        int   edge_flag[3];
        int   vcor_line[3];
       }      vtxcor[3];
                                                                      /*
 ====================================================================
     Structure loop_correction,
 ====================================================================
                                                                      */
int no_multi;
struct multiloop_correction {
	int   no_edge;
	int   edge[10];
	float edgex[10];
	float edgey[10];
        int   artv[10];
        int   artv_flag[10]; /*( -1/ 0/ 1)=( in_side/others/ input v )*/
        int   edge_line[10];
        int   edge_flag[10]; /*( 0 / 1 ) = ( others/ fermion ) */
	int   no_vtx;
        int   vtxno[10];
       }      multi[3];
                                                                      /*
=====================================================================
     Structure for keeping original information of graphs
=====================================================================
                                                                      */
int no_loop, cflag[10];
struct keep_vertex {
        int   flag;
        int   no_line;
	int   vtxno[10];
        int   lineno[10];
        }     keepvtx[500];

struct keep_line {
        int   flag;
	int   vtxno[2];
	}     keepline[500];

                                                                      /*
  ----------------------------------
      global variable list
  ----------------------------------
                                                                      */
long addr_graph[5][MXGRF];
                                                                      /*
    addr_graph[0][i] : graph number
    addr_graph[1][i] : pointer of this graph to the temp file
    addr_graph[2][i] : the number of vertecies in the graph
    addr_graph[3][i] : the array size of vtx_no[] and intline_no[]
    addr_graph[4][i] : number of internal and external lines
                                                                      */
int level[2][MXGRF];
int no_graph, graph_no;
int no_initial, no_final;
int nvtx_iniline;            /* The number of vertecies on the initial line */
int nvertex;
int no_vertex, no_line;
float xmax, ymax;
float size[2][MXGRF];                             /* relative size of graph */
int cluster_table[MXEXTV], no_cluster; /* cluster table and no. of clusters */
int vtx_cntr, adj_flag, IR_flag;

int dfnumber[MXEXTV], label[4][MXEXTV], low[MXEXTV], count, artpoint[MXEXTV];
int tmpbuf[3][10], loopdeg[MXEXTV];
int add1, add2, rm_flag;
int artv[MXEXTV], art_no;
int no_art, no_inside;
int no_in, loopin[100], vin[2], tmp1[3][100];

/*****************************************************************************
                   ============================                             */
                      int rm_loop(  )
/*                 =============================
******************************************************************************
*( Function )                                                                *
*     To determine the vertex positions in the tree Feynman diagram.         *
*( input )                                                                   *
*     structure vtx[i] : vertex information                                  *
*     structure intline[i] : line information                                *
*( output )                                                                  *
*     The vertex position in the graph                                       *
*         structure vtx[].x and structure vtx[].y                            *
******************************************************************************
                                                                            */
{
                                                                            /*
------------------------
    List of Functions
------------------------
                                                                            */
  int rm_sunrise( );
  int rm_self( );
  int rm_vcor( );
  int rm_multi( );
  void refuge( );
/*
  void tgdlist( );
*/
                                                                            /*
====================== Entry point of rm_loop ===============================
                                                                            */

  no_loop     = 0;
  no_sunrise  = 0;
  no_self     = 0;
  no_vcor     = 0;
  no_multi    = 0;
  rm_flag     = 1;

  while( rm_flag != 0 )
    {
      if( rm_sunrise(  ) == 1 )
        {
#ifdef                                                               DFrmloop
           printf("**** rm_sunrise == 1 ****\n");
#endif
         }
      else if( rm_self(  ) == 1 )
        {
#ifdef                                                               DFrmloop
           printf("**** rm_self == 1 ****\n");
#endif
         }
      else if( rm_vcor( ) == 1 )
        {
#ifdef                                                               DFrmloop
           printf("**** rm_vcor == 1 ****\n");
#endif
         }
      else if( rm_multi( ) == 1 )
        {
                                                                            /*
           *********************************************
           *  An unexpected graph pattern was found    *
           *********************************************
                                                                            */
           if( graph_no < 0 ) return 1;
                                          
#ifdef                                                               DFrmloop
           printf("**** rm_multi == 1 ****\n");
#endif
         }

#ifdef                                                               DFrmloop
       printf("\n");
       printf("**** return flags from rm_loop ****\n");
       printf("  rm_flag  no_loop no_sunrise  no_self  no_vcor no_multi\n");
       printf(" %8d %8d %10d %8d %8d %8d\n", 
	rm_flag, no_loop, no_sunrise, no_self, no_vcor, no_multi );
      /*
       tgdlist( );
      */
#endif
     }

#ifdef                                                               DFrmloop
   printf("**>> return from rm_loop <<**\n");
#endif

  return 0;
}

/*****************************************************************************
                   ============================                             */
                      void refuge(  )
/*                 =============================
******************************************************************************
*( Function )                                                                *
*     To to refuge the input graph information before removing the loop      *
*     correction part.                                                       *
*( input )                                                                   *
*     structure vtx[i] : vertex information                                  *
*     structure intline[i] : line information                                *
*( output )                                                                  *
*     structure keepvtx[].xxx and structure keepline[].xxx                   *
******************************************************************************
                                                                            */
{
									    /*
---------------------
  Local variables
---------------------
									    */
int j, m, n, nv;
									    /*
==================== Entry point of refuge ===================================
									    */
if( no_loop == 0 )
  {
    add1 = 0;
    add2 = 0;
   }
else
  {
    add1 = add1 + no_vertex;
    add2 = add2 + no_line;
   }

cflag[no_loop] = rm_flag;
no_loop++;

#ifdef                                                              DFrefuge
      printf(">> Function refuge starts no_loop =%d\n", no_loop );
#endif

for( n = 0; n < no_vertex; n++ )
   {
     m                  = n + add1;
     nv                 = vtx[n].no_line;
     keepvtx[m].no_line = nv;
     keepvtx[m].flag    = vtx[n].flag;
     for( j = 0; j < nv; j++ )
        {
          keepvtx[m].vtxno[j]  = vtxline[n].vtxno[j];
          keepvtx[m].lineno[j] = vtxline[n].lineno[j];
         }
    }
for( n = 0; n < no_line; n++ )
   {
     m                     = n + add2;
     keepline[m].flag      = intline[n].flag;
     keepline[m].vtxno[0]  = inlvtx[n].vtxno[0];
     keepline[m].vtxno[1]  = inlvtx[n].vtxno[1];
    }

#ifdef                                                              DFrefuge
   printf(">> Function refuge terminates.\n" );
#endif
}

/*****************************************************************************
                   ============================                             */
                      int rm_sunrise(  )
/*                 =============================
******************************************************************************
*( Function )                                                                *
*     To find the loop of sunrise shape in the graph,                        *
*     to remove this part from the information, and                          *
*     to change the graph information without this part.                     *
*( input )                                                                   *
*     structure vtx[i] : vertex information                                  *
*     structure intline[i] : line information                                *
*( output )                                                                  *
*     structure vtx[].xxx                                                    *
******************************************************************************
                                                                            */
{
                                                                            /*
  ----------------------------------
      local variable list
  ----------------------------------
                                                                            */
  int i, j, k, v0, v1, l, m, m1, n, nl;
  int returnf;
                                                                            /*
  ----------------------------------
      function list
  ----------------------------------
                                                                            */
void    refuge ( );
int     mode   ( );
                                                                            /*
================== Entry point of rm_sunrise ================================
                                                                            
========================================
(I) find the sun_rise part
========================================
                                                                            */
#ifdef                                                                DFrmsun
    printf(">> start rm_sunrise no_sunrise =%d\n", no_sunrise );
#endif

 rm_flag = 0;
 returnf = 0;
 for( i = 0; i < no_line; i++ )
    {
      if( intline[i].flag >= 0 )
        {
          v0  = inlvtx[i].vtxno[0];
          if( v0 == inlvtx[i].vtxno[1] )
            {
              sunrise[no_sunrise].line = i;
              sunrise[no_sunrise].vtx = v0;

              k = 0;
              for( j = 0; j < vtx[v0].no_line; j++ )
                 {
                   v1 = vtxline[v0].vtxno[j];
                   if( v1 != v0 )
                     {
                       sunrise[no_sunrise].edge[k] = v1;
                       sunrise[no_sunrise].edge_line[k]
                               = vtxline[v0].lineno[j];
                       k++;
                      }
                  }

#ifdef                                                                DFrmsun
             printf("**********************************\n");
             printf(" There are %d sun_rise parts !!\n", no_sunrise+1 );
             printf("**********************************\n");
#endif
                                                                            /*
 ====================================================================
(II) Refuge the graph information in struct keepvtx[].xxx
 ====================================================================
                                                                            */
              rm_flag = 1;
              returnf = 1;
/**
              refuge( rm_flag );
**/
              refuge( );

                                                                            /*
 ====================================================================
(III) save the information of the self energy parts in the struc self
 ====================================================================
                                                                            */
              intline[i].flag = -1;
              vtx[v0].flag    = -1;

#ifdef                                                                DFrmsun
       printf("\n");
       printf("====  sun_rise loop part %d ====\n", no_sunrise+1 );
       printf("                  line[%2d]\n", sunrise[no_sunrise].line );
       printf("                     === \n");
       printf("                    =   = \n");
       printf("                   =     =  \n");
       printf("                   =     =  \n");
       printf("                    =   = \n");
       printf(" v [%2d] ------------ v [%2d] ------------ v [%2d]\n", 
                 sunrise[no_sunrise].edge[0], sunrise[no_sunrise].vtx,
	         sunrise[no_sunrise].edge[1] );
       printf("       edge_ln[0][%2d]      edge_ln[1][%2d]\n", 
                 sunrise[no_sunrise].edge_line[0],
                 sunrise[no_sunrise].edge_line[1] );
#endif

                                                                            /*
 ====================================================================
(IV) change the data  in the struc vtx, vtxline etc.
 ====================================================================
                                                                            */
              m = 10000;

              for( j = 0; j < 2; j++ )
                 {
                   v0 = sunrise[no_sunrise].edge[j];
                   k = mode( j+1, 2 );
                   
                   l  = 0;
                   nl = vtx[v0].no_line;
                   for( n = 0; n < nl; n++ )
                      {
                        v1 = vtxline[v0].vtxno[n];

                        if( v1 != sunrise[no_sunrise].vtx )
                          {
                            tmpbuf[0][l] = v1;
                            tmpbuf[1][l] = vtxline[v0].lineno[n];
                            l++;
                           }
                        else
                          {
                            m1  =  vtxline[v0].lineno[n];
                            intline[m1].flag = -1;
                            if( j == 0 && m1 < m )
                                  m  = m1;
                           }

                       }
                    tmpbuf[0][l] = sunrise[no_sunrise].edge[k];
                    tmpbuf[1][l] = m;
                    l++;
                    if( j == 0 )
                      {
                        intline[m].flag = 1;
                        inlvtx[m].vtxno[0] = v0;
                        inlvtx[m].vtxno[1] = sunrise[no_sunrise].edge[k];
                       }
		    vtx[v0].no_line = l;
                    for( n = 0; n < l; n++ )
                       {
                         vtxline[v0].vtxno[n]  = tmpbuf[0][n];
                         vtxline[v0].lineno[n] = tmpbuf[1][n];
                        }
                  }
               no_sunrise++;
             }

         }

     }
#ifdef                                                                DFrmsun
       printf(">> rm_sunrise terminates. no_sunrise =%d\n", no_sunrise );
#endif

 return returnf;
}

/*****************************************************************************
                   ============================                             */
                      int rm_self(  )
/*                 =============================
******************************************************************************
*( Function )                                                                *
*     To find the self energy or vacum polarization part in the graph,       *
*     to remove this part from the information, and                          *
*     to change the graph information without this part.                     *
*( input )                                                                   *
*     structure vtx[i] : vertex information                                  *
*     structure intline[i] : line information                                *
*( output )                                                                  *
*     structure vtx[].xxx                                                    *
******************************************************************************
                                                                            */
{
                                                                            /*
  ----------------------------------
      local variable list
  ----------------------------------
                                                                            */
  int i1, j1, i, j, k, l, m, m1, n, nl, v0, v1;
  int returnf;
                                                                            /*
  ----------------------------------
      function list
  ----------------------------------
                                                                            */
void    refuge ( );
int     mode   ( );
                                                                            /*
================== Entry point of rm_self ================================
                                                                            
========================================
(I) find the self energy parts
========================================
                                                                            */
#ifdef                                                               DFrmself
    printf(">> Start rm_self starts no_self =%d\n", no_self );
#endif

 rm_flag = 0;
 returnf = 0;
 for( i1 = 0; i1 < no_line; i1++ )
 for( j1 = i1+1; j1 < no_line; j1++ )
    {
  if( intline[i1].flag >= 0 && intline[j1].flag >= 0 )
    {
  if( ( inlvtx[i1].vtxno[0] == inlvtx[j1].vtxno[0] &&
        inlvtx[i1].vtxno[1] == inlvtx[j1].vtxno[1] ) ||
      ( inlvtx[i1].vtxno[0] == inlvtx[j1].vtxno[1] &&
        inlvtx[i1].vtxno[1] == inlvtx[j1].vtxno[0] ) )
    {
      self[no_self].selfv[0] = inlvtx[i1].vtxno[0];
      self[no_self].selfv[1] = inlvtx[i1].vtxno[1];
      self[no_self].self_line[0] = i1;
      self[no_self].self_line[1] = j1;

            /*
             printf("**********************************\n");
             printf(" There are %d self energy parts !!\n", no_self );
             printf("**********************************\n");
            */
                                                                            /*
 ====================================================================
(II) Refuge the graph information in struct keepvtx[].xxx
 ====================================================================
                                                                            */
     rm_flag = 2;
     returnf = 1;
/**
     refuge( rm_flag );
**/
     refuge( );

                                                                            /*
 ====================================================================
(III) save the information of the self energy parts in the struc self
 ====================================================================
                                                                            */
      intline[i1].flag = -1;
      intline[j1].flag = -1;

         /*
          printf(" The %d-th self_energy part\n", i );
         */

      for( j = 0; j < 2; j++)
         {
           k = mode( j+1, 2 );
                   
           v0 = self[no_self].selfv[j];
           v1 = self[no_self].selfv[k];
           nl = vtx[v0].no_line;
           if( nl == 3 )
             {
               for( n = 0; n < nl; n++)
                  {
                    if( vtxline[v0].vtxno[n] != v1 )
                      {
                        self[no_self].edge[j]      = vtxline[v0].vtxno[n];
                        self[no_self].edge_line[j] = vtxline[v0].lineno[n];
                       }
                    }
                vtx[v0].flag = -1;
              }
           else
             {
               self[no_self].edge[j]      = v0;
               self[no_self].edge_line[j] = -1;
              }
          }

#ifdef                                                               DFrmself
       printf("\n");
       printf("====  self energy part %d ====\n", no_self+1 );
       printf("  edge0 ln[%2d]     v0 ln0[%2d]     v1 ln[%2d]  edge1\n", 
                 self[no_self].edge_line[0], self[no_self].self_line[0],
                 self[no_self].edge_line[1] );
       printf(" v [%2d] ------ v [%2d] ======= v [%2d] ------ v [%2d]\n", 
                 self[no_self].edge[0], self[no_self].selfv[0], 
	         self[no_self].selfv[1], self[no_self].edge[1] );
       printf("                      ln1[%2d]\n", 
		 self[no_self].self_line[1] );
#endif

                                                                            /*
 ====================================================================
(IV) change the data  in the struc vtx, vtxline etc.
 ====================================================================
                                                                            */
          m  = 1000;

          for( j = 0; j < 2; j++ )
             {
               v0 = self[no_self].edge[j];
               k = mode( j+1, 2 );
                   
               l  = 0;
               nl = vtx[v0].no_line;
#ifdef                                                               DFrmself
               printf(" * edge v0(%3d) has  nl(% 3d ) lines.\n", v0, nl );
#endif
               for( n = 0; n < nl; n++ )
                  {
                    v1 = vtxline[v0].vtxno[n];
#ifdef                                                               DFrmself
                    printf("  connect to v1(%3d)\n", v1 );
#endif
                    if( v0 == self[no_self].selfv[j] )
                      {
                        if( v1 != self[no_self].selfv[k] )
                          {
                            tmpbuf[0][l] = v1;
                            tmpbuf[1][l] = vtxline[v0].lineno[n];
                            l++;
                           }
                        else
                          {
                            m1  =  vtxline[v0].lineno[n];
                            intline[m1].flag = -1;
                            if( j == 0 && m1 < m )
				m  = m1;
                           }
                       }
                    else
                      {
                        if( v1 != self[no_self].selfv[j] )
                          {
                            tmpbuf[0][l] = v1;
                            tmpbuf[1][l] = vtxline[v0].lineno[n];
                            l++;
                           }
                        else
                          {
                            m1  =  vtxline[v0].lineno[n];
                            intline[m1].flag = -1;
                            if( j == 0 && m1 < m )
				m  = m1;
                           }
                       }
                   }
                tmpbuf[0][l] = self[no_self].edge[k];
                tmpbuf[1][l] = m;
                l++;
                if( j == 0 )
                  {
                    intline[m].flag = 1;
                    inlvtx[m].vtxno[0] = v0;
                    inlvtx[m].vtxno[1] = self[no_self].edge[k];
                   }
		vtx[v0].no_line = l;
                for( n = 0; n < l; n++ )
                   {
                     vtxline[v0].vtxno[n]  = tmpbuf[0][n];
                     nl                    = tmpbuf[1][n];
                     vtxline[v0].lineno[n] = nl;
                     intline[nl].flag      = 0;
#ifdef                                                               DFrmself
                     printf(" * v0( %3d ) connect to v(% 3d )", 
                                v0, tmpbuf[0][n] );
                     printf(" via ln( %3d ) flg(%2d)\n", nl, intline[nl].flag);
#endif
                    }
              }
     no_self++;


    }
    }
    }
#ifdef                                                               DFrmself
       printf(">> rm_self terminates. no_self =%d\n", no_self );
#endif

 return returnf;
}

/*****************************************************************************
                   ============================                             */
                      int rm_vcor(  )
/*                 =============================
******************************************************************************
*( Function )                                                                *
*     To find the vertex correction part in the graph,                       *
*     to remove this part from the information, and                          *
*     to change the graph information without this part.                     *
*( input )                                                                   *
*     structure vtx[i] : vertex information                                  *
*     structure intline[i] : line information                                *
*( output )                                                                  *
*     structure vtx[].xxx                                                    *
******************************************************************************
                                                                            */
{
                                                                            /*
  ----------------------------------
      local variable list
  ----------------------------------
                                                                            */
  int i, j, k, k1, l, m, m1, n, nv, nl, v0, v1, v2;
  int nvv, noc;
  int flag, vcflag, cntr;
  int returnf;
  int dfvtx[MXEXTV];
                                                                            /*
  ----------------------------------
      function list
  ----------------------------------
                                                                            */

void    rfuge  ( );
int     mode   ( );
int     vcfind ( );
void    dfcount ( );
void    print_vcor ( );
                                                                            /*
================== Entry point of rm_vcor ================================
                                                                            */
        /*
         printf(" Function rm_vcor starts no_vcor =%d\n", no_vcor );
        */
 rm_flag = 0;
 returnf = 0;

flag = 1;

while( flag == 1 ) 
{
	 /*
	  printf("**** find vcor outer loop ****\n");
         */

for( n = 0; n < no_vertex; n++ )
   {
     dfnumber[n] = 1000;
     if( vtx[n].flag < 0 ) dfnumber[n] = -1;
     dfvtx[n]    = 1000;
    }

n = 0;
        
dfcount( n, n, 1 );

nvv = 0;
for( i = 0; i < no_vertex; i++ )
   {
     k = dfnumber[i];
     if( k < no_vertex && k >= 0 )
       {
         dfvtx[k] = i;
         nvv++;
        }
    }

     /*
      printf("\n");
      printf(" ========== dfnumbers  ============\n");
      printf(" Vertex_no  dfnumber     dfvtx\n");
      for( n = 0; n < nvv; n++ )
           printf(" %9d %9d %9d\n", n, dfnumber[n], dfvtx[n] );
     */

for( i = 0; i < nvv; i++ )
   {
     k = dfvtx[i];
     if( vtx[k].flag >= 0 )
       {
                                                                            /*
    =======================================
    (I) find the vertex correction parts
    =======================================
                                                                            */
              /*
                printf("  start from v(%3d ) to find vcor\n", k );
              */

         for( j = 0; j < 3; j++ )
             tmpbuf[0][j] = -1;


         vcflag = 0;
         cntr   = 0;

         vcflag = vcfind( k, k, k, cntr );
                                                                            /*
    =============================================================
    (II) store the information of  the vertex correction part
               into struct vtxcor[].xxx.
    =============================================================
                                                                            */
         if( vcflag == 1 )
           {
             rm_flag = 3;
             returnf = 1;
/**
             refuge( rm_flag );
**/
             refuge( );

             for( j = 0; j < 3; j++ )
                {
                  v0   = tmpbuf[0][j];
                  vtxcor[no_vcor].vcorv[j] = v0;
                  vtx[v0].flag = -1;
                  k1   = mode( j + 1, 3);
                  l    = mode( j + 2, 3);
                  v1   = tmpbuf[0][k1];
                  v2   = tmpbuf[0][l];

                    /*
                     printf("**  vertex v0 =%2d, v1 =%2d, v2 =%2d\n",
	           		v0, v1, v2 );
                    */

                  nl = vtx[v0].no_line;
                  if( nl == 3 )
                    {
                      for( k = 0; k < 3; k++ )
                         {
                           n = vtxline[v0].vtxno[k];
                           if( ( n != v1 ) && ( n != v2 )  )
                             {
                                vtxcor[no_vcor].edge[j]  = n;
                                vtxcor[no_vcor].edge_line[j]
                                           = vtxline[v0].lineno[k];
                                /*
                                printf("  edgev%d = %2d  edge_line%d =%3d\n",
                                         j, vtxcor[no_vcor].edge[j],
                                         j,  vtxcor[no_vcor].edge_line[j] ); 
                                */
                              }
                          } 
                     }
                  else 
                    {
                      vtxcor[no_vcor].edge[j]  = v0;
                      vtxcor[no_vcor].edge_line[j]  = -1;
                       /*          
                        printf("  edgev%d = %2d  edge_line%d =%3d\n",
                                    j, vtxcor[no_vcor].edge[j],
                                    j, vtxcor[no_vcor].edge_line[j] ); 
                       */
                     }

                  for( k = 0; k < nl; k++ )
                     {
                       n = vtxline[v0].vtxno[k];
                       if( n == v1 )
                         {
                           l  = vtxline[v0].lineno[k];
                           vtxcor[no_vcor].vcor_line[j]  = l;
                           intline[l].flag               = -1;
                              /*
                                printf("  vcor_line%d =%3d\n",
                                 j, vtxcor[no_vcor].vcor_line[j] ); 
                              */
                          }
                      }

                 }
         /*
          printf("\n");
	  printf("** print from rm_vcor ****\n");
          print_vcor( 0 );
         */
                                                                            /*
    -------------------------------------------------------------------
    (iii) remove this part from the struct vtx[].xx and intline[].xx,
	   and reconnect the remaining vertices.
    -------------------------------------------------------------------
                                                                            */
             noc =    0;
             v2  =   -1;

             for( j = 0; j < 3; j++ )
                {

                  v0 = vtxcor[no_vcor].edge[j];
                        /*
                           printf("*** edge v =%3d\n", v0 );
                        */
                  k  = mode( j + 1, 3 );
                  k1 = mode( j + 2, 3 );
                  l  = 0;
                  nl = vtx[v0].no_line;

                  if( v0 == vtxcor[no_vcor].vcorv[j] )
                    {
                      if( v2 < 0 )
                          v2 = v0;
                      for( n = 0; n < nl; n++ )
                         {
                           v1 = vtxline[v0].vtxno[n];
                           if( ( v1 != vtxcor[no_vcor].vcorv[k] ) &&
                               ( v1 != vtxcor[no_vcor].vcorv[k1] ) )
                             {
                               tmp1[0][noc] = v1;
                               m            = vtxline[v0].lineno[n];
                               tmp1[1][noc] = m;
                               inlvtx[m].vtxno[0] = v2;
                               inlvtx[m].vtxno[1] = v1;
                               noc++;
                               nv  = vtx[v1].no_line;
                               for( m = 0; m < nv; m++ )
                                    if( vtxline[v1].vtxno[m] == v0 )
                                        vtxline[v1].vtxno[m] = v2;
                              }
                          }
                     }
                  else
                    { 
                      m1  = 0;
                      for( n = 0; n < nl; n++ )
                         {
                           v1 = vtxline[v0].vtxno[n];
                           if( v1 != vtxcor[no_vcor].vcorv[j] )
                             {
                               tmpbuf[0][l] = v1;
                               m            = vtxline[v0].lineno[n];
                               tmpbuf[1][l] = m;
                               l++;
                              }
                           else
                             {
                               if( m1 == 0 )
                                 {
                                   if( v2 < 0 )
                                     {
                                       v2 = v1;
                                         /*
                                           printf(" vertex %d is defined", 
					          v2 );
                                           printf(" as new vertex.\n" );
                                         */
 			              }
                                   tmpbuf[0][l] = v2;
                                   m            = vtxline[v0].lineno[n];
                                   tmpbuf[1][l] = m;
                                   l++;
                                   inlvtx[m].vtxno[0] = v2;
                                   inlvtx[m].vtxno[1] = v0;
                                   tmp1[0][noc] = v0;
                                   tmp1[1][noc] = m;
                                   noc++;
                                   m1  = 1;
                                  }
                              }
                          }
                      vtx[v0].no_line = l;
                      for( n = 0; n < l; n++ )
                         {
                           vtxline[v0].vtxno[n]  = tmpbuf[0][n];
                           vtxline[v0].lineno[n] = tmpbuf[1][n];
                          }
                         /*
	                   printf(" Vertex %3d was changed\n", v0 );
                           for( n = 0; n < l; n++ )
                              {
                                printf("  %2d : == %2d ==> v[%2d]\n",
                                    n, vtxline[v0].lineno[n], 
				    vtxline[v0].vtxno[n] );
                               }
                         */
                     }
                 }

             vtx[v2].flag    = 5;  /* rm_vcor : vtx[v2].flag = 5 */
             vtx[v2].no_line = noc;
             for( n = 0; n < noc; n++ )
                {
                  vtxline[v2].vtxno[n]  = tmp1[0][n];
                  vtxline[v2].lineno[n] = tmp1[1][n];
                 }
                /*
                printf(" rm_vcor : Vertex %3d is new vertex\n", v2 );
                printf("           vtx[%3d ].flag =%3d\n", v2, vtx[v2].flag );
                for( n = 0; n < noc; n++ )
                   {
                     printf("  %2d : == %2d ==> v[%2d]\n",
                     n, vtxline[v2].lineno[n], vtxline[v2].vtxno[n] );
                    }
               */

             no_vcor++;

	     flag = 1;
            }
         else
             flag = 0;
         }

     if( flag == 1 ) i = nvv;
    }
 }
      /*
       printf(" Function rm_vcor terminates no_vcor =%d\n", no_vcor );
      */

 return returnf;
}

/*****************************************************************************
                   ============================                             */
                      int rm_multi(  )
/*                 =============================
******************************************************************************
*( Function )                                                                *
*     To find the multi-points loop correction  part in the graph,           *
*     to remove this part from the information, and                          *
*     to change the graph information without this part.                     *
*( input )                                                                   *
*     structure vtx[i] : vertex information                                  *
*     structure intline[i] : line information                                *
*( output )                                                                  *
*     structure vtx[].xxx                                                    *
******************************************************************************
                                                                            */
{
                                                                            /*
  ----------------------------------
      local variable list
  ----------------------------------
                                                                            */
  int i, j, k, l, m, m1, n, nv, nl, v0, v1, v2;
  int vo, vp, vc;
  int tmp2[2][100], noc, ne;
  int found, returnf;
  int flag;
                                                                            /*
  ----------------------------------
      function list
  ----------------------------------
                                                                            */
void    cnode  ( );
void    cnode1 ( );
void    refuge ( );
int     mode   ( );
int     vcfind ( );
void    chk_vorder ( );

                                                                            /*
======================== Entry point of rm_multi ===========================
                                                                            */
      /*
       printf(" Function rm_multi starts no_multi =%d\n", no_multi );
      */

  rm_flag   = 0;
  returnf   = 0;

                                                                            /*
==============================================================================
    Find the second initial point of the loop for 2 body initial state
==============================================================================
                                                                           */
if( no_initial == 2 )
  {
                                                                            /*
    +------------------------------------------------------------------------+
    | (1) Find multi-points loops                                            |
    +------------------------------------------------------------------------+
                                                                           */
    no_in     = 0;
    count     = 0;
    art_no    = 0;
    for( n = 0; n < no_vertex; n++ )
       {
         dfnumber[n] = 1000;
         artpoint[n] =    0;
         low[n]      = 1000;
         artv[n] =    0;
        }

    n = 1;
        
    cnode( n, n );

#ifdef                                                            DFrm_multiA
      printf("\n");
      printf(" ========== articulation points from nv = 1  ============\n");
      printf(" art_no =%3d\n", art_no );
      printf(" Vertex_no  dfnumber       low art_point  art_vtx\n");
      for( n = 0; n < no_vertex; n++ )
           printf(" %9d %9d %9d %9d %9d\n", 
           n, dfnumber[n], low[n], artpoint[n], artv[n] );
#endif

    count     = 0;
    for( n = 0; n < no_vertex; n++ )
       {
         dfnumber[n] = 1000;
        }
    n = 1;
        
    cnode1( n, n );

#ifdef                                                            DFrm_multiA
      printf("\n");
      printf(" ========== articulation points from nv = 1  ============\n");
      printf(" art_no =%3d\n", art_no );
      printf(" Vertex_no  dfnumber       low art_point  art_vtx\n");
      for( n = 0; n < no_vertex; n++ )
           printf(" %9d %9d %9d %9d %9d\n", 
           n, dfnumber[n], low[n], artpoint[n], artv[n] );
#endif
                                                                            /*
    +------------------------------------------------------------------------+
    | (2) count the number of vertices in each loop                          |
    +------------------------------------------------------------------------+
                                                                            */
    for( n = 0; n < no_vertex; n++ )
       {
         loopdeg[n] = 0;
        }

    for( n = 0; n < no_vertex; n++ )
       {
         i = low[n];
         loopdeg[i]++;
        }
#ifdef                                                            DFrm_multi
           printf("****** list of loopdeg from v1 ***************\n" );
           printf("dfnumber ");
           for( n =0; n < no_vertex; n++ )
                printf("%5d", n );
           printf("\n");
           printf("frequency");
           for( n =0; n < no_vertex; n++ )
                printf("%5d", loopdeg[n] );
           printf("\n");
#endif

    for( i = 0; i < no_vertex; i++ )
       {
         if( loopdeg[i] > 3 )
           {
                                                                            /*
    +------------------------------------------------------------------------+
    | (3) A multi-points loop is found                                       |
    +------------------------------------------------------------------------+
                                                                            */
             for( j = 0; j < art_no; j++ )
                {
                  n          = artv[j];
                  if( low[n] == i )
                    {
                      if( artpoint[n] == 1 )
                        {
                          loopin[no_in] = n;
                         }
                     }
                 }

             /*
              printf(" ** loopin[%d] =%3d\n", 
	              no_in, loopin[no_in] );
             */

              no_in++;

            }
        }
   
   if( no_in == 0 ) return returnf;
   
  }
                                                                            /*
==============================================================================
    Find  a multi-points loops from vertex no = 0
==============================================================================
 +---------------------------------------------------------------------------+
 | (1) Find multi-points loops                                               |
 +---------------------------------------------------------------------------+
  +--------------------------------------------------------------------------+
  | (i) determine blocks and articulate points of the blocks                 |
  +--------------------------------------------------------------------------+
                                                                            */
  count     = 0;
  art_no    = 0;
  for( n = 0; n < no_vertex; n++ )
     {
       dfnumber[n] = 1000;
       artpoint[n] =    0;
       low[n]      = 1000;
       artv[n] =    0;
      }

  n = 0;
        
  cnode( n, n );

#ifdef                                                            DFrm_multiA
       printf("\n");
       printf(" ========== articulation points  from v0 ============\n");
       printf(" art_no =%3d\n", art_no );
       printf(" Vertex_no  dfnumber       low art_point  art_vtx\n");
       for( n = 0; n < no_vertex; n++ )
            printf(" %9d %9d %9d %9d %9d\n", 
            n, dfnumber[n], low[n], artpoint[n], artv[n] );
#endif

  count     = 0;
  for( n = 0; n < no_vertex; n++ )
     {
       dfnumber[n] = 1000;
      }
  n = 0;
        
  cnode1( n, n );

#ifdef                                                            DFrm_multiA
       printf("\n");
       printf(" ========== articulation points  from v0 ============\n");
       printf(" art_no =%3d\n", art_no );
       printf(" Vertex_no  dfnumber       low art_point  art_vtx\n");
       for( n = 0; n < no_vertex; n++ )
            printf(" %9d %9d %9d %9d %9d\n", 
            n, dfnumber[n], low[n], artpoint[n], artv[n] );
#endif
                                                                            /*
  +--------------------------------------------------------------------------+
  | (ii) count the number of vertices in each loop                           |
  +--------------------------------------------------------------------------+
                                                                            */

  for( n = 0; n < no_vertex; n++ )
     {
       loopdeg[n] = 0;
      }

  for( n = 0; n < no_vertex; n++ )
     {
       i = low[n];
       loopdeg[i]++;
      }

#ifdef                                                            DFrm_multi
           printf("****** list of loopdeg from v0 ***************\n" );
           printf("dfnumber ");
           for( n =0; n < no_vertex; n++ )
                printf("%5d", n );
           printf("\n");
           printf("frequency");
           for( n =0; n < no_vertex; n++ )
                printf("%5d", loopdeg[n] );
           printf("\n");
#endif

for( i = 0; i < no_vertex; i++ )
 {
 if( loopdeg[i] > 3 )
   {
                                                                            /*
 +---------------------------------------------------------------------------+
 | (2) A multi-points loop is found                                          |
 +---------------------------------------------------------------------------+
                                                                            */
     no_art    = 0;
     no_inside = 0;
     for( n = 0; n < no_vertex; n++ )
        {
          tmp1[0][n] = 0;
          tmp1[1][n] = 0;
          if( low[n] == i )
            {
              if( artpoint[n] != 1 )
                {
                  tmp1[1][no_inside]    = n;
                  no_inside++;
                 }
             }
         }
     for( j = 0; j < art_no; j++ )
        {
          n          = artv[j];
          tmp1[0][no_art] = 0;
          if( low[n] == i )
            {
              if( artpoint[n] == 1 )
                {
                  tmp1[0][no_art] = n;
                  no_art++;
                 }
             }
         }
                                                                            /*
==============================================================================
  Check the graph pattern. If it is an unexpected one, return
==============================================================================
                                                                            */
   if( no_art    <  3 )                        graph_no = -graph_no;
   if( no_art    == 3    && no_inside > 2  )   graph_no = -graph_no;
   if( no_art    == 4    &&
     ( no_inside == 1    || no_inside > 2 ) )  graph_no = -graph_no;
   if( no_art    == 5    && no_inside > 0 )    graph_no = -graph_no;
   if( no_art    == 6    && no_inside > 0 )    graph_no = -graph_no;
   if( no_art    == 7    && no_inside > 0 )    graph_no = -graph_no;
   if( no_art    >  7 )                        graph_no = -graph_no;


   if( graph_no < 0 )
     {
        printf("** graph-%d has an unexpected pattern.  skipped to drwaw\n",
                   -graph_no );
        printf("  The number of external points =%4d\n", no_art );
        printf("  The number of internal points =%4d\n", no_inside );
   
        return 1;
      }
                                                                            /*
==============================================================================
  The graph pattern is an expected one.
==============================================================================
                                                                            */

     if( no_art > 2 )
       {

         vin[0] = tmp1[0][no_art-1];
         vin[1] = -1;
         if( no_in > 0 )
           {
             for( j = 0; j < no_art; j++ )
                {
                                                                            /*
                 +-----------------------------------------------------------+
                 |  determine vin[1] if there are two input                  |
                 +-----------------------------------------------------------+
                                                                            */
                  v0         = tmp1[0][j];
                  tmp1[2][j] = 0;

                  for( k = 0; k < no_in; k++ )
                       if( loopin[k] == v0 )
                           vin[1] = v0;
                  multi[no_multi].artv_flag[j] = 0;

                                                                            /*
                 +-----------------------------------------------------------+
                 |  determine particle flags tmp1[2][i] for art_vertices     |
                 +-----------------------------------------------------------+
                                                                            */
                  nv   = vtx[v0].no_line;
                  for( k = 0; k < nv; k++ )
                     {
		       flag = 0;
                       v1 = vtxline[v0].vtxno[k];
                       for( n = 0; n < no_art; n++ )
                          {
                            if( v1 == tmp1[0][n] )
                              {
                                flag = 1, n = no_art;
                               }
                            }
                       if( flag == 0 )
			 {
                           for( n = 0; n < no_inside; n++ )
                              {
                                if( v1 == tmp1[1][n] )
                                  {
                                    flag = 1, n = no_inside;
                                   }
                                }
                          }
                       if( flag == 0 && 
			   iabs( tmp1[2][j] ) != 1 )
                         {
                           l = vtxline[v0].lineno[k];
                           tmp1[2][j] = intline[l].direct;
                          }
                      }
                 }
            }

#ifdef                                                            DFrm_multi
	     printf("  The vertices of initial side in the loop\n");
	     printf("  vin[0] =%3d,    vin[1] =%3d\n", vin[0], vin[1]);
           
             printf("** the number of art_points before ordering =%4d\n", 
	     no_art);
             printf("   the number of vertices inside     =%4d\n", no_inside );
             printf(" tmp1[0][i] =");
             for( n = 0; n < no_art; n++ )
                  printf("%5d", tmp1[0][n] );
             printf("\n" );
             printf(" tmp1[2][i] =");
             for( n = 0; n < no_art; n++ )
                  printf("%5d", tmp1[2][n] );
             printf("\n" );
             printf("   list of the vertices inside this loop\n" );
             for( n = 0; n < no_inside; n++ )
                  printf("%5d", tmp1[1][n] );
             printf("\n" );
#endif
                                                                            /*
==============================================================================
     Order of articulation points
==============================================================================
                                                                            */
          chk_vorder( );

#ifdef                                                            DFrm_multi
             printf("***** after chk_vorder ***************\n" );
             printf("** the number of articulation points =%4d\n", no_art);
             printf("   the number of vertices inside     =%4d\n", no_inside );
             for( n = 0; n < no_art; n++ )
                  printf("%5d", tmp1[0][n] );
             printf("\n" );
             for( n = 0; n < no_art; n++ )
                  printf("%5d", multi[no_multi].artv_flag[n] );
             printf("\n" );
             printf("   list of the vertices inside this loop\n" );
             for( n = 0; n < no_inside; n++ )
                  printf("%5d", tmp1[1][n] );
             printf("\n" );
#endif
                                                                            /*
==============================================================================
          Save the vertex and internal line information
==============================================================================
                                                                            */
          rm_flag = 4;
          returnf = 1;
/**
          refuge( rm_flag );
**/
          refuge( );

                                                                            /*
==============================================================================
           Fill the loop information into Struct loop
==============================================================================
                                                                            */
#ifdef                                                            DFrm_multi
            printf("==== Start to fill the loop information ===\n" );
#endif

          multi[no_multi].no_edge = no_art;
          multi[no_multi].no_vtx  = no_inside;

          for( j = 0; j < no_art; j++ )
             {
                                                                            /*
            +----------------------------------------------------------------+
            | (i) take one articulation point                                |
            +----------------------------------------------------------------+
                                                                            */
               v0                    = tmp1[0][j];
               multi[no_multi].artv[j] = v0;
#ifdef                                                            DFrm_multi
                       printf("**  articulation vertex v0 =%3d\n", v0 );
#endif
               if( j == 0 )
                 {
	           vc = v0;
#ifdef                                                            DFrm_multi
                       printf("**  center vertex vc =%3d\n", vc );
#endif
                  }
               else
                   vtx[v0].flag = -1;

                                                                            /*
            +----------------------------------------------------------------+
            | (ii) check if this articulation point degenerates with the edge| 
            +----------------------------------------------------------------+
                                                                            */
               nv = 0;
               nl = vtx[v0].no_line;
               for( k = 0; k < nl; k++ )
                  {
                    v1 = vtxline[v0].vtxno[k];
                    found  = 0;
                    for( l = 0; l < no_art; l++ )
                         if( v1 == tmp1[0][l] )
		             found = 1;
                    if( found == 0 )
                      {
                        for( l = 0; l < no_inside; l++ )
                             if( v1 == tmp1[1][l] ) found = 1;
                       }
                    if( found == 0 )
                      {
		        nv++;
                        vp = v1;
                       }
                    else
                      {
                        n     = vtxline[v0].lineno[k];
                        intline[n].flag = -1;
                       }
                   }
                                                                            /*
              +--------------------------------------------------------------+
              | (ii - 1) this articulation point degenerates with the edge.  |
              +--------------------------------------------------------------+
                                                                            */
	        if( nv > 1 )
                  {
                    vp                         = v0;
                    multi[no_multi].edge[j]      = v0;
                    multi[no_multi].edge_line[j] = -1;
                   }
                                                                            /*
              +--------------------------------------------------------------+
              | (ii - 2) this articulation point does not degenerate.        |
              +--------------------------------------------------------------+
                                                                            */
                else if( nv == 1 )
                  {
                    multi[no_multi].edge[j] = vp;
                    n   = vtx[vp].no_line;
                    for( k = 0; k < n ; k++ )
                         if( vtxline[vp].vtxno[k] == v0 )
                             nl  = vtxline[vp].lineno[k];
                    multi[no_multi].edge_line[j] = nl;
                   }

                                                                            /*
            +----------------------------------------------------------------+
            | (iii) check if this articulation point is initial side or not  |
            +----------------------------------------------------------------+
                                                                            */
                 for( k = 0; k < 2; k++ )
                    {
                      if( v0 == vin[k] )
                          multi[no_multi].artv_flag[j] = 1;

                     }

#ifdef                                                            DFrm_multi
	         printf("  edgev[%3d ] ===   edge_line[%3d ] ===   artv[%3d ]",
                      multi[no_multi].edge[j], multi[no_multi].edge_line[j],
                      multi[no_multi].artv[j] );
	         printf(" flag[%3d ]\n",
                      multi[no_multi].artv_flag[j] );
#endif
              }

          for( j = 0; j < no_inside; j++ )
             {
               v0                     = tmp1[1][j];
               vtx[v0].flag           = -1;
               multi[no_multi].vtxno[j] = v0;

               n    = vtx[v0].no_line;
               for( k = 0; k < n; k++ )
                  {
                    l = vtxline[v0].lineno[k];
                    intline[l].flag = -1;
                   }
              }
                                                                            /*
==============================================================================
          Remove the loop vertices from the Struct vtx[].xxxx
==============================================================================
                                                                            */
          noc = 0;
          v2  =   -1;

          for( j = 0; j < no_art; j++ )
             {
               v0 = multi[no_multi].edge[j];
                     /* 
                      printf("*** edge v =%3d\n", v0 );
                     */
               l  = 0;
               nl = vtx[v0].no_line;

               if( v0 == multi[no_multi].artv[j] )
                 {
                   if( v2 < 0 )
                       v2 = v0;
                   for( n = 0; n < nl; n++ )
                      {
                        v1 = vtxline[v0].vtxno[n];
                        found = 0;
                        for( k = 0; k < no_art; k++ )
                             if( v1 == tmp1[0][k] )
                                 found = 1;
                        for( k = 0; k < no_inside; k++ )
                             if( v1 == tmp1[1][k] )
                                 found = 1;
                        if( found == 0 )
                          {
                            tmp2[0][noc] = v1;
                            m            = vtxline[v0].lineno[n];
                            tmp2[1][noc] = m;
                            inlvtx[m].vtxno[0] = v2;
                            inlvtx[m].vtxno[1] = v1;
                            noc++;
                            nv  = vtx[v1].no_line;
                            for( m = 0; m < nv; m++ )
                                 if( vtxline[v1].vtxno[m] == v0 )
                                     vtxline[v1].vtxno[m] = v2;
                           }
                       }
                  }
               else
                 {
                   m1  = 0;
                   for( n = 0; n < nl; n++ )
                      {
                        v1 = vtxline[v0].vtxno[n];
                        if( v1 != multi[no_multi].artv[j] )
                          {
                            tmpbuf[0][l] = v1;
                            m            = vtxline[v0].lineno[n];
                            tmpbuf[1][l] = m;
                            l++;
                           }
                        else
                          {
                            if( m1 == 0 )
                              {
                                if( v2 < 0 )
                                  {
                                    v2 = v1;
                                   /*
                                    printf(" vertex %d is defined", v2 );
                                    printf(" as new vertex.\n" );
                                   */
				   }
                                tmpbuf[0][l] = v2;
                                m            = vtxline[v0].lineno[n];
                                tmpbuf[1][l] = m;
                                l++;
                                inlvtx[m].vtxno[0] = v2;
                                inlvtx[m].vtxno[1] = v0;
                                tmp2[0][noc] = v0;
                                tmp2[1][noc] = m;
                                noc++;
                                m1  = 1;
                               }
                           }
                       }
		     vtx[v0].no_line = l;
                     for( n = 0; n < l; n++ )
                        {
                          vtxline[v0].vtxno[n]  = tmpbuf[0][n];
                          vtxline[v0].lineno[n] = tmpbuf[1][n];
                         }
                    /*
		     printf(" Vertex %3d was changed\n", v0 );
                     for( n = 0; n < l; n++ )
                        {
                          printf("  %2d : == %2d ==> v[%2d]\n",
                          n, vtxline[v0].lineno[n], vtxline[v0].vtxno[n] );
                         }
                    */
                   }
	       }

          vtx[v2].flag    = 6;         /* multi_loop flag vtx[v2].flag = 6 */
          vtx[v2].no_line = noc;
          for( n = 0; n < noc; n++ )
             {
               vtxline[v2].vtxno[n]  = tmp2[0][n];
               vtxline[v2].lineno[n] = tmp2[1][n];
              }
          /*
           printf(" rm_multi : Vertex %3d is new vertex\n", v2 );
           printf("            vtx[%3d ].flag =%3d\n", v2, vtx[v2].flag );
           for( n = 0; n < noc; n++ )
              {
                printf("  %2d : == %2d ==> v[%2d]\n",
                n, vtxline[v2].lineno[n], vtxline[v2].vtxno[n] );
               }
          */

          no_multi++;

        }
    }
  }
   /*
   printf(" Function rm_multi terminates no_multi =%d\n", no_multi );
   */

return returnf;
}

/*****************************************************************************
                   =======================                                  */
                     void chk_vorder(  )
/*                 =======================
*****************************************************************************
*( Function )                                                               *
*      To determine the distance of each vertex from the root vertex.       *
*      The distance is defined  by the number of vertecies through          *
*       which the path approachs to it from the root vertex.                *
* ( input )                                                                 *
*      parentv   : the vertex ID for the parent                             *
*      currentv  : the vertex ID for the current vertex                     *
*      flag      : to distinguish the root vertecies.                       *
*      level[flag][] : distance from the root vertex to the parent vertex   *
*      Structure vtx, vtxline                                               *
* ( Output )                                                                *
*      level[flag][] : distance from the root to the current vertex and     *
*                  set the distances for the daughters same as the current. *
*****************************************************************************
*/
{
                                                                            /*
  ----------------------------------
      local variable list
  ----------------------------------
                                                                            */
  int i, j, k, l, m, m1, n, nv, nl, v0, v1, v2;
  int tmp2[3][20], noc, ne;
  int found, returnf;
  int flag, flag1;
  int j0, j1;
  int vo[2], voj[2];
                                                                            /*
  ----------------------------------
      function list
  ----------------------------------
                                                                            */
  int iabs( );
  int trace_fermions( );
  int chk_4point   ( );
                                                                            /*
==============================================================================
     (I) For 4-point vertex
==============================================================================
                                                                            */
 if( no_art == 4 )
   {
                                                                            /*
  --------------------------------------
  (1) Check the order of loop vertices
  --------------------------------------
                                                                            */
     flag = 0;
     if( no_in > 0 )
       {
         for( j = 0; j < no_in; j++ )
            {
              if( loopin[j] == tmp1[0][0] )
                  flag = 1;
               /*
                 printf(" loopin[%d](%3d ) =?= tmp1[0][0](%3d )\n",
                          j, loopin[j], tmp1[0][0] );
                 printf(" flag = %d\n", flag );
               */
             }
        }
                                                                            /*
  --------------------------------------
  (2) Reverse the order of loop vertices
  --------------------------------------
                                                                            */
     if( flag == 1 )
       {
         for( j = 0; j < no_art; j++ )
            {
              tmp2[0][j] = tmp1[0][j];
              tmp2[2][j] = tmp1[2][j];
             }
         for( j = 0; j < no_art; j++ )
            {
              k = no_art - j - 1;
              tmp1[0][k] = tmp2[0][j];
              tmp1[2][k] = tmp2[2][j];
             }
        }

     flag = 0;

     if( vin[1] > 0 )
       {
         n  = 0;
         for( j = 0; j < no_vertex; j++ )
              dfnumber[j] = -1;

         for( j = 0; j < no_art; j++ )
            {
              v0 = tmp1[0][j];
              dfnumber[v0] = 1000;
                     /*
		      printf(" tmp1[0,2][%d] =%3d %3d\n", 
                               j, tmp1[0][j], tmp1[2][j] );
                     */
              if( v0 != vin[0] && v0 != vin[1] )
                {
                  vo[n]  = v0;
                  voj[n] = j;
                  n++;
                 }
             }
         for( j = 0; j < no_inside; j++ )
            {
              v0 = tmp1[1][j];
              dfnumber[v0] = 1000;
                     /*
		      printf(" intv[%2d ] =%3d\n", j, v0 );
                     */
             }
            /*
	     printf(" chk_vorder  tmp1[2][voj[0]=%d] =%3d\n", 
		      voj[0], tmp1[2][voj[0]] );
            */
         if( iabs( tmp1[2][voj[0]] ) == 1 )
           {

	     count = 0;
	     v1 = trace_fermions( vin[0], vin[0] );

              /*
		printf("chk  from vin[0]  v1    =%3d\n", v1);
                printf("    vin[0] =%3d   vo[0] =%3d\n", vin[0], vo[0] );
                printf("    vin[1] =%3d   vo[1] =%3d\n", vin[1], vo[1] );
              */

             if( v1 == vo[0] )
                 flag = 1;
             else if( v1 == vo[1] )
               {
                 j0 = voj[0];
                 j1 = voj[1];
                 
                 tmp2[0][0]  = tmp1[0][j0];
                 tmp2[1][0]  = tmp1[2][j0];
                 tmp1[0][j0] = tmp1[0][j1];
                 tmp1[2][j0] = tmp1[2][j1];
                 tmp1[0][j1] = tmp2[0][0];
                 tmp1[2][j1] = tmp2[1][0];
                 flag = 1;
                }
            }
         if( flag == 0 )
           {
             if( chk_4point( vin[0], vin[1], vo[0], vo[1] ) )
               {
                 j0 = voj[0];
                 j1 = voj[1];
                
                 tmp2[0][0]  = tmp1[0][j0];
                 tmp2[1][0]  = tmp1[2][j0];
                 tmp1[0][j0] = tmp1[0][j1];
                 tmp1[2][j0] = tmp1[2][j1];
                 tmp1[0][j1] = tmp2[0][0];
                 tmp1[2][j1] = tmp2[1][0];
                 flag = 1;
                }
            }
        }
    }
                                                                            /*
==============================================================================
     (II) For 5-point vertex
==============================================================================
                                                                            
 else if( no_art == 5 )
   {
                                                                            /*
  --------------------------------------
  (1) Check the order of loop vertices
  --------------------------------------
                                                                            
         flag = 0;
         if( no_in > 0 )
           {
             for( j = 0; j < no_in; j++ )
                {
                  for( k = 0; k < no_art-1; k++ )
                     {
                       if( loopin[j] == tmp1[0][k] )
                         {
                           flag = k + 1;
                           k    = no_art;
                           j    = no_in;
                          }
                      }
                 }
            }
        /*
          printf(" order flag =%3d\n", flag );
                                                                            /*
  --------------------------------------
  (2) Change the order of loop vertices
  --------------------------------------
                                                                            
          if( flag == 2 )
            {
              for( j = 0; j < no_art; j++ )
                   tmp2[0][j] = tmp1[0][j];
              for( j = 0; j < 2; j++ )
                   tmp1[0][j] = tmp2[0][j+1];
              tmp1[0][2] = tmp2[0][0];
              j = 2;
              multi[no_multi].artv_flag[j] = -1;
              for( j = 3; j < no_art; j++ )
                   tmp1[0][j] = tmp2[0][j];
             }
          else if( flag == 3 )
            {
              for( j = 0; j < no_art; j++ )
                   tmp2[0][j] = tmp1[0][j];
              tmp1[0][1] = tmp2[0][flag];
              multi[no_multi].artv_flag[1] = -1;
              for( j = 2; j < flag+1; j++ )
                   tmp1[0][j] = tmp2[0][j-1];
              for( j = 4; j < no_art; j++ )
                   tmp1[0][j] = tmp2[0][j];
             }
                                                                            /*
  --------------------------------------
  (3) Reverse the order of loop vertices
  --------------------------------------
                                                                            
          if( flag == 1 || flag == 2 )
            {
              for( j = 0; j < no_art; j++ )
                   tmp2[0][j] = tmp1[0][j];
              for( j = 0; j < no_art; j++ )
                 {
                   k = no_art - j - 1;
                   tmp1[0][k] = tmp2[0][j];
                  }
             }
    }
                                                                            /*
==============================================================================
     (III) For 6-point vertex
==============================================================================
                                                                            */
 else if( no_art >= 5 )
   {
                                                                            /*
  --------------------------------------
  (1) Check the order of loop vertices
  --------------------------------------
                                                                            */
         flag = 0;
         if( no_in > 0 )
           {
             for( j = 0; j < no_in; j++ )
                {
                  for( k = 0; k < no_art-1; k++ )
                     {
                       if( loopin[j] == tmp1[0][k] )
                         {
                           flag = k + 1;
                           k    = no_art;
                           j    = no_in;
                          }
                      }
                 }
            }
        /*
          printf(" order flag =%3d\n", flag );
                                                                            /*
  --------------------------------------
  (2) Change the order of loop vertices
  --------------------------------------
                                                                            */
          if( flag == 2 )
            {
              for( j = 0; j < no_art; j++ )
                   tmp2[0][j] = tmp1[0][j];
              tmp1[0][0] = tmp2[0][1];
              tmp1[0][1] = tmp2[0][2];
              tmp1[0][2] = tmp2[0][0];
              multi[no_multi].artv_flag[2] = -1;
             }
          else if( flag >= 3 )
            {
              for( j = 0; j < no_art; j++ )
                   tmp2[0][j] = tmp1[0][j];
              k  = no_art - flag - 1;
              for( j = 0; j < k; j++ )
                 {
                   tmp1[0][flag-2+j] = tmp2[0][no_art-2-j];
                   multi[no_multi].artv_flag[flag-2+j] = -1;
                  }
               tmp1[0][no_art-2] = tmp2[0][flag-1];
               tmp1[0][no_art-3] = tmp2[0][flag-2];
             }
 /*
          else if( flag == 3 )
            {
              for( j = 0; j < no_art; j++ )
                   tmp2[0][j] = tmp1[0][j];
              tmp1[0][1] = tmp2[0][4];
              multi[no_multi].artv_flag[1] = -1;
              tmp1[0][2] = tmp2[0][3];
              multi[no_multi].artv_flag[2] = -1;
              tmp1[0][3] = tmp2[0][1];
              tmp1[0][4] = tmp2[0][2];
             }
          else if( flag == 4 )
            {
              for( j = 0; j < no_art; j++ )
                   tmp2[0][j] = tmp1[0][j];
              tmp1[0][2] = tmp2[0][4];
              multi[no_multi].artv_flag[2] = -1;
              tmp1[0][3] = tmp2[0][2];
              tmp1[0][4] = tmp2[0][3];
             }
          else if( flag == 5 )
            {
              for( j = 0; j < no_art; j++ )
                   tmp2[0][j] = tmp1[0][j];
              tmp1[0][3] = tmp2[0][5];
              multi[no_multi].artv_flag[3] = -1;
              tmp1[0][4] = tmp2[0][3];
              tmp1[0][5] = tmp2[0][4];
             }
 */
                                                                            /*
  --------------------------------------
  (3) Reverse the order of loop vertices
  --------------------------------------
                                                                            */
          if( flag == 1 || flag == 2 )
            {
              for( j = 0; j < no_art; j++ )
                 {
                   tmp2[0][j] = tmp1[0][j];
                   tmp2[1][j] = multi[no_multi].artv_flag[j];
                  }
              for( j = 0; j < no_art; j++ )
                 {
                   k = no_art - j - 1;
                   tmp1[0][k] = tmp2[0][j];
                   multi[no_multi].artv_flag[k] = tmp2[1][j];
                  }
             }
    }
}


/*****************************************************************************
               ==========================================                   */
               int chk_4point( vin0, vin1, vout0, vout1 ) 
/*             ==========================================
******************************************************************************
*( Function )                                                                *
*     To determine the configuration of vertices in the 4-point two loop     *
*( input )                                                                   *
*     v_in[i]  : vertex numbers of input vertices                            *
*     v_out[i] : vertex numbers of output vertices                           *
*( output )                                                                  *
*     looptype : looptype of the 4-point two loop                            *
*     v0       : vertex number of the vertex located at v0 position          *
*     v1       : vertex number of the vertex located at v1 position          *
******************************************************************************/

int vin0, vin1, vout0, vout1;
{
                                                                            /*
  ----------------------------------
      local variable list
  ----------------------------------
                                                                            */
  int level_no;
  int i, n, v, n_line;
  int n00, n01, n10, n11;
  int v_table[10];
  int returnf;
                                                                            /*
  ----------------------------------
      function list
  ----------------------------------
                                                                            */
  int  mode( );
  void find_line( );
                                                                            /*
================== Entry point of config_4point =============================
                                                                            */
      /*
       printf("** chk_4point start **\n");
      */
                                                                            /*
=============================================================================
      Initialization
=============================================================================
                                                                            */
 for( i = 0; i < no_vertex; i++ )
      dfnumber[i] = -1;
 for( i = 0; i < no_art; i++ )
    {
      v = tmp1[0][i];
      dfnumber[v] = 1000;
     }
 for( i = 0; i < no_inside; i++ )
    {
      v = tmp1[1][i];
      dfnumber[v] = 1000;
     }

 returnf = 1;
                                                                            /*
-----------------------------------------------------------------------------
   check the number of vertices on the line from vin0 to vout0
-----------------------------------------------------------------------------
                                                                            */

   find_line( vin0, vout0, &level_no );

   n = 0;
   for( i = 0; i < no_vertex; i++ )
      {
        if( level[0][i] == level_no )
          {
            v_table[n] = i;
            n++;
           }
       }
   n00 = n;
       /*
	printf(" %2d vertices on the line from vin0(%3d ) to vout0(%3d )\n",
                  n, vin0, vout0 );
        for( i = 0; i < n; i++ )
             printf("%5d", v_table[i] );
        printf("\n");
       */
   if( n00 == 2 )
     {
       returnf = 0;
       return returnf;
      }
                                                                            /*
-----------------------------------------------------------------------------
   check the number of vertices on the line from vin1 to vout1
-----------------------------------------------------------------------------
                                                                            */

   find_line( vin1, vout1, &level_no );

   n = 0;
   for( i = 0; i < no_vertex; i++ )
      {
        if( level[0][i] == level_no )
          {
            v_table[n] = i;
            n++;
           }
       }
   n01 = n;
       /*
	printf(" %2d vertices on the line from vin1(%3d ) to vout1(%3d )\n",
                  n, vin1, vout1 );
        for( i = 0; i < n; i++ )
             printf("%5d", v_table[i] );
        printf("\n");
       */
   if( n01 == 2 )
     {
       returnf = 0;
       return returnf;
      }
                                                                            /*
-----------------------------------------------------------------------------
   check the number of vertices on the line from vin1 to vout1
-----------------------------------------------------------------------------
                                                                            */
   if( n00 == n01 && n00 == 3 )
     {

       find_line( vin0, vin1, &level_no );

       n = 0;
       for( i = 0; i < no_vertex; i++ )
          {
            if( level[0][i] == level_no )
              {
                v_table[n] = i;
                n++;
               }
           }
       n11 = n;
       /*
	printf(" %2d vertices on the line from vin0(%3d ) to vin1(%3d )\n",
                  n, vin0, vin1 );
        for( i = 0; i < n; i++ )
             printf("%5d", v_table[i] );
        printf("\n");
       */
       if( n11 != 3 )
         {
           returnf = 0;
           return returnf;
          }
      }

   return returnf;
}

/*****************************************************************************
               ============================================                 */
                int vcfind( rootv, parentv, currentv, cntr )
/*             ============================================
*****************************************************************************
*( Function )                                                               *
*      To determine the distance of each vertex from the root vertex.       *
*      The distance is defined  by the number of vertecies through          *
*       which the path approachs to it from the root vertex.                *
* ( input )                                                                 *
*      parentv   : the vertex ID for the parent                             *
*      currentv  : the vertex ID for the current vertex                     *
*      flag      : to distinguish the root vertecies.                       *
*      level[flag][] : distance from the root vertex to the parent vertex   *
*      Structure vtx, vtxline                                               *
* ( Output )                                                                *
*      level[flag][] : distance from the root to the current vertex and     *
*                  set the distances for the daughters same as the current. *
*****************************************************************************
*/
int rootv, parentv, currentv, cntr;
{
int n_vertex, vertex_n, n, ok, cntr0;

ok  = 0;

if( cntr < 3 )
  {
    n_vertex = vtx[currentv].no_line;

     /*
      printf(" rootv    = %3d  parentv  = %3d", rootv, parentv );  
      printf(" ourrentv = %3d  n_vertex = %d\n", currentv, n_vertex);  
     */

    for( n = 0; n < n_vertex; n++ )
       {
         cntr0    = cntr;
         vertex_n =  vtxline[currentv].vtxno[n];

         if( vertex_n != parentv )
           {
             tmpbuf[0][cntr] = currentv;
             cntr0++;
             ok = vcfind( rootv, currentv, vertex_n, cntr0 );
           }
          if( ok == 1 ) break;
        }
   }
else if( cntr == 3 )
  {
    if( rootv == currentv )
      {
        ok    = 1;

        /*
         printf("***** A vertex correvtion part was found ************\n");
         printf(" v0 = %3d   v1 = %3d   v2 = %3d\n", 
		   tmpbuf[0][0], tmpbuf[0][1], tmpbuf[0][2] );
        */
       }
   }
else 
  {
    ok = 0;
   }

 return ok;
}

/*****************************************************************************
               ============================================                 */
                void dfs( currentv, count1 )
/*             ============================================
*****************************************************************************
*( Function )                                                               *
*      To determine the distance of each vertex from the root vertex.       *
*      The distance is defined  by the number of vertecies through          *
*       which the path approachs to it from the root vertex.                *
* ( input )                                                                 *
*      parentv   : the vertex ID for the parent                             *
*      currentv  : the vertex ID for the current vertex                     *
*      flag      : to distinguish the root vertecies.                       *
*      level[flag][] : distance from the root vertex to the parent vertex   *
*      Structure vtx, vtxline                                               *
* ( Output )                                                                *
*      level[flag][] : distance from the root to the current vertex and     *
*                  set the distances for the daughters same as the current. *
*****************************************************************************
*/
int currentv, count1;
{
  int n_vertex, vertex_n;
  int n;

  dfnumber[currentv] = count1;
  count1++;

  n_vertex = vtx[currentv].no_line;

  /*
    printf("n_vertex = %d\n",n_vertex);  
  */

  for( n = 0; n < n_vertex; n++ )
     {
       vertex_n =  vtxline[currentv].vtxno[n];

       if( dfnumber[vertex_n] > count1 )
	 {
           dfs( vertex_n, count1 );
          }
      }
}


/*****************************************************************************
               ============================================                 */
                void cnode( parentv, currentv )
/*             ============================================
*****************************************************************************
*( Function )                                                               *
*      To determine the distance of each vertex from the root vertex.       *
*      The distance is defined  by the number of vertecies through          *
*       which the path approachs to it from the root vertex.                *
* ( input )                                                                 *
*      parentv   : the vertex ID for the parent                             *
*      currentv  : the vertex ID for the current vertex                     *
*      flag      : to distinguish the root vertecies.                       *
*      level[flag][] : distance from the root vertex to the parent vertex   *
*      Structure vtx, vtxline                                               *
* ( Output )                                                                *
*      level[flag][] : distance from the root to the current vertex and     *
*                  set the distances for the daughters same as the current. *
*****************************************************************************
*/
int parentv, currentv;
{
  int n_vertex, vertex_n;
  int n, lowest, art;

  dfnumber[currentv] = count;
  low[currentv]      = count;
  lowest             = count;
  count++;

  n_vertex = vtx[currentv].no_line;

  /*
    printf("n_vertex = %d\n",n_vertex);  
  */

  art = 0;

  for( n = 0; n < n_vertex; n++ )
     {
       vertex_n =  vtxline[currentv].vtxno[n];

       if( vertex_n != parentv )
         {
           if( dfnumber[vertex_n] == 1000 )
	     {
               cnode( currentv, vertex_n );

               if( low[vertex_n] >= dfnumber[currentv] )
	           art    = 1;
              }
           if( lowest > low[vertex_n] )
	       lowest = low[vertex_n];
         }
      }
   low[currentv]     = lowest;
   if( parentv == currentv && n_vertex < 2 )
       art  = 0;
   artpoint[currentv] = art;
   if( art == 1 )
     {
       artv[art_no] = currentv;
       art_no++;
      }
}

/*****************************************************************************
               ============================================                 */
                void cnode1( parentv, currentv )
/*             ============================================
*****************************************************************************
*( Function )                                                               *
*      To determine the distance of each vertex from the root vertex.       *
*      The distance is defined  by the number of vertecies through          *
*       which the path approachs to it from the root vertex.                *
* ( input )                                                                 *
*      parentv   : the vertex ID for the parent                             *
*      currentv  : the vertex ID for the current vertex                     *
*      flag      : to distinguish the root vertecies.                       *
*      level[flag][] : distance from the root vertex to the parent vertex   *
*      Structure vtx, vtxline                                               *
* ( Output )                                                                *
*      level[flag][] : distance from the root to the current vertex and     *
*                  set the distances for the daughters same as the current. *
*****************************************************************************
*/
int parentv, currentv;
{
  int n_vertex, vertex_n;
  int n, lowest, art;

  dfnumber[currentv] = count;
  lowest             = low[currentv];
  count++;

  n_vertex = vtx[currentv].no_line;

  /*
    printf("n_vertex = %d\n",n_vertex);  
  */

  for( n = 0; n < n_vertex; n++ )
     {
       vertex_n =  vtxline[currentv].vtxno[n];

       if( vertex_n != parentv )
         {
           if( dfnumber[vertex_n] == 1000 )
	     {
               cnode1( currentv, vertex_n );

              }
           if( lowest > low[vertex_n] )
	       lowest = low[vertex_n];
         }
      }
   low[currentv]     = lowest;
}

int v_near, v_near_c;
/*****************************************************************************
               ============================================                 */
                int trace_fermions( parentv, currentv )
/*             ============================================
*****************************************************************************
*( Function )                                                               *
*      To determine the distance of each vertex from the root vertex.       *
*      The distance is defined  by the number of vertecies through          *
*       which the path approachs to it from the root vertex.                *
* ( input )                                                                 *
*      parentv   : the vertex ID for the parent                             *
*      currentv  : the vertex ID for the current vertex                     *
*      flag      : to distinguish the root vertecies.                       *
*      level[flag][] : distance from the root vertex to the parent vertex   *
*      Structure vtx, vtxline                                               *
* ( Output )                                                                *
*      level[flag][] : distance from the root to the current vertex and     *
*                  set the distances for the daughters same as the current. *
*****************************************************************************
*/
int parentv, currentv;
{
  int n_vertex, vertex_n, line_n;
  int n, returnf;

  int iabs( );
        /*
         printf("** trace_fermions parentv(%d)  currentv(%d)\n",
                     parentv, currentv );
        */
  if( parentv == currentv )
    {
      count    = 0;
      v_near   = 10000;
      v_near_c = 10000;
     }
  else
      count++;

  dfnumber[currentv] = count;

  n_vertex = vtx[currentv].no_line;

  /*
    printf("n_vertex = %d\n",n_vertex);  
  */

  returnf = currentv;

  for( n = 0; n < n_vertex; n++ )
     {
       vertex_n =  vtxline[currentv].vtxno[n];
       line_n   =  vtxline[currentv].lineno[n];

       if( vertex_n                       != parentv &&
           dfnumber[vertex_n]             >= 0       &&
	   iabs( intline[line_n].direct ) == 1 )
         {
           returnf = trace_fermions( currentv, vertex_n );
         }
      }
       /*
         printf("** trace_fermions parentv(%d)  currentv(%d)\n",
                     parentv, currentv );
         printf("   returnf(%3d )  =?= currentv(%3d )\n", returnf, currentv );
         printf("   v_near_c(%3d ) >?> count   (%3d )\n", v_near_c, count );
       */

 if( returnf == currentv && v_near_c > count )
   {
     v_near_c = count;
     v_near   = currentv;
    }

  count--;

  return v_near;
}
/*****************************************************************************
               ============================================                 */
                int trace_fermion( parentv, currentv )
/*             ============================================
*****************************************************************************
*( Function )                                                               *
*      To determine the distance of each vertex from the root vertex.       *
*      The distance is defined  by the number of vertecies through          *
*       which the path approachs to it from the root vertex.                *
* ( input )                                                                 *
*      parentv   : the vertex ID for the parent                             *
*      currentv  : the vertex ID for the current vertex                     *
*      flag      : to distinguish the root vertecies.                       *
*      level[flag][] : distance from the root vertex to the parent vertex   *
*      Structure vtx, vtxline                                               *
* ( Output )                                                                *
*      level[flag][] : distance from the root to the current vertex and     *
*                  set the distances for the daughters same as the current. *
*****************************************************************************
*/
int parentv, currentv;
{
  int n_vertex, vertex_n, line_n;
  int n, returnf;

  int iabs( );

#ifdef                                                           DFtr_fermi
         printf("** trace_fermion parentv(%d)  currentv(%d)  count(%d)\n",
                     parentv, currentv, count );
#endif 

  if( parentv == currentv )
    {
      count  = 0;
     }
  else
      count++;

  dfnumber[currentv] = count;

#ifdef                                                           DFtr_fermi
  if( count > 10 ) 
    {
      printf(" stop : more than 10 vertices are passed\n");
      exit( 0 );
     }
#endif

  n_vertex = vtx[currentv].no_line;

#ifdef                                                           DFtr_fermi
    printf("n_vertex = %d\n",n_vertex);  
#endif

  returnf = currentv;

  for( n = 0; n < n_vertex; n++ )
     {
       vertex_n =  vtxline[currentv].vtxno[n];
       line_n   =  vtxline[currentv].lineno[n];

#ifdef                                                           DFtr_fermi
       printf("n = %2d  vtx[%3d]  dfn[%5d]  ferm[%2d]\n",
                    n, vertex_n, dfnumber[vertex_n],
                    iabs( intline[line_n].direct ) );
#endif

       if( vertex_n                       != parentv &&
           dfnumber[vertex_n]             >= count   &&
	   iabs( intline[line_n].direct ) == 1 )
         {
           returnf = trace_fermion( currentv, vertex_n );
         }
      }

#ifdef                                                           DFtr_fermi
     printf("return from trace_fermion v = %3d\n", returnf );
#endif

  return returnf;
}
