#===============================================================
GRCFORT	= grcfort$(EXESUFF)
EXEC	= $(GRCFORT)
LIB=	../grclib
CDIR    = $(PWD)
CURRDIR = $(CDIR)
CFLAGS  = $(COPT) -I$(LIB)

OFRL=   $(LIB)/rdgrf.o $(LIB)/rdptbl.o $(LIB)/token.o $(LIB)/ergrf.o \
	$(LIB)/putid.o $(LIB)/cfgrf.o  $(LIB)/rational.o $(LIB)/mvert.o \
	$(LIB)/dagrf.o $(LIB)/flgrf.o $(LIB)/ilgrf.o \
	$(LIB)/args.o $(LIB)/path.o $(LIB)/cfnbase.o $(LIB)/cfnconv.o \
	$(LIB)/cmutl.o $(LIB)/cmfin.o $(LIB)/cmnfort.o

OFRT=   genfort.o ftgrf.o ftmakes.o \
	$(OFRL)

#---------------------------------------------------------------

.SUFFIXES: .c .o .hd

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.c.hd:
	grep 'Public' $*.c | grep 'ARG' | sed 's/^.*://' > $*.hd

#===============================================================

all: lib $(EXEC)

$(GRCFORT): $(OFRT) $(OMK)
	$(CC) $(CFLAGS) -o $(GRCFORT) $(OFRT) $(OMK)

lib:
	(cd $(LIB); make)

install: all
	cp $(EXEC) $(BINDIR)

#================================================================

HGENCD = $(LIB)/common.h $(LIB)/dbg.h $(LIB)/ptable.h $(LIB)/grdata.h \
	$(LIB)/config.h $(LIB)/cfnbase.h $(LIB)/gensc.h $(LIB)/ergrf.h \
	$(LIB)/lprocs.h \
	grcfort.h

ftgrf.o: $(HGENCD) $(LIB)/glue4.h $(LIB)/putid.h $(LIB)/cfnconv.h \
	ftgrf.c

ftmakes.o: $(HGENCD) $(LIB)/putid.h $(LIB)/version.h \
	ftmakes.c

genfort.o: $(HGENCD) $(LIB)/token.h $(LIB)/args.h $(LIB)/glue4.h \
	$(LIB)/version.h \
	genfort.c

#================================================================
clean: 
	rm -f *.o $(EXEC) mkver *core t tt tmp* junk* *~
	for i in `ls`; do \
	    if test -d $$i && test $$i != CVS; \
                then (cd $$i; echo `pwd`; make clean); \
            fi \
	done
