/********************************************************************
 *  File : ftmakes.c *
 *  Makefile generation for single UNIX machine(HP,HI,SGI,DEC,AIX,SUN)
 *                           by Kaneko Toshiaki   95/07/13 (LAPP)
 *                                     Rev.  TI   95/07/17 (LAPP)
 *                                     Rev.  TI   95/08/04 (KEK)
 *                                     Rev.  TI   96/02/04 (KEK)
 *                                     Rev.  TK   97/02/08 (MGU)
 */

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "grdata.h"
#include "config.h"
#include "cfnbase.h"
#include "gensc.h"
#include "putid.h"
#include "version.h"
#include "grcfort.h"

/*------------------------------------------------------------------
 * parameters
 */
#define TESTMK
#ifndef CERNLIB
#define CERNLIB 0
#endif

/*------------------------------------------------------------------*/
/* Local functions */
Private Void    ftmk         ARG((int));
Private Void    ftmainvpp    ARG((NoArg));
Private Void    ftnqsshvpp   ARG((int));
Private Void    ftmavbvpp    ARG((int));
Private Void    ftmavsvpp    ARG((int));

/*------------------------------------------------------------------*/
/* Local variable */

/*==================================================================*/
Public  Void    ftmakes(NoArg)
/*------------------------------------------------------------------*
 * generate makefiles : "Makefile".
 *------------------------------------------------------------------*/
{
    int pc;

    ftmk(-1);
    if(multiprc) {
        for(pc = 0; pc < nprocs; pc++) {
            ftmk(pc);
        }
    }
}

/*==================================================================*/
Private Void    ftmk(pc)
int     pc;
/*------------------------------------------------------------------*
 * generate makefiles : "Makefile".
 *------------------------------------------------------------------*/
{
    int    g0, pp, pps, ppe;
    string prf, prfn = NULL, prfs, oname;
    int    acut;
/*
    int    gn;
*/

    if(pc < 0) {
        prf = "";
    } else {
        prf = reprocp[pc];
    }
    cmopend(ROMAKE, prf, "Makefile");

    cmachine();

    fprintf(redfp, "\n");
    fprintf(redfp, "REDUCE    = %s\n", reduce);
    fprintf(redfp, "F77       = %s\n", fortcmp);
    fprintf(redfp, "FFLAGS    = %s\n\n", fflags);
    fprintf(redfp, "LDFLAGS   = %s\n\n", lflags);
    fprintf(redfp, "GRACEDIR  = %s\n", gracedir);
    fprintf(redfp, "GRACELDIR = $(GRACEDIR)/lib\n");
    fprintf(redfp, "GRACELDIR = %s\n\n", graceldir);
    if( mpirun ) {
    fprintf(redfp, "MONITOR =\n");
    fprintf(redfp, "MPIHOME = %s\n",mpihome);
    fprintf(redfp, "MPIINC = -I$(MPIHOME)/include\n");
    fprintf(redfp, "MPILIBS = -L$(MPIHOME)/lib -lfmpi -lmpi\n");
    }

    if(vpp) {
        if(basesv == 0) {
            fprintf(redfp, "BASES1LIB  = vb1\n");
            fprintf(redfp, "BASES4LIB  = vb4\n");
            fprintf(redfp, "BASES8LIB  = vb8\n");
        } else {
            fprintf(redfp, "BASES1LIB  = vbh1\n");
            fprintf(redfp, "BASES4LIB  = vbh4\n");
            fprintf(redfp, "BASES8LIB  = vbh8\n");
        }
        fprintf(redfp, "CHANELIB   = vchaneld\n");
    } else {
        if(!vcode) {
            fprintf(redfp, "BASESLIB  = bases\n");
            fprintf(redfp, "CHANELIB  = chanel\n");
        } else {
            fprintf(redfp, "BASESLIB  = vbases\n");
            fprintf(redfp, "CHANELIB  = vchanel\n");
        }
    }
    fprintf(redfp, "KINEMLIB  = kinem\n\n");
    if(susylib) {
        fprintf(redfp, "SUSYLIB   = susy\n\n");
    }
    if(CERNLIB == 1) {
        fprintf(redfp, "CERNLIBDIR = %s\n\n", cernlib);
    }

    if(multiprc) {
        if(pc < 0) {
            pps = 0;
            ppe = nprocs;
        } else {
            pps = pc;
            ppe = pc + 1;
        }
        for(pp = pps; pp < ppe; pp++) {
            prfn = reprocp[pp];
            if(pc < 0) {
                prfs = prfn;
            } else {
                prfs = "";
            }
            sprintf(momstr, "OBJA%s        = ", prfn);
            puinit(redfp, momstr, "            ", " ", "\\", "",
                          64, -1);

            if(mergefile) {
                sprintf(momstr, "a%smps.o ", prfn);
                oname = cmpath(prfs, momstr);
                putid(oname);
            } else {
                for(g0 = 0; g0 < reprocg[pp]; g0++) {
                    sprintf(momstr, "a%sg%d.o ", prfn, g0+1);
                    oname = cmpath(prfs, momstr);
                    putid(oname);
                }
            }
            sprintf(momstr, "fnc%s.o ", prfn);
            oname = cmpath(prfs, momstr);
            putid(oname);

            sprintf(momstr, "uso%s.o ", prfn);
            oname = cmpath(prfs, momstr);
            putid(oname);

            sprintf(momstr, "a%smclr.o ", prfn);
            oname = cmpath(prfs, momstr);
            putid(oname);

            sprintf(momstr, "a%smpord.o ", prfn);
            oname = cmpath(prfs, momstr);
            putid(oname);

            sprintf(momstr, "a%smpsum.o ", prfn);
            oname = cmpath(prfs, momstr);
            putid(oname);

            sprintf(momstr, "g%sfinit.o ", prfn);
            oname = cmpath(prfs, momstr);
            putid(oname);

            sprintf(momstr, "a%skptbl.o ", prfn);
            oname = cmpath(prfs, momstr);
            putid(oname);

            sprintf(momstr, "a%smptbl.o ", prfn);
            oname = cmpath(prfs, momstr);
            putid(oname);

    /*
            gn = (reprocg[pp] + TCUT - 1)/TCUT;
            for(g0 = 0; g0 < gn; g0++) {
                sprintf(momstr, "a%smpt%d.o ", prfn, g0);
                oname = cmpath(prfs, momstr);
                putid(oname);
            }
     */

            putend();
            fprintf(redfp, "\n");

            fprintf(redfp, "SRCA%s  = $(OBJA%s:.o=.f)\n\n", prf, prf);
            fprintf(redfp, "OBJA    = $(OBJA%s)\n\n", prf);
        }

        if(pc < 0) {
            sprintf(momstr, "OBJA    = ");
            puinit(redfp, momstr, "            ", " ", "\\", "",
                          64, -1);
            for(pp = 0; pp < nprocs; pp++) {
                sprintf(momstr, "$(OBJA%s)", reprocp[pp]);
                putid(momstr);
            }
            putend();
        }

    } else {
        sprintf(momstr, "OBJA    = ");
        puinit(redfp, momstr, "            ", " ", "\\", "",
                      64, -1);

        if(mergefile) {
            sprintf(momstr, "amps.o ");
            putid(momstr);
            acut = (reprocg[0]-1)/ACUT;
            for(g0=1;g0<=acut;g0++) {
                sprintf(momstr, "amps%d.o ",g0);
                putid(momstr);
            }
        } else {
            for(g0 = 0; g0 < reprocg[0]; g0++) {
                sprintf(momstr, "ag%d.o ", g0+1);
                putid(momstr);
            }
        }
        putend();
    }

    puinit(redfp, "OBJF      = ", "            ", " ", "\\", "",
                  64, -1);
    cmfobj(redfp);

    puinit(redfp, "OBJU      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("kinit.o");
    putid("kinem.o");
    if(!vcode) {
        putid("kfill.o");
    } else {
        putid("kvfill.o");
    }
    if(jqedps) {
        putid("kinitq.o");
        putid("kinemq.o");
        putid("kfillq.o");
    }
    if(vcode) {
        putid("kinemv.o");
    }
    if(!vcode) {
        putid("func.o");
    } else {
        putid("vbfnct.o");
    }
    putid("usrout.o");
    putid("amclr.o");

    putid("amkfcd.o");
    putid("ammas2.o");
    if(!multiprc) {
        putid("ampord.o");
    }

/*
    if(cpol) {
        putid("smcpol.o");
    }
*/

    if(!multiprc) {
/*          ampt0.f, ampt1.f, ... --> amptbl.f
        gn = (reprocg[0] + TCUT - 1)/TCUT;
        for(g0 = 0; g0 < gn; g0++) {
            sprintf(momstr, "a%smpt%d.o ", prfn, g0);
            oname = cmpath(prfs, momstr);
            putid(oname);
        }
 */

        putid("ampsum.o");
    }
    putid("gfinit.o");
    if(ucode) putid("gispin.o");
    if(ilenc) {
        putid("akptbl.o");
    }

    /* CF */
    if(colorv == 0) {
        if(cprocess->extcol > 0 && cprocess->qcd < 1) {
           putid("cfcalc.o");
        }
    }
    if(!multiprc) {
        putid("amptbl.o");
    }

#ifdef TESTMK
    putid("snprpd.o");
#endif
    putend();

    fprintf(redfp, "\n");

    puinit(redfp, "OBJG      = ", "            ", " ", "\\", "",
                  64, -1);
    if(!vcode) {
    putid("gauge.o");
    } else {
    putid("gaugev.o");
    }

#if 0
    putid("prmass.o");
#endif

    if(multiprc) {
        if(pc < 0) {
            for(pp = 0; pp < nprocs; pp++) {
                prfn = prfs = reprocp[pp];
                sprintf(momstr, "gau%s.o ", prfn);
                oname = cmpath(prfs, momstr);
                putid(oname);
            }
        } else {
            sprintf(momstr, "gau%s.o ", prf);
            putid(momstr);
        }
    }
    putend();

    puinit(redfp, "OBJI      = ", "            ", " ", "\\", "",
                  64, -1);
    if(!vcode) {
        putid("mainbs.o");
        if(multiprc) {
            if(pc < 0) {
                for(pp = 0; pp < nprocs; pp++) {
                    prfn = prfs = reprocp[pp];
                    sprintf(momstr, "mnbs%s.o ", prfn);
                    oname = cmpath(prfs, momstr);
                    putid(oname);
                }
            } else {
                sprintf(momstr, "mnbs%s.o ", prfn);
                putid(momstr);
            }
        }
    } else {
        putid("mainvb.o");
        if(multiprc) {
            if(pc < 0) {
                for(pp = 0; pp < nprocs; pp++) {
                    prfn = prfs = reprocp[pp];
                    sprintf(momstr, "mnvb%s.o ", prfn);
                    oname = cmpath(prfs, momstr);
                    putid(oname);
                }
            } else {
                sprintf(momstr, "mnvb%s.o ", prfn);
                putid(momstr);
            }
        }
    }
    putend();

    puinit(redfp, "OBJS      = ", "            ", " ", "\\", "",
                  64, -1);
    if(!vcode) {
        putid("mainsp.o");
        if(multiprc) {
            if(pc < 0) {
                for(pp = 0; pp < nprocs; pp++) {
                    prfn = prfs = reprocp[pp];
                    sprintf(momstr, "mnsp%s.o ", prfn);
                    oname = cmpath(prfs, momstr);
                    putid(oname);
                }
            } else {
                sprintf(momstr, "mnsp%s.o ", prf);
                putid(momstr);
            }
        }
    } else {
        putid("mainvs.o");
        if(multiprc) {
            if(pc < 0) {
                for(pp = 0; pp < nprocs; pp++) {
                    prfn = prfs = reprocp[pp];
                    sprintf(momstr, "mnvs%s.o ", prfn);
                    oname = cmpath(prfs, momstr);
                    putid(oname);
                }
            } else {
                sprintf(momstr, "mnvs%s.o ", prf);
                putid(momstr);
            }
        }
    }

    putid("spdetc.o");
    if(multiprc) {
        if(pc < 0) {
            for(pp = 0; pp < nprocs; pp++) {
                prfn = prfs = reprocp[pp];
                sprintf(momstr, "sp%sdetc.o ", prfn);
                oname = cmpath(prfs, momstr);
                putid(oname);
            }
        } else {
            sprintf(momstr, "sp%sdetc.o ", prf);
            putid(momstr);
        }
    }

    if(jetset) {
        putid("sp2lnd.o");
    }
    putend();
    fprintf(redfp, "\n");

    if(vpp) {
        fprintf(redfp, "IOBJS1    = ");
        fprintf(redfp, "$(OBJF) $(OBJA) $(OBJU) $(OBJI1)\n");
        fprintf(redfp, "IOBJS4    = ");
        fprintf(redfp, "$(OBJF) $(OBJA) $(OBJU) $(OBJI4)\n");
        fprintf(redfp, "IOBJS8    = ");
        fprintf(redfp, "$(OBJF) $(OBJA) $(OBJU) $(OBJI8)\n");
        fprintf(redfp, "\n");

        fprintf(redfp, "INTEG1    = integ1\n");
        fprintf(redfp, "INTEG4    = integ4\n");
        fprintf(redfp, "INTEG8    = integ8\n");
        fprintf(redfp, "\n");
    } else {
        fprintf(redfp, "GOBJS     = $(OBJF) $(OBJA) $(OBJU) $(OBJG)\n");
        fprintf(redfp, "IOBJS     = $(OBJF) $(OBJA) $(OBJU) $(OBJI)\n");
        fprintf(redfp, "SOBJS     = $(OBJF) $(OBJA) $(OBJU) $(OBJS)\n");
        fprintf(redfp, "\n");

        if(!vcode) {
            fprintf(redfp, "GAUGE     = gauge\n");
            fprintf(redfp, "INTEG     = integ\n");
            fprintf(redfp, "SPRING    = spring\n");
        } else {
            fprintf(redfp, "GAUGE     = gaugev\n");
            fprintf(redfp, "INTEG     = integv\n");
            fprintf(redfp, "SPRING    = springv\n");
        }
        fprintf(redfp, "\n");

    }

    puinit(redfp, "LIBDIR    = ", "            ", " ", "\\", "",
                  64, -1);
    putid("-L$(GRACELDIR)");
    cmflibdir(redfp);
    putend();

    puinit(redfp, "LIBS      = ", "            ", " ", "\\", "",
                  64, -1);
    putid("-l$(BASESLIB)");
    putid("-l$(CHANELIB)");
    putid("-l$(KINEMLIB)");
    cmflib(redfp);
    putend();

    fprintf(redfp, "\n.SUFFIXES: .f .o\n\n");

    fprintf(redfp, ".f.o:\n");
    fprintf(redfp, "\t$(F77) $(FFLAGS) -c $*.f\n\n");

    if(vpp) {
#ifdef TESTMK
        fprintf(redfp, "entry: $(INTEG1)\n\n");
#endif
        fprintf(redfp, "all: $(INTEG1) $(INTEG4) $(INTEG8)\n\n");

        fprintf(redfp, "$(INTEG1): $(IOBJS1)\n");
        fprintf(redfp, "\t$(F77) $(LDFLAGS) -o $(INTEG1) $(IOBJS1) \\\n");
        fprintf(redfp, "\t  $(LIBDIR) $(LIBS)\n\n");

        fprintf(redfp, "$(INTEG4): $(IOBJS4)\n");
        fprintf(redfp, "\t$(F77) $(LDFLAGS) -o $(INTEG4) $(IOBJS4) \\\n");
        fprintf(redfp, "\t  $(LIBDIR) $(LIBS)\n\n");

        fprintf(redfp, "$(INTEG8): $(IOBJS8)\n");
        fprintf(redfp, "\t$(F77) $(LDFLAGS) -o $(INTEG8) $(IOBJS8) \\\n");
        fprintf(redfp, "\t  $(LIBDIR) $(LIBS)\n\n");

        if(pc >= 0) {
            fprintf(redfp, "inclk.f: \n");
            fprintf(redfp, "\tcp ../inclm.h   inclm.h\n");
            fprintf(redfp, "\tcp ../inclc.h   inclc.h\n");
            fprintf(redfp, "\tcp ../inclk.h   inclk.h\n");
            fprintf(redfp, "\tcp ../incl2.h   incl2.h\n");
            fprintf(redfp, "\tcp ../inclk.h   inclk.f\n");
            fprintf(redfp, "\tcp ../inclg.h   inclg.h\n");
#ifdef TESTMK
            fprintf(redfp, "\tcp ../snprpd.f  snprpd.f\n");
#endif
            fprintf(redfp, "\n");
        } else {
            fprintf(redfp, "inclk.f: \n");
            fprintf(redfp, "\tln -s inclk.h inclk.f\n\n");
        }

        if(multiprc && pc < 0) {
            for(pp = 0; pp < nprocs; pp++) {
                prfs = reprocp[pp];
                fprintf(redfp, "$(OBJA%s) : $(SRCA%s)\n", prfs, prfs);
                fprintf(redfp, "\t(cd %s; make objs)\n\n", prfs);
            }
        }

        fprintf(redfp, "clean-all: clean\n");
        if(multiprc && pc < 0) {
            for(pp = 0; pp < nprocs; pp++) {
                fprintf(redfp, "\t(cd %s; make clean-all)\n", reprocp[pp]);
            }
        }
        fprintf(redfp, "\trm -f *.f *.h\n\n");

        fprintf(redfp, "clean:\n");
        fprintf(redfp, "\trm -f $(INTEG1) $(INTEG4) $(INTEG8) ");
        fprintf(redfp, "*.s *.o junk* tmp* core\n\n");

    } else {  /* not vpp */
        if(!vcode) {
#ifdef TESTMK
            fprintf(redfp, "entry: inclk.f $(GAUGE) \n\n");
#endif
            fprintf(redfp, "all: inclk.f $(GAUGE) $(INTEG) $(SPRING) ");
        } else {
            fprintf(redfp, "all: inclk.f $(INTEG) $(SPRING) ");
        }
        fprintf(redfp, "\n\n");

        fprintf(redfp, "$(GAUGE): $(GOBJS)\n");
        fprintf(redfp, "\t$(F77) $(LDFLAGS) -o $(GAUGE) $(GOBJS) \\\n");
        fprintf(redfp, "\t  $(LIBDIR) $(LIBS)");
        if(susylib) {
            fprintf(redfp, " -l$(SUSYLIB)");
        }
        if(CERNLIB == 1) {
            fprintf(redfp, " \\\n\t  -L$(CERNLIBDIR) -lkernlib");
        }
        fprintf(redfp, "\n\n");

        fprintf(redfp, "$(INTEG): $(IOBJS)\n");
        fprintf(redfp, "\t$(F77) $(LDFLAGS) -o $(INTEG) $(IOBJS) \\\n");
        fprintf(redfp, "\t  $(LIBDIR) $(LIBS)");
        if(mpirun) {
            fprintf(redfp, " -l$(MPILIBS)");
        }
        if(susylib) {
            fprintf(redfp, " -l$(SUSYLIB)");
        }
        if(CERNLIB == 1) {
            fprintf(redfp, " \\\n\t  -L$(CERNLIBDIR) -lkernlib");
            fprintf(redfp, " -lgenlib -lpacklib");
        }
        fprintf(redfp, "\n\n");

        fprintf(redfp, "$(SPRING): $(SOBJS)\n");
        fprintf(redfp, "\t$(F77) $(LDFLAGS) -o $(SPRING) $(SOBJS) \\\n");
        fprintf(redfp, "\t  $(LIBDIR) $(LIBS)");
        if(susylib) {
            fprintf(redfp, " -l$(SUSYLIB)");
        }
        if(mpirun) {
            fprintf(redfp, " -l$(MPILIBS)");
        }
        if(CERNLIB == 1) {
            fprintf(redfp, " \\\n\t  -L$(CERNLIBDIR) -lkernlib");
            fprintf(redfp, " -lgenlib -lpacklib");
        }
        fprintf(redfp, "\n\n");

        if(pc >= 0) {
            fprintf(redfp, "objs : $(GOBJS) $(IOBJS) $(SOBJS)\n\n");
            fprintf(redfp, "$(GOBJS) $(IOBJS) $(SOBJS) : inclk.f\n\n");
        }

        if(pc >= 0) {
            fprintf(redfp, "inclk.f: \n");
            fprintf(redfp, "\tcp ../inclm.h   inclm.h\n");
            fprintf(redfp, "\tcp ../inclc.h   inclc.h\n");
            fprintf(redfp, "\tcp ../inclk.h   inclk.h\n");
            fprintf(redfp, "\tcp ../incl2.h   incl2.h\n");
            fprintf(redfp, "\tcp ../inclk.h   inclk.f\n");
            fprintf(redfp, "\tcp ../inclg.h   inclg.h\n");
#ifdef TESTMK
            fprintf(redfp, "\tcp ../snprpd.f  snprpd.f\n");
#endif
            fprintf(redfp, "\n");
        } else {
            fprintf(redfp, "inclk.f: \n");
            fprintf(redfp, "\tln -s inclk.h inclk.f\n\n");
        }

        if(multiprc && pc < 0) {
            for(pp = 0; pp < nprocs; pp++) {
                prfs = reprocp[pp];
                fprintf(redfp, "$(OBJA%s) : $(SRCA%s)\n", prfs, prfs);
                fprintf(redfp, "\t(cd %s; make objs)\n\n", prfs);
            }
        }

        fprintf(redfp, "clean-all: clean\n");
        if(multiprc && pc < 0) {
            for(pp = 0; pp < nprocs; pp++) {
                fprintf(redfp, "\t(cd %s; make clean-all)\n", reprocp[pp]);
            }
        }
        fprintf(redfp, "\trm -f *.f *.h\n\n");

        fprintf(redfp, "clean:\n");
        fprintf(redfp, "\trm -f $(GAUGE) $(INTEG) $(SPRING) ");
        fprintf(redfp, "*.o junk* tmp* core\n\n");
    }

    cmmkrnw();

    if(vpp) {
        ftmainvpp();
    }

#ifdef TESTMK
    cmsnprpd("");
    if(multiprc) {
        for(pp = 0; pp < nprocs; pp++) {
            cmsnprpd(reprocp[pp]);
        }
    }
#endif
}

/*==================================================================*/
Private Void    ftmainvpp(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    ftmavbvpp(1);
    ftmavbvpp(4);
    ftmavbvpp(8);

    ftmavsvpp(1);

    ftnqsshvpp(1);
    ftnqsshvpp(4);
    ftnqsshvpp(8);
}

/*==================================================================*/
#define MXPWD 100
Private Void    ftnqsshvpp(numpe)
int numpe;
/*------------------------------------------------------------------*
    make NQS shell for VPP500
 *------------------------------------------------------------------*/
{
    char   c[5];
    char   filenm[20];
    char   pwdbuf[MXPWD];
    FILE   *temp_file;

    strcpy( filenm , "vpp");

    sprintf(c,"%d",numpe);
    strcat(filenm,c);
    cmopen(RONQS, filenm);

    system("pwd > tmp");
    temp_file = fopen("tmp","r");
/*    fgets( pwdbuf , MXPWD, temp_file);*/
    fscanf( temp_file ,"%s", pwdbuf );
    printf(" %d :%s END\n",((int)strlen(pwdbuf)),pwdbuf);
    fclose( temp_file );
    system("/bin/rm -f tmp");

    fprintf(redfp,"##\n");
    fprintf(redfp,"#@$-s /bin/csh\n");
    fprintf(redfp,"#@$-q q%d%c\n",numpe,(numpe == 1 ? 'c':' '));
    fprintf(redfp,"#@$-o %s/xxx%d.out\n",pwdbuf,numpe);
    fprintf(redfp,"#@$-eo\n");
    fprintf(redfp,"#@$-me\n");
    fprintf(redfp,"#@$\n");
    fprintf(redfp,"cd %s\n",pwdbuf);
    fprintf(redfp,"timex -H integ%d -W1, -Pm0\n",numpe);
    fprintf(redfp,"time\n");
}

/*==================================================================*/
Private Void    ftmavbvpp(numpe)
int numpe;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    pindex pa;
    int    n;
    char   c[5];
    char   filenm[20];


    if(!vcode) {
        strcpy( filenm , "mainbs");
    } else {
        strcpy( filenm , "mainvb");
    }

    sprintf(c,"%d",numpe);
    strcat(filenm,c);
    strcat(filenm,".f");

    cmopen(ROFORT, filenm);

    cmsepar('*');
    if(!vcode) {
        fprintf(redfp,"* main program for BASES 5.1\n");
    } else {
        fprintf(redfp,"* main program for vector BASES 5.1\n");
    }
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);
    fprintf(redfp,"      parameter ( numpe = %d )\n",numpe);

    if(caller != GRCFORT && caller != GRCREDA) {
        fprintf(redfp,"      include 'incomm.f'\n");
    }
    fprintf(redfp,"      common / loop0  / loop\n");
    fprintf(redfp,"      common / knmflg / ");
    fprintf(redfp,"knmgvs, knmhst, knmsph, knmisr\n");
    fprintf(redfp,"      external func\n");
    putc(EOL, redfp);
    if(CERNLIB == 1 && !vcode) {
        fprintf(redfp,"      parameter ( mhsize = 100000 )\n");
        fprintf(redfp,"      common /pawc/ memory(mhsize)\n");
    }

    if(vcode) {
       fprintf(redfp,"*    Control for number of nodes\n");
       fprintf(redfp,"      common/ninfo/ nodeid, numnod, ipflag\n");
       fprintf(redfp,"*xocl processor pe(numpe)\n");
       fprintf(redfp,"*xocl parallel region\n");
    }
    fprintf(redfp,"      write(*,'(20x,a/)') 'grace %d.%2d(%02d)'\n",
            GRCVER0,GRCVER1,GRCVER2);
    fprintf(redfp,"      write(*,'(10x,a/)')\n");
    fprintf(redfp,"     .'%s'\n", CRIGHT);
    cmsepar('*');



    fprintf(redfp,"      write(*,'(5x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ',\n     .  '");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");
    cmsepar('*');
    fprintf(redfp,"*               initialization Kinematics Flags\n");
    fprintf(redfp,"*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp,"*     knmhst  : (=1)Fill historgram \n");
    fprintf(redfp,"*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp,"*     knmisr  : reserved for initial state ");
    fprintf(redfp,"radiation\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 0\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");
    fprintf(redfp,"      loop   = 1\n");

    if(CERNLIB == 1 && !vcode) {
        cmsepar('*');
        fprintf(redfp,"*               initialization of HBOOK\n");
        fprintf(redfp,"      call hlimit( mhsize )\n");
        fprintf(redfp,"      call htitle('Histograms generated by ");
        fprintf(redfp,"BASES')\n");
    }
    cmsepar('*');
    fprintf(redfp,"*               initialization of BASES/SPRING");
    fprintf(redfp," 5.1\n");
    cmsepar('*');

    cmsepar('=');
    fprintf(redfp,"*          initialization of bases by calling ");
    fprintf(redfp,"bsinit\n");
    cmsepar('=');
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsinit\n");
    fprintf(redfp,"*         -------------\n");
    if(vcode) {
        fprintf(redfp,"      numnod = numpe\n");
    }

    cmsepar('=');
    fprintf(redfp,"*      initialization of parameters\n");
    fprintf(redfp,"*          for kinematics and matrix elements\n");
    fprintf(redfp,"*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp,"*     lu     = 11\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     open(lu,file='bases.result',status='");
    fprintf(redfp,"unknown',form='formatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"           call userin( 6 )\n");
    fprintf(redfp,"*         ------------------\n");

    cmsepar('*');
    fprintf(redfp,"*              numerical integration by ");
    fprintf(redfp,"BASES 5.1\n");
    cmsepar('*');
    fprintf(redfp,"\n");
    if(!vcode) {
        fprintf(redfp,"      call bases( func, estim, sigma, ctime, ");
    } else {
        fprintf(redfp,"      call vbases( func, estim, sigma, ctime, ");
    }
    fprintf(redfp,"it1, it2 )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     call bsinfo( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     call bhplot( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     close( lu )\n");
    fprintf(redfp,"\n");

    cmsepar('*');
    fprintf(redfp,"*             event generation by SPRING 5.1\n");
    cmsepar('*');
    cmsepar('=');
    fprintf(redfp,"*     save the probability information to the ");
    fprintf(redfp,"file\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"*     lun = 23\n");
    fprintf(redfp,"*     open(lun,file='bases.data',status='");
    fprintf(redfp,"unknown',form='unformatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     call bswrit( lun )\n");
    fprintf(redfp,"*     close ( lun )\n");
    fprintf(redfp,"\n");

    if(CERNLIB == 1) {
        cmsepar('=');
        fprintf(redfp,"*     save the contents of Histograms ");
        fprintf(redfp,"into Paw buffer\n");
        cmsepar('=');
        fprintf(redfp,"      call bshbok( 0 )\n");
        fprintf(redfp,"      call hrput( 0, 'bases.hbook','N')\n");
    }
    fprintf(redfp,"*xocl end parallel\n");

    fprintf(redfp,"      stop\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    ftmavsvpp(numpe)
int numpe;
/*------------------------------------------------------------------*
 */
{
    pindex pa;
    int    n;
    char   c[5];
    char   filenm[20];

    if(!vcode) {
        strcpy(filenm , "mainsp");
    } else {
        strcpy(filenm , "mainvs");
    }

    sprintf(c,"%d",numpe);
    strcat(filenm,c);
    strcat(filenm,".f");

    cmopen(ROFORT, filenm);

    cmsepar('*');

    cmsepar('*');
    fprintf(redfp,"* main program for SPRING 5.1 for VPP\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    fprintf(redfp,"      parameter ( numpe = %d )\n",numpe);

    if(vcode) {
        fprintf(redfp,"      include 'inclvs.f'\n");
    }

    if(caller != GRCFORT && caller != GRCREDA) {
        fprintf(redfp,"      include 'incomm.f'\n");
    }
    fprintf(redfp,"      common / knmflg / ");
    fprintf(redfp,"knmgvs, knmhst, knmsph, knmisr\n");
    fprintf(redfp,"      external func\n");
    putc(EOL, redfp);

    if(vcode) {
        fprintf(redfp,"      common / sprng3 / ic(n_vector), l(n_vector)\n");
    }

    if(CERNLIB == 1 && !vcode) {
        fprintf(redfp,"      parameter ( mhsize = 100000 )\n");
        fprintf(redfp,"      common /pawc/ memory(mhsize)\n");
    }
    if(vcode) {
       fprintf(redfp,"*    Control for number of nodes\n");
       fprintf(redfp,"      common/ninfo/ nodeid, numnod, ipflag\n");
       fprintf(redfp,"*xocl processor pe(numpe)\n");
       fprintf(redfp,"*xocl parallel region\n");
    }
    fprintf(redfp,"      write(*,'(20x,a/)') 'grace %d.%2d(%02d)'\n",
            GRCVER0,GRCVER1,GRCVER2);
    fprintf(redfp,"      write(*,'(10x,a/)')\n");
    fprintf(redfp,"     .'%s'\n", CRIGHT);

    fprintf(redfp,"      write(*,'(5x,a/)')\n");
    fprintf(redfp,"     .'Process: ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp, " --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp, "%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n");

    cmsepar('*');
    fprintf(redfp,"*               initialization Kinematics Flags\n");
    fprintf(redfp,"*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp,"*     knmhst  : (=1)Fill historgram for BASES\n");
    fprintf(redfp,"*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp,"*     knmisr  : reserved for initial state ");
    fprintf(redfp,"radiation\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 0\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");
    cmsepar('*');
    if(CERNLIB == 1 && !vcode) {
        cmsepar('*');
        fprintf(redfp,"*               initialization of HBOOK\n");
        fprintf(redfp,"      call hlimit( mhsize )\n");
    }
    fprintf(redfp,"*               initialization of BASES/SPRING");
    fprintf(redfp," 5.1\n");
    cmsepar('*');

    cmsepar('=');
    fprintf(redfp,"*          initialization of bases by calling ");
    fprintf(redfp,"bsinit\n");
    cmsepar('=');
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsinit\n");
    fprintf(redfp,"*         -------------\n");

    cmsepar('=');
    fprintf(redfp,"*          read the probability information from ");
    fprintf(redfp,"the file\n");
    cmsepar('=');
    fprintf(redfp,"           lun = 23\n");
    fprintf(redfp,"           open(lun,file='bases.data',status='");
    fprintf(redfp,"old',form='unformatted')\n");
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsread( lun )\n");
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           close( lun )\n");
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp,"*      initialization of parameters\n");
    fprintf(redfp,"*          for kinematics and matrix elements\n");
    fprintf(redfp,"*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp,"      lu     = 12\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      open(lu,file='spring.result',status='");
    fprintf(redfp,"unknown',form='formatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"           call userin( lu )\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp,"*     initialization of additional histograms ");
    fprintf(redfp,"for spring\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    cmsepar('=');
    fprintf(redfp,"*     event generation\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"      mxtry  = 50\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      mxevnt = 10000\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(6,*)' number of events ? '\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     read(5,*) mxevnt\n");
    fprintf(redfp,"\n");
    if(!vcode) {
    fprintf(redfp,"      do 100 nevnt = 1, mxevnt\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         call spring( func, mxtry )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"*        compute the four vectors of generated ");
    fprintf(redfp,"event\n");
    fprintf(redfp,"*          from the kinematical variables\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*        do 90 k = 1 , nextn\n");
    fprintf(redfp,"*           write(6,*) (vec(j,k),j=1,4)\n");
    fprintf(redfp,"*  90    continue\n");
    fprintf(redfp,"  100 continue\n");
    } else {
    fprintf(redfp,"      msum = 0\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"  100 continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         call vsprng( func, mxtry )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"*        compute the four vectors of generated ");
    fprintf(redfp,"event\n");
    fprintf(redfp,"*          from the kinematical variables\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         do 90 i = 1 , n_vector\n");
    fprintf(redfp,"            if(ic(i) .eq. 0) then\n");
    fprintf(redfp,"                msum = msum + 1\n");
    fprintf(redfp,"*               do 80 k = 1 , nextn\n");
    fprintf(redfp,"*                  write(6,*) (vec(j,k),j=1,4)\n");
    fprintf(redfp,"*  80           continue\n");
    fprintf(redfp,"            endif\n");
    fprintf(redfp,"   90    continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      if(msum .lt. mxevnt) goto 100\n");

    }
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call spinfo( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call shplot( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      close( lu )\n");
    fprintf(redfp,"\n");
    if(CERNLIB == 1 && !vcode) {
        cmsepar('=');
        fprintf(redfp,"*     save the contents of Histograms ");
        fprintf(redfp,"into Paw buffer\n");
        cmsepar('=');
        fprintf(redfp,"      call bshbok( 0 )\n");
        fprintf(redfp,"      call sphbok( 0 )\n");
        fprintf(redfp,"      call hrput( 0, 'spring.hbook','N')\n");
    }
    fprintf(redfp,"*xocl end parallel\n");
    fprintf(redfp,"      stop\n");
    fprintf(redfp,"      end\n");
    fprintf(redfp,"\n");
}
