#===============================================================
CDIR    = $(PWD)
CURRDIR = $(CDIR)
CFLAGS  = $(COPT)

OBJS=	args.o conserv.o dagrf.o divide.o ergrf.o flgrf.o \
	ilgrf.o mvert.o outf.o path.o perm.o \
	pset.o rdgrf.o rdptbl.o tlgrf.o token.o \
	cfnbase.o cfnconv.o cmnfort.o \
	cfbase.o cfconv.o cmfort.o \
	cfgrf.o putid.o rational.o \
	cmfin.o cmutl.o ordset.o

#---------------------------------------------------------------

.SUFFIXES: .c .o

.c.o:
	$(CC) $(CFLAGS) -c $*.c

#===============================================================

all: $(OBJS)

install:

version: mkver
	./mkver
	rm mkver

mkver: mkver.c
	$(CC) $(CFLAGS) -o mkver mkver.c

#================================================================
HGRDATA = common.h dbg.h ptable.h grdata.h ergrf.h lprocs.h lib.h

args.o: common.h config.h version.h args.h args.c

cfbase.o: common.h cfconv.h cfbase.h cfbase.c

cfconv.o: $(HGRDATA) glue4.h cfbase.h cfconv.h cfconv.c

cmfort.o: $(HGRDATA) config.h putid.h path.h gensc.h \
	cfbase.h cfconv.h version.h cmnfort.c

cfnbase.o: common.h cfnconv.h cfnbase.h cfnbase.c

cfnconv.o: $(HGRDATA) glue4.h cfnbase.h cfnconv.h cfnconv.c

cmnfort.o: $(HGRDATA) config.h putid.h path.h gensc.h \
	cfnbase.h cfnconv.h version.h cmnfort.c

cfgrf.o: $(HGRDATA) rational.h glue4.h cfgrf.c

cmfin.o: $(HGRDATA) config.h putid.h gensc.h cfnbase.h cmfin.c

cmutl.o: $(HGRDATA) config.h gensc.h version.h cmutl.c

conserv.o: $(HGRDATA) conserv.h conserv.c

dagrf.o: $(HGRDATA) dagrf.c

divide.o: common.h divide.h divide.c

ergrf.o: common.h dbg.h ergrf.c

flgrf.o: $(HGRDATA) flgrf.c

ilgrf.o: $(HGRDATA) ilgrf.c

mkver.o: common.h mkver.c

mvert.o: $(HGRDATA) mvert.c

ordset.o: $(HGRDATA) ordset.c

outf.o: $(HGRDATA) version.h outf.c

path.o: common.h path.h path.c

perm.o: common.h perm.h perm.c

pset.o: $(HGRDATA) pset.h pset.c

putid.o: common.h putid.h putid.c

rational.o: common.h rational.h rational.c

rdgrf.o: $(HGRDATA) version.h token.h rdgrf.c

rdptbl.o: $(HGRDATA) version.h config.h path.h token.h rdptbl.c

tlgrf.o: $(HGRDATA) tlgrf.c

token.o: common.h dbg.h token.h escchar.h token.c

#===============================================================
# for test
ordset: $(HGRDATA) ordset.c
	$(CC) $(CFLAGS) -DTESTMAIN -o ordset ordset.c

#===============================================================
clean: 
	rm -f *.o mkver *core tmp* junk* *.bak t ordset t tt t[0-9] *~
	for i in `ls`; do \
	    if test -d $$i && test $$i != CVS ; \
                then (cd $$i; echo `pwd`; make clean) ; \
            fi \
	done
