/*********************************************************************
 *  File :  conserv.h
 *
 *  Analysis of conservation of particles in the defined model.
 *
 *  When "conserv()" is called, "coindep-1" conservation lows will be
 *  found.
 *  The coefficient of i-th conservation low for p-th particle is:
 *
 *        coctbl[p][i]/coctbl[p][0]
 *
 *                                               by Kaneko Toshiaki
 */

#ifdef DEFGLOBAL
Global int   coindep;
Global int **coctbl=NULL;
#else
Global int   coindep;
Global int **coctbl;
#endif
