/*********************************************************************
 *  File :  gensc.h
 *
 *  Global variables for generationg source code.
 *
 *                                               by Kaneko Toshiaki
 */

Global bool   divpart;   /* create divergent part */
Global bool   junpei;
Global bool   tishika;
Global bool   ykqcd;     /* YK QCD */
Global bool   ampl;
Global bool   dimrn;     /* Dimensional Redcution */
Global bool   pubys;     /* pubys version */
Global bool   pubms;     /* pubms version (Momentum Shift)*/
Global bool   lcalone;   /* Loop Cal. at Once version (20000730)*/
Global bool   opver;     /* OP version */
Global bool   gm2;       /* flag for g-2 */
Global bool   mencode;     /* use encoded momenta */
Global int    counta;    /* amplitude of a counter term */
Global int    qcd;
Global int    vcode;
Global int    rvcode;
Global int    rcode;
Global int    ucode;     /* Unify code for multi-process */
Global int    lang;
Global int    caller;
Global int    cpol;
Global int    ilenc;        /* use encoded i-line number */

Global bool   mergefile; /* merge source code of amplitudes */

Global int    colorv;    /* New Color Factor version */
Global int    basesv;    /* BASES/SPRING version (0:org,1:hundred)*/
Global bool   minami;    /* Minami-Tateya tentative version flag */
Global bool   mpirun;    /* MPI run Flag*/
Global bool   jtgamm;    /* T-chanel Gamma (smintp) */
Global bool   jano3v;    /* Anomalous Coupling smvww */
Global bool   jqmas0;    /* Quark Mass 0*/
Global bool   jcolmb;    /* Coulomb Correction */
Global bool   jqcdcr;    /* QCD Correction */
Global bool   jetset;    /* Interface to jetset */
Global bool   jqedps;    /* QED-PS interface only for grc4f/susy23 */
Global bool   susylib;   /* SUSY library (tentaive)*/
Global int    hltype;    /* type for Helicity version 021004 */

Global FILE   *redfp;

Global int    nextern;
Global int    nilines;

#ifdef DEFGLOBAL
Global int    x0 = 2;   /* loop momentum => x2 */
#else
Global int    x0;
#endif

Global int    momoffs;
Global int    legoffs;
Global int    conjstart;
Global int    kloop;

Global char   outname[MAXPATHLEN];

Global char   momstr[MAXPATHLEN];
Global char   momstr1[MAXPATHLEN];
Global char   momstr2[MAXPATHLEN];
Global char   momstr3[MAXPATHLEN];
Global char   momstr4[MAXPATHLEN];
Global char   momstr5[MAXPATHLEN];
Global char   momstr6[MAXPATHLEN];

/* The table of processes. */
Global int    nprocs;
Global int    maxloop;
Global int    cnprc;    /*the current process : arg of daread */
Global int    cprocs;   /*the current process : index of arrays below */
Global int    reproct[MAXPROCS];  /* the table of process numbers */
Global int    reprocg[MAXPROCS];  /*the table of the number of graphs */
Global string reprocp[MAXPROCS];  /*the table of the prefix of graphs */
Global string cprefix;            /* the current prefix */

/* Global int    *grftype[MAXPROCS];*//* Graph type for grchl*/

/* The current graph */
Global int cngraph;

/* table of gauge parameters */
#define NGAUGE 10
#ifdef DEFGLOBAL
Global int ngauge = -1;
#else
Global int ngauge;
#endif
Global string sgauge[NGAUGE];
Global Ulong  gmask[NGAUGE];

/* table of graph selection */
#define NSELECT 10
#ifdef DEFGLOBAL
Global int nselect = -1;
#else
Global int nselect;
#endif
Global string sselect[NGAUGE];
Global Ulong  sselmask[NGAUGE];

#ifdef DEFGLOBAL
Global char gchr[6] = "?awzg";
Global char ftsuorv[3][2] = {"\0", "u","v"};
Global bool ampl = False;
Global long selgraph = -1L;
#else
Global char gchr[6];
Global char ftsuorv[3][2];
Global bool ampl;
Global long   selgraph;
#endif

/* multi-process ? */
Global bool multiprc;

/* program type used in reopen */
#define RONONE -1
#define ROFORM  0
#define ROFORT  1
#define ROC     2
#define ROMAKE  3
#define ROSH    4
#define RORED   5
#define ROFORM1 6
#define ROREDA  7
#define RONQS   8

/* type of caller */
#define GRCNONE -1
#define GRCFORT  0
#define GRCRED   1
#define GRCREDA  2
#define GRCFORM  3
#define GRCREDH  4

#define lp0min(lp)  ((int)((lp)+1)/2)
#define lp0max(lp)  (lp)

/* cut set of graphs into ampt0.f, ampt1.f ... */
#define TCUT    (100)
/* cut set of graphs into amps0.f, amps1.f ... */
#define ACUT    (500)

/* machine options ---> grclib/config.h */
#ifdef DEFGLOBAL
/*
Global string fortcmp = NULL;
Global string fflags  = NULL;
Global string reduce  = NULL;
Global string cernlib = NULL;
*/
Global bool   vpp     = False;
#else
/*
Global string fortcmp;
Global string fflags;
Global string reduce;
Global string cernlib;
*/
Global bool   vpp;
#endif
