/*********************************************************************
 *  File : glue4.h
 *
 *  Include file for expanding 4 gluon vertices to 3 gluon vertices.
 *
 *                                                 by Kaneko Toshiaki
 *
 * For node "nd" and (1 <= ndgl4(nd) <= 3)
 * 4 gluon vertices is decomposed to
 *
 *    a[0]           a[3]
 *         \       /
 *          \     /
 *           +---+
 *          /     \
 *         /       \
 *    a[1]           a[2]
 *
 * where
 *
 *     a[i] = glue4leg[ndgl4(nd), i];
 *
 */

Global int glue4leg[4][4] 
#ifdef DEFGLOBAL
    = { {0, 1, 2, 3}, {0, 1, 2, 3}, {0, 3, 1, 2}, {0, 2, 3, 1} }
#endif
    ;
