/*******************************************************************
 *    File : tlgrf.c
 *
 *    tools to analyze graph.
 *                                                 by Kaneko Toshiaki
 */

#include <stdlib.h>
#include <stdio.h>
#include <errno.h>
#include "grdata.h"

/*==================================================================*/
Public  int     tledge(nd1, nd2, ptcl)
node    nd1, nd2;
pindex  *ptcl;
/*--------------------------------------------------------------------
    make table edges between nd1 and nd2.
    the number of edges is returned.
--------------------------------------------------------------------*/
{
    int c, l;

#if DBG
    if(dbg >= tldbg) {
        printf("tledge(%d, %d) = ", nd1, nd2);
    }
#endif

    for(l = 0, c = 0; l < ndlegs(nd1); l++) {
        if(ndnextn(nd1, l) == nd2) {
            ptcl[c++] = ndparticle(nd1, l);
        }
    }

#if DBG
    if(dbg >= tldbg) {
        printf("%d\n", c);
    }
#endif

    return c;
}

/*==================================================================*/
Public  int     tlconn(n1, n2)
node     n1, n2;
/*--------------------------------------------------------------------
    Check if two nodes are adjacent or not.
--------------------------------------------------------------------*/
{
    int j;

    for(j = 0; j < ndlegs(n1); j++) {
        if(ndnextn(n1, j) == n2) {
            return True;
        }
    }
    return False;
}

