/*********************************************************************
 *    File : token.h
 *
 *    Include file to use token.c
 *
 *                                              by Kaneko Toshiaki
 */

#ifndef DBG
#define DBG 1
Global  int dbg;
Global  int rddbg;
#endif

/* variables given by "rdtoken" */
typedef struct {
        int     opt;
        int     arg;
        int     brother;
        int     ttype;
        union {
            char        tchar;
            long        tnum[2];
            string      tstr;
        } dat;
}       trdtoken;

/* save area */
typedef struct {
        FILE   *rdin;
        FILE   *rdecho;
        int     rdtol;
        int     rdc;
        int     rdln;
}       trdsava;

/* entry points of the file "token.c" */
#ifdef ANSI
Public  Void    rdinit          ARG((FILE*, int, FILE*));
Public  Void    rdsimple        ARG((NoArg));
Public  Void    rdadvanced      ARG((NoArg));
Public  Void    rdend           ARG((NoArg));
Public  Void    rdsave          ARG((trdsava*));
Public  Void    rdrestore       ARG((trdsava*));

Public  bool    rdtoken         ARG((trdtoken*,string,int));

Public  int     rdstat          ARG((NoArg));

Public  Void    rdpstat         ARG((int,int));
Public  Void    rdprint         ARG((int));

Public  bool    rdbool          ARG((int,int*));
Public  bool    rdenum          ARG((int,int*,int,string*,int*));
Public  bool    rdintarg        ARG((int,int*));
Public  bool    rdchkid         ARG((int,string));
Public  bool    rdkval          ARG((int, string, long*));
Public  Void    rdskpid         ARG((string));
Public  Void    rddump          ARG((int));
Public  int     rdstrcmp        ARG((string,string));

#endif

/* size parameters */
#define MAXLID          32      /* id length */
#define MAXLNUMB        9       /* maxinum length of number */

/* return value of "rdtype" */
#define RDID            2
#define RDINT           3
#define RDRNUM          4
#define RDSTRING        5
#define RDSPECIAL       6
#define RDTHROUGH       7
#define RDEOF           -1
#define RDERR           -2
#define RDNULL          -3
/* or EOF */

/* flag for case conversion */
#define RDNOCHANGE      0
#define RDTOUPPER       1
#define RDTOLOWER       2

#undef  RDNOCHANGE
#define RDNOCHANGE	RDTOLOWER

#define LRDTABLE 100
Global  trdtoken rdtable[LRDTABLE]; /* buffer of token elements */
Global  int     rdcurr;

#define LRDBUFF  1024
Global  char    rdbuff[LRDBUFF];  /* buffer of strings */
Global  int     rdbuffp;

Global  int     rdsln;      /* line number of statement */

/* acess function */
#define rdopt(i)        rdtable[i].opt
#define rdarg(i)        (((i)<0) ? -1 : rdtable[i].arg)
#define rdbrothr(i)     (((i)<0) ? -1 : rdtable[i].brother)
#define rdtype(i)       (((i)<0) ? RDNULL : rdtable[i].ttype)
#define rdchar(i)       rdtable[i].dat.tchar
#define rdint(i)        rdtable[i].dat.tnum[0]
#define rdrnum(i,j)     rdtable[i].dat.tnum[j]
#define rdid(i)         rdtable[i].dat.tstr

/*---------- end of token.h ---------------------------------------*/
