#===============================================================
GRC	= grc$(EXESUFF)
GRCPRC	= grcprc$(EXESUFF)
EXEC    = $(GRC) $(GRCPRC)
LIB     = ../grclib
CDIR    = $(PWD)
CURRDIR = $(CDIR)
CFLAGS  = $(COPT) -I$(LIB)

OGRL= 	$(LIB)/args.o $(LIB)/divide.o \
	$(LIB)/ergrf.o $(LIB)/flgrf.o $(LIB)/ilgrf.o \
	$(LIB)/mvert.o $(LIB)/outf.o $(LIB)/path.o $(LIB)/perm.o \
	$(LIB)/rdptbl.o $(LIB)/token.o $(LIB)/pset.o $(LIB)/ordset.o

OGRC=	grc.o alist.o assign.o axconn.o bfconn.o biconn.o elem.o gnode.o \
	hepend.o iline.o lclass.o print.o rdprocs.o scalar.o \
	$(OGRL)

OPRL=	$(LIB)/args.o $(LIB)/conserv.o $(LIB)/ergrf.o $(LIB)/path.o \
	$(LIB)/rdptbl.o $(LIB)/token.o $(LIB)/pset.o $(LIB)/ordset.o

OPRC= elem.o genprc.o rdprocs.o \
	$(OPRL)

#---------------------------------------------------------------

.SUFFIXES: .c .o

.c.o:
	$(CC) $(CFLAGS) -c $*.c

#===============================================================

all: lib $(EXEC)

$(GRC): $(OGRC)
	$(CC) $(CFLAGS) -o $(GRC) $(OGRC)

$(GRCPRC): $(OPRC)
	$(CC) $(CLFAGS) -o $(GRCPRC) $(OPRC) -lm

install: 
	cp $(EXEC) $(BINDIR)

lib:
	(cd $(LIB); make)

#================================================================
HGRDATA = $(LIB)/common.h $(LIB)/dbg.h $(LIB)/ptable.h $(LIB)/grdata.h \
	$(LIB)/config.h $(LIB)/ergrf.h 

HGRCH = $(HGRDATA) dbg.h grc.h proto.h

HGRCM =	$(LIB)/config.h $(LIB)/token.h $(LIB)/args.h $(LIB)/version.h \
	$(LIB)/pset.h

alist.o: $(HGRCH) alist.c

assign.o: $(HGRCH) assign.c

bfconn.o: $(HGRCH) bfconn.c

biconn.o: $(HGRCH) biconn.c

elem.o: $(HGRCH) elem.c

genprc.o: $(HGRCH) $(HGRCM) $(LIB)/conserv.h genprc.c

gnode.o: $(HGRCH) gnode.c

grc.o: $(HGRCH) $(HGRCM) grc.c

hepend.o: $(HGRCH) hepend.c

iline.o: $(HGRCH) iline.c

lclass.o: $(HGRCH) $(LIB)/perm.h lclass.c

print.o: $(HGRCH) print.c

rdprocs.o: $(HGRCH) $(LIB)/token.h rdprocs.c

scalar.o: $(HGRCH) scalar.c

#===============================================================
clean: 
	rm -f *.o $(EXEC) mkver *core tmp* junk* *~
	for i in `ls`; do \
	    if test -d $$i && test $$i != CVS ; \
                then (cd $$i; echo `pwd`; make clean) ; \
            fi \
	done
