#===============================================================
GRCDRAW	= grcdraw$(EXESUFF)
GRCPLOT	= grcplot$(EXESUFF)
GRCMDL	= grcmdl$(EXESUFF)
QCDCUT	= qcdcut$(EXESUFF)
GRCMOM	= grcmom$(EXESUFF)
TREAD	= tread$(EXESUFF)
GRCCUT	= grccut$(EXESUFF)
EXEC	= $(GRCDRAW) $(GRCPLOT) $(GRCMDL) $(QCDCUT) $(TREAD) $(QCDCORR) $(GRCMOM)
EXEA    = $(EXEC) $(GRCCUT)
LIB     = ../grclib
CDIR    = $(PWD)
CURRDIR = $(CDIR)
CFLAGS  = $(COPT) -I$(LIB)

ODRL=	$(LIB)/args.o $(LIB)/dagrf.o $(LIB)/ergrf.o $(LIB)/flgrf.o \
	$(LIB)/ilgrf.o $(LIB)/mvert.o $(LIB)/outf.o $(LIB)/path.o \
	$(LIB)/rdgrf.o $(LIB)/rdptbl.o $(LIB)/tlgrf.o $(LIB)/token.o \
	$(LIB)/ordset.o

ODRW=	draw.o drgrf.o dcx.o vr.o vrps.o vrx.o window.o \
	$(ODRL)

OPLL=	$(LIB)/args.o $(LIB)/dagrf.o $(LIB)/ergrf.o $(LIB)/flgrf.o \
	$(LIB)/ilgrf.o $(LIB)/mvert.o $(LIB)/outf.o $(LIB)/path.o \
	$(LIB)/rdgrf.o $(LIB)/rdptbl.o $(LIB)/tlgrf.o $(LIB)/token.o \
	$(LIB)/ordset.o

OPLT=	plot.o drgrf.o vrplot.o vrps.o window.o \
	$(OPLL)

OPRL=	$(LIB)/args.o $(LIB)/ergrf.o $(LIB)/path.o $(LIB)/rdptbl.o \
	$(LIB)/token.o $(LIB)/ordset.o

OPRD=	pread.o \
	$(OPRL)

OCUL=	$(LIB)/ergrf.o $(LIB)/flgrf.o $(LIB)/ilgrf.o $(LIB)/mvert.o \
	$(LIB)/outf.o $(LIB)/path.o $(LIB)/rdgrf.o $(LIB)/rdptbl.o \
	$(LIB)/token.o $(LIB)/ordset.o $(LIB)/dagrf.o 

OCUT=	grccut.o \
	$(OCUL)

OTRL=	$(LIB)/dagrf.o $(LIB)/ergrf.o $(LIB)/flgrf.o $(LIB)/ilgrf.o \
	$(LIB)/mvert.o $(LIB)/outf.o $(LIB)/path.o $(LIB)/rdgrf.o \
	$(LIB)/rdptbl.o $(LIB)/token.o $(LIB)/ordset.o $(LIB)/cfbase.o \
	$(LIB)/cfconv.o

OQED=	$(LIB)/dagrf.o $(LIB)/ergrf.o $(LIB)/flgrf.o $(LIB)/ilgrf.o \
	$(LIB)/mvert.o $(LIB)/outf.o $(LIB)/path.o $(LIB)/rdgrf.o \
	$(LIB)/rdptbl.o $(LIB)/token.o $(LIB)/ordset.o $(LIB)/cfbase.o \
	$(LIB)/cfconv.o $(LIB)/cmutl.o

OMOM=	grcmom.o \
	$(OTRL)

OTRD=	tread.o \
	$(OTRL)

OQCC=	qcdcut.o $(LIB)/args.o\
	$(OTRL)

#---------------------------------------------------------------

.SUFFIXES: .c .o .hd

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.c.hd:
	grep 'Public' $*.c | grep 'ARG' | sed 's/^.*://' > $*.hd

#===============================================================

standard: lib $(EXEC) setgrc setgrc.bash

all: lib $(EXEA) setgrc setgrc.bash

$(GRCDRAW): $(ODRW)
	$(CC) $(CFLAGS) -o $(GRCDRAW) $(ODRW) $(XOPTL) -lm $(XLLIB)

$(GRCPLOT): $(OPLT)
	$(CC) $(CLFAGS) -o $(GRCPLOT) $(OPLT) -lm

$(GRCMDL): $(OPRD)
	$(CC) $(OPTC) -o $(GRCMDL) $(OPRD)

lib:
	(cd $(LIB); make)

#------------------
# optional
#------------------
$(GRCCUT): $(OCUT)
	$(CC) $(OPTC) -o $(GRCCUT) $(OCUT)

$(GRCMOM): $(OMOM)
	$(CC) $(OPTC) -o $(GRCMOM) $(OMOM)

$(TREAD): $(OTRD)
	$(CC) $(OPTC) -o $(TREAD) $(OTRD)

$(QCDCORR): $(OQEDM)
	$(CC) $(OPTC) -o $(QCDCORR) $(OQEDM)

$(QCDCUT): $(OQCC)
	$(CC) $(OPTC) -o $(QCDCUT) $(OQCC)

#===============================================================

install: $(EXEC) setgrc.bin setgrc.bash.bin
	cp $(EXEC) $(BINDIR)
	cp setgrc.bin $(BINDIR)/../setgrc
	cp setgrc.bash.bin $(BINDIR)/../setgrc.bash

setgrc.tpl: Makefile
	@echo alias grc=grcsrc/grc             >  setgrc.tpl
	@echo alias grcprc=grcsrc/grcprc       >> setgrc.tpl
	@echo alias grcdraw=grcutl/grcdraw     >> setgrc.tpl
	@echo alias grcmdl=grcutl/grcmdl       >> setgrc.tpl
	@echo alias grcplot=grcutl/grcplot     >> setgrc.tpl
	@echo alias qcdcut=grcutl/qcdcut       >> setgrc.tpl
	@echo alias grcfort=grcfort/grcfort    >> setgrc.tpl
	@echo alias grcred=grcred/grcred       >> setgrc.tpl
	@echo alias grcform=grcform/grcform    >> setgrc.tpl
	@echo alias grcvorm=grcvorm/grcvorm    >> setgrc.tpl
	@echo alias grcsel=grcsel/grcsel       >> setgrc.tpl
	@echo alias gracefig=gracefig/gracefig >> setgrc.tpl

setgrc.bin: Makefile setgrc.tpl
	@sed -e "s|=.*/| $(BINDIR)/|" < setgrc.tpl > setgrc.bin

setgrc.bash.bin: Makefile setgrc.tpl
	@sed -e "s|=.*/|=$(BINDIR)/|" < setgrc.tpl > setgrc.bash.bin

setgrc: Makefile setgrc.tpl
	@sed -e "s|=| $(CURRDIR)/../|" < setgrc.tpl > setgrc

setgrc.bash: Makefile setgrc.tpl
	@sed -e "s|=|=$(CURRDIR)/../|" < setgrc.tpl > setgrc.bash

#================================================================
HGRDATA = $(LIB)/common.h $(LIB)/dbg.h $(LIB)/ptable.h $(LIB)/grdata.h \
	$(LIB)/config.h $(LIB)/cfbase.h $(LIB)/gensc.h $(LIB)/ergrf.h \
	$(LIB)/lprocs.h


HVRH = $(LIB)/common.h vrcolor.h vr.h

dcx.o: $(HVRH) $(LIB)/dbg.h dcx.h draw.h dcx.c
	$(CC) $(CFLAGS) $(XOPTI) $(XCOPT) -c dcx.c

draw.o: $(HGRDATA) $(HVRH) $(LIB)/config.h $(LIB)/token.h $(LIB)/args.h \
	$(LIB)/version.h window.h draw.h draw.c

drgrf.o: $(HGRDATA) vrcolor.h window.h drgrf.h drgrf.c


grccut.o: $(HGRDATA) $(LIB)/config.h $(LIB)/token.h grccut.c

plot.o: $(HGRDATA) $(HVRH) $(LIB)/config.h $(LIB)/token.h \
	$(LIB)/args.h $(LIB)/version.h \
	drgrf.h window.h plot.c

pread.o: $(HGRDATA) $(LIB)/config.h $(LIB)/token.h $(LIB)/args.h \
	$(LIB)/version.h \
	pread.c

grcmom.o: $(HGRDATA) $(LIB)/config.h $(LIB)/token.h grcmom.c

tread.o: $(HGRDATA) $(LIB)/config.h $(LIB)/token.h tread.c

vr.o: $(HVRH) vrx.h vrf.h vr.c

vrplot.o: $(HVRH) vrf.h vrplot.c

vrps.o: $(HVRH) vrf.h vrps.c

vrx.o: $(HVRH) vrx.h dcx.h vrx.c
	$(CC) $(CFLAGS) $(XOPTI) $(XCOPT) -c vrx.c

vrxfig.o: $(HVRH) vrx.h vrxfig.c

window.o: $(HVRH) window.h window.c

#===============================================================
clean: 
	rm -f *.o $(EXEA) mkver *core tmp* junk* *.bak *~
	for i in `ls`; do \
	    if test -d $$i && test $$i != CVS ; \
                then (cd $$i; echo `pwd`; make clean) ; \
            fi \
	done
