/*********************************************************************
  File : tread.c

  Entry for testing particle table
*/

#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <stdio.h>

#define  DEBUG
#define  DEFGLOBAL
#include "grdata.h"
#include "config.h"
#include "token.h"
#include "cfnbase.h"
#include "cfnconv.h"
#include "gensc.h"

/*--------------------------------------------------------------------
 * Local functions
 */
Private Void   grcarg           ARG((int, char**));

/*--------------------------------------------------------------------
 * Local variables
 */
Local   char    fgname[] = "out.grf";
Local   char    fgoutn[] = "out1.grf";
Local   char    fngrf[MAXPATHLEN];

Local   int     proct[MAXPROCS];
Local   int     procl[MAXPROCS];
Local   int     procg[MAXPROCS];

#define ilpartl(l,lg)     \
        ndparticle(iltable[l].ilnodes[lg],iltable[l].illegs[lg])
#define ilpart(l)     abs(ilpartl(l, 0))

/*==================================================================*/
Public  int    main(argc, argv)
int     argc;
char    **argv;
/*--------------------------------------------------------------------
    Main routine for graph drawin
--------------------------------------------------------------------*/
{
    FILE     *fpout;
    int       nprocs;
    int       gr;
    int       pc, cnprc, nextern, nilines, cngraph;
    tgraph   *graph = NULL;
    tproc    *proc;
    int       csgn = 1;
    int       ibase = 0, iprt = 0;

    int       fl, il;

    int       nnodes;
    node      n;
    vindex    vt;
    colorv = 1;

#if DBG
    trace   = 0;
#endif

#if DBG
    /* debugging flags for modules.
     * if(dbg >= xxdbg) then enable debugging
     */
    dbg = 0;
    dadbg = 1;  /* debug flag for dagrf.c */
    fldbg = 2;  /* debug flag for flgrf.c */
    ildbg = 2;  /* debug flag for ilgrf.c */
    pmdbg = 2;  /* debug flag for matchv.c */
    rddbg = 2;  /* debug flag for token.c */
    rgdbg = 2;  /* debug flag for rdgrf.c */
    pvdbg = 2;  /* debug flag for rdptbl.c */
#endif

    grcarg(argc, argv);   /* analyze arguments */

    if((fpout = fopen(fgoutn, "w")) == NULL) {
        fprintf(Stderr, "*** cannot open \"%s\"\n", fgoutn);
        exit(FAIL);
    }

    /* CF */
    if((gcolgr = (cftgraph *) malloc(sizeof(cftgraph))) == NULL) {
         fprintf(Stderr, "*** gcolgr: memory allocation failed\n");
         exit(1);
    }
    if((gcbase = (cftbase *) malloc(sizeof(cftbase))) == NULL) {
         fprintf(Stderr, "*** gcbase: memory allocation failed\n");
         exit(1);  
    }

    genct  = True;
    nprocs = dasave(fngrf, procl, procg);
    for(pc = 0; pc < nprocs; pc++) {
        proct[pc] = pc;
    }
    /* dainfodmp(stdout); */


    fofinit(fpout);

    for(pc = 0; pc < nprocs; pc++) {
        printf("%% +++ process = %d/%d +++\n", pc+1, nprocs);

        cnprc    = proct[pc];       /* process number */
        proc     = dagetp(cnprc);     /* process data */
        cprocess = proc;
        nextern  = cprocess->oextern;

        for(gr = 0; gr < procg[pc]; gr++) {
            printf("%% +++ graph = %d/%d (%d/%d) +++\n",
                   gr+1, procg[pc], pc+1, nprocs);

            if(gr == 0) {
                cngraph = 0;
                cgraph  = daread0(cnprc, cngraph);
                ilmom();                    /* initialize i-line table */
                nilines = cgraph->nilines;
                flget(cgraph);
                fofproc(fpout, proc, cgraph, NULL);
                if(colorv == 1) {
                    cfcbase(gcbase);
                    cfbase(gcbase,ibase,iprt);
#ifdef DEBUG
                    printf("call cfbdump:1\n");
                    cfbdump(gcbase);
#endif
                    if(gcbase->nbase == 1 && gcbase->nexcolor == 0) {
                        printf("No Color Particle\n");
                    }
                }

            }
            cngraph = gr;
            graph   = daread(cnprc, cngraph);
            cgraph  = graph;

            ilmom();
            nilines = cgraph->nilines;
            flget(cgraph); 
            for( fl=0 ; fl<nflines ; fl++) {
                 if( fltable[fl].type == FLCLOSED ) {
                     il  = ndiline(fltable[fl].ndlist[0],
                           fltable[fl].lglist[FL_OUT][0]);
                 }
            }

            if(colorv == 1) {

/*
                if(!(gcbase->nbase == 1 && gcbase->nexcolor == 0)) {
*/

                    csgn = cfcproj(gcbase,gcolgr);
#if DBG
                    printf("call cfgdump:3: after cfcproj\n");
                    cfgdump(gcolgr);
#endif
                    cfproj(gcbase, gcolgr, ibase, iprt);
#if DBG
                    printf("call cfgdump:3: after cfproj\n");
                    cfgdump(gcolgr);
#endif
#ifdef DEBUG
                    printf("wgt[0]=(%d/%d)\n", (gcolgr->wgt[0]).num,
                                               (gcolgr->wgt[0]).den);
#endif
/*
                }
*/
            }
/* Vertex */
            nnodes = cgraph->nnodes;
           
            printf("V:%d:%d:",pc+1,gr+1);
            for(n = 0; n < nnodes; n++) {
                /* null node */ 
                if(ndnode(n) == NULL) { 
                    printf("      null%d", n);
                }

                /* name of the vertex */
                if(ndtype(n) != NDTREEV) {
                } else {
                    vt = ndvertex(n);
                    printf("%d,", vt);
                }
            }
            printf("0\n");


            fofgraph(fpout, proc, graph);
            foflines(fpout);
        }
        fofpend(fpout, procg[pc]);
    }
    fofend(fpout, nprocs+1);

    daclose();

    return 0;
}

/*==================================================================*/
Private Void   grcarg(argc, argv)
int     argc;
char    **argv;
/*--------------------------------------------------------------------
*/
{
    int    c;
    string cmd;

#if DBG
    int d;
#endif

#if DBG
    d       = 0;
#endif

    cmd     = argv[0];

    while(--argc > 0 && (*++argv)[0] == '-') {
        c = (*argv)[1];
#if DBG
        if(c == 'd') {
            --argc;
            ++argv;
            d = atoi(*argv);
        } else {
#endif
    
            while ((c = *++argv[0]) != 0) {
                switch (c) {
                case 'h':
                case '?':
                    pvhelp(stdout);
                    printf("\n\n");
                    printf("Syntax %s [options] [Graph_File_name]\n",
                           cmd);
                    printf("\nOption\n");
#if DBG
                    printf("    -d int              ");
                    printf(": debug leve \n");
#endif
                    printf("    -h                  ");
                    printf(": more info\n");
                    printf("\nDefault file name is:\n");
                    printf("     Graph_File_name = %s\n", fgname);
                    exit(0);
                }
            }
#if DBG
        }
#endif
    }

    /* input process file name */
    if(argc == 1) {
        strcpy(fngrf, *argv);
    } else {
        strcpy(fngrf, fgname);
    }

#if DBG
    /* debugging flags */
    dbg   = 0;

    if(d > 0) {
        dbg = d;
    }
    if(d < 0) {
        dbg = -d;
    }
#endif

}

/*==================================================================*/
Public  Void   prdump(NoArg)
/*--------------------------------------------------------------------
    Dump.
*/
{
    rgdump(cprocess, cgraph);
    ildump();
}
