/*********************************************************************
 *  File : vrplot.c
 *
 *  Graphic Interface package
 *
 *                                                 by Kaneko Toshiaki
 */

#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <stdio.h>
#include "vr.h"
#include "vrf.h"

/*---------------------------------------------------------------------
    Local variables
*/

/*---------------------------------------------------------------------
    Local functions
*/

/*---------------------------------------------------------------------
    Local variables
*/

Local   coord wwidth;

/*********************************************************************
 * system control
 */
/*==================================================================*/
Public  Void vrinit(NoArg)
/*--------------------------------------------------------------------
 * initialize device
 */
{
    vfrinit();
}

/*==================================================================*/
Public  Void vropen(dest, opt)
int     dest;
int    *opt;
/*--------------------------------------------------------------------
 * this function is called when new bwindow is opened
 */
{
    vfropen(opt);
}

/*==================================================================*/
Public  Void vrcls(dest)
int     dest;
/*--------------------------------------------------------------------
 * this function is called when window is closed
 */
{
    vfrcls();
}

/*==================================================================*/
Public  Void vrdisp(NoArg)
/*--------------------------------------------------------------------
 * display graphic objects
 */
{
    vfrdisp();
}

/*==================================================================*/
Public  bool vrclr(bool clr)
/*--------------------------------------------------------------------
 * clear the current graphic display
 */
{
    return vfrclr(clr);
}

/*==================================================================*/
Public  Void vrnew(NoArg)
/*--------------------------------------------------------------------
 * this function is called when new subwindow is opened
 */
{
    vfrnew();
}

/*==================================================================*/
Public  Void vrend(NoArg)
/*--------------------------------------------------------------------
 * this function is called when new subwindow is closed
 */
{
    vfrend();
}

/*********************************************************************
 * Graphic objects
 *
 */
/*==================================================================*/
Public  Void vrline(lx0, ly0, lx1, ly1, color)
coord lx0, ly0;
coord lx1, ly1;
int color;
/*--------------------------------------------------------------------
*/
{
    vfrline(lx0, ly0, lx1, ly1, color);
}

/*==================================================================*/
Public  Void vrcrcl(cx, cy, r, color)
coord cx, cy;
coord r;
int color;
/*--------------------------------------------------------------------
*/
{
    vfrcrcl(cx, cy, r, color);
}

/*==================================================================*/
Public  Void vrarc(lx0, ly0, lx1, ly1, lx2, ly2, color)
coord lx0, ly0;
coord lx1, ly1;
coord lx2, ly2;
int color;
/*--------------------------------------------------------------------
*/
{
    vfrarc(lx0, ly0, lx1, ly1, lx2, ly2, color);
}

/*==================================================================*/
Public  Void vrtext(x, y, str, color)
coord x, y;
string str;
int color;
/*--------------------------------------------------------------------
*/
{
    vfrtext(x, y, str, color);
}

/*********************************************************************
 * Utility funcitons
 *
 */
/*==================================================================*/
Public  int vrcolr(NoArg)
/*--------------------------------------------------------------------
 * Return the number of colors.
*/
{
    return 4;
}

/*==================================================================*/
Public  int vrback(color)
int     color;
/*--------------------------------------------------------------------
 * Return the background color
*/
{
    return VR_WHITE;
}

/*==================================================================*/
Public  int vrgnum(NoArg)
/*--------------------------------------------------------------------
*/
{
    return 2;
}

/*==================================================================*/
Public  Void  vrchrw(str, ans)
string str;
coord  *ans;
/*--------------------------------------------------------------------
*/
{
}

/*==================================================================*/
Public  Void  vrchrh(size, ans)
coord size;
coord *ans;
/*--------------------------------------------------------------------
*/
{
    *ans = 0.01;
}

/*==================================================================*/
Public  Void  vrwvw(size)
coord size;
/*--------------------------------------------------------------------
 * set width of wave line
 */
{
    wwidth = size;
    vfrwvw(wwidth);
}

