/********************************************************************
 *  File : cmnfort.c *
 *  Fortran source code generation (main, kinem, etc).
 *                           by Kaneko Toshiaki   95/07/13 (LAPP)
 *                                     Rev.  TI   95/07/17 (LAPP)
 *                           Last Update          98/05/10
 */

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "grdata.h"
#include "config.h"
#include "gensc.h"
#include "cfnbase.h"
#include "cfnconv.h"
#include "putid.h"
#include "path.h"
#include "version.h"

/*------------------------------------------------------------------
 * Parameters
 */
#ifndef CERNLIB
#define CERNLIB 0
#endif
#define CMPLX 1
#define GSEL 1
/*------------------------------------------------------------------
 * Private functions
 */
Private Void    cmusrout   ARG((NoArg));
Private Void    cmusroup   ARG((int));
Private Void    cmmainbs   ARG((NoArg));
Private Void    cmmainbsp  ARG((int));
Private Void    cmmainsp   ARG((NoArg));
Private Void    cmmainspp  ARG((int));
Private Void    cmtest     ARG((NoArg));
Private Void    cmprms     ARG((string,int));
Private Void    cmfunc     ARG((NoArg));
Private Void    cmfuncv    ARG((NoArg));
Private Void    cmamclr    ARG((NoArg));
Private Void    cmamclp    ARG((int));
Private Void    cmamclpo   ARG((NoArg)); /* 2000.2.3 for opver*/
Private Void    cmamclpr   ARG((NoArg)); /* 2004.01.28 for rvcode */
Private Void    cmvbfnct   ARG((NoArg));
Private Void    cminclvs   ARG((NoArg));
Private Void    cminclbp   ARG((NoArg));
#ifdef MOD20020227
Private Void    cmprtitle  ARG((NoArg));
Private Void    cmwrtstr   ARG((string));
#endif
Private Void    cmkfmass   ARG((string));
Private Void    cmidmass   ARG((string));
Private Void    cmmass2    ARG((string));
Private Void    cmeps      ARG((NoArg));
Private Void    cmepsv     ARG((NoArg));
Private Void    cmpcode    ARG((NoArg));
Private Void    cmkinem    ARG((string));
Private Void    cmfkinemv  ARG((NoArg));
Private Void    cmfkvfill  ARG((NoArg));
Private bool    cmcpkin    ARG((string,string,string));
Private Void    cmfkfill   ARG((NoArg));
Private Void    cmfkinem   ARG((NoArg));
Private Void    cmfkinit   ARG((NoArg));
Private Void    cmdnn      ARG((NoArg));
Private Void    cmsp2lnd   ARG((NoArg));
Private Void    cmspdetc   ARG((NoArg));
Private Void    cmspdetp   ARG((int));
Private Void    cmgfinit   ARG((NoArg));
Private Void    cmkmass    ARG((FILE*));
Private Void    cmkmom     ARG((FILE*));
Private Void    cmgfinip   ARG((int));
Private Void    cmgfinicf  ARG((int));
Private Void    cmakptbp   ARG((int));
Private Void    cmtestp    ARG((int));
Private Void    cmtestp1   ARG((int));
Private Void    cmfunp     ARG((int));
#ifdef MOD20020227
Private Void    cmatcpl    ARG((string));
#endif
Private Void    cmshowp    ARG((NoArg));
#ifdef CMINCLVB
Private Void    cminclvb   ARG((NoArg));
#endif
/* TI inclp.h */
#define ilpartl(l,lg)     \
        ndparticle(iltable[l].ilnodes[lg],iltable[l].illegs[lg])
#define ilpart(l)     abs(ilpartl(l, 0))

/*------------------------------------------------------------------
 * Local variable
 */
/* (i)**(-pphase) */
Local   string spphase[4] = {"+1", "dcmplx(0.0d0, -1.0d0)",
                             "-1", "dcmplx(0.0d0, +1.0d0)"};

#define MAXCOLR     16

/*==================================================================*/
Public  Void    cmmodel(NoArg)
/*------------------------------------------------------------------*
 */
{
    int lo;

    printf("cmmodel<cmfort.c> \n");

    cmgfinit();

    lo = lang;
    lang = ROFORT;

    /* inclm.h and inclc.h */
    cmincl();

    if(vcode) {
        cmvbfnct();
        cminclvs();
        if( mpirun ) cminclbp();
#ifdef CMINCLVB
        cminclvb();
#endif
    } else if(rvcode) {
        cminclvs();
        cmfuncv();
    } else {
        cmfunc();
    }

    cmmainbs();
    cmmainsp();

    cmspdetc();

    if(jetset) {
        cmsp2lnd();
    }
    if(!multiprc) {
        cmprms("", -1);
    }
    cmkfmass("");
    cmidmass("");
    cmmass2("");

    cmtest();
    cmamclr();
    cmusrout();
    cmkinem("");
/* 000728
    cmatcpl("");
*/

    if(caller != GRCFORT) {
        if(rvcode) {
            cmepsv();
        } else {
            cmeps();
        }
        cmpcode();
    }

/* 95.5.22 TI */
    if(caller == GRCREDA) {
        cmdnn();
    }

    /* cmamparm should be called last */
    cmamparm("");

    lang = lo;
}

/*==================================================================*/
Public  Void    cmproc(NoArg)
/*------------------------------------------------------------------*
 */
{
    int lo;

    lo = lang;
    lang = ROFORT;

    cmgfinit();
    if(multiprc) {
        cmkinem(cprefix);
    }

    if(ilenc) {
        cmakptbl();
    }
    lang = lo;
}

/*==================================================================*/
Public  Void    cmprcpc(pc)
int     pc;
/*------------------------------------------------------------------*
 */
{
    string sdir = reprocp[pc];
    int lo;

    printf("cmprcpc<cmfort.c> <<%d>>\n",pc);

    lo = lang;
    lang = ROFORT;

    cmgfinip(pc);
    cmakptbp(pc);
    cmtestp(pc);
    if(maxloop == 1 && caller == GRCRED) {
        cmtestp1(pc);
    }
    cmmainbsp(pc);
    cmmainspp(pc);
    cmfunp(pc);
    cmusroup(pc);
    cmspdetp(pc);
    cmamclp(pc);
    cmprms(sdir, pc);
    cmkfmass(sdir);
    cmidmass(sdir);
    cmmass2(sdir);
/* 000728
    cmatcpl(sdir);
*/
    cmamparm(sdir);

    lang = lo;
}

/*==================================================================*/
Private Void    cmusrout(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmusroup(-1);
}

/*==================================================================*/
Private Void    cmusroup(pc)
int     pc;
/*------------------------------------------------------------------*
 */
{
    int    pps, ppe, pp;
    string prf, prfs;
    char   suf[16]; /* for grcfort */

    if( opver ) {
        sprintf(suf,"%d",cprocs);
    } else {
        suf[0] = '\0';
    }

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    if(multiprc) {
        cmopend(ROFORT, prfs, "usrout.f");
        cmsepar('*');
        fprintf(redfp,"      subroutine usrout\n");
        fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
        fprintf(redfp,"      common /amjprc/jproc\n");
        fprintf(redfp,"\n");

        for(pp = pps; pp < ppe; pp++) {
            fprintf(redfp,"        if(jproc .eq. %d) then\n", pp+1);
            fprintf(redfp,"            call uso%s\n", reprocp[pp]);
            fprintf(redfp,"        endif\n");
            fprintf(redfp,"\n");
        }
        fprintf(redfp,"        return\n");
        fprintf(redfp,"        end\n");

        if(pc < 0) {
            return;
        } else {
            sprintf(momstr, "uso%s", prf);
        }
    } else {
        sprintf(momstr, "usrout");
    }

    sprintf(momstr1, "%s.f", momstr);
    cmopend(ROFORT, prf, momstr1);

    cmsepar('*');
    fprintf(redfp,"      subroutine %s\n", momstr);
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"\n");
    if(vcode) {
        fprintf(redfp,"      include 'inclvs.h'\n");
    }
    if(rvcode) {
        fprintf(redfp,"      include 'incl%s1v.h'\n", prf);
    } else {
        fprintf(redfp,"      include 'incl%s1.h'\n", prf);
    }
    fprintf(redfp,"      include 'inclk.h'\n");
    cmsepar('-');
/*  */
    if(caller != GRCREDH && !rvcode) {
        fprintf(redfp,"      if(jgraph .lt. 1) then\n");
        fprintf(redfp,"        write(*,*) '*** No graphs ***'\n");
        fprintf(redfp,"        return\n");
        fprintf(redfp,"      endif\n");
        fprintf(redfp,"\n");
        if(vcode) {
            fprintf(redfp,"      do 200 j=1,1\n");
        }
        fprintf(redfp,"      write(*,620)\n");
        fprintf(redfp,"  620 format('1'/' integrated value of square of ");
        fprintf(redfp,"each graph',/\n");
        fprintf(redfp,"     & ' graph  ',8x,'absolute',10x,'relative')");
        fprintf(redfp,"\n");
        fprintf(redfp,"\n");

        fprintf(redfp,"      rn = 1.0d0/(fkcall + nkcall)\n");
        fprintf(redfp,"      do 100 ig = 1, jgraph\n");
        fprintf(redfp,"        write(*,*) igraph%s(ig), ' :', ",suf);
        if(!vcode) {
            fprintf(redfp," ansp%s(ig)*rn, ansp%s(ig)/ansp%s(0)\n",suf,suf,suf);
        } else {
            fprintf(redfp," ansp%s(j,ig)*rn,ansp%s(j,ig)/ansp%s(j,0)\n",suf,suf,suf);
        }
        fprintf(redfp,"  100 continue\n");
        if(!vcode) {
            fprintf(redfp,"      write(*,*) ' total :', ansp%s(0)*rn\n",suf);
        } else {
            fprintf(redfp,"      write(*,*) ' total :', ansp%s(j,0)*rn\n",suf);
        }
        if(vcode) {
            fprintf(redfp,"  200 continue\n");
        }

        fprintf(redfp,"  600 format(1x,i5,a, e18.8, e18.8)\n");
        fprintf(redfp,"  610 format(a, e18.8)\n");
        fprintf(redfp,"\n");
    }
    fprintf(redfp,"      write(*,*)\n");
    fprintf(redfp,"      write(*,*)\n");
    fprintf(redfp,"      write(*,*) 'WARNING: Squared Amplitude:'");
    fprintf(redfp,"\n");
    fprintf(redfp,"      write(*,*) '       It should be ");
    fprintf(redfp,"multiplied by the statistical ',\n");
    fprintf(redfp,"     &                  'factor 1/N! for N' \n");
    fprintf(redfp,"      write(*,*) '       identical final state ");
    fprintf(redfp,"particle to get the ',\n");
    fprintf(redfp,"     &                  'total X-section.'\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmmainbs(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmmainbsp(-1);
}

/*==================================================================*/
Private Void    cmmainbsp(pc)
int     pc;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int    pps, ppe, pp;
    string prf, prfs;

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    if(multiprc) {
        if(!vcode) {
            cmopend(ROFORT, prfs, "mainbs.f");
        } else {
            cmopend(ROFORT, prfs, "mainvb.f");
        }
        if(!vcode) {
            fprintf(redfp,"* main program for BASES 5.1\n");
        } else {
            fprintf(redfp,"* main program for vector BASES 5.1\n");
        }
        fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
        fprintf(redfp,"      common /amjprc/jproc\n");

        fprintf(redfp,"\n");
        fprintf(redfp,"      jproc = 1\n\n");

        if(nprocs > 1) {
            fprintf(redfp,"      write(*,*) 'enter jproc (1-%d)'\n", nprocs);
            fprintf(redfp,"      read(*,*)  jproc\n");
            fprintf(redfp,"      write(*,*) 'jproc = ', jproc\n");
            fprintf(redfp,"\n");
        }

        for(pp = pps; pp < ppe; pp++) {
            fprintf(redfp,"      if(jproc .eq. %d) then\n", pp+1);
            if(!vcode) {
                fprintf(redfp,"          call mnbs%s\n", reprocp[pp]);
            } else {
                fprintf(redfp,"          call mnvb%s\n", reprocp[pp]);
            }
            fprintf(redfp,"      endif\n");
            fprintf(redfp,"\n");
        }
        fprintf(redfp,"      end\n");

        if(pc < 0) {
            return;
        } else {
            if(!vcode) {
                sprintf(momstr, "mnbs%s", prf);
            } else {
                sprintf(momstr, "mnvb%s", prf);
            }
            sprintf(momstr1, "%s.f", momstr);
            cmopend(ROFORT, prf, momstr1);
            fprintf(redfp,"      subroutine %s\n", momstr);
        }
    } else {
        if(!vcode) {
            cmopen(ROFORT, "mainbs.f");
        } else {
            cmopen(ROFORT, "mainvb.f");
        }
    }

    cmsepar('*');

    if(!vcode) {
        fprintf(redfp,"* main program for BASES 5.1\n");
    } else {
        fprintf(redfp,"* main program for vector BASES 5.1\n");
    }
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    fprintf(redfp,"      common / knmflg / ");
    fprintf(redfp,"knmgvs, knmhst, knmsph, knmisr\n");
    fprintf(redfp,"      external func\n");
    putc(EOL, redfp);
    if(CERNLIB == 1 && !vcode) {
        fprintf(redfp,"      parameter ( mhsize = 100000 )\n");
        fprintf(redfp,"      common /pawc/ memory(mhsize)\n");
    }


    fprintf(redfp,"*    Control for number of nodes\n");
    fprintf(redfp,"      common/ninfo/ nodeid, numnod, ipflag\n");


    if(mpirun) {
       fprintf(redfp,"      include 'inclbp.h'\n");
       fprintf(redfp,"      numdp = 8\n");
       fprintf(redfp,"      numfp = 1\n");
       fprintf(redfp,"      np = numdp*numfp\n");
       fprintf(redfp,"*     Initialize  MPI MPI MPI\n");
       fprintf(redfp,"*         ==================\n");
       fprintf(redfp,"             CALL BPINIT\n");
       fprintf(redfp,"*         ==================\n");

    } else {
       fprintf(redfp,"      nodeid = 0\n");
       fprintf(redfp,"      numnod = 1\n");
    }

    cmsepar('-');
    cmshowp();
    cmsepar('-');

    fprintf(redfp,"*               initialization Kinematics Flags\n");
    fprintf(redfp,"*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp,"*     knmhst  : (=1)Fill historgram \n");
    fprintf(redfp,"*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp,"*     knmisr  : reserved for initial state ");
    fprintf(redfp,"radiation\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 1\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");

    if(CERNLIB == 1 && !vcode) {
        cmsepar('*');
        fprintf(redfp,"*               initialization of HBOOK\n");
        fprintf(redfp,"      call hlimit( mhsize )\n");
        fprintf(redfp,"      call htitle('Histograms generated by ");
        fprintf(redfp,"BASES')\n");
    }
    cmsepar('*');
    fprintf(redfp,"*               initialization of BASES/SPRING");
    fprintf(redfp," 5.1\n");
    cmsepar('*');

    cmsepar('=');
    fprintf(redfp,"*          initialization of bases by calling ");
    fprintf(redfp,"bsinit\n");
    cmsepar('=');
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsinit\n");
    fprintf(redfp,"*         -------------\n");

    cmsepar('=');
    fprintf(redfp,"*      initialization of parameters\n");
    fprintf(redfp,"*          for kinematics and matrix elements\n");
    fprintf(redfp,"*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp,"      lu     = 11\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      if( nodeid .eq. 0 ) then\n");
    fprintf(redfp,"      open(lu,file='bases.result',status='");
    fprintf(redfp,"unknown',form='formatted')\n");
    fprintf(redfp,"      endif\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"           call userin( lu )\n");
    fprintf(redfp,"*         ------------------\n");

    cmsepar('*');
    fprintf(redfp,"*              numerical integration by ");
    fprintf(redfp,"BASES 5.1\n");
    cmsepar('*');
    fprintf(redfp,"\n");
    if(!vcode) {
        fprintf(redfp,"      call bases( func, estim, sigma, ctime, ");
    } else {
        fprintf(redfp,"      call vbases( func, estim, sigma, ctime, ");
    }
    fprintf(redfp,"it1, it2 )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      if( nodeid .eq. 0 ) then\n");
    fprintf(redfp,"      call bsinfo( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call bhplot( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      close( lu )\n");
    fprintf(redfp,"      endif\n");
    fprintf(redfp,"\n");

    cmsepar('*');
    fprintf(redfp,"*             event generation by SPRING 5.1\n");
    cmsepar('*');
    cmsepar('=');
    fprintf(redfp,"*     save the probability information to the ");
    fprintf(redfp,"file\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"      if( nodeid .eq. 0 ) then\n");
    fprintf(redfp,"      lun = 23\n");
    fprintf(redfp,"      open(lun,file='bases.data',status='");
    fprintf(redfp,"unknown',form='unformatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call bswrit( lun )\n");
    fprintf(redfp,"      close ( lun )\n");
    fprintf(redfp,"      endif\n");
    fprintf(redfp,"\n");

    if(CERNLIB == 1 && !vcode) {
        cmsepar('=');
        fprintf(redfp,"*     save the contents of Histograms ");
        fprintf(redfp,"into Paw buffer\n");
        cmsepar('=');
        fprintf(redfp,"      call bshbok( 0 )\n");
        fprintf(redfp,"      call hrput( 0, 'bases.hbook','N')\n");
    }
    if(mpirun) {
        fprintf(redfp,"*     Finalize  MPI MPI MPI\n");
        fprintf(redfp,"*         ==================\n");
        fprintf(redfp,"              CALL BPFIN\n");
        fprintf(redfp,"*         ==================\n");
    }

    fprintf(redfp,"      stop\n");
    fprintf(redfp,"      end\n");
}


/*==================================================================*/
Private Void    cmmainsp(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmmainspp(-1);
}

/*==================================================================*/
Private Void    cmmainspp(pc)
int     pc;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int    pps, ppe, pp;
    string prf, prfs;

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    if(multiprc) {
        if(!vcode) {
            cmopend(ROFORT, prfs, "mainsp.f");
        } else {
            cmopend(ROFORT, prfs, "mainvs.f");
        }

        cmsepar('*');
        fprintf(redfp,"* main program for SPRING 5.1\n");
        fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
        fprintf(redfp,"      common /amjprc/jproc\n");

        fprintf(redfp,"\n");
        fprintf(redfp,"      jproc = 1\n\n");

        if(nprocs > 1) {
            fprintf(redfp,"      write(*,*) 'enter jproc (1-%d)'\n", nprocs);
            fprintf(redfp,"      read(*,*) jproc\n");
            fprintf(redfp,"      write(*,*) 'jproc = ', jproc\n");
            fprintf(redfp,"\n");
        }

        for(pp = pps; pp < ppe; pp++) {
            fprintf(redfp,"      if(jproc .eq. %d) then\n", pp+1);
            if(!vcode) {
                fprintf(redfp,"          call mnsp%s\n", reprocp[pp]);
            } else {
                fprintf(redfp,"          call mnvs%s\n", reprocp[pp]);
            }
            fprintf(redfp,"      endif\n");
            fprintf(redfp,"\n");
        }
        fprintf(redfp,"      end\n");

        if(pc < 0) {
            return;
        } else {
            if(!vcode) {
                sprintf(momstr, "mnsp%s", prf);
            } else {
                sprintf(momstr, "mnvs%s", prf);
            }
            sprintf(momstr1, "%s.f", momstr);
            cmopend(ROFORT, prf, momstr1);
            fprintf(redfp,"      subroutine %s\n", momstr);
        }
    } else {
        if(!vcode) {
            cmopen(ROFORT, "mainsp.f");
        } else {
            cmopen(ROFORT, "mainvs.f");
        }
    }

    cmsepar('*');

    fprintf(redfp,"* main program for SPRING 5.1\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(vcode) {
        fprintf(redfp,"      include 'inclvs.h'\n");
    }

    fprintf(redfp,"      include 'inclk.h'\n");
    fprintf(redfp,"      common / knmflg / ");
    fprintf(redfp,"knmgvs, knmhst, knmsph, knmisr\n");
    fprintf(redfp,"      external func\n");
    fprintf(redfp,"      parameter (nextn  =%d)\n", nextern);
    if(!vcode) {
        fprintf(redfp,"      common /sp4vec/ vec(4,nextn)\n");
    } else {
        fprintf(redfp,"      common /sp4vec/ vec(n_vector,4,nextn)\n");
    }
    putc(EOL, redfp);
    fprintf(redfp,"      common/ninfo/ nodeid, numnod, ipflag\n");
    fprintf(redfp,"      nodeid = 0\n");
    fprintf(redfp,"      numnod = 1\n");

    if(vcode) {
        fprintf(redfp,"      common / sprng3 / ic(n_vector), l(n_vector)\n");
    }

    if(CERNLIB == 1 && !vcode) {
        fprintf(redfp,"      parameter ( mhsize = 100000 )\n");
        fprintf(redfp,"      common /pawc/ memory(mhsize)\n");
    }

    cmsepar('-');
    cmshowp();

    fprintf(redfp,"*               initialization Kinematics Flags\n");
    fprintf(redfp,"*     knmgvs  : (=1)sqrt(S) is given in kinit.f\n");
    fprintf(redfp,"*     knmhst  : (=1)Fill historgram for BASES\n");
    fprintf(redfp,"*     knmsph  : reserved for soft photon check \n");
    fprintf(redfp,"*     knmisr  : reserved for initial state ");
    fprintf(redfp,"radiation\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 0\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");
    cmsepar('*');
    if(CERNLIB == 1 && !vcode) {
        cmsepar('*');
        fprintf(redfp,"*               initialization of HBOOK\n");
        fprintf(redfp,"      call hlimit( mhsize )\n");
    }
    fprintf(redfp,"*               initialization of BASES/SPRING");
    fprintf(redfp," 5.1\n");
    cmsepar('*');

    cmsepar('=');
    fprintf(redfp,"*          initialization of bases by calling ");
    fprintf(redfp,"bsinit\n");
    cmsepar('=');
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsinit\n");
    fprintf(redfp,"*         -------------\n");

    cmsepar('=');
    fprintf(redfp,"*          read the probability information from ");
    fprintf(redfp,"the file\n");
    cmsepar('=');
    fprintf(redfp,"           lun = 23\n");
    fprintf(redfp,"           open(lun,file='bases.data',status='");
    fprintf(redfp,"old',form='unformatted')\n");
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           call bsread( lun )\n");
    fprintf(redfp,"*         -------------\n");
    fprintf(redfp,"           close( lun )\n");
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp,"*      initialization of parameters\n");
    fprintf(redfp,"*          for kinematics and matrix elements\n");
    fprintf(redfp,"*      initialization of histograms\n");
    cmsepar('=');
    fprintf(redfp,"      lu     = 12\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      open(lu,file='spring.result',status='");
    fprintf(redfp,"unknown',form='formatted')\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"           call userin( lu )\n");
    fprintf(redfp,"*         ------------------\n");
    fprintf(redfp,"\n");

    if(jetset) {
    cmsepar('=');
    fprintf(redfp,"*     Set parameters for LUND from GRACE\n");
    cmsepar('=');
    fprintf(redfp,"*         --------------------------------\n");
    fprintf(redfp,"           if(jhadrn .eq. 1) call gr2lnd\n");
    fprintf(redfp,"*         --------------------------------\n");
    }

    cmsepar('=');
    fprintf(redfp,"*     initialization of additional histograms ");
    fprintf(redfp,"for spring\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    cmsepar('=');
    fprintf(redfp,"*     event generation\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"      mxtry  = 50\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      mxevnt = 10000\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(6,*)' number of events ? '\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     read(5,*) mxevnt\n");
    fprintf(redfp,"\n");
    if(!vcode) {
    fprintf(redfp,"      do 100 nevnt = 1, mxevnt\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         call spring( func, mxtry )\n");
    fprintf(redfp,"\n");
    if(colorv == 1 && gcbase->nbase > 1) {
        cmsepar('-');
        fprintf(redfp,"*     Determine color-state.\n");
        cmsepar('-');
        fprintf(redfp,"*         -------------\n");
        fprintf(redfp,"            call spdetc\n");
        fprintf(redfp,"*         -------------\n");
    }
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*        compute the four vectors of generated ");
    fprintf(redfp,"event\n");
    fprintf(redfp,"*          from the kinematical variables\n");
    cmsepar('-');
    fprintf(redfp,"\n");
    fprintf(redfp,"*        do 90 k = 1 , nextn\n");
    fprintf(redfp,"*           write(6,*) (vec(j,k),j=1,4)\n");
    fprintf(redfp,"*  90    continue\n");
    if(jetset) {
        cmsepar('-');
        fprintf(redfp,"*     SET /LUJETS/ and so on\n");
        cmsepar('-');
        fprintf(redfp,"*         --------------------------------\n");
        fprintf(redfp,"           if(jhadrn .eq. 1) call sp2lnd\n");
        fprintf(redfp,"*         --------------------------------\n");
    }
    fprintf(redfp,"  100 continue\n");
    } else {
    fprintf(redfp,"      msum = 0\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"  100 continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         call vsprng( func, mxtry )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"*        compute the four vectors of generated ");
    fprintf(redfp,"event\n");
    fprintf(redfp,"*          from the kinematical variables\n");
    fprintf(redfp,"*    --------------------------------------------");
    fprintf(redfp,"----\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         do 90 i = 1 , n_vector\n");
    fprintf(redfp,"            if(ic(i) .eq. 0) then\n");
    fprintf(redfp,"                msum = msum + 1\n");
    fprintf(redfp,"*               do 80 k = 1 , nextn\n");
    fprintf(redfp,"*                  write(6,*) (vec(j,k),j=1,4)\n");
    fprintf(redfp,"*  80           continue\n");
    fprintf(redfp,"            endif\n");
    fprintf(redfp,"   90    continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      if(msum .lt. mxevnt) goto 100\n");

    }
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call spinfo( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      call shplot( lu )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      close( lu )\n");
    fprintf(redfp,"\n");
    if(CERNLIB == 1 && !vcode) {
        cmsepar('=');
        fprintf(redfp,"*     save the contents of Histograms ");
        fprintf(redfp,"into Paw buffer\n");
        cmsepar('=');
        fprintf(redfp,"      call bshbok( 0 )\n");
        fprintf(redfp,"      call sphbok( 0 )\n");
        fprintf(redfp,"      call hrput( 0, 'spring.hbook','N')\n");
    }
    fprintf(redfp,"      stop\n");
    fprintf(redfp,"      end\n");
    fprintf(redfp,"\n");
}

/*==================================================================*/
Private Void    cmtest(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmtestp(-1);
    if(maxloop == 1 && caller == GRCRED) {
        cmtestp1(-1);
    }
}

/*==================================================================*/
Private Void    cmshowp(NoArg)
/*------------------------------------------------------------------*
 */
{
    pindex pa;
    int n;

    fprintf(redfp,"      if( nodeid .eq. 0 ) then\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      write(*,'(20x,a/)') 'grace %d.%d(%d)'\n",
            GRCVER0,GRCVER1,GRCVER2);
    fprintf(redfp,"      write(*,'(10x,a/)')\n");
    fprintf(redfp,"     .'%s'\n", CRIGHT);

    fprintf(redfp,"      write(*,'(5x,a)')");
    fprintf(redfp," 'Initial particles:'\n");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp,"      write(*,'(25x,a)')");
            fprintf(redfp," '%s'\n",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"      write(*,'(5x,a)')");
    fprintf(redfp," 'Final particles:'\n");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp,"      write(*,'(25x,a)')");
            fprintf(redfp," '%s'\n",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"      write(*,'(1x/)')");
    fprintf(redfp,"\n");

    fprintf(redfp,"      endif\n");
    cmsepar('-');
}

/*==================================================================*/
Private Void    cmtestp(pc)
int     pc;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    pindex p;
    int    i, pps, ppe, pp, lp;
    string prf, prfs;

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    if(caller == GRCFORT) {
        if(multiprc) {
            cmopend(ROFORT, prfs, "gauge.f");
            cmsepar('*');
            fprintf(redfp,"* main program for test\n");
            fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
            fprintf(redfp,"      common /amjprc/jproc\n");
            fprintf(redfp,"\n\n");

            fprintf(redfp,"      write(*,'(20x,a/)') 'grace %d.%d(%d)'\n",
                    GRCVER0,GRCVER1,GRCVER2);
            fprintf(redfp,"      write(*,'(10x,a/)')\n");
            fprintf(redfp,"     .'%s'\n", CRIGHT);

            fprintf(redfp,"      jproc = %d\n\n", pps+1);

            if(ppe - pps > 1) {
                fprintf(redfp,"      write(*,*) 'enter jproc (1-%d)'\n",
                        nprocs);
                fprintf(redfp,"      read(*,*) jproc\n");
                fprintf(redfp,"      write(*,*) 'jproc = ', jproc\n");
                fprintf(redfp,"\n");
            }

            for(pp = pps; pp < ppe; pp++) {
                fprintf(redfp,"      if(jproc .eq. %d) then\n", pp+1);
                fprintf(redfp,"          call gau%s\n", reprocp[pp]);
                fprintf(redfp,"      endif\n");
                fprintf(redfp,"\n");
            }
            fprintf(redfp,"      end\n");
            if(pc < 0) {
                return;
            } else {
                sprintf(momstr, "gau%s", prf);
                sprintf(momstr1, "%s.f", momstr);
                cmopend(ROFORT, prf, momstr1);
                fprintf(redfp,"      subroutine %s\n", momstr);
            }
        } else {
            if(!vcode) {
                cmopen(ROFORT, "gauge.f");
            } else {
                cmopen(ROFORT, "gaugev.f");
            }
        }
    } else {
        cmopen(ROFORT, "test0.f");
    }

    cmsepar('*');
    fprintf(redfp,"* main program for test\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if( vcode ) {
        fprintf(redfp,"      include 'inclvs.h'\n");
    }
    fprintf(redfp,"      include 'incl%s1.h'\n", prf);
    fprintf(redfp,"      include 'inclk.h'\n");
    putc(EOL, redfp);

    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      common / loop0 / loop\n");
    fprintf(redfp,"      common / bparm1 / xl(mxdim),xu(mxdim),");
    fprintf(redfp,       "ndim,nwild,\n");
    fprintf(redfp,"     &                 ig(mxdim),ncall\n");
    fprintf(redfp,"      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    fprintf(redfp,"      common / knmflg / knmgvs,knmhst,knmsph,");
    fprintf(redfp,"knmisr\n");
    putc(EOL, redfp);

    if( !vcode ) {
    fprintf(redfp,"      real*8   x(mxdim)\n");
    putc(EOL, redfp);
    } else {
        fprintf(redfp,"      external func\n");
        fprintf(redfp,"      real*8   wgt(n_vector), x(n_vector,mxdim), fx(n_vector)\n");
        fprintf(redfp,"      real*8   aaa(n_vector),bbb(n_vector)\n");
    }
    fprintf(redfp,"*     calculation for Amp(i)*Congj(Amp(j))\n");
    fprintf(redfp,"*     complex*16 agctmp(ngraph,0:lag-1,0:ncbase-1),amptxt\n");

    fprintf(redfp,"      common/ninfo/ nodeid, numnod, ipflag\n");
    fprintf(redfp,"      nodeid = 0\n");
    fprintf(redfp,"      numnod = 1\n");
    cmsepar('-');
    cmshowp();

    fprintf(redfp,"      call bsinit\n");
    putc(EOL, redfp);

    fprintf(redfp,"      loop   = 1\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 0\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");
    if(!vcode) {
    fprintf(redfp,"      wgt    = 1.0d0\n");
    fprintf(redfp,"      call bsputw(wgt)\n");
    }
    putc(EOL, redfp);

    fprintf(redfp,"      call userin( 6 )\n");
    putc(EOL, redfp);

/*
    for(p = 0; p < nmtable[N_WIDTH]; p++) {
        if(mtable[N_WIDTH][p][0] == '0') {
            continue;
        }
        fprintf(redfp,"      %6s = 0.0d0\n", mtable[N_WIDTH][p]);
    }
*/
    for(p = 0; p < nptable; p++) {
        if(isdigit(ptable[p]->width[0])) {
            continue;
        }
        cmwidth(p, 1, momstr);
        fprintf(redfp,"      %6s = 0.0d0\n", momstr);
    }
    putc(EOL, redfp);

    fprintf(redfp,"      call bschck\n");
    putc(EOL, redfp);

    fprintf(redfp,"CC    call prmass\n");
    putc(EOL, redfp);

    if( vcode ) {
        fprintf(redfp,"      call drnset(12345)\n");
        putc(EOL, redfp);
    }
    if( !vcode ) {
        fprintf(redfp,"ct    do 100 many x's\n");
        putc(EOL, redfp);
    }

    if( !vcode ) {
    fprintf(redfp,"      do 10 i = 1, ndim\n");
    fprintf(redfp,"        x(i) = 0.45d0+0.02d0*i\n");
    fprintf(redfp,"   10 continue\n");
    putc(EOL, redfp);
    } else {
    fprintf(redfp,"      do 10 i = 1, ndim\n");
    fprintf(redfp,"      do 10 j = 1, n_vector\n");
    fprintf(redfp,"        x(j,i) = drn(idum)\n");
    fprintf(redfp,"   10 continue\n");
    putc(EOL, redfp);
    }

    fprintf(redfp,"* Graph selection\n");
    if(caller == GRCFORT || caller == GRCREDA ) {
        fprintf(redfp,"      do 1020 ng = 1, n%sgraph\n",prf);
        fprintf(redfp,"        jselg(ng) = 1\n");
        fprintf(redfp," 1020 continue\n\n");
    } else if(caller == GRCREDH ) {
      if( hltype == 1 ) {
        fprintf(redfp,"      do 1020 ng = 1, ng0\n");
        fprintf(redfp,"        jselg0(ng) = 1\n");
        fprintf(redfp," 1020 continue\n\n");
      }
    } else if(caller == GRCRED ) {
        fprintf(redfp,"      do 1020 n2 = 1, ng0\n");
        fprintf(redfp,"      do 1020 n1 = 1, ng0\n");
        fprintf(redfp,"        jsel0(n1, n2) = 1\n");
        fprintf(redfp," 1020 continue\n\n");
        for(lp = 0; lp <= maxloop; lp++) {
            fprintf(redfp,"      do n1 = 1, ng%d\n", lp);
            fprintf(redfp,"        jselg%d(n1) = 1\n", lp);
            fprintf(redfp,"      enddo\n\n");
        }
    }

    if(caller == GRCFORT || caller == GRCREDA || caller == GRCREDH ) {
        if( !vcode ) {
        fprintf(redfp,"      write(*,*) 'integration variables'\n");
        fprintf(redfp,"      write(*,*) 'x     = ', (x(i),i=1,ndim)\n");
        putc(EOL, redfp);
        }

        fprintf(redfp,"      write(*,*) 'graph selection flags'\n");
        if(caller == GRCFORT || caller == GRCREDA ) {
          fprintf(redfp,"      write(*,*) 'jselg = ', jselg\n");
        } else if(caller == GRCREDH ) {
          fprintf(redfp,"      write(*,*) 'jselg0 = ', jselg0\n");
        }
        fprintf(redfp,"\n");

        if(caller == GRCFORT) {
            fprintf(redfp,"*   Unitary gauge\n");
            for(i = 0; i < ngauge; i++) {
                fprintf(redfp,"      igau%s = 0\n", sgauge[i]);
            }
            fprintf(redfp,"\n");
            fprintf(redfp,"      agauge(0) = 1.0d20\n");
            fprintf(redfp,"\n");
        } else if(caller == GRCREDA || caller == GRCREDH ) {
            fprintf(redfp,"*   Feynman gauge\n");
            for(i = 0; i < ngauge; i++) {
                fprintf(redfp,"      igau%s = %d\n", sgauge[i], i+1);
            }
            fprintf(redfp,"\n");
            for(i = 0; i < ngauge; i++) {
                fprintf(redfp,"      agauge(igau%s) = 1.0d0\n",
                        sgauge[i]);
            }
            fprintf(redfp,"\n");
        }
        for(i = 0; i < ngauge; i++) {
            fprintf(redfp,"      write(*,*) 'igau%s = ', igau%s, ",
                          sgauge[i], sgauge[i]);
            fprintf(redfp,"' agauge = ',agauge(igau%s)\n",
                          sgauge[i]);
        }

    } else {
        if( !vcode ) {
        fprintf(redfp,"      write(*,*) 'integration variables'\n");
        fprintf(redfp,"      write(*,*) 'x     = ', (x(i),i=1,ndim)\n");
        putc(EOL, redfp);
        }

        fprintf(redfp,"      write(*,*) 'Graph Selection flags'\n");
        fprintf(redfp,"      write(*,*) '  tree -- tree'\n");
        fprintf(redfp,"      do 40 n1 = 1, ng0\n");
        fprintf(redfp,"        write(*,*) n1, ':', ");
        fprintf(redfp,          "(jsel0(n1, n2), n2 = 1, ng0)\n");
        fprintf(redfp,"   40 continue\n\n");
        for(lp = 0; lp <= maxloop; lp++) {
            fprintf(redfp,"      do n1 = 1, ng%d\n", lp);
            fprintf(redfp,"        write(*,*) 'jselg%d = ', jselg%d(n1)\n",
                    lp, lp);
            fprintf(redfp,"      enddo\n\n");
        }
    }
    if( !vcode ) {
        fprintf(redfp,"      aaa = func(x)\n");
        fprintf(redfp,"      write(*,*)\n");
        fprintf(redfp,"      write(*,*) '================================='\n");
        fprintf(redfp,"      write(*,*) 'tree ', jgraph, 'graphs'\n");
        if(caller == GRCRED) {
            fprintf(redfp,"      write(*,*) '  (for only color-base = 1)'\n");
            fprintf(redfp,"      do i =  1 , ng0\n");
            fprintf(redfp,"      do j =  i , ng0\n");
            fprintf(redfp,"         write(*,*) '  agct(',i,',',j,') = ', ");
                fprintf(redfp,"agctxt(i,j)\n");
            fprintf(redfp,"      enddo\n");
            fprintf(redfp,"      enddo\n");
            fprintf(redfp,"\n");
        }
        fprintf(redfp,"      write(*,*)\n");

        if(maxloop == 1) {
            fprintf(redfp,"      write(*,*) '1 loop graphs :'\n");
            fprintf(redfp,"      do n1 = 1, ng%d\n", maxloop);
            fprintf(redfp,"        write(*,*) '  agcl(',n1,') = ', agcl(n1)\n");
            fprintf(redfp,"      enddo\n\n");
        }
        fprintf(redfp,"      write(*,*) '================================='\n");
        fprintf(redfp,"      write(*,*) '  ans = ',aaa\n");
        fprintf(redfp,"      write(*,*) '================================='\n");
        fprintf(redfp,"\n");

        fprintf(redfp,"c     call usrout\n");
        fprintf(redfp,"\n");
    } else {
        fprintf(redfp,"      call vbfnct(func,n_vector,x,fx,wgt)\n");
        fprintf(redfp,"      do 200 j = 1, n_vector\n");
        fprintf(redfp,"  200 aaa(j) = fx(j)\n");
    }

    if(caller != GRCFORT && caller != GRCREDA) {
        fprintf(redfp,"ct100 continue\n");
        fprintf(redfp, "*----- Omake (for only color-base = 1)\n");
        fprintf(redfp, "*     do i =  1 , ng0\n");
        fprintf(redfp, "*     do j =  i , ng0\n");
        fprintf(redfp, "*        print *,i,j,agctxt(i,j)\n");
        fprintf(redfp, "*     enddo\n");
        fprintf(redfp, "*     enddo\n");
        fprintf(redfp,"      end\n");
        return;
    }
/* CF */

    fprintf(redfp,"      fkcall = 0\n");
    fprintf(redfp,"      nkcall = 0\n");
    if( !vcode ) {
    fprintf(redfp,"      do 30 i = 0, jgraph\n");
    fprintf(redfp,"   30     ansp(i) = 0\n");
    fprintf(redfp,"\n");
    } else {
    fprintf(redfp,"      do 30 j = 1, n_vector\n");
    fprintf(redfp,"      do 30 i = 0, jgraph\n");
    fprintf(redfp,"   30     ansp(j,i) = 0\n");
    fprintf(redfp,"\n");
    }


    fprintf(redfp,"*   Covariant gauge (Feynman Gauge)\n");
    for(i = 0; i < ngauge; i++) {
        fprintf(redfp,"      igau%s = %d\n", sgauge[i], i+1);
    }
    fprintf(redfp,"\n");

    for(i = 0; i < ngauge; i++) {
/*
        fprintf(redfp,"      agauge(igau%s) = %d.0d0\n", sgauge[i], i+2);
*/
        fprintf(redfp,"      agauge(igau%s) = 1.0d0\n", sgauge[i]);
    }
    fprintf(redfp,"\n");

    if( !vcode ) {
    fprintf(redfp,"      write(*,*) 'x     = ', (x(i),i=1,ndim)\n");
    }
    fprintf(redfp,"      write(*,*) 'jselg = ', jselg\n");
    fprintf(redfp,"\n");

    for(i = 0; i < ngauge; i++) {
        fprintf(redfp,"      write(*,*) 'igau%s = ', igau%s, ",
                      sgauge[i], sgauge[i]);
        fprintf(redfp,"' agauge = ',agauge(igau%s)\n",
                      sgauge[i]);
    }
    fprintf(redfp,"\n");

    if( !vcode ) {
    fprintf(redfp,"      bbb = func(x)\n");
    fprintf(redfp,"      write(*,*) '  ans2     = ',bbb\n");
    fprintf(redfp,"      write(*,*) '# graphs = ',jgraph\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      call usrout\n");
    putc(EOL, redfp);
    } else {
    fprintf(redfp,"      call vbfnct(func,n_vector,x,fx,wgt)\n");
    fprintf(redfp,"      do 300 j = 1, n_vector\n");
    fprintf(redfp,"  300 bbb(j) = fx(j)\n");
    }
/* CF */

    fprintf(redfp,"      fkcall = 0\n");
    fprintf(redfp,"      nkcall = 0\n");
    if(!vcode) {
    fprintf(redfp,"      do 40 i = 0, jgraph\n");
    fprintf(redfp,"   40     ansp(i) = 0\n");
    fprintf(redfp,"\n");
    } else {
    fprintf(redfp,"      do 40 j = 1, n_vector\n");
    fprintf(redfp,"      do 40 i = 0, jgraph\n");
    fprintf(redfp,"   40     ansp(j,i) = 0\n");
    fprintf(redfp,"\n");
    }


    fprintf(redfp,"      write(*,'(''1'',72a1)') ('=', i = 1, 72)\n");
    if(!vcode) {
    fprintf(redfp,"      write(*,*) '  ans1   = ',aaa\n");
    fprintf(redfp,"      write(*,*) '  ans2   = ',bbb\n");
    fprintf(redfp,"      if(bbb.ne.0) then\n");
    fprintf(redfp,"        write(*,*) '  ans1/ans2 - 1 = ', aaa/bbb - ");
    fprintf(redfp,"1\n");

    fprintf(redfp,"      else\n");
    fprintf(redfp,"        write(*,*) 'ans1 = ', aaa,'  ans2 =', ");
    fprintf(redfp,"bbb\n");
    fprintf(redfp,"      endif\n");
    putc(EOL, redfp);

    fprintf(redfp,"ct100 continue\n");
    fprintf(redfp,"\n");
    } else {
    fprintf(redfp,"      do 5000 j = 1, n_vector\n");
    fprintf(redfp,"      write(*,*) '  ans1   = ',aaa(j)\n");
    fprintf(redfp,"      write(*,*) '  ans2   = ',bbb(j)\n");
    fprintf(redfp,"      if(bbb(j).ne.0) then\n");
    fprintf(redfp,"        write(*,*) '  ans1/ans2 - 1 = ', aaa(j)/bbb(j) - ");
    fprintf(redfp,"1\n");

    fprintf(redfp,"      else\n");
    fprintf(redfp,"        write(*,*) 'ans1 = ', aaa(j),'  ans2 =', ");
    fprintf(redfp,"bbb(j)\n");
    fprintf(redfp,"      endif\n");
    fprintf(redfp," 5000 continue\n");
    }

/* omake */
    fprintf(redfp, "*----- Omake (for only color-base = 1)\n");

    fprintf(redfp, "*     do i = 1, ngraph\n");
    fprintf(redfp, "*        do ng = 1, ngraph\n");
    fprintf(redfp, "*          jselg(ng) = 0\n");
    fprintf(redfp, "*         enddo\n");
    fprintf(redfp, "*        jselg(i) = 1\n");
    fprintf(redfp, "*        aaa = func(x)\n");
    fprintf(redfp, "*        do l = 0,lag-1\n");
    fprintf(redfp, "*           agctmp(i,l,0) = agc(l,0)\n");
    fprintf(redfp, "*        enddo\n");
    fprintf(redfp, "*     enddo\n");
    fprintf(redfp, "*---------------------\n");
    fprintf(redfp, "*     do i =  1 , ngraph\n");
    fprintf(redfp, "*     do j =  i , ngraph\n");
    fprintf(redfp, "*        amptxt = 0.0d0\n");
    fprintf(redfp, "*        do l = 0,lag-1\n");
    fprintf(redfp, "*           amptxt = amptxt + agctmp(i,l,0)*conjg(agctmp(j,l,0))\n");
    fprintf(redfp, "*        enddo\n");
    fprintf(redfp, "*        print *,i,j,amptxt\n");
    fprintf(redfp, "*     enddo\n");
    fprintf(redfp, "*     enddo\n");


    fprintf(redfp,"      end\n");

}

/*==================================================================*/
Private Void    cmtestp1(pc)
int     pc;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    pindex p;
    int    pps, ppe, lp;
    string prf, prfs;

    if(maxloop != 1 || caller != GRCRED) {
        return;
    }
    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    cmopen(ROFORT, "test1.f");

    cmsepar('*');
    fprintf(redfp,"* main program for test\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    fprintf(redfp,"      include 'incl%s1.h'\n", prf);
    fprintf(redfp,"      include 'inclk.h'\n");
    putc(EOL, redfp);

    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      common / loop0 / loop\n");
    fprintf(redfp,"      common / bparm1 / xl(mxdim),xu(mxdim),");
    fprintf(redfp,       "ndim,nwild,\n");
    fprintf(redfp,"     &                 ig(mxdim),ncall\n");
    fprintf(redfp,"      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    fprintf(redfp,"      common / knmflg / knmgvs,knmhst,knmsph,");
    fprintf(redfp,"knmisr\n");
    putc(EOL, redfp);

    fprintf(redfp,"      real*8     x(mxdim)\n");
    putc(EOL, redfp);
    fprintf(redfp,"      real*8     ans(2)\n");
    fprintf(redfp,"      complex*16 agcta(ng0,ng0,2), agcla(ng1,2)\n");
    putc(EOL, redfp);
    fprintf(redfp,"*     calculation for Amp(i)*Congj(Amp(j))\n");
    fprintf(redfp,"*     complex*16 agctmp(ngraph,0:lag-1,0:ncbase-1),amptxt\n");

    fprintf(redfp,"      common/ninfo/ nodeid, numnod, ipflag\n");
    fprintf(redfp,"      nodeid = 0\n");
    fprintf(redfp,"      numnod = 1\n");
    cmsepar('-');
    cmshowp();

    fprintf(redfp,"      call bsinit\n");
    putc(EOL, redfp);

    fprintf(redfp,"      loop   = 1\n");
    fprintf(redfp,"      knmgvs = 1\n");
    fprintf(redfp,"      knmhst = 0\n");
    fprintf(redfp,"      knmsph = 0\n");
    fprintf(redfp,"      knmisr = 0\n");
    fprintf(redfp,"      wgt    = 1.0d0\n");
    fprintf(redfp,"      call bsputw(wgt)\n");
    putc(EOL, redfp);

    fprintf(redfp,"      call userin( 6 )\n");
    putc(EOL, redfp);

    for(p = 0; p < nptable; p++) {
        if(isdigit(ptable[p]->width[0])) {
            continue;
        }
        cmwidth(p, 1, momstr);
        fprintf(redfp,"      %6s = 0.0d0\n", momstr);
    }
    putc(EOL, redfp);

    fprintf(redfp,"      call bschck\n");
    putc(EOL, redfp);

    fprintf(redfp,"CC    call prmass\n");
    putc(EOL, redfp);

    fprintf(redfp,"ct    do 100 many x's\n");
    putc(EOL, redfp);

    fprintf(redfp,"      do 10 i = 1, ndim\n");
    fprintf(redfp,"        x(i) = 0.45d0+0.02d0*i\n");
    fprintf(redfp,"   10 continue\n");
    putc(EOL, redfp);

    fprintf(redfp,"* Graph selection\n");
    fprintf(redfp,"      do 1020 n2 = 1, ng0\n");
    fprintf(redfp,"      do 1020 n1 = 1, ng0\n");
    fprintf(redfp,"        jsel0(n1, n2) = 1\n");
    fprintf(redfp," 1020 continue\n\n");
    for(lp = 0; lp <= maxloop; lp++) {
        fprintf(redfp,"      do n1 = 1, ng%d\n", lp);
        fprintf(redfp,"        jselg%d(n1) = 1\n", lp);
        fprintf(redfp,"      enddo\n\n");
    }

    fprintf(redfp,"      write(*,*) 'integration variables'\n");
    fprintf(redfp,"      write(*,*) 'x     = ', (x(i),i=1,ndim)\n");
    putc(EOL, redfp);

    fprintf(redfp,"      write(*,*) 'Graph Selection flags'\n");
    fprintf(redfp,"      write(*,*) '  tree -- tree'\n");
    fprintf(redfp,"      do 40 n1 = 1, ng0\n");
    fprintf(redfp,"        write(*,*) n1, ':', ");
    fprintf(redfp,          "(jsel0(n1, n2), n2 = 1, ng0)\n");
    fprintf(redfp,"   40 continue\n\n");
    for(lp = 0; lp <= maxloop; lp++) {
        fprintf(redfp,"      do n1 = 1, ng%d\n", lp);
        fprintf(redfp,"        write(*,*) 'jselg%d = ', jselg%d(n1)\n",
                lp, lp);
        fprintf(redfp,"      enddo\n\n");
    }

    fprintf(redfp,"      do np = 1, 2\n");
    fprintf(redfp,"      \n");
    fprintf(redfp,"        xnla = 2*(np-1)\n");
    fprintf(redfp,"        xnlb = 3*(np-1)\n");
    fprintf(redfp,"        xnld = 4*(np-1)\n");
    fprintf(redfp,"        xnlk = 5*(np-1)\n");
    fprintf(redfp,"        xnle = 6*(np-1)\n");
    fprintf(redfp,"        xia  = 7*(np-1)\n");
    fprintf(redfp,"        xiz  = 8*(np-1)\n");
    fprintf(redfp,"        xiw  = 9*(np-1)\n");
    fprintf(redfp,"        cuv  = 10*(np-1)\n");
    fprintf(redfp,"           \n");
    fprintf(redfp,"        call setcpl\n");
    fprintf(redfp,"        call gfinit\n");
    fprintf(redfp,"        call kinit( lu )\n");
    fprintf(redfp,"     \n");
    fprintf(redfp,"        write(*,*) 'np   = ', np\n");
    fprintf(redfp,"        write(*,*) 'xnla = ', xnla\n");
    fprintf(redfp,"        write(*,*) 'xnlb = ', xnlb\n");
    fprintf(redfp,"        write(*,*) 'xnld = ', xnld\n");
    fprintf(redfp,"        write(*,*) 'xnlk = ', xnlk\n");
    fprintf(redfp,"        write(*,*) 'xnle = ', xnle\n");
    fprintf(redfp,"        write(*,*) 'xia  = ', xia\n");
    fprintf(redfp,"        write(*,*) 'xiz  = ', xiz\n");
    fprintf(redfp,"        write(*,*) 'xiw  = ', xiw\n");
    fprintf(redfp,"        write(*,*) 'cuv  = ', cuv\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"        ans(np) = func(x)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"        do i = 1, ng0\n");
    fprintf(redfp,"        do j = 1, ng0\n");
    fprintf(redfp,"          agcta(i,j,np) = agctxt(i,j)\n");
    fprintf(redfp,"        enddo\n");
    fprintf(redfp,"        enddo\n");
    fprintf(redfp,"        do i = 1, ng1\n");
    fprintf(redfp,"          agcla(i,np)  = agcl(i)\n");
    fprintf(redfp,"        enddo\n");
    fprintf(redfp,"      enddo\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      write(*,*)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      write(*,*) '================================='\n");
    fprintf(redfp,"      write(*,*) 'tree ', jgraph, 'graphs'\n");
    fprintf(redfp,"      write(*,*) '  (for only color-base = 1)'\n");
    fprintf(redfp,"      do i =  1 , ng0\n");
    fprintf(redfp,"      do j =  i , ng0\n");
    fprintf(redfp,"        do np = 1, 2\n");
    fprintf(redfp,"           write(*,*) '  agcta(',i,',',j,',',np,') = ', ");
    fprintf(redfp,"agcta(i,j,np)\n");
    fprintf(redfp,"        enddo\n");
    fprintf(redfp,"      enddo\n");
    fprintf(redfp,"      enddo\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      write(*,*)\n");
    fprintf(redfp,"      write(*,*) '1 loop graphs :'\n");
    fprintf(redfp,"      do n1 = 1, ng1\n");
    fprintf(redfp,"        do np = 1, 2\n");
    fprintf(redfp,"          write(*,*) '  agcla(',n1,',',np,') = ', ");
    fprintf(redfp,"agcla(n1,np)\n");
    fprintf(redfp,"        enddo\n");
    fprintf(redfp,"      enddo\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      write(*,*) '================================='\n");
    fprintf(redfp,"      do np = 1, 2\n");
    fprintf(redfp,"        write(*,*) '  ans(', np, ') = ',ans(np)\n");
    fprintf(redfp,"      enddo\n");
    fprintf(redfp,"      write(*,*) '  err:', (ans(2) - ans(1))/ans(1)\n");
    fprintf(redfp,"      write(*,*) '================================='\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmprms(sdir, pc)
string  sdir;
int     pc;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int    p, lp;
    bool   prcond;
    string prf;

    cmopend(ROFORT, sdir, "prmass.f");

    cmsepar('*');
    fprintf(redfp,"      subroutine prmass\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
    } else {
        prf  = reprocp[pc];
    }

    if(rvcode) {
        fprintf(redfp,"      include 'incl1v.h'\n");
    } else {
        fprintf(redfp,"      include 'incl%s1.h'\n", prf);
    }
    fprintf(redfp,"      include 'inclm.h'\n");
    putc(EOL, redfp);

    /* mass */
    cmsepar('-');
    fprintf(redfp,"      write(*,*) '+++ mass +++'\n");
    for(p = 1; p < nptable; p++) {
        cmmass(p, 1, momstr);
        if(strcmp(momstr,"0") == 0) {
            continue;
        }
        fprintf(redfp,"      write(*,*) '   %6s = ', %6s\n", momstr, momstr);
    }
    putc(EOL, redfp);

    /* width */
    cmsepar('-');
    fprintf(redfp,"      write(*,*) '+++ width +++'\n");
    for(p = 1; p < nptable; p++) {
        cmwidth(p, 1, momstr);
        if(momstr == NULL || strcmp(momstr,"0") == 0) {
            continue;
        }
        fprintf(redfp,"      write(*,*) '   %6s = ', %6s\n", momstr, momstr);
    }
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"      write(*,*) '+++ coupling constants +++'\n");
    fprintf(redfp,"      write(*,*) '     cqed = ',      cqed\n");
    fprintf(redfp,"      write(*,*) '     cqcd = ',      cqcd\n");

    if(caller == GRCFORT || caller == GRCREDA ) {
        for(lp = 0; lp <= maxloop; lp++) {
            for(p = nvstart; p < nvtable; p++) {
                if(vtable[p]->composit == V_AUX) {
                    continue;
                }
                if(vtable[p]->loop > lp) {
                    continue;
                }
                if(p != pvvnfind(p)) {
                    continue;
                }
                Discard cmcoupl(p, 0, lp, momstr);
                fprintf(redfp,"      write(*,*) '%9s = ', %9s\n",
                        momstr, momstr);
            }
        }
    } else {
        prcond = False;
        for(lp = 0; lp <= maxloop; lp++) {
            for(p = nvstart; p < nvtable; p++) {
                if(vtable[p]->composit == V_AUX) {
                    continue;
                }
                if(vtable[p]->loop > lp) {
                    continue;
                }
                if(p != pvvnfind(p)) {
                    continue;
                }
                Discard cmcoupl(p, 0, lp, momstr);
                fprintf(redfp,"      write(*,*) '%9s = ', %9s\n",
                        momstr, momstr);
#if CMPLX
#else
                Discard cmcoupl(p, -2, lp, momstr);
                fprintf(redfp,"      write(*,*) '%9s = ', %9s\n",
                        momstr, momstr);
#endif
            }

            if(maxloop > 0 && lp == 0) {
                fprintf(redfp,"\n      if(lloop.gt.0) then\n\n");
                prcond = True;
            }
        }
        if(prcond) {
            fprintf(redfp,"\n      endif\n\n");
        }
    }
    putc(EOL, redfp);
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmamclr(NoArg)
/*------------------------------------------------------------------*
 */
{
    if( opver ) {
        cmamclpo();
    } else if(rvcode) {
        cmamclpr();
    } else {
        cmamclp(-1);
    }
}

/*==================================================================*/
Private Void    cmamclp(pc)
int     pc;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int    pps, ppe, pp;
    string prf, prfs;

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    if(multiprc) {
        cmopend(ROFORT, prfs, "amclr.f");
        cmsepar('*');
        fprintf(redfp,"      subroutine amclr\n");
        fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
        fprintf(redfp,"      common /amjprc/jproc\n");

        fprintf(redfp,"\n");

        for(pp = pps; pp < ppe; pp++) {
            fprintf(redfp,"      if(jproc .eq. %d) then\n", pp+1);
            fprintf(redfp,"          call a%smclr\n", reprocp[pp]);
            fprintf(redfp,"      endif\n");
            fprintf(redfp,"\n");
        }
        fprintf(redfp,"      return\n");
        fprintf(redfp,"      end\n");

        if(pc < 0) {
            return;
        } else {
            sprintf(momstr, "a%smclr", prf);
        }
    } else {
        sprintf(momstr, "amclr");
    }
    sprintf(momstr1, "%s.f", momstr);
    cmopend(ROFORT, prf, momstr1);

    cmsepar('*');
    fprintf(redfp,"      subroutine %s\n", momstr);
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);
    if(vcode) {
       fprintf(redfp,"      include 'inclvs.h'\n");
    }
    fprintf(redfp,"      include 'incl%s1.h'\n", prf);
    fprintf(redfp,"      include 'inclk.h'\n");
    putc(EOL, redfp);

    if( caller == GRCREDA || caller == GRCREDH ) {
        fprintf(redfp,"           n%sgraph = ng0\n", prf);
    }
/* CF */
/*  if(colorv == 0) { */
    fprintf(redfp,"           do 300 igr = 0, n%sgraph\n", prf);
    if(!vcode) {
        fprintf(redfp,"             ansp(igr) = 0.0d0\n");
    } else {
        fprintf(redfp,"           do 300 j = 1, n_vector\n");
        fprintf(redfp,"              ansp(j,igr) = 0.0d0\n");
    }
    fprintf(redfp,"  300      continue\n");
    fprintf(redfp,"           do 310 igr = 1, n%sgraph\n", prf);
    if(!vcode) {
        fprintf(redfp,"             ancp(igr) = 0.0d0\n");
    } else {
        fprintf(redfp,"           do 310 j = 1, n_vector\n");
        fprintf(redfp,"              ancp(j,igr) = 0.0d0\n");
    }
    fprintf(redfp,"  310      continue\n");
    fprintf(redfp,"           fkcall = 0\n");
    fprintf(redfp,"           nkcall = 0\n");
    putc(EOL, redfp);
/*  } */

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmamclpr(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int    pps, ppe;
    string prf, prfs;

    if(cprefix == NULL) {
        prf = "";
    } else {
        prf  = cprefix;
    }
    prfs = "";
    pps  = 0;
    ppe  = nprocs;

    if(multiprc) {
        fprintf(Stderr, "*** rvcode option is not supported for multiprc\n");
        exit(FAIL);
    }
    sprintf(momstr1, "amclrv.f");
    cmopen(ROFORT, momstr1);

    cmsepar('*');
    fprintf(redfp,"      subroutine amclr\n");
    fprintf(redfp,"      implicit none\n");
    putc(EOL, redfp);
    fprintf(redfp,"      include 'incl%s1v.h'\n", prf);
    fprintf(redfp,"      include 'inclk.h'\n");
    fprintf(redfp,"      integer igr\n");
    putc(EOL, redfp);

    if( caller == GRCREDA || caller == GRCREDH ) {
        fprintf(redfp,"           n%sgraph = ng0\n", prf);
    }
    fprintf(redfp,"      do igr = 0, n%sgraph\n", prf);
    fprintf(redfp,"         ansp(:,igr) = 0.0d0\n");
    fprintf(redfp,"         ancp(:,igr) = 0.0d0\n");
    fprintf(redfp,"      enddo\n");
    fprintf(redfp,"      fkcall = 0\n");
    fprintf(redfp,"      nkcall = 0\n");
    putc(EOL, redfp);
/*  } */

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}
/*==================================================================*/
Private Void    cmpcode(NoArg)
/*------------------------------------------------------------------*
 * write pcode
 *------------------------------------------------------------------*/
{
    int p,pc;
    cmopen(ROFORT, "setpcd.f");
    fprintf(redfp,"      do 1000 i=1,%d\n",nptable);
    fprintf(redfp,"      ptname(i) =  ' '\n");
    fprintf(redfp,"      ipcode(i) =  -999 \n");
    fprintf(redfp," 1000 continue\n");
    for(p = 1; p < nptable; p++) {
        if( ( ptable[p]->ptype >= 1 ) && ( ptable[p]->ptype <= 5 ) ) {
          pc = ptable[p]->pcode;
          fprintf(redfp,"      ptname(%d) = '%s'\n",p,pvename(1,p));
          fprintf(redfp,"      ipcode(%d) =  %d \n",p,pc);
        }
    }
    cmopen(ROFORT, "inclpc.h");
    fprintf(redfp,"      character*16 ptname\n");
    fprintf(redfp,"      real*8    ptname(%d)\n",nptable);
    fprintf(redfp,"      integer   ipcode(%d)\n",nptable);
}
/*==================================================================*/
Private Void    cmamclpo(NoArg)
/*------------------------------------------------------------------*
 * only for opver
 *------------------------------------------------------------------*/
{
    int lp,l0;
    string prf;
    prf = "";
    sprintf(momstr, "amclr");
    sprintf(momstr1, "%s.f", momstr);
    cmopend(ROFORT, prf, momstr1);

    cmsepar('*');
    fprintf(redfp,"      subroutine %s\n", momstr);
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);
    if(vcode) {
       fprintf(redfp,"      include 'inclvs.h'\n");
    }
    fprintf(redfp,"      include 'incl%s1.h'\n", prf);
    fprintf(redfp,"      include 'inclk.h'\n");
    putc(EOL, redfp);

/*HERE*/
    for(lp = 0; lp <= maxloop; lp++) {
    for(l0 = lp0min(lp); l0 <= lp0max(lp); l0++) {


    fprintf(redfp,"           do %4d igr = 0, n%sgraph%d\n", 1000+l0,prf,l0);
    if(!vcode) {
        fprintf(redfp,"             ansp%d(igr) = 0.0d0\n",l0);
        fprintf(redfp,"             ancp%d(igr) = 0.0d0\n",l0);
    } else {
        fprintf(redfp,"           do %4d j = 1, n_vector\n",1000+l0);
        fprintf(redfp,"              ansp%d(j,igr) = 0.0d0\n",l0);
        fprintf(redfp,"              ancp%d(j,igr) = 0.0d0\n",l0);
    }
    fprintf(redfp," %4d      continue\n",1000+l0);

    }
    }
    fprintf(redfp,"           fkcall = 0\n");
    fprintf(redfp,"           nkcall = 0\n");
    putc(EOL, redfp);
/*  } */

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmeps(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{

    cmopen(ROFORT, "eps.f");

    fprintf(redfp,"***************************************");
    fprintf(redfp,       "*********************************\n");
    fprintf(redfp,"      function eps(p1, p2, p3, p4)\n");
    cmsepar('*');
    fprintf(redfp,"*     2000.07.26 (add eps=-eps)\n");
    cmsepar('*');
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"      real*8   eps\n");
    putc(EOL, redfp);

    fprintf(redfp,"      real*8   p1(4), p2(4), p3(4), p4(4)\n");
    putc(EOL, redfp);

    fprintf(redfp,"*======================================");
    fprintf(redfp,       "=================================\n");
    fprintf(redfp,"*          initialization\n");
    fprintf(redfp,"*======================================");
    fprintf(redfp,       "=================================\n");
    putc(EOL, redfp);

    fprintf(redfp,"      de4=\n");
    fprintf(redfp,"     & +p1(4)*p2(3)*p3(2)*p4(1)\n");
    fprintf(redfp,"     & -p1(4)*p2(3)*p3(1)*p4(2)\n");
    fprintf(redfp,"     & -p1(4)*p2(2)*p3(3)*p4(1)\n");
    fprintf(redfp,"     & +p1(4)*p2(2)*p3(1)*p4(3)\n");
    fprintf(redfp,"     & +p1(4)*p2(1)*p3(3)*p4(2)\n");
    fprintf(redfp,"     & -p1(4)*p2(1)*p3(2)*p4(3)\n");
    fprintf(redfp,"      de3=\n");
    fprintf(redfp,"     & -p1(3)*p2(4)*p3(2)*p4(1)\n");
    fprintf(redfp,"     & +p1(3)*p2(4)*p3(1)*p4(2)\n");
    fprintf(redfp,"     & +p1(3)*p2(2)*p3(4)*p4(1)\n");
    fprintf(redfp,"     & -p1(3)*p2(2)*p3(1)*p4(4)\n");
    fprintf(redfp,"     & -p1(3)*p2(1)*p3(4)*p4(2)\n");
    fprintf(redfp,"     & +p1(3)*p2(1)*p3(2)*p4(4)\n");
    fprintf(redfp,"      de2=\n");
    fprintf(redfp,"     & +p1(2)*p2(4)*p3(3)*p4(1)\n");
    fprintf(redfp,"     & -p1(2)*p2(4)*p3(1)*p4(3)\n");
    fprintf(redfp,"     & -p1(2)*p2(3)*p3(4)*p4(1)\n");
    fprintf(redfp,"     & +p1(2)*p2(3)*p3(1)*p4(4)\n");
    fprintf(redfp,"     & +p1(2)*p2(1)*p3(4)*p4(3)\n");
    fprintf(redfp,"     & -p1(2)*p2(1)*p3(3)*p4(4)\n");
    fprintf(redfp,"      de1=\n");
    fprintf(redfp,"     & -p1(1)*p2(4)*p3(3)*p4(2)\n");
    fprintf(redfp,"     & +p1(1)*p2(4)*p3(2)*p4(3)\n");
    fprintf(redfp,"     & +p1(1)*p2(3)*p3(4)*p4(2)\n");
    fprintf(redfp,"     & -p1(1)*p2(3)*p3(2)*p4(4)\n");
    fprintf(redfp,"     & -p1(1)*p2(2)*p3(4)*p4(3)\n");
    fprintf(redfp,"     & +p1(1)*p2(2)*p3(3)*p4(4)\n");
    fprintf(redfp,"      eps = de4 + de3 + de2 + de1\n");
    fprintf(redfp,"      eps = -eps\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmepsv(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{

    cmopen(ROFORT, "eps_v.f");

    fprintf(redfp,"***********************************************");
    fprintf(redfp,"*************************\n");
    fprintf(redfp,"      subroutine eps_v(p1, p2, p3, p4, eps)\n");
    fprintf(redfp,"***********************************************");
    fprintf(redfp,"*************************\n");
    fprintf(redfp,"*     2000.07.26 (add eps=-eps)\n");
    fprintf(redfp,"***********************************************");
    fprintf(redfp,"*************************\n");
    fprintf(redfp,"      implicit none\n");
    fprintf(redfp,"      include 'inclvs.h'\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      real*8   p1(n_vector,4), p2(n_vector,4)\n");
    fprintf(redfp,"      real*8   p3(n_vector,4), p4(n_vector,4)\n");
    fprintf(redfp,"      real*8   eps(n_vector)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*==============================================");
    fprintf(redfp,"=========================\n");
    fprintf(redfp,"*          initialization\n");
    fprintf(redfp,"*==============================================");
    fprintf(redfp,"=========================\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      eps(:) = - (\n");
    fprintf(redfp,"     & +p1(:,4)*p2(:,3)*p3(:,2)*p4(:,1)\n");
    fprintf(redfp,"     & -p1(:,4)*p2(:,3)*p3(:,1)*p4(:,2)\n");
    fprintf(redfp,"     & -p1(:,4)*p2(:,2)*p3(:,3)*p4(:,1)\n");
    fprintf(redfp,"     & +p1(:,4)*p2(:,2)*p3(:,1)*p4(:,3)\n");
    fprintf(redfp,"     & +p1(:,4)*p2(:,1)*p3(:,3)*p4(:,2)\n");
    fprintf(redfp,"     & -p1(:,4)*p2(:,1)*p3(:,2)*p4(:,3)\n");
    fprintf(redfp,"     & )\n");
    fprintf(redfp,"      eps(:) = eps(:) - (\n");
    fprintf(redfp,"     & -p1(:,3)*p2(:,4)*p3(:,2)*p4(:,1)\n");
    fprintf(redfp,"     & +p1(:,3)*p2(:,4)*p3(:,1)*p4(:,2)\n");
    fprintf(redfp,"     & +p1(:,3)*p2(:,2)*p3(:,4)*p4(:,1)\n");
    fprintf(redfp,"     & -p1(:,3)*p2(:,2)*p3(:,1)*p4(:,4)\n");
    fprintf(redfp,"     & -p1(:,3)*p2(:,1)*p3(:,4)*p4(:,2)\n");
    fprintf(redfp,"     & +p1(:,3)*p2(:,1)*p3(:,2)*p4(:,4)\n");
    fprintf(redfp,"     & )\n");
    fprintf(redfp,"      eps(:) = eps(:) - (\n");
    fprintf(redfp,"     & +p1(:,2)*p2(:,4)*p3(:,3)*p4(:,1)\n");
    fprintf(redfp,"     & -p1(:,2)*p2(:,4)*p3(:,1)*p4(:,3)\n");
    fprintf(redfp,"     & -p1(:,2)*p2(:,3)*p3(:,4)*p4(:,1)\n");
    fprintf(redfp,"     & +p1(:,2)*p2(:,3)*p3(:,1)*p4(:,4)\n");
    fprintf(redfp,"     & +p1(:,2)*p2(:,1)*p3(:,4)*p4(:,3)\n");
    fprintf(redfp,"     & -p1(:,2)*p2(:,1)*p3(:,3)*p4(:,4)\n");
    fprintf(redfp,"     & )\n");
    fprintf(redfp,"      eps(:) = eps(:) - (\n");
    fprintf(redfp,"     & -p1(:,1)*p2(:,4)*p3(:,3)*p4(:,2)\n");
    fprintf(redfp,"     & +p1(:,1)*p2(:,4)*p3(:,2)*p4(:,3)\n");
    fprintf(redfp,"     & +p1(:,1)*p2(:,3)*p3(:,4)*p4(:,2)\n");
    fprintf(redfp,"     & -p1(:,1)*p2(:,3)*p3(:,2)*p4(:,4)\n");
    fprintf(redfp,"     & -p1(:,1)*p2(:,2)*p3(:,4)*p4(:,3)\n");
    fprintf(redfp,"     & +p1(:,1)*p2(:,2)*p3(:,3)*p4(:,4)\n");
    fprintf(redfp,"     & )\n");
    fprintf(redfp,"      end\n");
    fprintf(redfp,"\n");
}

/*==================================================================*/
Private Void    cmfunc(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmfunp(-1);
}
/*==================================================================*/
Private Void    cmfuncv(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmopen(ROFORT, "funcv.f");

    fprintf(redfp,"*\n");
    fprintf(redfp,"* for testing vector version (not correct)\n");
    cmsepar('*');
    fprintf(redfp,"      function funcv(x)\n");
    fprintf(redfp,"c     implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"      implicit none\n");
    fprintf(redfp,"      real*8   funcv\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      include 'incl1v.h'\n");
    fprintf(redfp,"      include 'inclk.h'\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      real*8   x(n_vector,mxdim)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      integer     mxdim\n");
    fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      integer loop\n");
    fprintf(redfp,"      common / loop0 / loop\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      real*8  xl, xu, acc1, acc2\n");
    fprintf(redfp,"      integer ndim, nwild, ig, ncall\n");
    fprintf(redfp,"      integer itmx1, itmx2\n");
    fprintf(redfp,"      common / bparm1 / xl(mxdim),xu(mxdim),ndim,nwild,\n");
    fprintf(redfp,"     &                 ig(mxdim),ncall\n");
    fprintf(redfp,"      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    fprintf(redfp,"      real*8  vec\n");
    fprintf(redfp,"      common /sp4vec/ vec(4,nextn)\n");
    fprintf(redfp,"\n");
    cmsepar('=');
    fprintf(redfp,"      real*8     ansm(n_vector), ans(n_vector)\n");
    fprintf(redfp,"      real*8     xx(mxdim),p(4,nextn),pp(nextn,nextn)\n");
    fprintf(redfp,"      real*8     ansum(n_vector), yacob(n_vector)\n");
    fprintf(redfp,"      real*8     wgt, dft\n");
    fprintf(redfp,"      integer    iv, i, nreg, jump, ireg, k, j, igr\n");
    cmsepar('=');
    fprintf(redfp,"*          initialization\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"      ansum(:) = 0.0d0\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      do 120 iv = 1, n_vector\n");
    fprintf(redfp,"      do  5 i = 1, ndim\n");
    fprintf(redfp,"         xx(i) = x(iv,i)\n");
    fprintf(redfp,"    5 continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      nreg  = 1\n");
    fprintf(redfp,"ctk   dft   = 0.d0\n");
    cmsepar('=');
    fprintf(redfp,"*          kinematics\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"c     do 1000 ireg = 1 , mxreg\n");
    fprintf(redfp,"c\n");
    fprintf(redfp,"c        if(ireg .gt. nreg) go to 1000\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"        call kinem(nextn,xx,p,pp,");
    fprintf(redfp,"yacob(iv),nreg,ireg,jump)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"        if(nreg.gt.1) then\n");
    fprintf(redfp,"            print *, '*** funcv : nreg = ', nreg\n");
    fprintf(redfp,"        endif\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"        print *, 'xx    = ', xx\n");
    fprintf(redfp,"        print *, 'p     = ', p\n");
    fprintf(redfp,"        print *, 'pp    = ', pp\n");
    fprintf(redfp,"        print *, 'yacob = ', yacob(iv)\n");
    fprintf(redfp,"        print *, 'nreg  = ', nreg\n");
    fprintf(redfp,"        print *, 'inreg = ', ireg\n");
    fprintf(redfp,"        print *, 'jump  = ', jump\n");
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*          reset the temporal buffer for the region 1\n");
    cmsepar('-');
    fprintf(redfp,"      if(ireg .eq. 1) then\n");
    fprintf(redfp,"          dft = 0.d0\n");
    fprintf(redfp,"          do 180 k = 1, nextn\n");
    fprintf(redfp,"          do 180 j = 1, 4\n");
    fprintf(redfp,"             vec(j,k) = 0.d0\n");
    fprintf(redfp,"  180     continue\n");
    fprintf(redfp,"      endif\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         if(jump .ne. 0) go to 1000\n");
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*          for user's cut\n");
    cmsepar('-');
    fprintf(redfp,"\n");
    fprintf(redfp,"*--> call usrcut(jump)\n");
    fprintf(redfp,"*--> if(jump .ne. 0) goto 1000\n");
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*          four momenta of external particles\n");
    cmsepar('-');
    fprintf(redfp,"\n");
    fprintf(redfp,"      do 20 i = 1, 4\n");
    fprintf(redfp,"*     1: initial electron mass=amel\n");
    fprintf(redfp,"      pe1(iv,i) = p(i, kperm(1))\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     2: initial positron mass=amel\n");
    fprintf(redfp,"      pe2(iv,i) = p(i, kperm(2))\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     3: final nu-e mass=amne\n");
    fprintf(redfp,"      pe3(iv,i) = p(i, kperm(3))\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     4: final nu-e-bar mass=amne\n");
    fprintf(redfp,"      pe4(iv,i) = p(i, kperm(4))\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     5: final higgs mass=amh\n");
    fprintf(redfp,"      pe5(iv,i) = p(i, kperm(5))\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     6: final higgs mass=amh\n");
    fprintf(redfp,"      pe6(iv,i) = p(i, kperm(6))\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"   20 continue\n");
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*        inner products of momenta of external particles\n");
    cmsepar('-');
    fprintf(redfp,"\n");
    fprintf(redfp,"      do 30 j = 1, nextn\n");
    fprintf(redfp,"      do 30 i = 1, nextn\n");
    fprintf(redfp,"        prod(iv, i, j) = pp(kperm(i), kperm(j))\n");
    fprintf(redfp,"   30 continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"  120 continue\n");
    fprintf(redfp,"*     enddo iv = 1, n_vector\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");
    cmsepar('=');
    fprintf(redfp,"*          amplitude calculation\n");
    cmsepar('=');
    fprintf(redfp,"        call akptblv\n");
    fprintf(redfp,"*       ===================\n");
    fprintf(redfp,"        call kinemp( ireg )\n");
    fprintf(redfp,"*       ===================\n");
    fprintf(redfp,"        call amptblv\n");
    fprintf(redfp,"*       ===================\n");
    fprintf(redfp,"        call ampsum(ansm)\n");
    fprintf(redfp,"*       ===================\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      do iv = 1, n_vector\n");
    fprintf(redfp,"        fknorm = yacob(iv)*aspin\n");
    fprintf(redfp,"        ans(iv)   = ansm(iv)*fknorm/aident\n");
    fprintf(redfp,"        ansum(iv) = ansum(iv) + ans(iv)\n");
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*    save four momenta and probabilities of the region 1\n");
    cmsepar('-');
    fprintf(redfp,"      dft = 0\n");
    fprintf(redfp,"      if(ireg .eq. 1) then\n");
    fprintf(redfp,"          dft = ans(iv)\n");
    fprintf(redfp,"          do 420 k = 1, nextn\n");
    fprintf(redfp,"          do 420 j = 1, 4\n");
    fprintf(redfp,"             vec(j,k) = p(j,k)\n");
    fprintf(redfp,"  420     continue\n");
    fprintf(redfp,"      endif\n");
    fprintf(redfp,"\n");
    cmsepar('=');
    fprintf(redfp,"*          fill histograms and scatter plots\n");
    cmsepar('=');
    fprintf(redfp,"      call kfill(nextn, ndim, x, p, pp, ans*aident)\n");
    cmsepar('=');
    fprintf(redfp,"*          update summary table\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"        call bsgetw(wgt)\n");
    fprintf(redfp,"        ansp(iv,0) = ansp(iv,0) + wgt*ans(iv)\n");
    fprintf(redfp,"        do 60 igr = 1, jgraph\n");
    fprintf(redfp,"          ansp(iv,igr)=ansp(iv,igr) ");
    fprintf(redfp,"+ wgt*yacob(iv)*aspin*ancp(iv,igr)\n");
    fprintf(redfp,"   60   continue\n");
    fprintf(redfp,"        nkcall = nkcall + 1\n");
    fprintf(redfp,"        if(nkcall.gt.10000) then\n");
    fprintf(redfp,"          nkcall = nkcall - 10000\n");
    fprintf(redfp,"          fkcall = fkcall + 10000\n");
    fprintf(redfp,"        endif\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      enddo\n");
    fprintf(redfp,"*     enddo iv = 1, n_vector\n");
    fprintf(redfp,"\n");
    fprintf(redfp," 1000 continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      funcv = ansum(1)\n");
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*          put the final 4 vectors into the arrays vec()\n");
    cmsepar('-');
    fprintf(redfp,"*     if(func .gt. 0.d0) then\n");
    fprintf(redfp,"*         if(dft/func .lt. drn(dum)) then\n");
    fprintf(redfp,"*             do 850 k = 1, nextn\n");
    fprintf(redfp,"*             do 850 j = 1, 4\n");
    fprintf(redfp,"*                vec(j,k) = p(j,k)\n");
    fprintf(redfp,"* 850         continue\n");
    fprintf(redfp,"*         endif\n");
    fprintf(redfp,"*     endif\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmfunp(pc)
int     pc;
/*------------------------------------------------------------------*
 *   multiprc   pc<0    generated
 *
 *    False     True    func(body)
 *    True      True    func(controler)
 *    True      False   x/func(controler), x/fncx(body)
 *
 */
{
    int    n, p;
    tnode  *nd;
    tleg   *lg;
    int    pps, ppe, pp;
    string prf, prfs;
    char   suf[16]; /* for grcfort */

    if( opver ) {
        sprintf(suf,"%d",cprocs);
    } else {
        suf[0] = '\0';
    }

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    if(multiprc) {
        cmopend(ROFORT, prfs, "func.f");
        cmsepar('*');
        fprintf(redfp,"      function func(x)\n");
        fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
        fprintf(redfp,"      common /amjprc/jproc\n");
        if(basesv == 0) {
            fprintf(redfp,"      parameter ( mxdim = 50 )\n");
        } else {
            fprintf(redfp,"      parameter ( mxdim = 100 )\n");
        }
        fprintf(redfp,"      real*8   x(mxdim)\n");

        fprintf(redfp,"\n");

        for(pp = pps; pp < ppe; pp++) {
            fprintf(redfp,"      if(jproc .eq. %d) then\n", pp+1);
            fprintf(redfp,"          func = fnc%s(x)\n", reprocp[pp]);
            fprintf(redfp,"      endif\n");
            fprintf(redfp,"\n");
        }
        fprintf(redfp,"      return\n");
        fprintf(redfp,"      end\n");

        if(pc < 0) {
            return;
        } else {
            sprintf(momstr, "fnc%s", prf);
        }
    } else {
        sprintf(momstr, "func");
    }

    sprintf(momstr1, "%s.f", momstr);
    cmopend(ROFORT, prf, momstr1);

    cmsepar('*');
    fprintf(redfp,"      function %s(x)\n", momstr);
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"      real*8   %s\n", momstr);
    putc(EOL, redfp);

    fprintf(redfp,"      include 'incl%s1.h'\n", prf);
    fprintf(redfp,"      include 'inclk.h'\n");
    putc(EOL, redfp);

    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      common / loop0 / loop\n");
    fprintf(redfp,"      common / bparm1 / xl(mxdim),xu(mxdim),");
    fprintf(redfp,       "ndim,nwild,\n");
    fprintf(redfp,"     &                 ig(mxdim),ncall\n");
    fprintf(redfp,"      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    putc(EOL, redfp);

    fprintf(redfp,"      real*8   x(mxdim)\n");
    putc(EOL, redfp);


/* moved to inclk
    fprintf(redfp,"      common /kmreg / mxreg\n");
 */
/*
 *  if(caller != GRCFORT && caller != GRCREDA) {
 *      fprintf(redfp,"      common /amspin/aspin, aident\n");
 *  }
 */
    fprintf(redfp,"      real*8     ansm, ans\n");
    putc(EOL, redfp);

    fprintf(redfp,"      real*8     xx(mxdim),p(4,n%sextn),", prf);
    fprintf(redfp,       "pp(n%sextn,n%sextn)\n", prf, prf);
    fprintf(redfp,"      common /sp4vec/ vec(4,n%sextn)\n", prf);
    cmsepar('=');
    fprintf(redfp,"*          initialization\n");
    cmsepar('=');
    putc(EOL, redfp);

    fprintf(redfp,"      ansum = 0.0d0\n");
    putc(EOL, redfp);

    fprintf(redfp,"      do  5 i = 1, ndim\n");
    fprintf(redfp,"         xx(i) = x(i)\n");
    fprintf(redfp,"    5 continue\n");
    putc(EOL, redfp);

    fprintf(redfp,"      nreg  = 1\n");
    fprintf(redfp,"      dft   = 0.d0\n");
    cmsepar('=');
    fprintf(redfp,"*          kinematics\n");
    cmsepar('=');
    putc(EOL, redfp);

    fprintf(redfp,"      do 1000 ireg = 1 , mxreg\n");
    putc(EOL, redfp);

    fprintf(redfp,"         if(ireg .gt. nreg) go to 1000\n");
    putc(EOL, redfp);

    fprintf(redfp,"        call kinem(n%sextn, xx, p, pp, yacob,", prf);
    fprintf(redfp,       "nreg,ireg,jump)\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          reset the temporal buffer for ");
    fprintf(redfp,       "the region 1\n");
    cmsepar('-');
    fprintf(redfp,"      if(ireg .eq. 1) then\n");
    fprintf(redfp,"          dft = 0.d0\n");
    fprintf(redfp,"          do 180 k = 1, n%sextn\n", prf);
    fprintf(redfp,"          do 180 j = 1, 4\n");
    fprintf(redfp,"             vec(j,k) = 0.d0\n");
    fprintf(redfp,"  180     continue\n");
    fprintf(redfp,"      endif\n");
    putc(EOL, redfp);

    fprintf(redfp,"         if(jump .ne. 0) go to 1000\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          for user's cut\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp,"*--> call usrcut(jump)\n");
    fprintf(redfp,"*--> if(jump .ne. 0) goto 1000\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          four momenta of external particles\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp,"      do 20 i = 1, 4\n");

    for(n = 0; n < nextern; n++) {
        nd  = ndnode(n);
        lg  = ndleg(n, 0);
        p   = abs(ndname(n));
        cmmass(p, 1, momstr);

        fprintf(redfp,"*     %d: %s %s mass=%s\n",
                n+1, eliorf(nd->nvkind),
                pvename(nd->nvkind, lg->lgpart),
                momstr);

        cmecmom(momstr, n+1, 1, "pe");
        fprintf(redfp,"      %s(i) = p(i, kperm(%d))\n", momstr, n+1);

        putc(EOL, redfp);
    }
    fprintf(redfp,"   20 continue\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          inner products of momenta of ");
    fprintf(redfp,       "external particles\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp,"      do 30 j = 1, n%sextn\n", prf);
    fprintf(redfp,"      do 30 i = 1, n%sextn\n", prf);
    fprintf(redfp,"        prod(i, j) = pp(kperm(i), kperm(j))\n");
    fprintf(redfp,"   30 continue\n");
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp,"*          amplitude calculation\n");
    cmsepar('=');

    if(ilenc) {
        fprintf(redfp,"        call a%skptbl\n", prf);
        fprintf(redfp,"*       ===================\n");
        fprintf(redfp,"        call kinemp( ireg )\n");
        fprintf(redfp,"*       ===================\n");
    }
    fprintf(redfp,"        call a%smptbl\n", prf);
    fprintf(redfp,"*       ===================\n");
    fprintf(redfp,"        call a%smpsum(ansm)\n", prf);
    fprintf(redfp,"*       ===================\n");
    putc(EOL, redfp);

    fprintf(redfp,"        fknorm = yacob*aspin\n");
    fprintf(redfp,"        ans    = ansm*fknorm/aident\n");
    fprintf(redfp,"        ansum  = ansum + ans\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          save four momenta and probabilities ");
    fprintf(redfp,       "of the region 1\n");
    cmsepar('-');
    fprintf(redfp,"      if(ireg .eq. 1) then\n");
    fprintf(redfp,"          dft = ans\n");
    fprintf(redfp,"          do 420 k = 1, n%sextn\n", prf);
    fprintf(redfp,"          do 420 j = 1, 4\n");
    fprintf(redfp,"             vec(j,k) = p(j,k)\n");
    fprintf(redfp,"  420     continue\n");
    fprintf(redfp,"      endif\n");
    putc(EOL, redfp);

    cmsepar('=');
    fprintf(redfp,"*          fill histograms and scatter plots\n");
    cmsepar('=');
    fprintf(redfp,"      call kfill(n%sextn, ndim, x, p, pp, ans*aident)\n",
            prf);

    cmsepar('=');
    fprintf(redfp,"*          update summary table\n");
    cmsepar('=');
    putc(EOL, redfp);
/* CF */
/*  if(colorv == 0) { */
        fprintf(redfp,"        call bsgetw(wgt)\n");
        fprintf(redfp,"        ansp%s(0) = ansp%s(0) + wgt*ans\n",suf,suf);
        fprintf(redfp,"        do 60 igr = 1, jgraph\n");
        fprintf(redfp,"          ansp%s(igr)=ansp%s(igr) + ",suf,suf);
        fprintf(redfp,       "wgt*yacob*aspin*ancp%s(igr)\n",suf);
        fprintf(redfp,"   60   continue\n");
        fprintf(redfp,"        nkcall = nkcall + 1\n");
        fprintf(redfp,"        if(nkcall.gt.10000) then\n");
        fprintf(redfp,"          nkcall = nkcall - 10000\n");
        fprintf(redfp,"          fkcall = fkcall + 10000\n");
        fprintf(redfp,"        endif\n");
        putc(EOL, redfp);
/*  } */

    fprintf(redfp," 1000 continue\n");
    putc(EOL, redfp);

    if(pc < 0) {
        sprintf(momstr, "func");
    } else {
        sprintf(momstr, "fnc%s", prf);
    }
    fprintf(redfp,"      %s = ansum\n", momstr);
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          put the final 4 vectors into ");
    fprintf(redfp,       "the arrays vec()\n");
    cmsepar('-');
    fprintf(redfp,"*     if(func .gt. 0.d0) then\n");
    fprintf(redfp,"*         if(dft/func .lt. drn(dum)) then\n");
    fprintf(redfp,"*             do 850 k = 1, n%sextn\n", prf);
    fprintf(redfp,"*             do 850 j = 1, 4\n");
    fprintf(redfp,"*                vec(j,k) = p(j,k)\n");
    fprintf(redfp,"* 850         continue\n");
    fprintf(redfp,"*         endif\n");
    fprintf(redfp,"*     endif\n");
    putc(EOL, redfp);

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmvbfnct(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int    n, p;
    tnode  *nd;
    tleg   *lg;
    char   suf[16]; /* for grcfort */

    if( opver ) {
        sprintf(suf,"%d",cprocs);
    } else {
        suf[0] = '\0';
    }

    cmopen(ROFORT, "vbfnct.f");

    cmsepar('*');
    fprintf(redfp,"      subroutine vbfnct(func,nsampl,x,fx,wgt)\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    fprintf(redfp,"      external func\n");
    fprintf(redfp,"      include 'inclvs.h'\n");
    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      real*8   wgt(n_vector), x(n_vector,mxdim), fx(n_vector)\n");
    fprintf(redfp,"      include 'incl1.h'\n");
    fprintf(redfp,"      include 'inclm.h'\n");
    putc(EOL, redfp);

    fprintf(redfp,"      common / loop0 / loop\n");
    fprintf(redfp,"      common / bparm1 / xl(mxdim),xu(mxdim),");
    fprintf(redfp,       "ndim,nwild,\n");
    fprintf(redfp,"     &                 ig(mxdim),ncall\n");
    fprintf(redfp,"      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    putc(EOL, redfp);

    putc(EOL, redfp);

    fprintf(redfp,"      common /kmreg / mxreg\n");
    putc(EOL, redfp);

    fprintf(redfp,"      real*8     ansm(n_vector)\n");
    if( rcode ) {
      fprintf(redfp,"      real*8     p(4,nextn,n_vector),");
      fprintf(redfp,"pp(nextn,nextn,n_vector)\n");
    } else {
      fprintf(redfp,"      real*8     p(n_vector,4,nextn),");
      fprintf(redfp,"pp(n_vector,nextn,nextn)\n");
    }
    fprintf(redfp,"      real*8     yacob(n_vector),dfx(n_vector),");
    fprintf(redfp,"dft(n_vector),dff(n_vector),rn(n_vector)\n");
    fprintf(redfp,"      integer    nreg(n_vector),jump(n_vector),");
    fprintf(redfp,"l(n_vector)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      common /sp4vec/ vec(n_vector,4,nextn)\n");
    cmsepar('=');
    fprintf(redfp,"*          initialization\n");
    cmsepar('=');
    putc(EOL, redfp);

    fprintf(redfp,"      do 100 i = 1, nsampl\n");
    fprintf(redfp,"         fx(i)   = 0.0d0\n");
    fprintf(redfp,"         nreg(i) = 1\n");
    fprintf(redfp,"         dft(i)  = 0.0d0\n");
    fprintf(redfp,"  100 continue\n");
    fprintf(redfp," \n");

    cmsepar('=');
    fprintf(redfp,"*          kinematics\n");
    cmsepar('=');
    putc(EOL, redfp);

    fprintf(redfp,"      do 1000 ireg = 1 , mxreg\n");
    putc(EOL, redfp);

    fprintf(redfp,"        call kinemv(nsampl, ndim, x, p, pp, ");
    fprintf(redfp,       "yacob, nreg, ireg, jump)\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          reset the temporal buffer for ");
    fprintf(redfp,       "the region 1\n");
    cmsepar('-');
    fprintf(redfp,"*     if(ireg .eq. 1) then\n");
    fprintf(redfp,"*       do 200 k = 1, nextn\n");
    fprintf(redfp,"*       do 200 j = 1, 4\n");
    fprintf(redfp,"*       do 200 i = 1, nsampl\n");
    fprintf(redfp,"*          vec(i,j,k) = 0.d0\n");
    fprintf(redfp,"* 200   continue\n");
    fprintf(redfp,"*       do 210 i = 1, nsampl\n");
    fprintf(redfp,"*          dft(i) = 0.d0\n");
    fprintf(redfp,"* 210   continue\n");
    fprintf(redfp,"*     endif\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          for user's cut ( jump(i) = 1 )\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp,"*--> call usrcut(jump)\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*      Gather the actual sampling points ");
    fprintf(redfp,"(MXLOOP : # of actual S.P.\n");
    cmsepar('-');
    fprintf(redfp,"        mxloop    = 0\n");
    fprintf(redfp,"        do 300 i  = 1, nsampl\n");
    fprintf(redfp,"           dfx(i) = 0.0d0\n");
    fprintf(redfp,"           if(jump(i) .eq. 0) then\n");
    fprintf(redfp,"               mxloop = mxloop + 1\n");
    fprintf(redfp,"               l(mxloop) = i\n");
    fprintf(redfp,"           endif\n");
    fprintf(redfp,"  300   continue\n");
    fprintf(redfp," \n");
    fprintf(redfp,"        if(mxloop .le. 0) go to 1000\n");
    cmsepar('-');
    fprintf(redfp,"*          four momenta of external particles\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp,"      do 400 j  = 1, 4\n");
    fprintf(redfp,"      do 400 i  = 1, mxloop\n");

    for(n = 0; n < nextern; n++) {
        nd  = ndnode(n);
        lg  = ndleg(n, 0);
        p   = abs(ndname(n));
        cmmass(p, 1, momstr);

        fprintf(redfp,"*     %d: %s %s mass=%s\n",
                n+1, eliorf(nd->nvkind),
                pvename(nd->nvkind, lg->lgpart),
                momstr);

/*        cmicmom(momstr, n+1, 1, "pe");*/
        cmecmom(momstr, n+1, 1, "pe");
        if( rcode ) {
          fprintf(redfp,"      %s(j,i) = p(j, kperm(%d),l(i))\n",
                  momstr, n+1);
        } else {
          fprintf(redfp,"      %s(i,j) = p(l(i), j, kperm(%d))\n",
                  momstr, n+1);
        }
        putc(EOL, redfp);
    }
    fprintf(redfp,"  400 continue\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          inner products of momenta of ");
    fprintf(redfp,       "external particles\n");
    cmsepar('-');
    putc(EOL, redfp);

    fprintf(redfp,"      do 410 k = 1, nextn\n");
    fprintf(redfp,"      do 410 j = 1, nextn\n");
    fprintf(redfp,"      do 410 i = 1, mxloop\n");
        if( rcode ) {
            fprintf(redfp,"         prod(j, k, i) = ");
            fprintf(redfp,"pp(kperm(j), kperm(k), l(i))\n");
        } else {
            fprintf(redfp,"         prod(i, j, k) = ");
            fprintf(redfp,"pp(l(i), kperm(j), kperm(k))\n");
        }
    fprintf(redfp,"  410 continue\n");
    fprintf(redfp,"\n");

    cmsepar('=');
    fprintf(redfp,"*          amplitude calculation\n");
    cmsepar('=');

    if(ilenc) {
        fprintf(redfp,"        call akptbl(mxloop)\n");
        fprintf(redfp,"*       ===================\n");
        fprintf(redfp,"        call kinmvp(ireg,mxloop)\n");
        fprintf(redfp,"*       ===================\n");
    }
    fprintf(redfp,"        call amptbl(mxloop)\n");
    fprintf(redfp,"*       ===================\n");
    fprintf(redfp,"        call ampsum(mxloop,ansm)\n");
    fprintf(redfp,"*       ===================\n");
    putc(EOL, redfp);

    fprintf(redfp,"*VOCL LOOP,SCALAR\n");
    fprintf(redfp,"        do 500 i=1, mxloop\n");
    fprintf(redfp,"           dfx(l(i)) = ansm(i)*yacob(l(i))");
    fprintf(redfp,"*aspin\n");
    fprintf(redfp,"           fx(l(i))  = fx(l(i)) + dfx(l(i))\n");
    fprintf(redfp,"  500   continue\n");
    fprintf(redfp,"*       fknorm = yacob*aspin\n");
    fprintf(redfp,"*       ans    = ansm*fknorm\n");
    fprintf(redfp,"*       ansum  = ansum + ans\n");
    putc(EOL, redfp);

    cmsepar('-');
    fprintf(redfp,"*          save four momenta and probabilities ");
    fprintf(redfp,       "of the region 1\n");
    cmsepar('-');
    fprintf(redfp,"c        if(ireg .eq. 1) then\n");
    fprintf(redfp,"c            do 620 k = 1, nextn\n");
    fprintf(redfp,"c            do 620 j = 1, 4\n");
    fprintf(redfp,"c            do 620 i = 1, mxloop\n");
    fprintf(redfp,"c               vec(l(i),j,k) = p(l(i),j,k)\n");
    fprintf(redfp,"c 620        continue\n");
    fprintf(redfp,"c            do 630 i  = 1, nsampl\n");
    fprintf(redfp,"c               dft(i) = dfx(i)\n");
    fprintf(redfp,"c               dff(i) = dft(i)*aident\n");
    fprintf(redfp,"c 630        continue\n");
    fprintf(redfp,"c        endif\n");
    fprintf(redfp," \n");
    putc(EOL, redfp);

    cmsepar('=');
    fprintf(redfp,"*          fill histograms and scatter plots\n");
    cmsepar('=');
    fprintf(redfp,"      call kvfill(nsampl, nextn, ndim, jump, x, p, pp, ");
    fprintf(redfp,"dfx)\n");

    cmsepar('=');
    fprintf(redfp,"*          update summary table\n");
    cmsepar('=');
    putc(EOL, redfp);
/* CF */
/*  if(colorv == 0) { */
       fprintf(redfp,"c       do 710 i  = 1, mxloop\n");
       fprintf(redfp,"c          ansp%s(l(i),0)   = ansp%s(l(i),0) + ",suf,suf);
       fprintf(redfp,"wgt(l(i))*dfx(l(i))\n");
       fprintf(redfp,"c 710   continue\n");
       fprintf(redfp,"c       do 720 igr = 1, jgraph\n");
       fprintf(redfp,"c       do 720 i   = 1, mxloop\n");
       fprintf(redfp,"c          ansp%s(l(i),igr) = ansp%s(l(i),igr)\n",suf,suf);
       fprintf(redfp,"c    .        +  wgt(l(i))*yacob(l(i))*aspin*");
       fprintf(redfp,"ancp%s(l(i),igr)\n",suf);
       fprintf(redfp,"c 720   continue\n");
       fprintf(redfp,"*       do 810 i  = 1, nsampl\n");
       fprintf(redfp,"*          nkcall = nkcall + 1\n");
       fprintf(redfp,"*          if(nkcall.gt.10000) then\n");
       fprintf(redfp,"*             nkcall = nkcall - 10000\n");
       fprintf(redfp,"*             fkcall = fkcall + 10000\n");
       fprintf(redfp,"*          endif\n");
       fprintf(redfp,"* 810   continue\n");
       putc(EOL, redfp);
/*  } */

    fprintf(redfp," 1000 continue\n");
    putc(EOL, redfp);


    cmsepar('-');
    fprintf(redfp,"*          put the final 4 vectors into ");
    fprintf(redfp,       "the arrays vec()\n");
    cmsepar('-');
    fprintf(redfp,"*     call vbrndm( 1, n_vector, nsampl, rn )\n");
    fprintf(redfp,"*     do 900 i = 1, nsampl\n");
    fprintf(redfp,"*        l(i)  = 0\n");
    fprintf(redfp,"* 900 continue\n");
    fprintf(redfp,"*     mxloop   = 0\n");
    fprintf(redfp,"*     do 920 i = 1, nsampl\n");
    fprintf(redfp,"*        if(fx(i) .gt. 0.d0) then\n");
    fprintf(redfp,"*            if(dft(i)/fx(i) .lt. rn(i)) then\n");
    fprintf(redfp,"*                mxloop = mxloop + 1\n");
    fprintf(redfp,"*                l(mxloop) = i\n");
    fprintf(redfp,"*            endif\n");
    fprintf(redfp,"*        endif\n");
    fprintf(redfp,"* 920 continue\n");
    fprintf(redfp,"*     do 950 k = 1, nextn\n");
    fprintf(redfp,"*     do 950 j = 1, 4\n");
    fprintf(redfp,"*     do 950 i = 1, mxloop\n");
    fprintf(redfp,"*        vec(l(i),j,k) = p(l(i),j,k)\n");
    fprintf(redfp,"* 950 continue\n");
    putc(EOL, redfp);

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
    cmsepar('=');
    fprintf(redfp,"      function func(x)\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"      real*8     func\n");
    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      real*8   x(mxdim)\n");
    fprintf(redfp,"      func = 0.0d0\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmkfmass(sdir)
string  sdir;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    pindex p;
    int    maxkf, kf;

    cmopend(ROFORT, sdir, "amkfcd.f");

    cmsepar('*');
    fprintf(redfp,"      subroutine amkfcd\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(vcode) {
        fprintf(redfp,"      include 'inclvs.h'\n");
    }
    fprintf(redfp,"      include 'inclm.h'\n");
    fprintf(redfp,"      include 'inclc.h'\n");

    cmsepar('-');
    maxkf = cmaxkf();
    fprintf(redfp,"      do 10 i = 1, %d\n", maxkf);
    fprintf(redfp,"          amprtl(i) = -1.0d30\n");
    fprintf(redfp,"          agprtl(i) = -1.0d30\n");
    fprintf(redfp,"   10 continue\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"* mass as a function of KF-code\n");
    fprintf(redfp,"*\n");
    for(p = 1; p < nptable; p++) {
        kf = ptable[p]->kfcode;
        if(kf < 1) {
            fprintf(redfp,"\n");
            fprintf(redfp,"*** no KF-code for %s\n",pvename(1,p));
            cmmass(p, 1, momstr);
            fprintf(redfp,"*     amprtl( ?? ) = %6s\n", momstr);
            cmwidth(p, 1, momstr);
            fprintf(redfp,"*     agprtl( ?? ) = %6s\n", momstr);
            fprintf(redfp,"\n");
        } else {
            cmmass(p, 1, momstr);
            fprintf(redfp,"      amprtl(%2d) = %6s\n", kf, momstr);
            cmwidth(p, 1, momstr);
            fprintf(redfp,"      agprtl(%2d) = %6s\n", kf, momstr);
        }
    }

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmidmass(sdir)
string  sdir;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    pindex p;
    int    maxkf, kf;

    cmopend(ROFORT, sdir, "gr_amidpc.f");

    cmsepar('*');
    fprintf(redfp,"      subroutine gr_amidpc\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(vcode) {
        fprintf(redfp,"      include 'inclvs.h'\n");
    }
    fprintf(redfp,"      include 'inclm.h'\n");
    fprintf(redfp,"      include 'inclfa.h'\n");
    fprintf(redfp,"      include 'inclm_idpc.h'\n");

    cmsepar('-');
    maxkf = cmaxkf();
    fprintf(redfp,"      do 10 i = 1, %d\n", maxkf);
    fprintf(redfp,"          amidpc(i) = -1.0d30\n");
    fprintf(redfp,"          agidpc(i) = -1.0d30\n");
    fprintf(redfp,"   10 continue\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"* mass as a function of KF-code\n");
    fprintf(redfp,"*\n");
    for(p = 1; p < nptable; p++) {
        kf = ptable[p]->pcode;
        if( ptable[p]->ptype != P_AUX ) {
            if(kf < 1) {
                fprintf(redfp,"\n");
                fprintf(redfp,"*** no KF-code for %s\n",pvename(1,p));
                cmmass(p, 1, momstr);
                fprintf(redfp,"*     amidpc( ?? ) = %6s\n", momstr);
                cmwidth(p, 1, momstr);
                fprintf(redfp,"*     agidpc( ?? ) = %6s\n", momstr);
                fprintf(redfp,"\n");
            } else {
                cmmass(p, 1, momstr);
                if( ptable[p]->massless ) {
                fprintf(redfp,"      amidpc(%4d) = f%6s\n", kf, momstr);
                } else {
                fprintf(redfp,"      amidpc(%4d) = %6s\n", kf, momstr);
                }
                cmwidth(p, 1, momstr);
                fprintf(redfp,"      agidpc(%4d) = %6s\n", kf, momstr);
            }
        }
    }

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmmass2(sdir)
string  sdir;
/*------------------------------------------------------------------*
   mass2
 *------------------------------------------------------------------*/
{
    int n;
    /* mass2 */
    cmopend(ROFORT, sdir, "ammas2.f");

    cmsepar('*');
    fprintf(redfp,"      subroutine ammas2\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);
    fprintf(redfp,"      include 'inclm.h'\n");

    cmsepar('-');
    fprintf(redfp, "* mass**2\n");
    cmsepar('-');
    for(n = 1; n < nptable; n++) {
        if(isdigit(ptable[n]->mass[0])) {
            continue;
        }
        cmmass(n, -1, momstr);
        if(strcmp(momstr,"0") == 0) {
            continue;
        }
        cmmass(n, 1, momstr1);
        fprintf(redfp,"      %6s = %6s**2\n", momstr, momstr1);
    }
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

#ifdef MOD20020227
/*==================================================================*/
Private Void    cmprtitle(NoArg)
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    ttitle *ttl;

    for(ttl = title; ttl != NULL; ttl = ttl->next) {
        cmwrtstr(ttl->tstr);
    }
}

/*==================================================================*/
Private Void    cmwrtstr(str)
string  str;
/*------------------------------------------------------------------*
 */
{
    int s, e, l;

    s = 0;
    e = strlen(str);

    fprintf(redfp,"      write(*,*) '");
    l = 19;
    while(str != NULL && *str != '\0') {
        if(l >= 64) {
            fprintf(redfp,"'\n");
            fprintf(redfp,"     &          ,'");
            l = 19;
        }
        if(*str == '\'') {
            fprintf(redfp,"''");
            l += 2;
        } else {
            fprintf(redfp,"%c", *str);
            l++;
        }
        str++;
    }
    fprintf(redfp,"'\n");
}
#endif

/*==================================================================*/
Public  Void    cminclk(NoArg)
/*------------------------------------------------------------------*
 * generate "inclk.h"
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "inclk.h");

    fprintf(redfp,"* mass and width\n");
    fprintf(redfp,"      include 'inclm.h'\n\n");

    if(caller == GRCRED || caller == GRCREDH || caller == GRCREDA ) {
       fprintf(redfp,"      include 'inclfa.h'\n\n");
    }

    /* common /kmreg/ */
    fprintf(redfp,"* multiplicity\n");
    fprintf(redfp,"      integer         mxreg\n");
    fprintf(redfp,"      common /kmreg / mxreg\n");

    /* common /kmopts/ */
    if(minami) {
        fprintf(redfp,"      integer         jtgamm, jano3v, jcolmb, jqcdcr\n");
        fprintf(redfp,"      common /kmopts/ jtgamm, jano3v, jcolmb, jqcdcr\n");
    }

    /* common /kmoptc/ */
    if(jcolmb) {
        fprintf(redfp,"      real*8          colmbf\n");
        fprintf(redfp,"      common /kmoptc/ colmbf\n");
    }

    /* common /kmoptm/ */
    if(jqmas0) {
        fprintf(redfp,"      integer         jqmass\n");
        fprintf(redfp,"      common /kmoptm/ jqmass\n");
    }

    /* common /aman3v/ */
    if(jano3v) {
        fprintf(redfp,"      real*8          andka, andkz, anlma, anlmz\n");
        fprintf(redfp,"      common /aman3v/ andka, andkz, anlma, anlmz\n");
    }

    if(jetset) {
        fprintf(redfp,"      integer         jdecay, jhadrn\n");
        fprintf(redfp,"      common /kmoptj/ jdecay, jhadrn\n");
    }

    fprintf(redfp,"\n* external particles name\n");
    fprintf(redfp,"      integer    MXEXTN, MXHELI\n");
    fprintf(redfp,"      parameter (MXEXTN = 10)\n");
    fprintf(redfp,"      parameter (MXHELI = 1024)\n");
/*
    fprintf(redfp,"      common /kmprt1/ kmprtc(%d)\n",nextern);
    fprintf(redfp,"      common /kmprt2/ kmprtl(%d)\n",nextern);
*/
    fprintf(redfp,"      character*16    kmprtc(mxextn)\n");
    fprintf(redfp,"      common /kmprt1/ kmprtc\n");
    fprintf(redfp,"      integer         kmprtl(mxextn)\n");
    fprintf(redfp,"      common /kmprt2/ kmprtl\n");
    fprintf(redfp,"      integer         maxjhs(mxextn),maxjhe(mxextn),");
    fprintf(redfp,"mskhel(0:MXHELI-1)\n");
    fprintf(redfp,"      common /kmspin/ maxjhs,maxjhe,mskhel\n");

    /* common /kmoptq/ */
    if(jqedps) {
        fprintf(redfp,"\n* QEDPS flags\n");
        fprintf(redfp,"      integer         jqedps\n");
        fprintf(redfp,"      common /kmoptq/ jqedps\n");
    }

    /* common /kmmass/ */
    fprintf(redfp,"\n* masses of external particles\n");
/*
    fprintf(redfp,"      common /kmmass/ amass1(%d), amass2(%d)\n",
                  nextern, nextern);
*/
    fprintf(redfp,"      real*8          amass1(mxextn), amass2(mxextn)\n");
    fprintf(redfp,"      common /kmmass/ amass1, amass2\n");

    fprintf(redfp,"\n* charge(*3) and KFcode of external particles\n");
/*
    fprintf(redfp,"      common /kminfo/ kcharg(%d), kfcode(%d)\n",
                  nextern,nextern);
*/
    fprintf(redfp,"      integer         kcharg, kfcode\n");
    fprintf(redfp,"      common /kminfo/ kcharg(mxextn), kfcode(mxextn)\n");

/*
    fprintf(redfp,"      common /tgamma/itapol\n");
*/

    cmainclk(redfp);
}

/*==================================================================*/
Private Void    cmkinem(cdir)
string  cdir;
/*------------------------------------------------------------------*
 * copy kinit.f, kinem.f and kfill.f
 */
{
    if(cprocess->kinem == NULL) {
        printf("Kinem is not specified\n");
        cmfkinit();
        cmfkinem();
        if(!vcode) {
            cmfkfill();
        } else {
            cmfkvfill();
        }
    } else {
        if(!cmcpkin(cprocess->kinem, cdir, "kinit.f")) {
            cmfkinit();
        }
        if(!cmcpkin(cprocess->kinem, cdir, "kinem.f")) {
            cmfkinem();
        }
        if(!vcode) {
            if(!cmcpkin(cprocess->kinem, cdir, "kfill.f")) {
                cmfkfill();
            }
        } else {
            if(!cmcpkin(cprocess->kinem, cdir, "kvfill.f")) {
                cmfkvfill();
            }
        }
    }
    if(vcode) {
        cmfkinemv();
    }
}

/*==================================================================*/
Private bool    cmcpkin(subdir, cdir, fname)
string  subdir;
string  cdir;
string  fname;
/*------------------------------------------------------------------*
 * copy a file from kinematics directory
 */
{
    string fullname;
    FILE   *fp;
    int c;

    fullname = pnfname("KINEMPATH", kinempath, subdir, fname);
    if(fullname == NULL) {
        return False;
    }

    if((fp = fopen(fullname, "r")) == NULL) {
        fprintf(Stderr, "*** cmcpkinem : open error %s\n", fullname);
        return False;
    }

    cmopend(ROFORT, cdir, fname);

    while((c = getc(fp)) != EOF) {
        putc(c, redfp);
    }

    printf("+++ \"%s\" is copied \n", fullname);

    fclose(fp);
    fp = NULL;

    return True;
}

/*==================================================================*/
Private Void    cmfkinit(NoArg)
/*------------------------------------------------------------------*
 * generate template of kinit.f
 */
{
    pindex p, pa;
    int    n,  tp, il;
    cmopen(ROFORT, "kinit.f");
    fprintf(redfp,"      subroutine kinit\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n\n");
    cmsepar('-');
    fprintf(redfp,"*     This subroutine is called by USERIN");
    fprintf(redfp," and initilizes kinematics.\n");
    cmsepar('-');
    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      common / loop0 / loop\n");
    fprintf(redfp,"      common / bparm1 / ");
    fprintf(redfp,"xl(mxdim),xu(mxdim),ndim,nwild,\n");
    fprintf(redfp,"     &                 ig(mxdim),ncall\n");
    fprintf(redfp,"      common / bparm2 / acc1,acc2,itmx1,itmx2\n");
    fprintf(redfp,"      COMMON / kinem1 / s,w,fact\n");
    fprintf(redfp,"      common / knmflg /");
    fprintf(redfp," knmgvs, knmhst, knmsph, knmisr\n\n");
    fprintf(redfp,"      include 'inclk.h'\n");
    fprintf(redfp,"      character xstr*14, dstr*24\n");
    fprintf(redfp,"*--- 1. inforamtion of Mass and width\n");

    for(n = 0; n < nextern; n++) {
        pa  = ndname(n);
        p   = abs(pa);
        il  = ndiline(n, 0);
        tp  = iltable[il].iltype;
        cmmass(p, 1, momstr);

        fprintf(redfp,"*     %d: %s %s mass=%s\n",
                n+1, eliorf(ndiorf(n)), pvename(ndiorf(n),pa),
                momstr);
    }

    fprintf(redfp,"*--- 2. Initialize constants for kinematics.\n");
    fprintf(redfp,"*        User's parameters, i.e. beam energy, ");
    fprintf(redfp,"cut-off parameters etc.,\n");
    fprintf(redfp,"*        can be given here.\n");
    fprintf(redfp,"*\n");
    fprintf(redfp,"*     S = (P1+P2)**2\n");
    fprintf(redfp,"*     W = SQRT(S)\n");
    cmsepar('-');
    fprintf(redfp,"      if(knmgvs .eq. 1) then\n");
    fprintf(redfp,"          w = 200.d0\n");
    fprintf(redfp,"      endif\n");
    fprintf(redfp,"      s = w*w\n\n\n");
    cmsepar('-');
    fprintf(redfp,"* Following flux factor is for a ");
    fprintf(redfp,"particle-antiparticle collision\n");
    fprintf(redfp,"* at s/m**2 >> 1. For an e-gamma collision ");
    fprintf(redfp,"or low energy interactions\n");
    fprintf(redfp,"* you should use appropriate formulae.\n");
    cmsepar('-');
    fprintf(redfp,"      vrel = 2.d0\n");
    fprintf(redfp,"      flux = vrel*s\n");
    fprintf(redfp,"      fact = gevpb/flux\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*--- 3. Set MXREG : the maximum number of ");
    fprintf(redfp,"values which are returned \n");
    fprintf(redfp,"*       by FUNC for one phase space point\n\n");
    fprintf(redfp,"      mxreg = \n\n");
    cmsepar('=');
    fprintf(redfp,"*          Parameters for BASES\n");
    cmsepar('=');
    fprintf(redfp,"\n");
    fprintf(redfp,"*--- 4. Dimension of integration.\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"           ndim  =\n");
    fprintf(redfp,"           nwild =\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*--- 5. Region of integration.\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"           xl(1)     =\n");
    fprintf(redfp,"           xu(1)     =\n");
    fprintf(redfp,"           xl(2)     =\n");
    fprintf(redfp,"           xu(2)     =\n");
    fprintf(redfp,"              ...     \n");
    fprintf(redfp,"           xl(ndim)  =\n");
    fprintf(redfp,"           xu(ndim)  =\n");
    fprintf(redfp,"                      \n");
    fprintf(redfp,"           ig(1)     =\n");
    fprintf(redfp,"           ig(2)     =\n");
    fprintf(redfp,"              ...  \n");
    fprintf(redfp,"           ig(ndim)  =\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"C          do 10 i  =   1, ndim\n");
    fprintf(redfp,"C             xl(i)  = \n");
    fprintf(redfp,"C             xu(i)  = \n");
    fprintf(redfp,"C             ig(i)  = \n");
    fprintf(redfp,"C  10      continue \n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*--- 6. Numbers of iterations and sampling ");
    fprintf(redfp,"points / iteration\n");
    fprintf(redfp,"*       and expected accuracies\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"           itmx1  =  15\n");
    fprintf(redfp,"           itmx2  = 100\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"           acc1   = 0.2d0\n");
    fprintf(redfp,"           acc2   = 0.01d0\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"           ncall  = 5000\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*--- 7. Set histograms\n");
    fprintf(redfp,"      if(knmhst .eq. 1) then\n");
    fprintf(redfp,"           nx = 50\n");
    fprintf(redfp,"           nd = 50\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"           do 100 i = 1, ndim\n");
    fprintf(redfp,"              write(xstr, 110) I\n");
    fprintf(redfp,"  110         format('x(',i2,') Spectrum')\n");
    fprintf(redfp,"              call xhinit(i, xl(i), xu(i), nx,");
    fprintf(redfp," xstr)\n");
    fprintf(redfp,"  100      continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"           k = ndim\n");
    fprintf(redfp,"           do 200 i = 1, ndim - 1\n");
    fprintf(redfp,"           do 200 j = i + 1, ndim\n");
    fprintf(redfp,"              write(dstr, 210) i, j\n");
    fprintf(redfp,"  210         format('x(',i2,')-x(',i2,') ");
    fprintf(redfp,"Distribution')\n");
    fprintf(redfp,"              k = k + 1\n");
    fprintf(redfp,"              call dhinit(k, xl(i),xu(i),nd, ");
    fprintf(redfp,"xl(j),xu(j),nd,dstr)\n");
    fprintf(redfp,"  200      continue\n");
    fprintf(redfp,"      endif\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmfkinem(NoArg)
/*------------------------------------------------------------------*
 * generate template of kinem.f
 */
{
    pindex p, pa;
    int    n,  i, tp, il;
    cmopen(ROFORT, "kinem.f");
    fprintf(redfp,"      subroutine kinem(nextn, x, pe, pp, ");
    fprintf(redfp,"yacob, nreg, ireg, jump) \n");
    cmsepar('*');
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"      integer nextn \n");
    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      real*8  x(mxdim) \n");
    fprintf(redfp,"      real*8  %s(4,nextn), pp(nextn,nextn) \n", momstr);
    fprintf(redfp,"      real*8  yacob \n");
    fprintf(redfp,"      integer nreg, ireg \n");
    fprintf(redfp,"      integer jump \n");
    fprintf(redfp,"      include 'inclk.h'\n");
    cmsepar('=');
    fprintf(redfp,"*     This subroutine calculates four momenta ");
    fprintf(redfp,"of external particles.\n");
    fprintf(redfp,"*\n");
    fprintf(redfp,"*     Arguments\n");
    fprintf(redfp,"*       NEXTRN : input  : The number of ");
    fprintf(redfp,"external particles.\n");
    fprintf(redfp,"*       X      : input  : Position in the ");
    fprintf(redfp,"integration volume.\n");
    fprintf(redfp,"*       PE     : output : Table of four momenta ");
    fprintf(redfp,"of external particles.\n");
    fprintf(redfp,"*       PP     : output : Table of inner ");
    fprintf(redfp,"products of four momenta\n");
    fprintf(redfp,"*                         between two external ");
    fprintf(redfp,"particles.\n");
    fprintf(redfp,"*       YACOB  : output : Normalization for ");
    fprintf(redfp,"converting square of\n");
    fprintf(redfp,"*                         amplitude to ");
    fprintf(redfp,"cross-section.\n");
    fprintf(redfp,"*       NREG   : in/out : Maximum number of ");
    fprintf(redfp,"points in the phase space\n");
    fprintf(redfp,"*                         which correspond to ");
    fprintf(redfp,"the integration point.\n");
    fprintf(redfp,"*                         This value is one ");
    fprintf(redfp,"for the first call\n");
    fprintf(redfp,"*                         for the same ");
    fprintf(redfp,"integration point.\n");
    fprintf(redfp,"*       IREG   : input  : Counter of calling ");
    fprintf(redfp,"this subroutine for the\n");
    fprintf(redfp,"*                         same integration ");
    fprintf(redfp,"point.\n");
    fprintf(redfp,"*                         same integration ");
    fprintf(redfp,"point.\n");
    fprintf(redfp,"*                         Function FUNC ");
    fprintf(redfp,"increments this variable,\n");
    fprintf(redfp,"*                         and call this ");
    fprintf(redfp,"subroutine while (IREG.LE.NREG)\n");
    fprintf(redfp,"*       JUMP   : output : If this integration ");
    fprintf(redfp,"point is rejected,\n");
    fprintf(redfp,"*                         one should set this ");
    fprintf(redfp,"variable other than one,\n");
    fprintf(redfp,"*                         otherwize it should ");
    fprintf(redfp,"be zero.\n");
    cmsepar('=');
    fprintf(redfp,"      jump = 0\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     if(reject this integration point) then\n");
    fprintf(redfp,"*       jump = 1 \n");
    fprintf(redfp,"*       return \n");
    fprintf(redfp,"*     endif \n");
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*     if(ireg.eq.1) then\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*       The first call for this phase space ");
    fprintf(redfp,"point. \n");
    fprintf(redfp,"*       If you want to use this subroutine ");
    fprintf(redfp,"more than once for the same\n");
    fprintf(redfp,"*       phase space point, change the value ");
    fprintf(redfp,"of NREG.\n");
    fprintf(redfp,"*       This subroutine will be called NREG ");
    fprintf(redfp,"times.\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     else\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*       IREG-th call for this phase space ");
    fprintf(redfp,"point.\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     endif\n");
    cmsepar('-');
    fprintf(redfp,"*     Table of four momenta.\n");
    fprintf(redfp,"* PE(I, J) : I = 1 -> X, 2 -> Y, ... 4 -> ");
    fprintf(redfp,"energy, of J-th particle.\n");
    cmsepar('-');
    for(n = 0; n < nextern; n++) {
        pa  = ndname(n);
        p   = abs(pa);
        il  = ndiline(n, 0);
        tp  = iltable[il].iltype;
        cmmass(p, 1, momstr);

        fprintf(redfp,"*     %d: %s %s mass=%s\n",
                    n+1, eliorf(ndiorf(n)), pvename(ndiorf(n),pa),
                    momstr);
        for(i=0;i<4;i++) {
            fprintf(redfp,"      pe(%2d,%2d) =    \n",i+1,n+1);
        }
    }
    cmsepar('-');
    fprintf(redfp,"*     PP(I,J) = inner product between I-th ");
    fprintf(redfp," and J-th particle's momenta\n");
    fprintf(redfp,"*\n");
    fprintf(redfp,"*     This table should be calculated from ");
    fprintf(redfp,"invariants.\n");
    fprintf(redfp,"*     When it is constructed from PE, it will ");
    fprintf(redfp,"not so accurate.\n");
    cmsepar('-');
        for(n = 0; n < nextern; n++) {
        for(i = 0; i < nextern; i++) {
            fprintf(redfp,"      pp(%2d,%2d) = ",n+1,i+1);
            if(i == n) {
                fprintf(redfp,"amass2(%d)\n",i+1);
            } else if(i > n) {
                fprintf(redfp,"\n");
            } else {
                fprintf(redfp,"pp(%2d,%2d)\n",i+1,n+1);
            }
        }
        cmsepar('-');
        }
    fprintf(redfp,"*     Normalization factor\n");
    cmsepar('-');
    fprintf(redfp,"\n");
    fprintf(redfp,"      yacob =\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmfkinemv(NoArg)
/*------------------------------------------------------------------*
 * generate template of kinemv.f for interface to kinem.f
 */
{
    cmopen(ROFORT, "kinemv.f");
    fprintf(redfp,"      subroutine kinemv(nsampl, ndim, ");
    fprintf(redfp," xv, pev, ppv, yacobv,\n");
    fprintf(redfp,"     &                  nregv, ireg, jumpv)\n");
    cmsepar('*');
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"      include 'inclvs.h'\n");
    fprintf(redfp,"      include 'incl1.h'\n");
    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      real*8  xv(n_vector,mxdim) \n");
    fprintf(redfp,"      real*8  pev(n_vector,4,nextn), ");
    fprintf(redfp,"ppv(n_vector,nextn,nextn) \n");
    fprintf(redfp,"      real*8  yacobv(n_vector) \n");
    fprintf(redfp,"      integer nregv(n_vector), ireg \n");
    fprintf(redfp,"      integer jumpv(n_vector) \n");
    cmsepar('*');
    fprintf(redfp,"      real*8  xx(mxdim)\n");
    fprintf(redfp,"      real*8  pe(4,nextn), pp(nextn,nextn)\n");
    fprintf(redfp,"      real*8  yacob\n");
    fprintf(redfp,"      integer nreg, jump\n");
    cmsepar('=');

    fprintf(redfp,"      do 500 j = 1, nsampl\n");
    fprintf(redfp,"         do 100 i = 1, ndim\n");
    fprintf(redfp,"            xx(i)  = xv(j,i)\n");
    fprintf(redfp,"  100    continue\n");
    fprintf(redfp,"         nreg = nregv(j)\n");
    cmsepar('=');
    fprintf(redfp,"         call kinem(nextn, xx, pe, pp, yacob, ");
    fprintf(redfp,"nreg, ireg, jump)\n");
    cmsepar('=');
    fprintf(redfp,"         jumpv(j)  = jump\n");
    fprintf(redfp,"         nregv(j)  = nreg\n");
    fprintf(redfp,"         if(jumpv(j)  .eq. 0) then\n");
    fprintf(redfp,"             do 200 i = 1, 4\n");
    fprintf(redfp,"             do 200 k = 1, nextn\n");
    fprintf(redfp,"                pev(j,i,k) = pe(i,k)\n");
    fprintf(redfp,"  200        continue\n");
    fprintf(redfp,"             do 300 i = 1, nextn\n");
    fprintf(redfp,"             do 300 k = 1, nextn\n");
    fprintf(redfp,"                ppv(j,i,k) = pp(i,k)\n");
    fprintf(redfp,"  300        continue\n");
    fprintf(redfp,"             yacobv(j) = yacob\n");
    fprintf(redfp,"         else\n");
    fprintf(redfp,"             yacobv(j) = 0.0d0\n");
    fprintf(redfp,"         endif\n");
    fprintf(redfp,"  500 continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
    cmsepar('*');
    fprintf(redfp,"      subroutine kinmvp(ireg,mxloop)\n");
    cmsepar('*');
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"      include 'inclvs.h'\n");
    fprintf(redfp,"      include 'incl1.h'\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}
/*==================================================================*/
Private Void    cmfkfill(NoArg)
/*------------------------------------------------------------------*
 * generate template of kfill.f
 */
{
    int i;
    cmopen(ROFORT, "kfill.f");
    fprintf(redfp,"      subroutine kfill");
    fprintf(redfp,"(nextn, ndim, x, pe, pp, ans)\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n\n");
    for(i=0;i<72;i++) fprintf(redfp,"*");
    fprintf(redfp,"\n      integer nextn\n");
    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      real*8  x(mxdim)\n");
    fprintf(redfp,"      real*8  pe(4,nextn), pp(nextn,nextn)\n");
    fprintf(redfp,"      include 'inclk.h'\n");
    fprintf(redfp,"*");
    for(i=1;i<72;i++) fprintf(redfp,"=");
    fprintf(redfp,"\n");
    fprintf(redfp,"*          ");
    fprintf(redfp,"Fill Histograms and Scatter plots\n");
    fprintf(redfp,"*");
    for(i=1;i<72;i++) fprintf(redfp,"=");
    fprintf(redfp,"\n\n");

    fprintf(redfp,"      do 40 i = 1, ndim\n");
    fprintf(redfp,"         call xhfill( i, x(i), ans )\n");
    fprintf(redfp,"   40 continue\n\n");

    fprintf(redfp,"      k = ndim\n");
    fprintf(redfp,"      do 50 i = 1, ndim-1\n");
    fprintf(redfp,"      do 50 j = i+1, ndim\n");
    fprintf(redfp,"         k    = k + 1\n");
    fprintf(redfp,"         call dhfill( k, x(i), x(j), ans )\n");
    fprintf(redfp,"   50 continue\n");

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmfkvfill(NoArg)
/*------------------------------------------------------------------*
 * generate template of kfillv.f for interface to kfill.f
 */
{
    cmopen(ROFORT, "kvfill.f");
    fprintf(redfp,"      subroutine kvfill");
    fprintf(redfp,"(nsampl, nextn, ndim, jumpv, xv, pev, ppv, ansv)\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n\n");
    cmsepar('*');
    fprintf(redfp,"      include 'inclvs.h'\n");
    fprintf(redfp,"      integer nextn \n");
    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      integer jumpv(n_vector) \n");
    fprintf(redfp,"      real*8  xv(n_vector,mxdim) \n");
    fprintf(redfp,"      real*8  pev(n_vector,4,nextn), ");
    fprintf(redfp,"ppv(n_vector,nextn,nextn),ansv(n_vector)\n");
    cmsepar('*');
    fprintf(redfp,"*\n");
    fprintf(redfp,"Fill Histograms and Scatter plots\n");
    fprintf(redfp,"*\n");
    fprintf(redfp,"      do 40 i = 1, ndim\n");
    fprintf(redfp,"         call xvhfil( i, nsampl,jumpv,xv(i,1), ansv )\n");
    fprintf(redfp,"   40 continue\n\n");

    cmsepar('=');
    fprintf(redfp,"      k = ndim\n");
    fprintf(redfp,"      do 50 i = 1, ndim-1\n");
    fprintf(redfp,"      do 50 j = i+1, ndim\n");
    fprintf(redfp,"         k    = k + 1\n");
    fprintf(redfp,"         call dvhfil( k, nsampl, jumpv, xv(i,1), xv(j,1), ansv )\n");
    fprintf(redfp,"   50 continue\n");

    fprintf(redfp,"  500 continue\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}
/*==================================================================*/
Private Void    cmdnn(NoArg)
/*------------------------------------------------------------------*
 * Generate dnn.f
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "dnn.f");

    cmsepar('*');
    fprintf(redfp,"      double precision function dnn(p,am)\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n\n");
    fprintf(redfp,"      dimension p(4)\n\n");
    fprintf(redfp,"      dnn = p(4)*p(4) - p(1)*p(1) - p(2)*p(2)");
    fprintf(redfp," - p(3)*p(3) - am*am\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cminclvs(NoArg)
/*------------------------------------------------------------------*
 * generate "inclvs.h" for vector code
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "inclvs.h");

    fprintf(redfp,"* buffer size (vector length)\n");
/*
    fprintf(redfp,"*     parameter ( n_vector =   256 )\n");
    fprintf(redfp,"      parameter ( n_vector =  1024 )\n");
    fprintf(redfp,"*     parameter ( n_vector =  2048 )\n");
    fprintf(redfp,"*     parameter ( n_vector =  8192 )\n");
*/
    fprintf(redfp,"*------- for SR8000 ------\n");
    fprintf(redfp,"      integer     n_vector\n");
    fprintf(redfp,"      parameter ( n_vector =  256 )\n");
    fprintf(redfp,"*     12\n");
    fprintf(redfp,"*     parameter ( n_vector =  4128 )\n");
    fprintf(redfp,"*     13\n");
    fprintf(redfp,"*     parameter ( n_vector =  8224 )\n");
    fprintf(redfp,"* end of inclvs.h \n");
}
/*==================================================================*/
Private Void    cminclbp(NoArg)
/*------------------------------------------------------------------*
 * generate "inclbp.h" for vbasesMPI
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "inclbp.h");

    fprintf(redfp,"* \n");
    fprintf(redfp,"      parameter (nodemx=256)\n");
    fprintf(redfp,"      common / hybrid / numdp,numfp,np,nodfid,noddid,\n");
    fprintf(redfp,"     & nrdp(nodemx),nrfp(nodemx,nodemx),gnam,dpgrp,fpgrp(nodemx),dpcom,\n");
    fprintf(redfp,"     & fpcom(nodemx),irdp,irfp,mypid\n");
    fprintf(redfp,"* \n");
    fprintf(redfp,"      integer np, nodfid, noddid\n");
    fprintf(redfp,"      integer gnam, dpgrp, fpgrp, dpcom, fpcom, nrdp,nrfp\n");
    fprintf(redfp,"      integer irdp,irfp,mypid\n");
    fprintf(redfp,"* end of inclbp.h \n");

}
#ifdef CMINCLVB
/*==================================================================*/
Private Void    cminclvb(NoArg)
/*------------------------------------------------------------------*
 * generate "inclvb.h" for vector code
 *------------------------------------------------------------------*/
{
    cmopen(ROFORT, "inclvb.h");

    fprintf(redfp,"* common block for vector bases\n");
    if(basesv == 0) {
        fprintf(redfp,"      parameter ( mxdim = 50 )\n");
    } else {
        fprintf(redfp,"      parameter ( mxdim = 100 )\n");
    }
    fprintf(redfp,"      include 'inclvs.h'\n");
    fprintf(redfp,"      common / vbvect / wgt(n_vector), ");
    fprintf(redfp,"x(n_vector,mxdim), fx(n_vector)\n");
    fprintf(redfp,"* end of inclvb.h \n");
}
#endif

/*==================================================================*/
Private Void    cmsp2lnd(NoArg)
/*------------------------------------------------------------------*
 */
{
    int p;

    cmopen(ROFORT, "sp2lnd.f");
    cmsepar('*');
    fprintf(redfp,"      subroutine sp2lnd\n");

    fprintf(redfp,"*  Inteface of SPRING to JETSET.\n");

    if(!susylib) {

    fprintf(redfp,"      implicit real*8 (a-h,o-z)\n");
    fprintf(redfp,"      include 'inclc.h'\n");
    fprintf(redfp,"      include 'inclk.h'\n");
    fprintf(redfp,"      dimension ijoin(2)\n");
    fprintf(redfp,"*     real*4  en,th,ph\n");
    fprintf(redfp,"      real*4  p,v\n");
    fprintf(redfp,"      common/lujets/n,k(4000,5),p(4000,5),");
    fprintf(redfp,"v(4000,5)\n");
    fprintf(redfp,"      common /sp4vec/ vec(4,nextn)\n");
    cmsepar('-');
    if(jqedps) {
        fprintf(redfp,"*     For only QEDPS\n");
        cmsepar('-');
        fprintf(redfp,"      common common/qplist/");
        fprintf(redfp,"plptn(10,1000),nlptn(10,1000),ntop\n");
        fprintf(redfp,"\n");
    }
    cmsepar('-');
    fprintf(redfp,"*     Put 4-momentum\n");
    cmsepar('-');
    fprintf(redfp,"*     kc = 0\n");
    fprintf(redfp,"*     do 10 j = 3 , nextn\n");
    fprintf(redfp,"*        px = vec(1,j)\n");
    fprintf(redfp,"*        py = vec(2,j)\n");
    fprintf(redfp,"*        pz = vec(3,j)\n");
    fprintf(redfp,"*        en = vec(4,j)\n");
    fprintf(redfp,"*        pa = sqrt(px**2+py**2+pz**2)\n");
    fprintf(redfp,"*        th = acos(pz/pa)\n");
    fprintf(redfp,"*        if(px**2+py**2 .le. 0.0d0) then\n");
    fprintf(redfp,"*            ph = 0.0\n");
    fprintf(redfp,"*        else\n");
    fprintf(redfp,"*            ph = atan2(py,px)\n");
    fprintf(redfp,"*        endif\n");
    fprintf(redfp,"*        kc  = kc + 1\n");
    fprintf(redfp,"*        call lu1ent(k,kfcode(j),en,th,ph)\n");
    fprintf(redfp,"*  10 continue\n");
    cmsepar('-');
    if(jqedps) {
    fprintf(redfp,"      if(jqedps .eq. 0) then\n");
    cmsepar('-');
    }
    fprintf(redfp,"      kc = 0\n");
    fprintf(redfp,"      do 10 j = 3 , nextn\n");
    fprintf(redfp,"         kc  = kc + 1\n");
    fprintf(redfp,"         p(kc,1) = real(vec(1,j))\n");
    fprintf(redfp,"         p(kc,2) = real(vec(2,j))\n");
    fprintf(redfp,"         p(kc,3) = real(vec(3,j))\n");
    fprintf(redfp,"         p(kc,4) = real(vec(4,j))\n");
    fprintf(redfp,"         p(kc,5) = real(amass1(j))\n");
    fprintf(redfp,"         k(kc,1) = 1\n");
    fprintf(redfp,"         k(kc,2) = kfcode(j)\n");
    fprintf(redfp,"         k(kc,3) = 0\n");
    fprintf(redfp,"         k(kc,4) = 0\n");
    fprintf(redfp,"         k(kc,5) = 0\n");
    fprintf(redfp,"         v(kc,1) = 0.0\n");
    fprintf(redfp,"         v(kc,2) = 0.0\n");
    fprintf(redfp,"         v(kc,3) = 0.0\n");
    fprintf(redfp,"         v(kc,4) = 0.0\n");
    fprintf(redfp,"         v(kc,5) = 0.0\n");
    fprintf(redfp,"   10 continue\n");
    fprintf(redfp,"      n = kc\n");
    cmsepar('-');
    if(jqedps) {
    fprintf(redfp,"      else\n");
    cmsepar('-');
    fprintf(redfp,"      k0 = nextn - 2\n");
    fprintf(redfp,"      do 11 j = 1 , ntop\n");
    fprintf(redfp,"         if(nlptn(3,j).ne.0) goto 11\n");
    fprintf(redfp,"         if(nlptn(1,j).ge.3) then\n");
    fprintf(redfp,"            kc     = nlptn(1,j)\n");
    fprintf(redfp,"            p(kc,1) = real(plptn(4,j))\n");
    fprintf(redfp,"            p(kc,2) = real(plptn(5,j))\n");
    fprintf(redfp,"            p(kc,3) = real(plptn(6,j))\n");
    fprintf(redfp,"            p(kc,4) = real(plptn(7,j))\n");
    fprintf(redfp,"            p(kc,5) = real(amass1(j))\n");
    fprintf(redfp,"            k(kc,1) = 1\n");
    fprintf(redfp,"            k(kc,2) = kfcode(j)\n");
    fprintf(redfp,"            k(kc,3) = 0\n");
    fprintf(redfp,"            k(kc,4) = 0\n");
    fprintf(redfp,"            k(kc,5) = 0\n");
    fprintf(redfp,"            v(kc,1) = 0.0\n");
    fprintf(redfp,"            v(kc,2) = 0.0\n");
    fprintf(redfp,"            v(kc,3) = 0.0\n");
    fprintf(redfp,"            v(kc,4) = 0.0\n");
    fprintf(redfp,"            v(kc,5) = 0.0\n");
    fprintf(redfp,"         else\n");
    fprintf(redfp,"            k0      = k0 + 1\n");
    fprintf(redfp,"            p(k0,1) = real(plptn(4,j))\n");
    fprintf(redfp,"            p(k0,2) = real(plptn(5,j))\n");
    fprintf(redfp,"            p(k0,3) = real(plptn(6,j))\n");
    fprintf(redfp,"            p(k0,4) = real(plptn(7,j))\n");
    fprintf(redfp,"            p(k0,5) = 0.0\n");
    fprintf(redfp,"            k(k0,1) = 1\n");
    fprintf(redfp,"            k(k0,2) = 22\n");
    fprintf(redfp,"            k(k0,3) = 0\n");
    fprintf(redfp,"            k(k0,4) = 0\n");
    fprintf(redfp,"            k(k0,5) = 0\n");
    fprintf(redfp,"            v(k0,1) = 0.0\n");
    fprintf(redfp,"            v(k0,2) = 0.0\n");
    fprintf(redfp,"            v(k0,3) = 0.0\n");
    fprintf(redfp,"            v(k0,4) = 0.0\n");
    fprintf(redfp,"            v(k0,5) = 0.0\n");
    fprintf(redfp,"         endif\n");
    fprintf(redfp,"   11 continue\n");
    fprintf(redfp,"      n = k0\n");
    cmsepar('-');
    fprintf(redfp,"      endif\n");
    }
    cmsepar('-');

    if(gcbase->nbase > 1) {
        cmsepar('-');
        fprintf(redfp,"*     String Join\n");
        cmsepar('-');
        fprintf(redfp,"      do 20 i = 1, kmcbmx, 2\n");
        fprintf(redfp,"         if(kmcstr(i,icolst) .ne. 0) then\n");
        fprintf(redfp,"             ijoin(1) = kmcstr( i ,icolst) - 2\n");
        fprintf(redfp,"             ijoin(2) = kmcstr(i+1,icolst) - 2\n");
        fprintf(redfp,"*            call lujoin(2,ijoin)\n");
        fprintf(redfp,"             k(ijoin(1),1) = 3\n");
        fprintf(redfp,"             if(k(ijoin(1),2) .gt. 0) then\n");
        fprintf(redfp,"                 k(ijoin(1),4) = ijoin(2)*10000\n");
        fprintf(redfp,"             else\n");
        fprintf(redfp,"                 k(ijoin(1),5) = ijoin(2)*10000\n");
        fprintf(redfp,"             endif\n");
        fprintf(redfp,"             k(ijoin(2),1) = 3\n");
        fprintf(redfp,"             if(k(ijoin(2),2) .gt. 0) then\n");
        fprintf(redfp,"                 k(ijoin(2),4) = ijoin(1)*10000\n");
        fprintf(redfp,"             else\n");
        fprintf(redfp,"                 k(ijoin(2),5) = ijoin(1)*10000\n");
        fprintf(redfp,"             endif\n");
        fprintf(redfp,"         endif\n");
        fprintf(redfp,"   20 continue\n");
    } else if(gcbase->nbase == 1 && gcbase->nexcolor > 0) {
        cmsepar('-');
        fprintf(redfp,"*     String Join\n");
        cmsepar('-');
        fprintf(redfp,"      do 20 i = 1, kmcbmx, 2\n");
        fprintf(redfp,"         if(kmcstr(i) .ne. 0) then\n");
        fprintf(redfp,"             ijoin(1) = kmcstr( i ) - 2\n");
        fprintf(redfp,"             ijoin(2) = kmcstr(i+1) - 2\n");
        fprintf(redfp,"*            call lujoin(2,ijoin)\n");
        fprintf(redfp,"             k(ijoin(1),1) = 3\n");
        fprintf(redfp,"             if(k(ijoin(1),2) .gt. 0) then\n");
        fprintf(redfp,"                 k(ijoin(1),4) = ijoin(2)*10000\n");
        fprintf(redfp,"             else\n");
        fprintf(redfp,"                 k(ijoin(1),5) = ijoin(2)*10000\n");
        fprintf(redfp,"             endif\n");
        fprintf(redfp,"             k(ijoin(2),1) = 3\n");
        fprintf(redfp,"             if(k(ijoin(2),2) .gt. 0) then\n");
        fprintf(redfp,"                 k(ijoin(2),4) = ijoin(1)*10000\n");
        fprintf(redfp,"             else\n");
        fprintf(redfp,"                 k(ijoin(2),5) = ijoin(1)*10000\n");
        fprintf(redfp,"             endif\n");
        fprintf(redfp,"         endif\n");
        fprintf(redfp,"   20 continue\n");
    }
    } else {
/* For SUSY23 (color connection is not considered)*/
    fprintf(redfp,"      implicit real*8 (a-h,o-z)\n");
    cmsepar('*');
    fprintf(redfp,"      include 'inclc.h'\n");
    fprintf(redfp,"      include 'inclk.h'\n");
    fprintf(redfp,"*     real*4 e,theta,phi\n");
    fprintf(redfp,"      \n");
    fprintf(redfp,"      real*8 gsp(4,1000)\n");
    fprintf(redfp,"      integer igsn,igsad(1000),igsid(1000),igsp(1000),igsc(1000),\n");
    fprintf(redfp,"     .        igsd(1000)\n");
    fprintf(redfp,"      integer ijoin(2),icjoin(10),isgsc(10)\n");
    fprintf(redfp,"      common /gsmom/ gsp,igsn,igsad,igsid,igsp,igsc,igsd,igscc\n");
    fprintf(redfp,"      real*4  pmas,parf,vckm\n");
    fprintf(redfp,"      common/ludat2/kchg(500,3),pmas(500,4),parf(2000),vckm(4,4)\n");
    cmsepar('-');
    fprintf(redfp,"*     common /lujets/\n");
    cmsepar('-');
    fprintf(redfp,"      real*4  p,v\n");
    fprintf(redfp,"      common/lujets/n,k(4000,5),p(4000,5),v(4000,5)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      l=0\n");
    fprintf(redfp,"      m=0\n");
    fprintf(redfp,"      do 6666 j=1,10\n");
    fprintf(redfp,"         icjoin(j)=0\n");
    fprintf(redfp,"         isgsc(j)=0\n");
    fprintf(redfp,"6666  continue\n");
    fprintf(redfp,"      do 7777 j=1,igsn\n");
    fprintf(redfp,"         if(igsd(j).eq.0) then\n");
    fprintf(redfp,"            m=m+1\n");
    fprintf(redfp,"*------ direct call\n");
    fprintf(redfp,"*           px = gsp(1,j)\n");
    fprintf(redfp,"*           py = gsp(2,j)\n");
    fprintf(redfp,"*           pz = gsp(3,j)\n");
    fprintf(redfp,"*           e  = gsp(4,j)\n");
    fprintf(redfp,"*           pa = sqrt(px**2+py**2+pz**2)\n");
    fprintf(redfp,"*           theta = acos(pz/pa)\n");
    fprintf(redfp,"*           if((px**2+py**2).eq.0.d0) then\n");
    fprintf(redfp,"*             phi = 0.d0\n");
    fprintf(redfp,"*           else\n");
    fprintf(redfp,"*             phi = atan2(py,px)\n");
    fprintf(redfp,"*           end if\n");
    fprintf(redfp,"*           call lu1ent(m,igsid(j),e,theta,phi)\n");
    fprintf(redfp,"*------ assign common area\n");
    fprintf(redfp,"         p(m,1) = real(gsp(1,j))\n");
    fprintf(redfp,"         p(m,2) = real(gsp(2,j))\n");
    fprintf(redfp,"         p(m,3) = real(gsp(3,j))\n");
    fprintf(redfp,"         p(m,4) = real(gsp(4,j))\n");
    fprintf(redfp,"         p(m,5) = real(pmas(abs(igsid(j)),1))\n");
    fprintf(redfp,"         k(m,1) = 1\n");
    fprintf(redfp,"         k(m,2) = igsid(j)\n");
    fprintf(redfp,"         k(m,3) = 0\n");
    fprintf(redfp,"         k(m,4) = 0\n");
    fprintf(redfp,"         k(m,5) = 0\n");
    fprintf(redfp,"         v(m,1) = 0.0\n");
    fprintf(redfp,"         v(m,2) = 0.0\n");
    fprintf(redfp,"         v(m,3) = 0.0\n");
    fprintf(redfp,"         v(m,4) = 0.0\n");
    fprintf(redfp,"         v(m,5) = 0.0\n");
    fprintf(redfp,"*------ end\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"               if(igsc(j).ne.0) then\n");
    fprintf(redfp,"                  if(mod(igsc(j)+1,2).eq.0) then\n");
    fprintf(redfp,"                    l=l+1\n");
    fprintf(redfp,"                    icjoin(l)=m\n");
    fprintf(redfp,"                    isgsc(l)=igsc(j)\n");
    fprintf(redfp,"                  else \n");
    fprintf(redfp,"                    do 8888 kk=1,l\n");
    fprintf(redfp,"                      if((igsc(j)-isgsc(kk)).eq.1) then\n");
    fprintf(redfp,"                        ijoin(1)=icjoin(kk)\n");
    fprintf(redfp,"                        ijoin(2)=m\n");
    fprintf(redfp,"*------ direct call\n");
    fprintf(redfp,"*                       call lujoin(2,ijoin) \n");
    fprintf(redfp,"*------ assign common area\n");
    fprintf(redfp,"                        k(ijoin(1),1) = 3\n");
    fprintf(redfp,"                        if(k(ijoin(1),2) .gt. 0) then\n");
    fprintf(redfp,"                            k(ijoin(1),4) = ijoin(2)*10000\n");
    fprintf(redfp,"                        else\n");
    fprintf(redfp,"                            k(ijoin(1),5) = ijoin(2)*10000\n");
    fprintf(redfp,"                        endif\n");
    fprintf(redfp,"                        k(ijoin(2),1) = 3\n");
    fprintf(redfp,"                        if(k(ijoin(2),2) .gt. 0) then\n");
    fprintf(redfp,"                            k(ijoin(2),4) = ijoin(1)*10000\n");
    fprintf(redfp,"                        else\n");
    fprintf(redfp,"                            k(ijoin(2),5) = ijoin(1)*10000\n");
    fprintf(redfp,"                        endif\n");
    fprintf(redfp,"*------ end of string connection\n");
    fprintf(redfp,"                      end if\n");
    fprintf(redfp," 8888 continue\n");
    fprintf(redfp,"                  end if\n");
    fprintf(redfp,"               end if\n");
    fprintf(redfp,"            end if\n");
    fprintf(redfp," 7777 continue\n");
    fprintf(redfp,"      n = m\n");
    }
    cmsepar('-');
    fprintf(redfp,"*     Hadronization\n");
    cmsepar('-');
    fprintf(redfp,"*     call lulist(1)\n");
    fprintf(redfp,"*     call luexec\n");
    fprintf(redfp,"*     call lulist(1)\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
/* Generation of gr2lnd */
    cmsepar('=');
    cmsepar(' ');
    fprintf(redfp,"*    Set parameter of GRACE to LUND*\n");
    cmsepar(' ');
    fprintf(redfp,"*    Coded by S.Kawabata May'93 at LAPP                                *\n");
    cmsepar('=');
    fprintf(redfp,"      subroutine gr2lnd\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      include 'inclk.h'\n");
    fprintf(redfp,"      real*4  paru,parj\n");
    fprintf(redfp,"      real*4  pmas,parf,vckm\n");
    fprintf(redfp,"      common/ludat1/mstu(200),paru(200),");
    fprintf(redfp,"mstj(200),parj(200)\n");
    fprintf(redfp,"      common/ludat2/kchg(500,3),pmas(500,4),");
    fprintf(redfp,"parf(2000),vckm(4,4)\n");
    fprintf(redfp,"*     character*18 cmass,calpha\n");
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*     GRACE will generate the direct statment from model file.\n");
    fprintf(redfp,"*     call lugive('pmas(lucomp(24,1)= 70.0d0');\n");
    cmsepar('-');
    fprintf(redfp,"*     cmass(19:20) = 'd0'\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*   Mass\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amw\n");
    fprintf(redfp,"*     call lugive('pmas(24,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amz\n");
    fprintf(redfp,"*     call lugive('pmas(23,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') ama\n");
    fprintf(redfp,"*     call lugive('pmas(22,1)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amg\n");
    fprintf(redfp,"*     call lugive('pmas(21,1)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amh\n");
    fprintf(redfp,"*     call lugive('pmas(25,1)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amne\n");
    fprintf(redfp,"*     call lugive('pmas(12,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amnm\n");
    fprintf(redfp,"*     call lugive('pmas(14,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amnt\n");
    fprintf(redfp,"*     call lugive('pmas(16,1)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amel\n");
    fprintf(redfp,"*     call lugive('pmas(11,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') ammu\n");
    fprintf(redfp,"*     call lugive('pmas(13,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amta\n");
    fprintf(redfp,"*     call lugive('pmas(15,1)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amuq\n");
    fprintf(redfp,"*     call lugive('pmas( 2,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amcq\n");
    fprintf(redfp,"*     call lugive('pmas( 4,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amtq\n");
    fprintf(redfp,"*     call lugive('pmas( 6,1)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amdq\n");
    fprintf(redfp,"*     call lugive('pmas( 1,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') amsq\n");
    fprintf(redfp,"*     call lugive('pmas( 3,1)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') ambq\n");
    fprintf(redfp,"*     call lugive('pmas( 5,1)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*   Width\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') agw\n");
    fprintf(redfp,"*     call lugive('pmas(24,2)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') agz\n");
    fprintf(redfp,"*     call lugive('pmas(23,2)='//cmass)\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') aga\n");
    fprintf(redfp,"**    call lugive('pmas(22,2)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') agg\n");
    fprintf(redfp,"**    call lugive('pmas(21,2)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') agh\n");
    fprintf(redfp,"*     call lugive('pmas(25,2)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') agne\n");
    fprintf(redfp,"**    call lugive('pmas(12,2)='//cmass)\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') agnm\n");
    fprintf(redfp,"**    call lugive('pmas(14,2)='//cmass)\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') agnt\n");
    fprintf(redfp,"**    call lugive('pmas(16,2)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') agel\n");
    fprintf(redfp,"**    call lugive('pmas(11,2)='//cmass)\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') agmu\n");
    fprintf(redfp,"**    call lugive('pmas(13,2)='//cmass)\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') agta\n");
    fprintf(redfp,"**    call lugive('pmas(15,2)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') aguq\n");
    fprintf(redfp,"**    call lugive('pmas( 2,2)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') agcq\n");
    fprintf(redfp,"*     call lugive('pmas( 4,2)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') agtq\n");
    fprintf(redfp,"*     call lugive('pmas( 6,2)='//cmass)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"**    write(cmass,'(e18.10)') agdq\n");
    fprintf(redfp,"**    call lugive('pmas( 1,2)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') agsq\n");
    fprintf(redfp,"*     call lugive('pmas( 3,2)='//cmass)\n");
    fprintf(redfp,"*     write(cmass,'(e18.10)') agbq\n");
    fprintf(redfp,"*     call lugive('pmas( 5,2)='//cmass)\n");
    fprintf(redfp,"*  Alpha\n");
    fprintf(redfp,"*     calpha(19:20) = 'd0'\n");
    fprintf(redfp,"*     write(calpha,'(e18.10)') alpha\n");
    fprintf(redfp,"*     call lugive('paru(101)='//calpha)\n");
    fprintf(redfp,"\n");
    cmsepar('-');
    fprintf(redfp,"*     PUT COMMON BLOCK \n");
    cmsepar('-');
    fprintf(redfp,"*\n");
    fprintf(redfp,"*   Mass & Width\n");
    fprintf(redfp,"*\n");
    fprintf(redfp,"*     <Gauge Boson>\n");
    fprintf(redfp,"*\n");
/*
    fprintf(redfp,"      pmas(21,1) = real(amg)\n");
    fprintf(redfp,"      pmas(22,1) = real(ama)\n");
    fprintf(redfp,"      pmas(23,1) = real(amz)\n");
    fprintf(redfp,"      pmas(24,1) = real(amw)\n");
    fprintf(redfp,"      pmas(25,1) = real(amh)\n");
    fprintf(redfp,"*     pmas(21,2) = real(agg)\n");
    fprintf(redfp,"*     pmas(22,2) = real(aga)\n");
    fprintf(redfp,"      pmas(23,2) = real(agz)\n");
    fprintf(redfp,"      pmas(24,2) = real(agw)\n");
    fprintf(redfp,"      pmas(25,2) = real(agh)\n");
*/
    for(p = 1; p < nptable; p++) {
        cmmass(p, 1, momstr);
        if(strcmp(momstr,"0") == 0) {
            continue;
        }
    }
    fprintf(redfp,"*\n");
    fprintf(redfp,"*     <Quark>\n");
    fprintf(redfp,"*\n");
/*
    fprintf(redfp,"      pmas( 1,1) = real(amdq)\n");
    fprintf(redfp,"      pmas( 2,1) = real(amuq)\n");
    fprintf(redfp,"      pmas( 3,1) = real(amsq)\n");
    fprintf(redfp,"      pmas( 4,1) = real(amcq)\n");
    fprintf(redfp,"      pmas( 5,1) = real(ambq)\n");
    fprintf(redfp,"      pmas( 6,1) = real(amtq)\n");
    fprintf(redfp,"*     pmas( 1,2) = real(agdq)\n");
    fprintf(redfp,"*     pmas( 2,2) = real(aguq)\n");
    fprintf(redfp,"      pmas( 3,2) = real(agsq)\n");
    fprintf(redfp,"      pmas( 4,2) = real(agcq)\n");
    fprintf(redfp,"      pmas( 5,2) = real(agbq)\n");
    fprintf(redfp,"      pmas( 6,2) = real(agtq)\n");
*/
    for(p = 1; p < nptable; p++) {
        cmmass(p, 1, momstr);
        if(strcmp(momstr,"0") == 0) {
            continue;
        }
    }

    fprintf(redfp,"*\n");
    fprintf(redfp,"*     <Lepton>\n");
    fprintf(redfp,"*\n");
/*
    fprintf(redfp,"      pmas(11,1) = real(amel)\n");
    fprintf(redfp,"      pmas(12,1) = real(amne)\n");
    fprintf(redfp,"      pmas(13,1) = real(ammu)\n");
    fprintf(redfp,"      pmas(14,1) = real(amnm)\n");
    fprintf(redfp,"      pmas(15,1) = real(amta)\n");
    fprintf(redfp,"      pmas(16,1) = real(amnt)\n");
    fprintf(redfp,"*     pmas(11,2) = real(agel)\n");
    fprintf(redfp,"*     pmas(12,2) = real(agne)\n");
    fprintf(redfp,"*     pmas(13,2) = real(agmu)\n");
    fprintf(redfp,"*     pmas(14,2) = real(agnm)\n");
    fprintf(redfp,"*     pmas(15,2) = real(agta)\n");
    fprintf(redfp,"*     pmas(16,2) = real(agnt)\n");
*/
    for(p = 1; p < nptable; p++) {
        cmmass(p, 1, momstr);
        if(strcmp(momstr,"0") == 0) {
            continue;
        }
    }

    fprintf(redfp,"*\n");
    fprintf(redfp,"*  Alpha\n");
    fprintf(redfp,"*\n");
    fprintf(redfp,"      paru(101) = real(alpha)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end \n");

    if(susylib) {
    fprintf(redfp,"*  SUBROUTINE DECAY MANAGER\n");
    fprintf(redfp,"*  nextn      : ");
    fprintf(redfp,"number of external particles (idcp = 3 -> nextn)\n");
    fprintf(redfp,"*  idcp       : particle address in GRACE system\n");
    fprintf(redfp,"*  kfcode(idcp) : KFcode of particle\n");
    fprintf(redfp,"*  infc(idcp) : colour address\n");
    cmsepar('*');
    fprintf(redfp,"      subroutine sudcay\n");
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      INCLUDE 'inclc.h'\n");
    fprintf(redfp,"      INCLUDE 'inclk.h'\n");
    fprintf(redfp,"      integer kfcode,infc(1000)\n");
    fprintf(redfp,"      common /ps4vec/ vecps(4,1000)\n");
    fprintf(redfp,"      common /sp4vec/ vec(4,nextn)\n");
    fprintf(redfp,"      \n");
    fprintf(redfp,"      real*8 gsp(4,1000)\n");
    fprintf(redfp,"      integer igsn,igsad(1000),igsid(1000),\n");
    fprintf(redfp,"igsp(1000),igsc(1000),\n");
    fprintf(redfp,"     .        igsd(1000)\n");
    fprintf(redfp,"      common /gsmom/ gsp,igsn,igsad,igsid,");
    fprintf(redfp,"igsp,igsc,igsd,igscc\n");
    fprintf(redfp,"      COMMON/QPLIST/PLPTN(10,1000),NLPTN(10,1000),NTOP\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      igsn   =   0\n");
    fprintf(redfp,"      igscc  =   0\n");
    fprintf(redfp,"         do 5000 i=1,1000\n");
    fprintf(redfp,"         igsc(i) =0\n");
    fprintf(redfp,"         igsd(i) =0\n");
    fprintf(redfp,"         igsad(i) =0\n");
    fprintf(redfp,"         igsid(i) =0\n");
    fprintf(redfp,"         igsp(i) =0\n");
    fprintf(redfp,"         infc(i) =0\n");
    fprintf(redfp,"5000     continue\n");
    fprintf(redfp,"\n");
    cmsepar('*');
    fprintf(redfp,"          if(jqedps.eq.0) then\n");
    cmsepar('*');
    fprintf(redfp,"\n");
    fprintf(redfp,"         do 1000 idcp=3,nextn\n");

    if(gcbase->nbase == 1) {
        if(gcbase->nconid[0] > 0) {
            fprintf(redfp,"           do 2000 l=1,kmcbmx\n");
            fprintf(redfp,"             if (idcp.eq.kmcstr(l)) then\n");
            fprintf(redfp,"                infc(idcp)=l\n");
            fprintf(redfp,"             endif\n");
            fprintf(redfp,"2000       continue \n");
        }
    } else if(gcbase->nbase > 1) {
            fprintf(redfp,"           do 2000 l=1,kmcbmx\n");
            fprintf(redfp,"             if (idcp.eq.kmcstr(l,icolst)) then\n");
            fprintf(redfp,"                infc(idcp)=l\n");
            fprintf(redfp,"             endif\n");
            fprintf(redfp,"2000       continue \n");
    }

    fprintf(redfp,"         if((abs(kfcode(idcp)).le.22).or.(abs(kfcode(idcp)).eq.71)) then\n");
    fprintf(redfp,"             igsn=igsn+1\n");
    fprintf(redfp,"* non-decay particle momentum\n");
    fprintf(redfp,"             do 100 j=1,4\n");
    fprintf(redfp,"               gsp(j,igsn)=vec(j,idcp)\n");
    fprintf(redfp,"100              continue         \n");
    fprintf(redfp,"               igsad(igsn)=igsn\n");
    fprintf(redfp,"               igsid(igsn)=kfcode(idcp)\n");
    fprintf(redfp,"               igsc(igsn)=infc(idcp)\n");
    fprintf(redfp,"               igsd(igsn)=0\n");
    fprintf(redfp,"         end if\n");
    fprintf(redfp,"           \n");
    fprintf(redfp,"           if(kfcode(idcp).eq.75) then\n");
    fprintf(redfp,"              call dcsw1(idcp,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-75) then\n");
    fprintf(redfp,"              call dcsw1(idcp,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.46) then\n");
    fprintf(redfp,"              call dcst1(idcp,0,infc(idcp))\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-46) then\n");
    fprintf(redfp,"              call dcst1(idcp,1,infc(idcp)) \n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.45) then\n");
    fprintf(redfp,"              call dcsb1(idcp,0,infc(idcp))\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-45) then\n");
    fprintf(redfp,"              call dcsb1(idcp,1,infc(idcp)) \n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.72) then\n");
    fprintf(redfp,"              call dcsn2(idcp,0)\n");
    fprintf(redfp,"           end if\n");
    fprintf(redfp,"           \n");
    fprintf(redfp,"           if(kfcode(idcp).eq.57) then\n");
    fprintf(redfp,"              call dcser(idcp,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-57) then\n");
    fprintf(redfp,"              call dcser(idcp,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.58) then\n");
    fprintf(redfp,"              call dcsmr(idcp,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-58) then\n");
    fprintf(redfp,"              call dcsmr(idcp,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.51) then\n");
    fprintf(redfp,"              call dcsel(idcp,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-51) then\n");
    fprintf(redfp,"              call dcsel(idcp,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.53) then\n");
    fprintf(redfp,"              call dcsml(idcp,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-53) then\n");
    fprintf(redfp,"              call dcsml(idcp,1)\n");
    fprintf(redfp,"c           else if(kfcode(idcp).eq.55) then\n");
    fprintf(redfp,"c              call dcsa1(idcp,0)\n");
    fprintf(redfp,"c           else if(kfcode(idcp).eq.-55) then\n");
    fprintf(redfp,"c              call dcsa1(idcp,1)\n");
    fprintf(redfp,"           end if\n");
    fprintf(redfp,"           \n");
    fprintf(redfp,"           if(kfcode(idcp).eq.52) then\n");
    fprintf(redfp,"              call dcsne(idcp,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-52) then\n");
    fprintf(redfp,"              call dcsne(idcp,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.54) then\n");
    fprintf(redfp,"              call dcsnm(idcp,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-54) then\n");
    fprintf(redfp,"              call dcsnm(idcp,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.56) then\n");
    fprintf(redfp,"              call dcsnt(idcp,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-56) then\n");
    fprintf(redfp,"              call dcsnt(idcp,1)\n");
    fprintf(redfp,"           end if\n");
    fprintf(redfp,"1000   continue       \n");
    fprintf(redfp,"      \n");
    fprintf(redfp,"          else\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"         do 1001 l=1,ntop\n");
    fprintf(redfp,"         \n");
    fprintf(redfp,"         if (nlptn(1,l).eq.1.or.nlptn(1,l).eq.2) goto 1001\n");
    fprintf(redfp,"         if (nlptn(1,l).eq.0.and.nlptn(3,l).eq.0) then\n");
    fprintf(redfp,"           kfcode(nlptn(1,l))=22\n");
    fprintf(redfp,"           infc(nlptn(1,l))=0\n");
    fprintf(redfp,"         end if\n");
    fprintf(redfp,"         \n");
    fprintf(redfp,"         vecps(1,l) = plptn(4,l)\n");
    fprintf(redfp,"         vecps(2,l) = plptn(5,l)\n");
    fprintf(redfp,"         vecps(3,l) = plptn(6,l)\n");
    fprintf(redfp,"         vecps(4,l) = plptn(7,l)\n");
    fprintf(redfp,"         \n");
    fprintf(redfp,"         idcp = nlptn(1,l)\n");

    if(gcbase->nbase == 1) {
        if(gcbase->nconid[0] > 0) {
            fprintf(redfp,"           do 2010 l=1,kmcbmx\n");
            fprintf(redfp,"             if (idcp.eq.kmcstr(l)) then\n");
            fprintf(redfp,"                infc(idcp)=l\n");
            fprintf(redfp,"             endif\n");
            fprintf(redfp," 2010      continue \n");
        }
    } else if(gcbase->nbase > 1) {
            fprintf(redfp,"           do 2010 l=1,kmcbmx\n");
            fprintf(redfp,"             if (idcp.eq.kmcstr(l,icolst)) then\n");
            fprintf(redfp,"                infc(idcp)=l\n");
            fprintf(redfp,"             endif\n");
            fprintf(redfp," 2010      continue \n");
    }

    fprintf(redfp,"         if(((abs(kfcode(idcp)).le.22).or.\n");
    fprintf(redfp,"     .        (abs(kfcode(idcp)).eq.71)).and.\n");
    fprintf(redfp,"     .       (NLPTN(3,l).eq.0) ) then\n");
    fprintf(redfp,"             igsn=igsn+1\n");
    fprintf(redfp,"* non-decay particle momentum\n");
    fprintf(redfp,"             do 101 j=1,4\n");
    fprintf(redfp,"               gsp(j,igsn)=vecps(j,l)\n");
    fprintf(redfp,"101              continue         \n");
    fprintf(redfp,"               igsad(igsn)=igsn\n");
    fprintf(redfp,"               igsid(igsn)=kfcode(idcp)\n");
    fprintf(redfp,"               igsc(igsn)=infc(idcp)\n");
    fprintf(redfp,"               igsd(igsn)=0\n");
    fprintf(redfp,"         end if\n");
    fprintf(redfp,"           \n");
    fprintf(redfp,"           if(kfcode(idcp).eq.75) then\n");
    fprintf(redfp,"              call dcsw1ps(l,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-75) then\n");
    fprintf(redfp,"              call dcsw1ps(l,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.46) then\n");
    fprintf(redfp,"              call dcst1ps(l,0,infc(idcp))\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-46) then\n");
    fprintf(redfp,"              call dcst1ps(l,1,infc(idcp)) \n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.45) then\n");
    fprintf(redfp,"              call dcsb1ps(l,0,infc(idcp))\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-45) then\n");
    fprintf(redfp,"              call dcsb1ps(l,1,infc(idcp)) \n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.72) then\n");
    fprintf(redfp,"              call dcsn2ps(l,0)\n");
    fprintf(redfp,"           end if\n");
    fprintf(redfp,"           \n");
    fprintf(redfp,"           if(kfcode(idcp).eq.57) then\n");
    fprintf(redfp,"              call dcserps(l,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-57) then\n");
    fprintf(redfp,"              call dcserps(l,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.58) then\n");
    fprintf(redfp,"              call dcsmrps(l,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-58) then\n");
    fprintf(redfp,"              call dcsmrps(l,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.51) then\n");
    fprintf(redfp,"              call dcselps(l,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-51) then\n");
    fprintf(redfp,"              call dcselps(l,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.53) then\n");
    fprintf(redfp,"              call dcsmlps(l,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-53) then\n");
    fprintf(redfp,"              call dcsmlps(l,1)\n");
    fprintf(redfp,"c           else if(kfcode(idcp).eq.55) then\n");
    fprintf(redfp,"c              call dcsa1ps(l,0)\n");
    fprintf(redfp,"c           else if(kfcode(idcp).eq.-55) then\n");
    fprintf(redfp,"c              call dcsa1ps(l,1)\n");
    fprintf(redfp,"           end if\n");
    fprintf(redfp,"           \n");
    fprintf(redfp,"           if(kfcode(idcp).eq.52) then\n");
    fprintf(redfp,"              call dcsneps(l,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-52) then\n");
    fprintf(redfp,"              call dcsneps(l,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.54) then\n");
    fprintf(redfp,"              call dcsnmps(l,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-54) then\n");
    fprintf(redfp,"              call dcsnmps(l,1)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.56) then\n");
    fprintf(redfp,"              call dcsntps(l,0)\n");
    fprintf(redfp,"           else if(kfcode(idcp).eq.-56) then\n");
    fprintf(redfp,"              call dcsntps(l,1)\n");
    fprintf(redfp,"           end if\n");
    fprintf(redfp,"1001   continue\n");
    fprintf(redfp,"      \n");
    fprintf(redfp,"       endif\n");
    fprintf(redfp,"       return\n");
    fprintf(redfp,"       end\n");
    }
}

/*==================================================================*/
Private Void    cmspdetc(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmspdetp(-1);
}

/*==================================================================*/
Private Void    cmspdetp(pc)
int     pc;
/*------------------------------------------------------------------*
 * generate "spdetc.f" for JETSET interface routine
 *------------------------------------------------------------------*/
{
    int    pps, ppe, pp;
    string prf, prfs;

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    if(multiprc) {
        cmopend(ROFORT, prfs, "spdetc.f");
        cmsepar('*');
        fprintf(redfp,"      subroutine spdetc\n");
        fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
        fprintf(redfp,"      common /amjprc/jproc\n");
        fprintf(redfp,"\n");

        for(pp = pps; pp < ppe; pp++) {
            fprintf(redfp,"        if(jproc .eq. %d) then\n", pp+1);
            fprintf(redfp,"            call sp%sdetc\n", reprocp[pp]);
            fprintf(redfp,"        endif\n");
            fprintf(redfp,"\n");
        }
        fprintf(redfp,"        return\n");
        fprintf(redfp,"        end\n");

        if(pc < 0) {
            return;
        } else {
            sprintf(momstr, "sp%sdetc", prf);
        }
    } else {
        sprintf(momstr, "spdetc");
    }

    sprintf(momstr1, "%s.f", momstr);
    cmopend(ROFORT, prf, momstr1);

    cmsepar('*');
    fprintf(redfp,"      subroutine %s\n", momstr);

    cmsepar('-');
    fprintf(redfp,"*     Selection of Color State\n");
    fprintf(redfp,"*        output:icolst (0->ncbase-1)\n");
    cmsepar('-');
    fprintf(redfp,"      implicit real*8 (a-h,o-z)\n");

    if(!(colorv ==1 && gcbase->nbase > 1)) {
        fprintf(redfp,"\n");
        fprintf(redfp,"      return\n");
        fprintf(redfp,"      end\n");
        return;
    }

    fprintf(redfp,"      include 'inclk.h'\n");
    fprintf(redfp,"      include 'incl%s1.h'\n", prf);
    fprintf(redfp,"      dimension asum(0:ncbase-1),cratio(0:ncbase-1)\n");
    fprintf(redfp,"      external drn\n");
    cmsepar('-');
    fprintf(redfp,"*        Calcul amplitutes squared.\n");
    cmsepar('-');
    fprintf(redfp,"      do 120 ic = 0 , ncbase-1\n");
    fprintf(redfp,"      asum(ic) = 0.0d0\n");
    fprintf(redfp,"      do 110 ih = 0, l%sag-1\n", prf);
    fprintf(redfp,"         asum(ic) = ");
    fprintf(redfp,"asum(ic) + dble(agc(ih,ic))**2 + imag(agc(ih,ic))**2\n");
    fprintf(redfp,"  110 continue\n");
    fprintf(redfp,"      asum(ic) = asum(ic)*cfmtx(ic,ic)\n");
    fprintf(redfp,"  120 continue\n");
    cmsepar('-');
    fprintf(redfp,"*        Search maximum.\n");
    cmsepar('-');
    fprintf(redfp,"      allsum = 0.0d0\n");
    fprintf(redfp,"      do 130 ic = 1, ncbase-1\n");
    fprintf(redfp,"         allsum = allsum + asum(ic)\n");
    fprintf(redfp,"  130 continue\n");
    fprintf(redfp,"      tmpsum = 0.0d0\n");
    fprintf(redfp,"      do 140 ic = 1, ncbase-1\n");
    fprintf(redfp,"         tmpsum = tmpsum + asum(ic)\n");
    fprintf(redfp,"         cratio(ic) = tmpsum/allsum\n");
    fprintf(redfp,"  140 continue\n");
    fprintf(redfp,"\n");
    fprintf(redfp,"      cran = drn(idummy)\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      icolst = 0\n");
    fprintf(redfp,"      do 150 ic = 1, ncbase-1\n");
    fprintf(redfp,"         if(cratio(ic) .gt. cran) then\n");
    fprintf(redfp,"             goto 160\n");
    fprintf(redfp,"         else\n");
    fprintf(redfp,"             icolst = ic\n");
    fprintf(redfp,"         endif\n");
    fprintf(redfp,"  150 continue\n");
    fprintf(redfp,"  160 continue\n");
    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmgfinit(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmgfinip(-1);
}

/*==================================================================*/
Private Void    cmgfinip(pc)
int     pc;
/*------------------------------------------------------------------*
 */
{
    int    n, m, tp, il, p;
/*    int    ic1,ic2;*/
    int    i;
/*    int  j, mxlen;*/
    int    nident, aident;
/*    int    kol[MAXCOLR],ktmp,k;*/
    int    lp,l0;
    tnode  *nd;
    pindex pa;
    int    jcheck[MAXNODES];
    int    pps, ppe, pp;
    string prf, prfs;
    int    lo;
    int    ninit, nfinal;

    printf(" cmgfinip(%d) ... started\n",pc);

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    if( multiprc ) {
        printf(" Multiprc on %s\n",prfs);
    } else {
        printf(" Multiprc off %s\n",prfs);
    }

    if(multiprc) {
        cmopend(ROFORT, prfs, "gfinit.f");
        cmsepar('*');
        fprintf(redfp,"      subroutine gfinit\n");
        fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
        fprintf(redfp,"      common /amjprc/jproc\n");
        fprintf(redfp,"\n");

        for(pp = pps; pp < ppe; pp++) {
            fprintf(redfp,"        if(jproc .eq. %d) then\n", pp+1);
            fprintf(redfp,"            call g%sfinit\n", reprocp[pp]);
            fprintf(redfp,"        endif\n");
            fprintf(redfp,"\n");
        }
        fprintf(redfp,"        return\n");
        fprintf(redfp,"        end\n");

        sprintf(momstr, "g%sfinit", prf);
    } else {
        sprintf(momstr, "gfinit");
    }
    sprintf(momstr1, "%s.f", momstr);
    printf(" cmgfinip ... cmopend %s %s\n",prfs,momstr1);
    cmopend(ROFORT, prf, momstr1);
/* 000810 ???*/
/*    cmopend(ROFORT, prfs, momstr1);*/

    cmsepar('*');
    fprintf(redfp,"      subroutine %s\n", momstr);
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(vcode) {
        fprintf(redfp,"      include 'inclvs.h'\n");
    }
    fprintf(redfp,"      include 'incl%s1.h'\n", prf);
    fprintf(redfp,"      include 'inclk.h'\n");

    fprintf(redfp,"      common /chcntl/ jwidth, jtgamm\n");
    fprintf(redfp,"      integer nbody, ninit, nfinal\n");
    fprintf(redfp,"      common /kcntl1/nbody\n");

    cmsepar('-');
/* For YK
    cmprtitle();
*/

    cmsepar('-');
    fprintf(redfp,"      zimg   = dcmplx(0.0d0,1.0d0)\n");
    cmsepar('-');

    fprintf(redfp,"* Propagator = (i)**(-pphase)\n");
    fprintf(redfp,"      pphase = %s\n\n", spphase[pphase%4]);
    if( caller != GRCFORT) {
    fprintf(redfp,"      pphas2 = pphase**2\n");
    fprintf(redfp,"      pphas3 = pphase*pphas2\n");
    fprintf(redfp,"      pphas4 = pphas2**2\n");
    fprintf(redfp,"      pphas5 = pphase*pphas4\n");
    fprintf(redfp,"      pphas6 = pphas4*pphas2\n");

    fprintf(redfp,"      pphas1 = 1/pphase\n");
    fprintf(redfp,"      pphas2 = 1/pphas2\n");
    fprintf(redfp,"      pphas3 = 1/pphas3\n");
    fprintf(redfp,"      pphas4 = 1/pphas4\n");
    fprintf(redfp,"      pphas5 = 1/pphas5\n");
    fprintf(redfp,"      pphas6 = 1/pphas6\n");
    }

    fprintf(redfp,"\n");
    fprintf(redfp,"* Set KF-Code\n");
    fprintf(redfp,"      call amkfcd\n");
    fprintf(redfp,"\n");
    if( pubys || caller == GRCREDH || caller == GRCRED ) {
        fprintf(redfp,"* Set P-Code\n");
        fprintf(redfp,"      call gr_amidpc\n");
    }

    /* mass2 */
    fprintf(redfp,"* Set Mass**2\n");
    fprintf(redfp,"      call ammas2\n");
/*
    cmsepar('-');
    fprintf(redfp, "* mass**2\n");
    cmsepar('-');
    for(n = 1; n < nptable; n++) {
        if(isdigit(ptable[n]->mass[0])) {
            continue;
        }
        cmmass(n, -1, momstr);
        if(strcmp(momstr,"0") == 0) {
            continue;
        }
        cmmass(n, 1, momstr1);
        fprintf(redfp,"      %6s = %6s**2\n", momstr, momstr1);
    }
    putc(EOL, redfp);
*/
    cmsepar('-');
    fprintf(redfp,"* Parameters for the process\n");
    fprintf(redfp,"      kmngr  = n%sgraph\n", prf);
    fprintf(redfp,"      kmnext = n%sextn\n", prf);
    if( caller == GRCFORT) {
        fprintf(redfp,"      kmlag  = l%sag\n", prf);
    }
    if(prf == NULL || strlen(prf) < 1) {
        fprintf(redfp,"      smpref = ' '\n");
    } else {
        fprintf(redfp,"      smpref = '%s'\n", prf);
    }
    fprintf(redfp,"c??   smproc = '");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELINITIAL) {
            pa  = ndname(n);
            fprintf(redfp,"%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp," --> ");
    for(n = 0; n < nextern; n++) {
        if(ndiorf(n) == ELFINAL) {
            pa  = ndname(n);
            fprintf(redfp,"%s ",pvename(ndiorf(n),pa));
        }
    }
    fprintf(redfp,"'\n\n");

    cmsepar('-');

    if(maxloop > 0) {
        fprintf(redfp,"\n* Counter terms\n");
        fprintf(redfp,"      call cterms\n\n");
    }
    if(caller == GRCFORT || caller == GRCREDA || caller == GRCREDH ) {
        if(caller == GRCFORT) {
            fprintf(redfp,"* Gauge parametes (default is unitary gauge)\n");
/* 980708
            fprintf(redfp,"      igau00 = 0\n");
            for(n = 1; n < 5; n++) {
                fprintf(redfp,"      igau%cb = 0\n", gchr[n]);
            }
*/
            for(i = 0; i < ngauge; i++) {
                fprintf(redfp,"      igau%s = 0\n", sgauge[i]);
            }
/*
            fprintf(redfp,"      agauge(igau00) = 1.0d0\n");
            for(n = 1; n < 5; n++) {
                fprintf(redfp,"      agauge(igau%cb) = 1.0d0\n", gchr[n]);
            }
*/
            fprintf(redfp,"\n");
            fprintf(redfp,"      agauge(0) = 1.0d20\n");
            fprintf(redfp,"\n");
        } else if(caller == GRCREDA || caller == GRCREDH ) {
            fprintf(redfp,"\n* Gauge parametes (default is Feynman gauge)\n");
/*
            for(n = 1; n < 5; n++) {
                fprintf(redfp,"      igau%cb = %d\n", gchr[n],n);
            }
            for(n = 1; n < 5; n++) {
                fprintf(redfp,"      agauge(igau%cb) = 1.0d0\n", gchr[n]);
            }
            fprintf(redfp,"      agauge(igau00) = 1.0d0\n");
*/
            for(i = 0; i < ngauge; i++) {
                fprintf(redfp,"      igau%s = %d\n", sgauge[i], i+1);
            }
            fprintf(redfp,"\n");
            for(i = 0; i < ngauge; i++) {
                fprintf(redfp,"      agauge(igau%s) = 1.0d0\n",
                        sgauge[i]);
            }
            fprintf(redfp,"\n");
        }

        ninit  = 0;
        nfinal = 0;
        fprintf(redfp,"\n* Spin average\n");
        fprintf(redfp,"      aspin = 1.0d0\n");
        for(n = 0; n < nextern; n++) {
            pa  = ndname(n);
            p   = abs(pa);
            il  = ndiline(n, 0);
            tp  = iltable[il].iltype;
            cmmass(p, 1, momstr);

            fprintf(redfp,"\n");
            fprintf(redfp,"*     %d: %s %s mass=%s\n",
                    n+1, eliorf(ndiorf(n)), pvename(ndiorf(n),pa),
                    momstr);

            Discard cmindx(momstr, tp, p);
            Discard cmindx(momstr1, tp, p);
            fprintf(redfp,"      maxjhs(%d) = 0\n", n+1);
            fprintf(redfp,"      maxjhe(%d) = %s - 1\n", n+1, momstr);
            fprintf(redfp,"      jhs(%d) = 0\n", n+1);
            fprintf(redfp,"      jhe(%d) = %s - 1\n", n+1, momstr);
            if(ndiorf(n) == ELINITIAL && pvsdeg(p) > 1) {
                fprintf(redfp,"      aspin = aspin/");
                fprintf(redfp,"dble(jhe(%d) - jhs(%d)+1)\n",
                        n+1, n+1);
                ninit++;
            } else {
                nfinal++;
            }
        }
        if(cpol) {
            for(n = 0; n < ndnodes(); n++) {
/* 2002/03/07
 *              if(n == 0) {
 *                  fprintf(redfp,"\n* Flag of cyclic polarization\n");
 *              }
 */
                if(ndtype(n) != NDEXTERN) {
                    continue;
                }
                if(cmphoton(n)) {
                    pa  = ndname(n);
                    fprintf(redfp,"\n* Flag of cyclic polarization of %s\n",
                                  pvename(ndiorf(n),pa));
                    fprintf(redfp,"* (linear : 0,  circular : 1)\n");
                    fprintf(redfp,"      jcpol(%d) = 0\n", n+1);
                }
            }
        }
    } else {
/*
        fprintf(redfp,"\n* coupling constant for reduce code\n");
        fprintf(redfp,"      call atcpl\n");
*/
        ninit  = 0;
        nfinal = 0;
        fprintf(redfp,"\n* Spin average\n");
        fprintf(redfp,"      aspin = 1.0d0");
        for(n = 0; n < nextern; n++) {
            nd  = ndnode(n);
            if(nd->nvkind == ELINITIAL) {
                p = abs(ndname(n));
                fprintf(redfp,"/%d.0d0", pvsdeg(p));
                ninit++;
            } else {
                nfinal++;
            }
        }
    }
    fprintf(redfp,"\n* The number of initial and final particles\n");
    fprintf(redfp,"      ninit  = %d\n", ninit);
    fprintf(redfp,"      nfinal = %d\n", nfinal);
    fprintf(redfp,"      nbody  = nfinal\n");

    if(ucode) fprintf(redfp,"       call gispin(nextn,jhs,jhe)\n");

    fprintf(redfp,"\n* Initial color average\n");
    if(colorv == 1 && gcbase->nexcolor > 0) {
        fprintf(redfp,"      acolav = 1.0d0/%ld.0d0\n", gcbase->iniav);
    } else {
        fprintf(redfp,"      acolav = 1.0d0\n");
        for(n = 0; n < nextern; n++) {
            if(ndiorf(n) != ELINITIAL) {
                continue;
            }
            p = abs(ndname(n));
            fprintf(redfp,"      acolav = acolav/%d.0d0\n",
                    ptable[p]->color);
        }
    }
    fprintf(redfp,"      aspin = aspin*acolav\n");

    fprintf(redfp,"\n* Symmetry factor for final identical particles\n");
    fprintf(redfp,"      aident = 1.0d0\n");
    fprintf(redfp,"*     aident = 1.0d0");
    for(n = 0; n < nextern; n++) {
        nd  = ndnode(n);
        if(nd->nvkind == ELINITIAL) {
            jcheck[n] = True;
        } else {
            jcheck[n] = False;
        }
    }
    for(n = 0; n < nextern - 1; n++) {
        if(jcheck[n]) {
            continue;
        }
        nident = 1;
        aident = 1;
        p = ndname(n);
        for(m = n + 1; m < nextern; m++) {
            if(jcheck[m]) {
                continue;
            }
            if(p == ndname(m)) {
                jcheck[m] = True;
                nident++;
                aident *= nident;
            }
        }
        if(aident != 1) {
            fprintf(redfp,"*%d.0d0", aident);
        }
    }
    fprintf(redfp,"\n");
/*  fprintf(redfp,"      aspin = aspin/aident\n\n"); */

    fprintf(redfp,"* graph selection\n");
    if(caller == GRCFORT || caller == GRCREDA ) {
        fprintf(redfp,"      do 10 n1 = 1, n%sgraph\n", prf);
        fprintf(redfp,"        jselg(n1) = 1\n");
        fprintf(redfp,"   10 continue\n\n");
        fprintf(redfp,"      jgraph = 0\n");
    } else {

/* HERE */
      if( opver ) {
        for(lp = 0; lp <= maxloop; lp++) {
            for(l0 = lp0min(lp); l0 <= lp0max(lp); l0++) {
                fprintf(redfp,"      do %4d n%d = 1, ng%d\n",
                     1000+l0,l0,l0);
                fprintf(redfp,"        jselg%d(n%d) = 1\n",l0,l0);
                fprintf(redfp," %4d continue\n\n",1000+l0);
            }
        }
      } else {
        if( caller == GRCRED ) {
            fprintf(redfp,"      iglsel =0\n");
            fprintf(redfp,"      if( iglsel .eq. 1 )then\n");
        }
        fprintf(redfp,"      do 10 n2 = 1, ng0\n");
        fprintf(redfp,"      do 10 n1 = 1, ng0\n");
        fprintf(redfp,"        jsel0(n1, n2) = 1\n");
        fprintf(redfp,"   10 continue\n\n");
/*
        fprintf(redfp,"      do 20 n2 = 1, ng0\n");
        fprintf(redfp,"      do 20 n1 = 1, ng1\n");
        fprintf(redfp,"        jsel1(n1, n2) = 1\n");
        fprintf(redfp,"   20 continue\n\n");
*/
        fprintf(redfp,"      do 20 n1 = 1, ng1\n");
        fprintf(redfp,"        jselg1(n1) = 1\n");
        fprintf(redfp,"   20 continue\n\n");
        fprintf(redfp,"      do 30 n1 = 1, ng0\n");
        fprintf(redfp,"        jselg0(n1) = 1\n");
        fprintf(redfp,"   30 continue\n\n");
        if( caller == GRCRED ) {
            fprintf(redfp,"      endif\n");
        }
        fprintf(redfp,"      jgraph = 0\n");
      }
    }
    putc(EOL, redfp);
    fprintf(redfp,"\n");

    lo = lang;
    lang = ROFORT;


    if(jtgamm) {
        fprintf(redfp,"*     QED vertex with on-shell fermions.\n");
        fprintf(redfp,"      jtgamm = 0\n\n");
    }
    if(jano3v) {
        fprintf(redfp,"*     Anomalous coupling for 3-vector-boson.\n");
        fprintf(redfp,"      jano3v = 0\n\n");
    }
    if(jcolmb) {
        fprintf(redfp,"*     Coulomb correction.\n");
        fprintf(redfp,"      jcolmb = 0\n\n");
    }
    if(jqcdcr) {
        fprintf(redfp,"*     QCD correction.\n");
        fprintf(redfp,"      jqcdcr = 0\n\n");
    }
#ifdef OLDSEL
    fprintf(redfp,"*     Private flag (Internal Higgs)\n");
    fprintf(redfp,"      jhiggs = 1\n\n");

    fprintf(redfp,"*     Private flag (Internal Gluon)\n");
    fprintf(redfp,"      jgluon = 0\n\n");
#else
    fprintf(redfp,"*     Graph selection flags\n");
    for(i = 0; i < nselect; i++) {
        fprintf(redfp,"      j%s = 1\n\n", sselect[i]);
    }
#endif

    if(minami) {
        fprintf(redfp,"*     Private flag (Decay)\n");
        fprintf(redfp,"      jdecay = 0\n\n");

        fprintf(redfp,"*     Private flag (Hadronization)\n");
        fprintf(redfp,"      jhadrn = 1\n\n");

    }
    fprintf(redfp,"*     Running width (0) or fixed width(1) in CHANEL\n");
    fprintf(redfp,"      jwidth = 1\n\n");
    fprintf(redfp,"      jtgamm = 1\n\n");

/*
    fprintf(redfp,"      itapol = 0\n\n");
*/
/* COLOR COLOR COLOR COLOR */
/*
    if(colorv == 0) {
        if(caller == GRCFORT || caller == GRCREDA) {
            if(cprocess->qcd != 0) {
                fprintf(redfp,"\n* read color factor\n");
                fprintf(redfp,"      open(22, file='cf0x0.dat', ");
                fprintf(redfp,"file='cf0x0.dat', status='old')\n");
                fprintf(redfp,"\n");
                fprintf(redfp,"      do 140 i = 1, 4\n");
                fprintf(redfp,"        read(22,*)\n");
                fprintf(redfp,"  140 continue\n");
                fprintf(redfp,"      do 100 i = 1, n%sgraph\n", prf);
                fprintf(redfp,"        igraph(i) = 0\n");
                fprintf(redfp,"        do 100 j = 1, n%sgraph\n", prf);
                fprintf(redfp,"          read(22,*) ig, jg, nn, nd\n");
                fprintf(redfp,"          if(ig.ne.i .or. jg.ne.j) then\n");
                fprintf(redfp,"            write(6,*) 'illegal file of color ");
                fprintf(redfp,"factors (colorf)' \n");
                fprintf(redfp,"            write(6,*) ig, jg, nn, nd\n");
                fprintf(redfp,"            stop\n");
                fprintf(redfp,"          endif\n");
                fprintf(redfp,"          cf(j, i) = nn/dble(nd)\n");
                fprintf(redfp,"  100 continue\n");
                fprintf(redfp,"\n");
            } else if(cprocess->extcol != 0) {
                fprintf(redfp,"      call cfcalc\n");
            }
        }
    } else if(colorv == 1) {
        if(gcbase->nbase > 1) {
            fprintf(redfp,"* weight for the color base\n");
            for(ic1=0;ic1<gcbase->nbase;ic1++) {
                for(ic2=0;ic2<gcbase->nbase;ic2++) {
                    if((gcbase->cwgt[ic1][ic2]).den == 1) {
                        fprintf(redfp,"      cfmtx(%d,%d)= %d.d0\n",
                                ic1,ic2,(gcbase->cwgt[ic1][ic2]).num);
                    } else {
                        fprintf(redfp,"      cfmtx(%d,%d)= %d.d0/%d.d0\n",
                                ic1,ic2,(gcbase->cwgt[ic1][ic2]).num,
                                (gcbase->cwgt[ic1][ic2]).den);
                    }
                }
            }
            fprintf(redfp,"\n");
        } else {
            fprintf(redfp,"* weight for the color base\n");
            if((gcbase->cwgt[0][0]).den == 1) {
                fprintf(redfp,"      cfmtx(0,0) = %d.d0\n",
                        (gcbase->cwgt[0][0]).num);
            } else {
                fprintf(redfp,"      cfmtx(0,0) = %d.d0/%d.d0\n",
                        (gcbase->cwgt[0][0]).num,(gcbase->cwgt[0][0]).den);
            }
            fprintf(redfp,"\n");
        }
    }
*/
    /* color string */
/*
    if(colorv == 1 && gcbase->nbase > 0) {
        fprintf(redfp,"\n* Color string information\n");
        if(gcbase->nbase == 1) {

            fprintf(redfp,"      kmcbas    = %d\n",gcbase->nbase);
            fprintf(redfp,"      kmcbmx    = %d\n",gcbase->nconid[0]);
            for(j = 0; j < gcbase->nconid[0]; j++) {
                kol[j] = cfnnind(gcbase->conid[0][j])+1;
            }

          *//* lower - higher *//*
            for(i=0;i< gcbase->nconid[0];i=i+2) {
                if(kol[i] > kol[i+1]) {
                    ktmp = kol[i];
                    kol[i] = kol[i+1];
                    kol[i+1] = ktmp;
                }
            }

          *//* ordering sets *//*
            for(i=0;i< gcbase->nconid[0];i=i+2) {
                for(j=i+2;j<gcbase->nconid[0];j=j+2) {
                    if(kol[i] > kol[j]) {
                        ktmp = kol[i];
                        kol[i] = kol[j];
                        kol[j] = ktmp;
                        ktmp = kol[i+1];
                        kol[i+1] = kol[j+1];
                        kol[j+1] = ktmp;
                    }
                }
            }

            for(j = 0; j < gcbase->nconid[0]; j++) {
                fprintf(redfp,"      kmcstr(%d) = %d\n",j+1,kol[j]);
            }

        } else if(gcbase->nbase > 1) {
            mxlen = gcbase->nconid[0];
            for(i = 1; i < gcbase->nbase; i++) {
                if(gcbase->nconid[i] > mxlen) {
                    mxlen = gcbase->nconid[i];
                }
            }
            fprintf(redfp,"      kmcbas    = %d\n",gcbase->nbase);
            fprintf(redfp,"      kmcbmx    = %d\n",mxlen);

            for(i = 0; i < gcbase->nbase; i++) {

                printf(" color %d",i);
                for(j = 0; j < gcbase->nconid[i]; j++) {
                    kol[j] = cfnnind(gcbase->conid[i][j])+1;
                    printf(" %d",kol[j]);
                }
                printf("\n");


              *//* lower - higher *//*
                for(k=0;k< gcbase->nconid[i];k=k+2) {
                    if(kol[k] > kol[k+1]) {
                        ktmp = kol[k];
                        kol[k] = kol[k+1];
                        kol[k+1] = ktmp;
                    }
                }

              *//* ordering sets *//*
                for(j=0;j<gcbase->nconid[i];j=j+2) {
                    for(k=j+2;k<gcbase->nconid[i];k=k+2) {
                        if(kol[j] > kol[k]) {
                            ktmp = kol[j];
                            kol[j] = kol[k];
                            kol[k] = ktmp;
                            ktmp = kol[j+1];
                            kol[j+1] = kol[k+1];
                            kol[k+1] = ktmp;
                        }
                    }
                }

                for(j = 0; j < gcbase->nconid[i]; j++) {
                    fprintf(redfp,"      kmcstr(%d,%d) = %d\n",j+1,
                          i,kol[j]);
                }
            }
        }
    }
    fprintf(redfp,"\n");
*/

    cmgfinicf(pc);/*2000.01.30*/

    cmsepar('-');
    cmkmass(redfp);

    cmsepar('-');
    fprintf(redfp,"* initialization of summary table\n");
    fprintf(redfp,"      call amclr\n");
    fprintf(redfp,"\n");

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");

    lang = lo;
}

/*==================================================================*/
Private Void    cmgfinicf(pc)
int     pc;
/*------------------------------------------------------------------*
 *     Assign Color Factor in gfinit.f
 */
{
    int    j;
    int    ic1,ic2;
    int    i, mxlen;
    int    kol[MAXCOLR];
/*
    int    ktmp, k;
*/
    string prf;

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
    } else {
        prf  = reprocp[pc];
    }
    if(colorv == 0) {
        if(caller == GRCFORT || caller == GRCREDA) {
            if(cprocess->qcd != 0) {
                fprintf(redfp,"\n* read color factor\n");
                fprintf(redfp,"      open(22, file='cf0x0.dat', ");
                fprintf(redfp,"file='cf0x0.dat', status='old')\n");
                fprintf(redfp,"\n");
                fprintf(redfp,"      do 140 i = 1, 4\n");
                fprintf(redfp,"        read(22,*)\n");
                fprintf(redfp,"  140 continue\n");
                fprintf(redfp,"      do 100 i = 1, n%sgraph\n", prf);
                fprintf(redfp,"        igraph(i) = 0\n");
                fprintf(redfp,"        do 100 j = 1, n%sgraph\n", prf);
                fprintf(redfp,"          read(22,*) ig, jg, nn, nd\n");
                fprintf(redfp,"          if(ig.ne.i .or. jg.ne.j) then\n");
                fprintf(redfp,"            write(6,*) 'illegal file of color ");
                fprintf(redfp,"factors (colorf)' \n");
                fprintf(redfp,"            write(6,*) ig, jg, nn, nd\n");
                fprintf(redfp,"            stop\n");
                fprintf(redfp,"          endif\n");
                fprintf(redfp,"          cf(j, i) = nn/dble(nd)\n");
                fprintf(redfp,"  100 continue\n");
                fprintf(redfp,"\n");
            } else if(cprocess->extcol != 0) {
                fprintf(redfp,"      call cfcalc\n");
            }
        }
    } else if(colorv == 1) {
        if(gcbase->nbase > 1) {
            fprintf(redfp,"* weight for the color base\n");
            for(ic1=0;ic1<gcbase->nbase;ic1++) {
                for(ic2=0;ic2<gcbase->nbase;ic2++) {
/*
                    fprintf(redfp,"      cfmtx(%d,%d)= %lfd0\n",
                           ic1,ic2,gcbase->cwgt[ic1][ic2]);
*/
                    if((gcbase->cwgt[ic1][ic2]).den == 1) {
                        fprintf(redfp,"      cfmtx(%d,%d)= %d.d0\n",
                                ic1,ic2,(gcbase->cwgt[ic1][ic2]).num);
                    } else {
                        fprintf(redfp,"      cfmtx(%d,%d)= %d.d0/%d.d0\n",
                                ic1,ic2,(gcbase->cwgt[ic1][ic2]).num,
                                (gcbase->cwgt[ic1][ic2]).den);
                    }
                }
            }
            fprintf(redfp,"\n");
        } else {
/*
            if(gcbase->nbase == 1 && gcbase->nexcolor == 1) {
*/
            if(gcbase->cwgt == NULL) {
                fprintf(redfp,"      cfmtx(0,0) = 1.0d0\n");
	    } else {
                fprintf(redfp,"* weight for the color base\n");
                if((gcbase->cwgt[0][0]).den == 1) {
                    fprintf(redfp,"      cfmtx(0,0) = %d.d0\n",
                            (gcbase->cwgt[0][0]).num);
                } else {
                    fprintf(redfp,"      cfmtx(0,0) = %d.d0/%d.d0\n",
                            (gcbase->cwgt[0][0]).num,(gcbase->cwgt[0][0]).den);
                }
                fprintf(redfp,"\n");
            }
        }
    }

    /* color string */
    if(colorv == 1 && gcbase->nbase > 0) {
        fprintf(redfp,"\n* Color string information\n");
        if(gcbase->nconid != NULL && gcbase->nbase == 1) {

            fprintf(redfp,"      kmcbas    = %d\n",gcbase->nbase);
            fprintf(redfp,"      kmcbmx    = %d\n",gcbase->nconid[0]);
            for(j = 0; j < gcbase->nconid[0]; j++) {
                kol[j] = cfnnind(gcbase->conid[0][j])+1;
            }

            /* lower - higher */
/* 001004 *//*
            for(i=0;i< gcbase->nconid[0];i=i+2) {
                if(kol[i] > kol[i+1]) {
                    ktmp = kol[i];
                    kol[i] = kol[i+1];
                    kol[i+1] = ktmp;
                }
            }
*/
            /* ordering sets */
/* 001004 *//*
            for(i=0;i< gcbase->nconid[0];i=i+2) {
                for(j=i+2;j<gcbase->nconid[0];j=j+2) {
                    if(kol[i] > kol[j]) {
                        ktmp = kol[i];
                        kol[i] = kol[j];
                        kol[j] = ktmp;
                        ktmp = kol[i+1];
                        kol[i+1] = kol[j+1];
                        kol[j+1] = ktmp;
                    }
                }
            }
*/

            for(j = 0; j < gcbase->nconid[0]; j++) {
                fprintf(redfp,"      kmcstr(%d) = %d\n",j+1,kol[j]);
            }

        } else if(gcbase->nbase > 1) {
            mxlen = gcbase->nconid[0];
            for(i = 1; i < gcbase->nbase; i++) {
                if(gcbase->nconid[i] > mxlen) {
                    mxlen = gcbase->nconid[i];
                }
            }
            fprintf(redfp,"      kmcbas    = %d\n",gcbase->nbase);
            fprintf(redfp,"      kmcbmx    = %d\n",mxlen);

            for(i = 0; i < gcbase->nbase; i++) {
/*              printf(" color %d:",i);*/
                for(j = 0; j < gcbase->nconid[i]; j++) {
                    kol[j] = cfnnind(gcbase->conid[i][j])+1;
/*                  printf(" %d ",kol[j]);*/
                }
/*              printf("\n"); */

                /* lower - higher */
/* 001004 *//*
                for(k=0;k< gcbase->nconid[i];k=k+2) {
                    if(kol[k] > kol[k+1]) {
                        ktmp = kol[k];
                        kol[k] = kol[k+1];
                        kol[k+1] = ktmp;
                    }
                }
*/
                /* ordering sets */
/* 001004 *//*
                for(j=0;j<gcbase->nconid[i];j=j+2) {
                    for(k=j+2;k<gcbase->nconid[i];k=k+2) {
                        if(kol[j] > kol[k]) {
                            ktmp = kol[j];
                            kol[j] = kol[k];
                            kol[k] = ktmp;
                            ktmp = kol[j+1];
                            kol[j+1] = kol[k+1];
                            kol[k+1] = ktmp;
                        }
                    }
                }
*/
                for(j = 0; j < gcbase->nconid[i]; j++) {
                    fprintf(redfp,"      kmcstr(%d,%d) = %d\n",j+1,
                          i,kol[j]);
                }
            }
        }
    }
    fprintf(redfp,"\n");
}
/*==================================================================*/
/*Private Void    cmakptbl(NoArg)*/
Public  Void    cmakptbl(NoArg)
/*------------------------------------------------------------------*
 */
{
    cmakptbp(-1);
}

/*==================================================================*/
Private Void    cmakptbp(pc)
int     pc;
/*------------------------------------------------------------------*
 */
{
    int    pps, ppe, pp;
    string prf, prfs;

    if(pc < 0) {
        if(cprefix == NULL) {
            prf = "";
        } else {
            prf  = cprefix;
        }
        prfs = "";
        pps  = 0;
        ppe  = nprocs;
    } else {
        prf  = reprocp[pc];
        prfs = prf;
        pps  = pc;
        ppe  = pc + 1;
    }

    if(multiprc) {
        if(rvcode) {
            cmopend(ROFORT, prfs, "akptblv.f");
        } else {
            cmopend(ROFORT, prfs, "akptbl.f");
        }
        cmsepar('*');
        if( vcode ) {
           fprintf(redfp,"      subroutine akptbl(nsampl)\n");
        } else if(rvcode) {
           fprintf(redfp,"      subroutine akptbl\n");
        } else {
           fprintf(redfp,"      subroutine akptbl\n");
        }
        fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
        fprintf(redfp,"      common /amjprc/jproc\n");
        fprintf(redfp,"\n");

        for(pp = pps; pp < ppe; pp++) {
            fprintf(redfp,"        if(jproc .eq. %d) then\n", pp+1);
            fprintf(redfp,"            call a%skptbl\n", reprocp[pp]);
            fprintf(redfp,"        endif\n");
            fprintf(redfp,"\n");
        }
        fprintf(redfp,"        return\n");
        fprintf(redfp,"        end\n");

        sprintf(momstr, "a%skptbl", prf);
    } else if(rvcode) {
        sprintf(momstr, "akptblv");
    } else {
        sprintf(momstr, "akptbl");
    }
    sprintf(momstr1, "%s.f", momstr);
    cmopend(ROFORT, prf, momstr1);

    cmsepar('*');
    if( vcode ) {
        fprintf(redfp,"      subroutine %s(nsampl)\n",momstr);
    } else {
        fprintf(redfp,"      subroutine %s\n",momstr);
    }
    fprintf(redfp,"      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(vcode) {
        fprintf(redfp,"      include 'inclvs.h'\n");
    }
    if(rvcode) {
        fprintf(redfp,"      include 'incl%s1v.h'\n", prf);
        fprintf(redfp,"      include 'inclk.h'\n");
        fprintf(redfp,"      include 'incl%spv.h'\n", prf);
    } else {
        fprintf(redfp,"      include 'incl%s1.h'\n", prf);
        fprintf(redfp,"      include 'inclk.h'\n");
        fprintf(redfp,"      include 'incl%sp.h'\n", prf);
    }

    cmsepar('-');
    cmkmom(redfp);

    fprintf(redfp,"      return\n");
    fprintf(redfp,"      end\n");
}

/*==================================================================*/
Private Void    cmkmass(rdfp)
FILE    *rdfp;
/*------------------------------------------------------------------*
 */
{
    int n, c,lname;
    pindex p, pa;

#ifdef GENGAUGEP
    int il, tp;
    tnode  *nd;
#endif

    fprintf(rdfp,"* Permutation of external particles\n");
    for(n = 0; n < nextern; n++) {
        fprintf(rdfp,"      kperm(%d) = %d\n",n+1,n+1);
    }
    fprintf(rdfp,"\n");

    fprintf(rdfp,"* Particle name\n");
    for(n = 0; n < nextern; n++) {
        pa  = ndname(n);
        fprintf(rdfp,"      kmprtc(kperm(%d)) = '%s'\n",
                n+1,pvename(ndiorf(n),pa));
        lname = strlen(pvename(ndiorf(n),pa));
        fprintf(rdfp,"      kmprtl(kperm(%d)) = %d\n",n+1,lname);
    }
    fprintf(rdfp,"\n");

    fprintf(rdfp,"* Masses of external particles\n");
    for(n = 0; n < nextern; n++) {
        p   = abs(ndname(n));
        cmvcmom(momstr, n, 0, False, "pe");
        cmmass(p, 1, momstr1);
        fprintf(rdfp,"      amass1(kperm(%d)) = %s\n", n+1, momstr1);
    }
    for(n = 0; n < nextern; n++) {
        fprintf(rdfp,"      amass2(kperm(%d)) = amass1(kperm(%d))**2\n",
                n+1, n+1);
    }
    fprintf(rdfp,"\n");

    /* charge */
    fprintf(rdfp,"* Charge*3\n");
    for(n = 0; n < nextern; n++) {
        pa  = ndname(n);
        p   = abs(pa);
        if(pa > 0) {
            c =   ptable[p]->charge3;
        } else {
            c = - ptable[p]->charge3;
        }
        if(ndiorf(n) == ELINITIAL) {
            c *= ptable[p]->antip;
        }
        fprintf(rdfp,"      kcharg(kperm(%d)) = %3d\n", n+1, c);
    }
    fprintf(rdfp,"\n");

    /* fkcode */
    fprintf(rdfp,"* KFcode\n");
    for(n = 0; n < nextern; n++) {
        pa  = ndname(n);
        p   = abs(pa);
        if(pa > 0) {
            c =   ptable[p]->kfcode;
        } else {
            c = - ptable[p]->kfcode;
        }
        if(ndiorf(n) == ELINITIAL) {
            c *= ptable[p]->antip;
        }
/* Toriazu TI : neutralinos : necessary ? TK */
/* No, unnecessary 981009
        if(c >=-74 && c <=-71) {
            printf("Special patch for kfcode 71-74\n");
            c = -c;
        }
*/
        fprintf(rdfp,"      kfcode(kperm(%d)) = %3d\n", n+1, c);
    }
    fprintf(rdfp,"\n");

/* gauge parameters should be set in 'setmas.f' */
#ifdef GENGAUGEP
   if(caller == GRCFORT || caller == GRCREDA || caller == GRCREDH ) {
        if(caller == GRCFORT) {
            fprintf(rdfp,"\n* Gauge parametes (default is unitary gauge)\n");
            for(n = 1; n < 5; n++) {
                fprintf(rdfp,"      igau%cb = 0\n", gchr[n]);
            }
            for(n = 1; n < 5; n++) {
                fprintf(rdfp,"      agauge(igau%cb) = 1.0d0\n", gchr[n]);
            }
            fprintf(rdfp,"      agauge(igau00) = 1.0d0\n");
        } else if(caller == GRCREDA || caller == GRCREDH ) {
            fprintf(rdfp,"\n* Gauge parametes (default is Feynman gauge)\n");
            for(n = 1; n < 5; n++) {
                fprintf(rdfp,"      igau%cb = %d\n", gchr[n],n);
            }
            for(n = 1; n < 5; n++) {
                fprintf(rdfp,"      agauge(igau%cb) = 1.0d0\n", gchr[n]);
            }
            fprintf(rdfp,"      agauge(igau00) = 1.0d0\n");
        }

        fprintf(rdfp,"\n* Spin average\n");
        fprintf(rdfp,"      aspin = 1.0d0\n");
        for(n = 0; n < nextern; n++) {
            pa  = ndname(n);
            p   = abs(pa);
            il  = ndiline(n, 0);
            tp  = iltable[il].iltype;
            Discard cmindx(momstr, tp, p);
            Discard cmmass(p, 1, momstr1);

            fprintf(rdfp,"\n");
            fprintf(rdfp,"*     %d: %s %s mass=%s\n",
                    n+1, eliorf(ndiorf(n)), pvename(ndiorf(n),pa),
                    momstr1);

            Discard cmindx(momstr1, tp, p);
            fprintf(rdfp,"      jhs(%d) = 0\n", n+1);
            fprintf(rdfp,"      jhe(%d) = %s - 1\n", n+1, momstr);
            if(ndiorf(n) == ELINITIAL && pvsdeg(p) > 1) {
                fprintf(rdfp,"      aspin = aspin/");
                fprintf(rdfp,"dble(jhe(%d) - jhs(%d)+1)\n",
                        n+1, n+1);
            }
        }
        if(cpol) {
/* 2002/03/07
 *          fprintf(rdfp,"\n* Flag of cyclic polarization\n");
 */
            for(n = 0; n < ndnodes(); n++) {
                if(ndtype(n) != NDEXTERN) {
                    continue;
                }
                if(cmphoton(n)) {
                    pa  = ndname(n);
                    fprintf(rdfp,"\n* Flag of cyclic polarization of %s\n",
                                  pvename(ndiorf(n),pa));
                    fprintf(rdfp,"* (linear : 0,  circular : 1)\n");
                    fprintf(rdfp,"      jcpol(%d) = 0\n", n+1);
                }
            }
        }
    } else {
        fprintf(rdfp,"\n* Spin average\n");
        fprintf(rdfp,"      aspin = 1.0d0");
        for(n = 0; n < nextern; n++) {
            nd  = ndnode(n);
            if(nd->nvkind == ELINITIAL) {
                p = abs(ndname(n));
                fprintf(rdfp,"/%d.0d0", pvsdeg(p));
            }
        }
    }
    fprintf(rdfp,"\n");
#endif
}

/*==================================================================*/
Private Void    cmkmom(rdfp)
FILE    *rdfp;
/*------------------------------------------------------------------*
 */
{
    int nmom;
    int i, j, k, s, c, ce;
/* ORG
    int p;
*//* 980412 */
    int *mvect;
    bool prntd;

    if((mvect = (int *) malloc(sizeof(int)*(nextern+1))) == NULL) {
        fprintf(Stderr, "*** cmkmom : memory\n");
        exit(FAIL);
    }

    nmom = 1;
    for(i = 0; i < nextern; i++) {
        nmom *= 2;
    }


    fprintf(rdfp,"      do 1000 i = 1, 4\n");
    if(vcode) {
        fprintf(rdfp,"      do 1000 j = 1, nsampl\n");
    }
    cmecmom(momstr1, -1, 1, "pe");
    for(i = 2; i < nmom; i += 2) {
        cmccmom(momstr, i, 1, "pe");
        ildecode(i, nextern+1, mvect);
        prntd = False;

/* debug
        for(j = 1; j <= nextern; j++) {
            fprintf(rdfp,"* code = %d mvect[%d]=%d\n", i, j, mvect[j]);
        }
*/

        if(vcode) {
            if(rcode) {
                fprintf(rdfp,"        %s(i,j) = ", momstr);
            } else {
                fprintf(rdfp,"        %s(j,i) = ", momstr);
            }
        } else if(rvcode) {
            fprintf(rdfp,"        %s(:,i) = ", momstr);
        } else {
            fprintf(rdfp,"        %s(i) = ", momstr);
        }
        for(j = 1; j <= nextern; j++) {
            if(mvect[j] == 0) {
                continue;
            }
            cmecmom(momstr1, j, 1, "pe");
            if(vcode) {
                if(rcode) {
                    fprintf(rdfp," %c %s(i,j)", (mvect[j]>0?'+':'-'), momstr1);
                } else {
                    fprintf(rdfp," %c %s(j,i)", (mvect[j]>0?'+':'-'), momstr1);
                }
            } else if(rvcode) {
                fprintf(rdfp," %c %s(:,i)", (mvect[j]>0?'+':'-'), momstr1);
            } else {
                fprintf(rdfp," %c %s(i)", (mvect[j]>0?'+':'-'), momstr1);
            }
            prntd = True;
        }
        if(!prntd) {
            fprintf(rdfp," 0");
        }
        fprintf(rdfp,"\n");
    }
    fprintf(rdfp,"\n");


    for(i = 3; i < nmom; i += 2) {
        cmccmom(momstr, i, 1, "pe");
        cmccmom(momstr1, i-1, 1, "pe");
        if(vcode) {
            if(rcode) {
                fprintf(rdfp,"        %s(i,j) = - %s(i,j)\n", momstr, momstr1);
            } else {
                fprintf(rdfp,"        %s(j,i) = - %s(j,i)\n", momstr, momstr1);
            }
        } else if(rvcode) {
            fprintf(rdfp,"        %s(:,i) = - %s(:,i)\n", momstr, momstr1);
        } else {
            fprintf(rdfp,"        %s(i) = - %s(i)\n", momstr, momstr1);
        }
    }
    fprintf(rdfp," 1000 continue\n\n");

    if(vcode) {
        fprintf(rdfp,"      do 2000 j = 1, nsampl\n");
    }
    for(i = 2; i < nmom; i += 2) {
        cmccmom(momstr, i, 1, "vm");
        ildecode(i, nextern+1, mvect);
        prntd = False;

        puinit(rdfp,"      ", "     &      ","","","", 70, 16);
        putid(momstr);
        if(vcode) {
            putid("(j)");
        }
        putid(" = ");

        for(j = 1; j <= nextern; j++) {
            if(mvect[j] == 0) {
                continue;
            }
            for(k = j+1; k <= nextern; k++) {
                if(mvect[k] == 0) {
                    continue;
                }
                ce = mvect[j]*mvect[k];

                if(ce > 0) {
                    s = ce;
                    c = '+';
                } else {
                    s = -ce;
                    c = '-';
                }
                sprintf(momstr1, " %c ", c);
                putid(momstr1);
                s *= 2;
                if(s != 1) {
                    sprintf(momstr1, "%d.0d0*", s);
                    putid(momstr1);
                }
                if(vcode) {
                    if(rcode) {
                        sprintf(momstr1, "prod(%d,%d,j)", j, k);
                    } else {
                        sprintf(momstr1, "prod(j,%d,%d)", j, k);
                    }
                } else if(rvcode) {
                    sprintf(momstr1, "prod(:,%d,%d)", j, k);
                } else {
                    sprintf(momstr1, "prod(%d,%d)", j, k);
                }
                putid(momstr1);
                prntd = True;
            }
        }

        /* mass terms */
        for(j = 1; j <= nextern; j++) {
            if(mvect[j] == 0) {
                continue;
            }
/* ORG
            p = abs(ndname(j-1));
            Discard cmmass(p, 1, momstr2);
            sprintf(momstr1, " + %s**2", momstr2);
*//* 980412 *//*
            sprintf(momstr1, " + amass2(%d)", j);
*//* 990519 */
            sprintf(momstr1, " + amass2(kperm(%d))", j);
            putid(momstr1);
        }
        putend();
    }
    for(i = 3; i < nmom; i += 2) {
        cmccmom(momstr, i, 1, "vm");
        cmccmom(momstr1, i-1, 1, "vm");
        if(vcode) {
             fprintf(rdfp,"      %s(j) = %s(j)\n", momstr, momstr1);
        } else {
             fprintf(rdfp,"      %s = %s\n", momstr, momstr1);
        }
    }


    if(vcode) {
        fprintf(rdfp," 2000 continue\n");
    }
}

#ifdef MOD20020227
/*==================================================================*/
Private Void    cmatcpl(sdir)
string  sdir;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    /* begin g980507 */
    int    n, ct, lp, dimn, ndef, ctd, i;
    /* end g980507 */
    int    *dimsz, *dimix;

    cmopend(ROFORT, sdir, "atcpl.f");

    cmsepar('*');
    fprintf(redfp, "      subroutine atcpl\n");
    fprintf(redfp, "      implicit real*8(a-h,o-z)\n");
    putc(EOL, redfp);

    if(caller == GRCFORT) {
        fprintf(redfp, "      return\n");
        fprintf(redfp, "      end\n");
        return;
    }

    if(vcode) {
        fprintf(redfp, "      include 'inclvs.h'\n");
    }
    fprintf(redfp,"      include 'inclm.h'\n");
    fprintf(redfp,"      include 'inclc.h'\n");
    fprintf(redfp,"      include 'incltc.h'\n");

/*
    fprintf(redfp, "      complex*16 zr, zi\n");
    fprintf(redfp, "      save       zr, zi\n");
    fprintf(redfp, "      zr = dcmplx(1.0d0, 0.0d0)\n");
    fprintf(redfp, "      zi = dcmplx(0.0d0, 1.0d0)\n");

    cmsepar('-');
    fprintf(redfp, "* mass**2\n");
    cmsepar('-');
    for(n = 1; n < nptable; n++) {
        if(isdigit(ptable[n]->mass[0])) {
            continue;
        }
        cmmass(n, 1, momstr);
        if(strcmp(momstr,"0") == 0) {
            continue;
        }
        fprintf(redfp,"      %6s2 = %6s**2\n", momstr, momstr);
    }
    putc(EOL, redfp);
*/

    cmsepar('-');

    fprintf(redfp, "* coupling constants\n");
    cmsepar('-');

    for(lp = 0; lp <= maxloop; lp++) {
        for(n = nvstart; n < nvtable; n++) {
            if(vtable[n]->composit == V_AUX) {
                continue;
            }
            if(vtable[n]->loop > lp) {
                continue;
            }
            /* check type */
            if(lp <= 0) {
                ndef = pvvnfind(n);
                ct   = vtable[n]->ctype;
                ctd  = vtable[ndef]->ctype;
                if((ct == V_NOTYPE && ctd != V_NOTYPE) ||
                   (ct != V_NOTYPE && ctd == V_NOTYPE)) {
                    fprintf(redfp, "\n *** Illegal definition of types\n");

                    fprintf(Stderr, "*** cmatcpl: ");
                    Discard cmtcoupl(n, 1, lp, momstr);
                    Discard cmtcoupl(ndef, 1, lp, momstr1);
                    fprintf(Stderr, "cannt define both %s and %s\n",
                            momstr, momstr1);
                }
            }

            dimn = cmdimn(n, lp, &dimsz, &dimix);

            if(lp > 0 || ct == V_NOTYPE) {
                /* begin g980507 */
                if(dimn > 0) {
                    for(i = 1; i <= dimsz[0]; i++) {
                        Discard cmtcoupl(n, i, lp, momstr);
                        Discard  cmcoupl(n, i, lp, momstr1);
                        fprintf(redfp, "      %s = %s\n", momstr, momstr1);
                    }
                } else {
                    Discard cmtcoupl(n, 0, lp, momstr);
                    Discard  cmcoupl(n, 0, lp, momstr1);
                    fprintf(redfp, "      %s = %s\n", momstr, momstr1);
                }
                /* end g980507 */

            /* tree */
            } else {
                if(ct == V_V) {
                    Discard cmtcoupl(n, 1, lp, momstr);
                    fprintf(redfp, "      %s = ", momstr);

                    Discard  cmcoupl(n, 1, lp, momstr1);
                    Discard  cmcoupl(n, 2, lp, momstr2);
                    fprintf(redfp, "0.5*(+ %s + %s)\n", momstr1, momstr2);

                } else if(ct == V_A) {
                    Discard cmtcoupl(n, 2, lp, momstr);
                    fprintf(redfp, "      %s = ", momstr);

                    Discard  cmcoupl(n, 1, lp, momstr1);
                    Discard  cmcoupl(n, 2, lp, momstr2);
                    fprintf(redfp, "0.5*(- %s + %s)\n", momstr1, momstr2);

                } else if(ct == V_VminusA) {
                    Discard cmtcoupl(n, 1, lp, momstr);
                    Discard  cmcoupl(n, 1, lp, momstr1);

                    fprintf(redfp, "      %s = %s\n", momstr, momstr1);

                } else if(ct == V_VplusA) {
                    Discard cmtcoupl(n, 2, lp, momstr);
                    Discard  cmcoupl(n, 2, lp, momstr1);

                    fprintf(redfp, "      %s = %s\n", momstr, momstr1);

                } else {
                    fprintf(Stderr, "Illegal type : %s\n", momstr1);
                    exit(FAIL);
                }
            } /* for */
        } /* for */

    }

    fprintf(redfp, "      return\n");
    fprintf(redfp, "      end\n");
}
#endif

/*==================================================================*/
Public Void    cminclp(pc)
int     pc;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    cminclpv(pc, "", "n_vector");
}

/*==================================================================*/
Public Void    cminclpv(pc, suff, vsize)
int     pc;
string  suff;
string  vsize;
/*------------------------------------------------------------------*
 *------------------------------------------------------------------*/
{
    int  i, j;
    long nmom;
    string prf0 = "";
    string prf;

    if(pc < 0) {
        prf = prf0;
    } else {
        prf = reprocp[pc];
    }
    sprintf(momstr1, "incl%sp%s.h", prf, suff);
    cmopend(ROFORT, prf, momstr1);

    for(j = 0; j < 2; j++) {
        if(j == 0) {
            sprintf(momstr2, "      real*8         ");
        } else {
            sprintf(momstr2, "      common /a%smilcd/", prf);
        }
        puinit(redfp, momstr2,
                      "     &               ",
                      ",", ",", "", 72, 16);
        nmom = 1;
        for(i = 0; i < nextern; i++) {
            nmom *= 2;
        }
        for(i = 2; i < nmom; i++) {
            cmccmom(momstr3, i, 1, "pe");
            if(j == 0) {
                if(!vcode && !rvcode) {
                    sprintf(momstr4, "%s(4)", momstr3);
                }else {
                    if(rcode) {
                        sprintf(momstr4, "%s(4,%s)", momstr3, vsize);
                    } else {
                        sprintf(momstr4, "%s(%s,4)", momstr3, vsize);
                    }
                }
                putid(momstr4);
            } else {
                putid(momstr3);
            }
        }
        putend();
    }

    for(j = 0; j < 2; j++) {
        if(j == 0) {
            sprintf(momstr2, "      real*8         ");
        } else {
            sprintf(momstr2, "      common /a%smilcp/", prf);
        }
        puinit(redfp, momstr2,
                      "     &               ",
                      ",", ",", "", 72, 16);
        nmom = 1;
        for(i = 0; i < nextern; i++) {
            nmom *= 2;
        }
        for(i = 2; i < nmom; i++) {
            cmccmom(momstr, i, 1, "vm");
            if(j == 0) {
                if(!vcode && !rvcode) {
                    sprintf(momstr1, "%s", momstr);
                }else {
                    sprintf(momstr1, "%s(%s)", momstr, vsize);
                }
                putid(momstr1);
            } else {
                putid(momstr);
            }
        }
        putend();
    }
}
